/* equation-lexer.c generated by valac 0.56.16, the Vala compiler
 * generated from equation-lexer.vala, do not modify */

/*
 * Copyright (C) 2012 Arth Patel
 * Copyright (C) 2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/* Enum for tokens generated by pre-lexer and lexer. */

#include "calculator.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PRE_LEXER_0_PROPERTY,
	PRE_LEXER_NUM_PROPERTIES
};
static GParamSpec* pre_lexer_properties[PRE_LEXER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	LEXER_TOKEN_0_PROPERTY,
	LEXER_TOKEN_NUM_PROPERTIES
};
static GParamSpec* lexer_token_properties[LEXER_TOKEN_NUM_PROPERTIES];
enum  {
	LEXER_0_PROPERTY,
	LEXER_NUM_PROPERTIES
};
static GParamSpec* lexer_properties[LEXER_NUM_PROPERTIES];
#define _parser_unref0(var) ((var == NULL) ? NULL : (var = (parser_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PreLexerPrivate {
	gboolean eos;
};

struct _LexerPrivate {
	Parser* parser;
	PreLexer* prelexer;
	guint next_token;
	gint number_base;
};

static gint PreLexer_private_offset;
static gpointer pre_lexer_parent_class = NULL;
static gpointer lexer_token_parent_class = NULL;
static gint Lexer_private_offset;
static gpointer lexer_parent_class = NULL;

static void pre_lexer_finalize (GObject * obj);
static GType pre_lexer_get_type_once (void);
static void lexer_token_finalize (GObject * obj);
static GType lexer_token_get_type_once (void);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static LexerToken* lexer_insert_next_token (Lexer* self);
static gboolean lexer_check_if_function (Lexer* self);
static gboolean lexer_check_if_unit (Lexer* self);
static gboolean lexer_check_if_literal_base (Lexer* self);
static gboolean lexer_check_if_number (Lexer* self);
static LexerToken* lexer_insert_token (Lexer* self,
                                LexerTokenType type);
static LexerToken* lexer_insert_digit (Lexer* self);
static LexerToken* lexer_insert_decimal (Lexer* self);
static LexerToken* lexer_insert_hex (Lexer* self);
static LexerToken* lexer_insert_letter (Lexer* self);
static LexerToken* lexer_insert_angle_num_dm (Lexer* self);
static LexerToken* lexer_insert_angle_num_dms (Lexer* self);
static LexerToken* lexer_insert_hex_dec (Lexer* self);
static LexerToken* lexer_insert_decimal_hex (Lexer* self);
static void lexer_finalize (GObject * obj);
static GType lexer_get_type_once (void);

static GType
lexer_token_type_get_type_once (void)
{
	static const GEnumValue values[] = {{LEXER_TOKEN_TYPE_UNKNOWN, "LEXER_TOKEN_TYPE_UNKNOWN", "unknown"}, {LEXER_TOKEN_TYPE_PL_DECIMAL, "LEXER_TOKEN_TYPE_PL_DECIMAL", "pl-decimal"}, {LEXER_TOKEN_TYPE_PL_DIGIT, "LEXER_TOKEN_TYPE_PL_DIGIT", "pl-digit"}, {LEXER_TOKEN_TYPE_PL_HEX, "LEXER_TOKEN_TYPE_PL_HEX", "pl-hex"}, {LEXER_TOKEN_TYPE_PL_SUPER_DIGIT, "LEXER_TOKEN_TYPE_PL_SUPER_DIGIT", "pl-super-digit"}, {LEXER_TOKEN_TYPE_PL_SUPER_MINUS, "LEXER_TOKEN_TYPE_PL_SUPER_MINUS", "pl-super-minus"}, {LEXER_TOKEN_TYPE_PL_SUB_DIGIT, "LEXER_TOKEN_TYPE_PL_SUB_DIGIT", "pl-sub-digit"}, {LEXER_TOKEN_TYPE_PL_FRACTION, "LEXER_TOKEN_TYPE_PL_FRACTION", "pl-fraction"}, {LEXER_TOKEN_TYPE_PL_DEGREE, "LEXER_TOKEN_TYPE_PL_DEGREE", "pl-degree"}, {LEXER_TOKEN_TYPE_PL_MINUTE, "LEXER_TOKEN_TYPE_PL_MINUTE", "pl-minute"}, {LEXER_TOKEN_TYPE_PL_SECOND, "LEXER_TOKEN_TYPE_PL_SECOND", "pl-second"}, {LEXER_TOKEN_TYPE_PL_LETTER, "LEXER_TOKEN_TYPE_PL_LETTER", "pl-letter"}, {LEXER_TOKEN_TYPE_PL_EOS, "LEXER_TOKEN_TYPE_PL_EOS", "pl-eos"}, {LEXER_TOKEN_TYPE_PL_SKIP, "LEXER_TOKEN_TYPE_PL_SKIP", "pl-skip"}, {LEXER_TOKEN_TYPE_ADD, "LEXER_TOKEN_TYPE_ADD", "add"}, {LEXER_TOKEN_TYPE_SUBTRACT, "LEXER_TOKEN_TYPE_SUBTRACT", "subtract"}, {LEXER_TOKEN_TYPE_MULTIPLY, "LEXER_TOKEN_TYPE_MULTIPLY", "multiply"}, {LEXER_TOKEN_TYPE_DIVIDE, "LEXER_TOKEN_TYPE_DIVIDE", "divide"}, {LEXER_TOKEN_TYPE_MOD, "LEXER_TOKEN_TYPE_MOD", "mod"}, {LEXER_TOKEN_TYPE_L_FLOOR, "LEXER_TOKEN_TYPE_L_FLOOR", "l-floor"}, {LEXER_TOKEN_TYPE_R_FLOOR, "LEXER_TOKEN_TYPE_R_FLOOR", "r-floor"}, {LEXER_TOKEN_TYPE_L_CEILING, "LEXER_TOKEN_TYPE_L_CEILING", "l-ceiling"}, {LEXER_TOKEN_TYPE_R_CEILING, "LEXER_TOKEN_TYPE_R_CEILING", "r-ceiling"}, {LEXER_TOKEN_TYPE_ROOT, "LEXER_TOKEN_TYPE_ROOT", "root"}, {LEXER_TOKEN_TYPE_ROOT_3, "LEXER_TOKEN_TYPE_ROOT_3", "root-3"}, {LEXER_TOKEN_TYPE_ROOT_4, "LEXER_TOKEN_TYPE_ROOT_4", "root-4"}, {LEXER_TOKEN_TYPE_NOT, "LEXER_TOKEN_TYPE_NOT", "not"}, {LEXER_TOKEN_TYPE_AND, "LEXER_TOKEN_TYPE_AND", "and"}, {LEXER_TOKEN_TYPE_OR, "LEXER_TOKEN_TYPE_OR", "or"}, {LEXER_TOKEN_TYPE_XOR, "LEXER_TOKEN_TYPE_XOR", "xor"}, {LEXER_TOKEN_TYPE_IN, "LEXER_TOKEN_TYPE_IN", "in"}, {LEXER_TOKEN_TYPE_NUMBER, "LEXER_TOKEN_TYPE_NUMBER", "number"}, {LEXER_TOKEN_TYPE_SUP_NUMBER, "LEXER_TOKEN_TYPE_SUP_NUMBER", "sup-number"}, {LEXER_TOKEN_TYPE_NSUP_NUMBER, "LEXER_TOKEN_TYPE_NSUP_NUMBER", "nsup-number"}, {LEXER_TOKEN_TYPE_SUB_NUMBER, "LEXER_TOKEN_TYPE_SUB_NUMBER", "sub-number"}, {LEXER_TOKEN_TYPE_FUNCTION, "LEXER_TOKEN_TYPE_FUNCTION", "function"}, {LEXER_TOKEN_TYPE_UNIT, "LEXER_TOKEN_TYPE_UNIT", "unit"}, {LEXER_TOKEN_TYPE_VARIABLE, "LEXER_TOKEN_TYPE_VARIABLE", "variable"}, {LEXER_TOKEN_TYPE_SHIFT_LEFT, "LEXER_TOKEN_TYPE_SHIFT_LEFT", "shift-left"}, {LEXER_TOKEN_TYPE_SHIFT_RIGHT, "LEXER_TOKEN_TYPE_SHIFT_RIGHT", "shift-right"}, {LEXER_TOKEN_TYPE_ASSIGN, "LEXER_TOKEN_TYPE_ASSIGN", "assign"}, {LEXER_TOKEN_TYPE_L_R_BRACKET, "LEXER_TOKEN_TYPE_L_R_BRACKET", "l-r-bracket"}, {LEXER_TOKEN_TYPE_R_R_BRACKET, "LEXER_TOKEN_TYPE_R_R_BRACKET", "r-r-bracket"}, {LEXER_TOKEN_TYPE_L_S_BRACKET, "LEXER_TOKEN_TYPE_L_S_BRACKET", "l-s-bracket"}, {LEXER_TOKEN_TYPE_R_S_BRACKET, "LEXER_TOKEN_TYPE_R_S_BRACKET", "r-s-bracket"}, {LEXER_TOKEN_TYPE_L_C_BRACKET, "LEXER_TOKEN_TYPE_L_C_BRACKET", "l-c-bracket"}, {LEXER_TOKEN_TYPE_R_C_BRACKET, "LEXER_TOKEN_TYPE_R_C_BRACKET", "r-c-bracket"}, {LEXER_TOKEN_TYPE_ABS, "LEXER_TOKEN_TYPE_ABS", "abs"}, {LEXER_TOKEN_TYPE_POWER, "LEXER_TOKEN_TYPE_POWER", "power"}, {LEXER_TOKEN_TYPE_FACTORIAL, "LEXER_TOKEN_TYPE_FACTORIAL", "factorial"}, {LEXER_TOKEN_TYPE_PERCENTAGE, "LEXER_TOKEN_TYPE_PERCENTAGE", "percentage"}, {LEXER_TOKEN_TYPE_ARGUMENT_SEPARATOR, "LEXER_TOKEN_TYPE_ARGUMENT_SEPARATOR", "argument-separator"}, {LEXER_TOKEN_TYPE_FUNC_DESC_SEPARATOR, "LEXER_TOKEN_TYPE_FUNC_DESC_SEPARATOR", "func-desc-separator"}, {0, NULL, NULL}};
	GType lexer_token_type_type_id;
	lexer_token_type_type_id = g_enum_register_static ("LexerTokenType", values);
	return lexer_token_type_type_id;
}

GType
lexer_token_type_get_type (void)
{
	static volatile gsize lexer_token_type_type_id__once = 0;
	if (g_once_init_enter (&lexer_token_type_type_id__once)) {
		GType lexer_token_type_type_id;
		lexer_token_type_type_id = lexer_token_type_get_type_once ();
		g_once_init_leave (&lexer_token_type_type_id__once, lexer_token_type_type_id);
	}
	return lexer_token_type_type_id__once;
}

static inline gpointer
pre_lexer_get_instance_private (PreLexer* self)
{
	return G_STRUCT_MEMBER_P (self, PreLexer_private_offset);
}

PreLexer*
pre_lexer_construct (GType object_type,
                     const gchar* input)
{
	PreLexer * self = NULL;
	gchar* _tmp0_;
#line 82 "../lib/equation-lexer.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 82 "../lib/equation-lexer.vala"
	self = (PreLexer*) g_object_new (object_type, NULL);
#line 84 "../lib/equation-lexer.vala"
	_tmp0_ = g_strdup (input);
#line 84 "../lib/equation-lexer.vala"
	_g_free0 (self->stream);
#line 84 "../lib/equation-lexer.vala"
	self->stream = _tmp0_;
#line 85 "../lib/equation-lexer.vala"
	self->index = 0;
#line 86 "../lib/equation-lexer.vala"
	self->mark_index = 0;
#line 82 "../lib/equation-lexer.vala"
	return self;
#line 142 "equation-lexer.c"
}

PreLexer*
pre_lexer_new (const gchar* input)
{
#line 82 "../lib/equation-lexer.vala"
	return pre_lexer_construct (TYPE_PRE_LEXER, input);
#line 150 "equation-lexer.c"
}

static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1306 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1307 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 164 "equation-lexer.c"
		gchar* _tmp0_;
#line 1308 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1308 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1309 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1310 "glib-2.0.vapi"
		result = TRUE;
#line 1310 "glib-2.0.vapi"
		if (c) {
#line 1310 "glib-2.0.vapi"
			*c = _vala_c;
#line 178 "equation-lexer.c"
		}
#line 1310 "glib-2.0.vapi"
		return result;
#line 182 "equation-lexer.c"
	} else {
#line 1312 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1313 "glib-2.0.vapi"
		result = FALSE;
#line 1313 "glib-2.0.vapi"
		if (c) {
#line 1313 "glib-2.0.vapi"
			*c = _vala_c;
#line 192 "equation-lexer.c"
		}
#line 1313 "glib-2.0.vapi"
		return result;
#line 196 "equation-lexer.c"
	}
}

void
pre_lexer_roll_back (PreLexer* self)
{
	gunichar c = 0U;
	const gchar* _tmp0_;
	gunichar _tmp1_ = 0U;
#line 90 "../lib/equation-lexer.vala"
	g_return_if_fail (self != NULL);
#line 92 "../lib/equation-lexer.vala"
	if (self->priv->eos) {
#line 94 "../lib/equation-lexer.vala"
		self->priv->eos = FALSE;
#line 95 "../lib/equation-lexer.vala"
		return;
#line 214 "equation-lexer.c"
	}
#line 98 "../lib/equation-lexer.vala"
	_tmp0_ = self->stream;
#line 98 "../lib/equation-lexer.vala"
	string_get_prev_char (_tmp0_, &self->index, &_tmp1_);
#line 98 "../lib/equation-lexer.vala"
	c = _tmp1_;
#line 222 "equation-lexer.c"
}

void
pre_lexer_set_marker (PreLexer* self)
{
#line 102 "../lib/equation-lexer.vala"
	g_return_if_fail (self != NULL);
#line 104 "../lib/equation-lexer.vala"
	self->mark_index = self->index;
#line 232 "equation-lexer.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1466 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1466 "glib-2.0.vapi"
	end = _tmp0_;
#line 1467 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1467 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1468 "glib-2.0.vapi"
		result = maxlen;
#line 1468 "glib-2.0.vapi"
		return result;
#line 255 "equation-lexer.c"
	} else {
		gchar* _tmp2_;
#line 1470 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1470 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1470 "glib-2.0.vapi"
		return result;
#line 264 "equation-lexer.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1479 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 283 "equation-lexer.c"
	} else {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 287 "equation-lexer.c"
	}
#line 1479 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1481 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 293 "equation-lexer.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1483 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1483 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1483 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 303 "equation-lexer.c"
	}
#line 1486 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1487 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1488 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 311 "equation-lexer.c"
	} else {
#line 1490 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 315 "equation-lexer.c"
	}
#line 1492 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1493 "glib-2.0.vapi"
		len = string_length - offset;
#line 321 "equation-lexer.c"
	}
#line 1495 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1496 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1496 "glib-2.0.vapi"
	result = _tmp3_;
#line 1496 "glib-2.0.vapi"
	return result;
#line 331 "equation-lexer.c"
}

gchar*
pre_lexer_get_marked_substring (PreLexer* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 108 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../lib/equation-lexer.vala"
	_tmp0_ = self->stream;
#line 110 "../lib/equation-lexer.vala"
	_tmp1_ = string_substring (_tmp0_, (glong) self->mark_index, (glong) (self->index - self->mark_index));
#line 110 "../lib/equation-lexer.vala"
	result = _tmp1_;
#line 110 "../lib/equation-lexer.vala"
	return result;
#line 350 "equation-lexer.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1267 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1268 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1269 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 366 "equation-lexer.c"
		gchar* _tmp0_;
#line 1270 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1270 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1271 "glib-2.0.vapi"
		result = TRUE;
#line 1271 "glib-2.0.vapi"
		if (c) {
#line 1271 "glib-2.0.vapi"
			*c = _vala_c;
#line 378 "equation-lexer.c"
		}
#line 1271 "glib-2.0.vapi"
		return result;
#line 382 "equation-lexer.c"
	} else {
#line 1273 "glib-2.0.vapi"
		result = FALSE;
#line 1273 "glib-2.0.vapi"
		if (c) {
#line 1273 "glib-2.0.vapi"
			*c = _vala_c;
#line 390 "equation-lexer.c"
		}
#line 1273 "glib-2.0.vapi"
		return result;
#line 394 "equation-lexer.c"
	}
}

LexerTokenType
pre_lexer_get_next_token (PreLexer* self)
{
	gunichar c = 0U;
	const gchar* _tmp0_;
	gunichar _tmp1_ = 0U;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_ = FALSE;
	LexerTokenType result;
#line 114 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 117 "../lib/equation-lexer.vala"
	_tmp0_ = self->stream;
#line 117 "../lib/equation-lexer.vala"
	_tmp2_ = string_get_next_char (_tmp0_, &self->index, &_tmp1_);
#line 117 "../lib/equation-lexer.vala"
	c = _tmp1_;
#line 117 "../lib/equation-lexer.vala"
	if (!_tmp2_) {
#line 120 "../lib/equation-lexer.vala"
		self->priv->eos = TRUE;
#line 121 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_EOS;
#line 121 "../lib/equation-lexer.vala"
		return result;
#line 470 "equation-lexer.c"
	}
#line 123 "../lib/equation-lexer.vala"
	self->priv->eos = FALSE;
#line 125 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ',')) {
#line 125 "../lib/equation-lexer.vala"
		_tmp3_ = TRUE;
#line 478 "equation-lexer.c"
	} else {
#line 125 "../lib/equation-lexer.vala"
		_tmp3_ = c == ((gunichar) '.');
#line 482 "equation-lexer.c"
	}
#line 125 "../lib/equation-lexer.vala"
	if (_tmp3_) {
#line 126 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_DECIMAL;
#line 126 "../lib/equation-lexer.vala"
		return result;
#line 490 "equation-lexer.c"
	}
#line 128 "../lib/equation-lexer.vala"
	if (g_unichar_isdigit (c)) {
#line 129 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_DIGIT;
#line 129 "../lib/equation-lexer.vala"
		return result;
#line 498 "equation-lexer.c"
	}
#line 131 "../lib/equation-lexer.vala"
	if (c >= ((gunichar) 'a')) {
#line 131 "../lib/equation-lexer.vala"
		_tmp5_ = c <= ((gunichar) 'f');
#line 504 "equation-lexer.c"
	} else {
#line 131 "../lib/equation-lexer.vala"
		_tmp5_ = FALSE;
#line 508 "equation-lexer.c"
	}
#line 131 "../lib/equation-lexer.vala"
	if (_tmp5_) {
#line 131 "../lib/equation-lexer.vala"
		_tmp4_ = TRUE;
#line 514 "equation-lexer.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 131 "../lib/equation-lexer.vala"
		if (c >= ((gunichar) 'A')) {
#line 131 "../lib/equation-lexer.vala"
			_tmp6_ = c <= ((gunichar) 'F');
#line 521 "equation-lexer.c"
		} else {
#line 131 "../lib/equation-lexer.vala"
			_tmp6_ = FALSE;
#line 525 "equation-lexer.c"
		}
#line 131 "../lib/equation-lexer.vala"
		_tmp4_ = _tmp6_;
#line 529 "equation-lexer.c"
	}
#line 131 "../lib/equation-lexer.vala"
	if (_tmp4_) {
#line 132 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_HEX;
#line 132 "../lib/equation-lexer.vala"
		return result;
#line 537 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (c == 8304U) {
#line 134 "../lib/equation-lexer.vala"
		_tmp15_ = TRUE;
#line 543 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp15_ = c == 185U;
#line 547 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp15_) {
#line 134 "../lib/equation-lexer.vala"
		_tmp14_ = TRUE;
#line 553 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp14_ = c == 178U;
#line 557 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp14_) {
#line 134 "../lib/equation-lexer.vala"
		_tmp13_ = TRUE;
#line 563 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp13_ = c == 179U;
#line 567 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp13_) {
#line 134 "../lib/equation-lexer.vala"
		_tmp12_ = TRUE;
#line 573 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp12_ = c == 8308U;
#line 577 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp12_) {
#line 134 "../lib/equation-lexer.vala"
		_tmp11_ = TRUE;
#line 583 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp11_ = c == 8309U;
#line 587 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp11_) {
#line 134 "../lib/equation-lexer.vala"
		_tmp10_ = TRUE;
#line 593 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp10_ = c == 8310U;
#line 597 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp10_) {
#line 134 "../lib/equation-lexer.vala"
		_tmp9_ = TRUE;
#line 603 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp9_ = c == 8311U;
#line 607 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp9_) {
#line 134 "../lib/equation-lexer.vala"
		_tmp8_ = TRUE;
#line 613 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp8_ = c == 8312U;
#line 617 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp8_) {
#line 134 "../lib/equation-lexer.vala"
		_tmp7_ = TRUE;
#line 623 "equation-lexer.c"
	} else {
#line 134 "../lib/equation-lexer.vala"
		_tmp7_ = c == 8313U;
#line 627 "equation-lexer.c"
	}
#line 134 "../lib/equation-lexer.vala"
	if (_tmp7_) {
#line 135 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SUPER_DIGIT;
#line 135 "../lib/equation-lexer.vala"
		return result;
#line 635 "equation-lexer.c"
	}
#line 137 "../lib/equation-lexer.vala"
	if (c == 8315U) {
#line 138 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SUPER_MINUS;
#line 138 "../lib/equation-lexer.vala"
		return result;
#line 643 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (c == 8320U) {
#line 140 "../lib/equation-lexer.vala"
		_tmp24_ = TRUE;
#line 649 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp24_ = c == 8321U;
#line 653 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp24_) {
#line 140 "../lib/equation-lexer.vala"
		_tmp23_ = TRUE;
#line 659 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp23_ = c == 8322U;
#line 663 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp23_) {
#line 140 "../lib/equation-lexer.vala"
		_tmp22_ = TRUE;
#line 669 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp22_ = c == 8323U;
#line 673 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp22_) {
#line 140 "../lib/equation-lexer.vala"
		_tmp21_ = TRUE;
#line 679 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp21_ = c == 8324U;
#line 683 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp21_) {
#line 140 "../lib/equation-lexer.vala"
		_tmp20_ = TRUE;
#line 689 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp20_ = c == 8325U;
#line 693 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp20_) {
#line 140 "../lib/equation-lexer.vala"
		_tmp19_ = TRUE;
#line 699 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp19_ = c == 8326U;
#line 703 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp19_) {
#line 140 "../lib/equation-lexer.vala"
		_tmp18_ = TRUE;
#line 709 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp18_ = c == 8327U;
#line 713 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp18_) {
#line 140 "../lib/equation-lexer.vala"
		_tmp17_ = TRUE;
#line 719 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp17_ = c == 8328U;
#line 723 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp17_) {
#line 140 "../lib/equation-lexer.vala"
		_tmp16_ = TRUE;
#line 729 "equation-lexer.c"
	} else {
#line 140 "../lib/equation-lexer.vala"
		_tmp16_ = c == 8329U;
#line 733 "equation-lexer.c"
	}
#line 140 "../lib/equation-lexer.vala"
	if (_tmp16_) {
#line 141 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SUB_DIGIT;
#line 141 "../lib/equation-lexer.vala"
		return result;
#line 741 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (c == 189U) {
#line 143 "../lib/equation-lexer.vala"
		_tmp38_ = TRUE;
#line 747 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp38_ = c == 8531U;
#line 751 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp38_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp37_ = TRUE;
#line 757 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp37_ = c == 8532U;
#line 761 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp37_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp36_ = TRUE;
#line 767 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp36_ = c == 188U;
#line 771 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp36_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp35_ = TRUE;
#line 777 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp35_ = c == 190U;
#line 781 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp35_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp34_ = TRUE;
#line 787 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp34_ = c == 8533U;
#line 791 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp34_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp33_ = TRUE;
#line 797 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp33_ = c == 8534U;
#line 801 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp33_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp32_ = TRUE;
#line 807 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp32_ = c == 8535U;
#line 811 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp32_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp31_ = TRUE;
#line 817 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp31_ = c == 8536U;
#line 821 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp31_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp30_ = TRUE;
#line 827 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp30_ = c == 8537U;
#line 831 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp30_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp29_ = TRUE;
#line 837 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp29_ = c == 8538U;
#line 841 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp29_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp28_ = TRUE;
#line 847 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp28_ = c == 8539U;
#line 851 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp28_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp27_ = TRUE;
#line 857 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp27_ = c == 8540U;
#line 861 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp27_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp26_ = TRUE;
#line 867 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp26_ = c == 8541U;
#line 871 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp26_) {
#line 143 "../lib/equation-lexer.vala"
		_tmp25_ = TRUE;
#line 877 "equation-lexer.c"
	} else {
#line 143 "../lib/equation-lexer.vala"
		_tmp25_ = c == 8542U;
#line 881 "equation-lexer.c"
	}
#line 143 "../lib/equation-lexer.vala"
	if (_tmp25_) {
#line 144 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_FRACTION;
#line 144 "../lib/equation-lexer.vala"
		return result;
#line 889 "equation-lexer.c"
	}
#line 146 "../lib/equation-lexer.vala"
	if (c == 730U) {
#line 146 "../lib/equation-lexer.vala"
		_tmp39_ = TRUE;
#line 895 "equation-lexer.c"
	} else {
#line 146 "../lib/equation-lexer.vala"
		_tmp39_ = c == 176U;
#line 899 "equation-lexer.c"
	}
#line 146 "../lib/equation-lexer.vala"
	if (_tmp39_) {
#line 147 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_DEGREE;
#line 147 "../lib/equation-lexer.vala"
		return result;
#line 907 "equation-lexer.c"
	}
#line 149 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '\'')) {
#line 150 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_MINUTE;
#line 150 "../lib/equation-lexer.vala"
		return result;
#line 915 "equation-lexer.c"
	}
#line 152 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '"')) {
#line 153 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SECOND;
#line 153 "../lib/equation-lexer.vala"
		return result;
#line 923 "equation-lexer.c"
	}
#line 155 "../lib/equation-lexer.vala"
	if (g_unichar_isalpha (c)) {
#line 155 "../lib/equation-lexer.vala"
		_tmp41_ = TRUE;
#line 929 "equation-lexer.c"
	} else {
#line 155 "../lib/equation-lexer.vala"
		_tmp41_ = c == ((gunichar) '_');
#line 933 "equation-lexer.c"
	}
#line 155 "../lib/equation-lexer.vala"
	if (_tmp41_) {
#line 155 "../lib/equation-lexer.vala"
		_tmp40_ = TRUE;
#line 939 "equation-lexer.c"
	} else {
#line 155 "../lib/equation-lexer.vala"
		_tmp40_ = c == ((gunichar) '\\');
#line 943 "equation-lexer.c"
	}
#line 155 "../lib/equation-lexer.vala"
	if (_tmp40_) {
#line 156 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_LETTER;
#line 156 "../lib/equation-lexer.vala"
		return result;
#line 951 "equation-lexer.c"
	}
#line 158 "../lib/equation-lexer.vala"
	if (c == 8743U) {
#line 159 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_AND;
#line 159 "../lib/equation-lexer.vala"
		return result;
#line 959 "equation-lexer.c"
	}
#line 161 "../lib/equation-lexer.vala"
	if (c == 8744U) {
#line 162 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_OR;
#line 162 "../lib/equation-lexer.vala"
		return result;
#line 967 "equation-lexer.c"
	}
#line 164 "../lib/equation-lexer.vala"
	if (c == 8891U) {
#line 164 "../lib/equation-lexer.vala"
		_tmp42_ = TRUE;
#line 973 "equation-lexer.c"
	} else {
#line 164 "../lib/equation-lexer.vala"
		_tmp42_ = c == 8853U;
#line 977 "equation-lexer.c"
	}
#line 164 "../lib/equation-lexer.vala"
	if (_tmp42_) {
#line 165 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_XOR;
#line 165 "../lib/equation-lexer.vala"
		return result;
#line 985 "equation-lexer.c"
	}
#line 167 "../lib/equation-lexer.vala"
	if (c == 172U) {
#line 167 "../lib/equation-lexer.vala"
		_tmp43_ = TRUE;
#line 991 "equation-lexer.c"
	} else {
#line 167 "../lib/equation-lexer.vala"
		_tmp43_ = c == ((gunichar) '~');
#line 995 "equation-lexer.c"
	}
#line 167 "../lib/equation-lexer.vala"
	if (_tmp43_) {
#line 168 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_NOT;
#line 168 "../lib/equation-lexer.vala"
		return result;
#line 1003 "equation-lexer.c"
	}
#line 170 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '+')) {
#line 171 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ADD;
#line 171 "../lib/equation-lexer.vala"
		return result;
#line 1011 "equation-lexer.c"
	}
#line 173 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '-')) {
#line 173 "../lib/equation-lexer.vala"
		_tmp45_ = TRUE;
#line 1017 "equation-lexer.c"
	} else {
#line 173 "../lib/equation-lexer.vala"
		_tmp45_ = c == 8722U;
#line 1021 "equation-lexer.c"
	}
#line 173 "../lib/equation-lexer.vala"
	if (_tmp45_) {
#line 173 "../lib/equation-lexer.vala"
		_tmp44_ = TRUE;
#line 1027 "equation-lexer.c"
	} else {
#line 173 "../lib/equation-lexer.vala"
		_tmp44_ = c == 8211U;
#line 1031 "equation-lexer.c"
	}
#line 173 "../lib/equation-lexer.vala"
	if (_tmp44_) {
#line 174 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_SUBTRACT;
#line 174 "../lib/equation-lexer.vala"
		return result;
#line 1039 "equation-lexer.c"
	}
#line 176 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '*')) {
#line 176 "../lib/equation-lexer.vala"
		_tmp46_ = TRUE;
#line 1045 "equation-lexer.c"
	} else {
#line 176 "../lib/equation-lexer.vala"
		_tmp46_ = c == 215U;
#line 1049 "equation-lexer.c"
	}
#line 176 "../lib/equation-lexer.vala"
	if (_tmp46_) {
#line 177 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_MULTIPLY;
#line 177 "../lib/equation-lexer.vala"
		return result;
#line 1057 "equation-lexer.c"
	}
#line 179 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '/')) {
#line 179 "../lib/equation-lexer.vala"
		_tmp48_ = TRUE;
#line 1063 "equation-lexer.c"
	} else {
#line 179 "../lib/equation-lexer.vala"
		_tmp48_ = c == 8725U;
#line 1067 "equation-lexer.c"
	}
#line 179 "../lib/equation-lexer.vala"
	if (_tmp48_) {
#line 179 "../lib/equation-lexer.vala"
		_tmp47_ = TRUE;
#line 1073 "equation-lexer.c"
	} else {
#line 179 "../lib/equation-lexer.vala"
		_tmp47_ = c == 247U;
#line 1077 "equation-lexer.c"
	}
#line 179 "../lib/equation-lexer.vala"
	if (_tmp47_) {
#line 180 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_DIVIDE;
#line 180 "../lib/equation-lexer.vala"
		return result;
#line 1085 "equation-lexer.c"
	}
#line 182 "../lib/equation-lexer.vala"
	if (c == 8970U) {
#line 183 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_FLOOR;
#line 183 "../lib/equation-lexer.vala"
		return result;
#line 1093 "equation-lexer.c"
	}
#line 185 "../lib/equation-lexer.vala"
	if (c == 8971U) {
#line 186 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_FLOOR;
#line 186 "../lib/equation-lexer.vala"
		return result;
#line 1101 "equation-lexer.c"
	}
#line 188 "../lib/equation-lexer.vala"
	if (c == 8968U) {
#line 189 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_CEILING;
#line 189 "../lib/equation-lexer.vala"
		return result;
#line 1109 "equation-lexer.c"
	}
#line 191 "../lib/equation-lexer.vala"
	if (c == 8969U) {
#line 192 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_CEILING;
#line 192 "../lib/equation-lexer.vala"
		return result;
#line 1117 "equation-lexer.c"
	}
#line 194 "../lib/equation-lexer.vala"
	if (c == 8730U) {
#line 195 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ROOT;
#line 195 "../lib/equation-lexer.vala"
		return result;
#line 1125 "equation-lexer.c"
	}
#line 197 "../lib/equation-lexer.vala"
	if (c == 8731U) {
#line 198 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ROOT_3;
#line 198 "../lib/equation-lexer.vala"
		return result;
#line 1133 "equation-lexer.c"
	}
#line 200 "../lib/equation-lexer.vala"
	if (c == 8732U) {
#line 201 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ROOT_4;
#line 201 "../lib/equation-lexer.vala"
		return result;
#line 1141 "equation-lexer.c"
	}
#line 203 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '=')) {
#line 204 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ASSIGN;
#line 204 "../lib/equation-lexer.vala"
		return result;
#line 1149 "equation-lexer.c"
	}
#line 206 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '(')) {
#line 207 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_R_BRACKET;
#line 207 "../lib/equation-lexer.vala"
		return result;
#line 1157 "equation-lexer.c"
	}
#line 209 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ')')) {
#line 210 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_R_BRACKET;
#line 210 "../lib/equation-lexer.vala"
		return result;
#line 1165 "equation-lexer.c"
	}
#line 212 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '[')) {
#line 213 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_S_BRACKET;
#line 213 "../lib/equation-lexer.vala"
		return result;
#line 1173 "equation-lexer.c"
	}
#line 215 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ']')) {
#line 216 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_S_BRACKET;
#line 216 "../lib/equation-lexer.vala"
		return result;
#line 1181 "equation-lexer.c"
	}
#line 218 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '{')) {
#line 219 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_C_BRACKET;
#line 219 "../lib/equation-lexer.vala"
		return result;
#line 1189 "equation-lexer.c"
	}
#line 221 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '}')) {
#line 222 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_C_BRACKET;
#line 222 "../lib/equation-lexer.vala"
		return result;
#line 1197 "equation-lexer.c"
	}
#line 224 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '|')) {
#line 225 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ABS;
#line 225 "../lib/equation-lexer.vala"
		return result;
#line 1205 "equation-lexer.c"
	}
#line 227 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '^')) {
#line 228 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_POWER;
#line 228 "../lib/equation-lexer.vala"
		return result;
#line 1213 "equation-lexer.c"
	}
#line 230 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '!')) {
#line 231 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_FACTORIAL;
#line 231 "../lib/equation-lexer.vala"
		return result;
#line 1221 "equation-lexer.c"
	}
#line 233 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '%')) {
#line 234 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PERCENTAGE;
#line 234 "../lib/equation-lexer.vala"
		return result;
#line 1229 "equation-lexer.c"
	}
#line 236 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ';')) {
#line 237 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ARGUMENT_SEPARATOR;
#line 237 "../lib/equation-lexer.vala"
		return result;
#line 1237 "equation-lexer.c"
	}
#line 239 "../lib/equation-lexer.vala"
	if (c == 187U) {
#line 240 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_SHIFT_RIGHT;
#line 240 "../lib/equation-lexer.vala"
		return result;
#line 1245 "equation-lexer.c"
	}
#line 242 "../lib/equation-lexer.vala"
	if (c == 171U) {
#line 243 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_SHIFT_LEFT;
#line 243 "../lib/equation-lexer.vala"
		return result;
#line 1253 "equation-lexer.c"
	}
#line 245 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ' ')) {
#line 245 "../lib/equation-lexer.vala"
		_tmp51_ = TRUE;
#line 1259 "equation-lexer.c"
	} else {
#line 245 "../lib/equation-lexer.vala"
		_tmp51_ = c == ((gunichar) '\r');
#line 1263 "equation-lexer.c"
	}
#line 245 "../lib/equation-lexer.vala"
	if (_tmp51_) {
#line 245 "../lib/equation-lexer.vala"
		_tmp50_ = TRUE;
#line 1269 "equation-lexer.c"
	} else {
#line 245 "../lib/equation-lexer.vala"
		_tmp50_ = c == ((gunichar) '\t');
#line 1273 "equation-lexer.c"
	}
#line 245 "../lib/equation-lexer.vala"
	if (_tmp50_) {
#line 245 "../lib/equation-lexer.vala"
		_tmp49_ = TRUE;
#line 1279 "equation-lexer.c"
	} else {
#line 245 "../lib/equation-lexer.vala"
		_tmp49_ = c == ((gunichar) '\n');
#line 1283 "equation-lexer.c"
	}
#line 245 "../lib/equation-lexer.vala"
	if (_tmp49_) {
#line 246 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SKIP;
#line 246 "../lib/equation-lexer.vala"
		return result;
#line 1291 "equation-lexer.c"
	}
#line 248 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '@')) {
#line 249 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_FUNC_DESC_SEPARATOR;
#line 249 "../lib/equation-lexer.vala"
		return result;
#line 1299 "equation-lexer.c"
	}
#line 251 "../lib/equation-lexer.vala"
	result = LEXER_TOKEN_TYPE_UNKNOWN;
#line 251 "../lib/equation-lexer.vala"
	return result;
#line 1305 "equation-lexer.c"
}

static void
pre_lexer_class_init (PreLexerClass * klass,
                      gpointer klass_data)
{
#line 75 "../lib/equation-lexer.vala"
	pre_lexer_parent_class = g_type_class_peek_parent (klass);
#line 75 "../lib/equation-lexer.vala"
	g_type_class_adjust_private_offset (klass, &PreLexer_private_offset);
#line 75 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (klass)->finalize = pre_lexer_finalize;
#line 1318 "equation-lexer.c"
}

static void
pre_lexer_instance_init (PreLexer * self,
                         gpointer klass)
{
#line 75 "../lib/equation-lexer.vala"
	self->priv = pre_lexer_get_instance_private (self);
#line 80 "../lib/equation-lexer.vala"
	self->priv->eos = FALSE;
#line 1329 "equation-lexer.c"
}

static void
pre_lexer_finalize (GObject * obj)
{
	PreLexer * self;
#line 75 "../lib/equation-lexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PRE_LEXER, PreLexer);
#line 77 "../lib/equation-lexer.vala"
	_g_free0 (self->stream);
#line 75 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (pre_lexer_parent_class)->finalize (obj);
#line 1342 "equation-lexer.c"
}

static GType
pre_lexer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreLexerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pre_lexer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreLexer), 0, (GInstanceInitFunc) pre_lexer_instance_init, NULL };
	GType pre_lexer_type_id;
	pre_lexer_type_id = g_type_register_static (G_TYPE_OBJECT, "PreLexer", &g_define_type_info, 0);
	PreLexer_private_offset = g_type_add_instance_private (pre_lexer_type_id, sizeof (PreLexerPrivate));
	return pre_lexer_type_id;
}

GType
pre_lexer_get_type (void)
{
	static volatile gsize pre_lexer_type_id__once = 0;
	if (g_once_init_enter (&pre_lexer_type_id__once)) {
		GType pre_lexer_type_id;
		pre_lexer_type_id = pre_lexer_get_type_once ();
		g_once_init_leave (&pre_lexer_type_id__once, pre_lexer_type_id);
	}
	return pre_lexer_type_id__once;
}

LexerToken*
lexer_token_construct (GType object_type)
{
	LexerToken * self = NULL;
#line 256 "../lib/equation-lexer.vala"
	self = (LexerToken*) g_object_new (object_type, NULL);
#line 256 "../lib/equation-lexer.vala"
	return self;
#line 1375 "equation-lexer.c"
}

LexerToken*
lexer_token_new (void)
{
#line 256 "../lib/equation-lexer.vala"
	return lexer_token_construct (TYPE_LEXER_TOKEN);
#line 1383 "equation-lexer.c"
}

static void
lexer_token_class_init (LexerTokenClass * klass,
                        gpointer klass_data)
{
#line 256 "../lib/equation-lexer.vala"
	lexer_token_parent_class = g_type_class_peek_parent (klass);
#line 256 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (klass)->finalize = lexer_token_finalize;
#line 1394 "equation-lexer.c"
}

static void
lexer_token_instance_init (LexerToken * self,
                           gpointer klass)
{
}

static void
lexer_token_finalize (GObject * obj)
{
	LexerToken * self;
#line 256 "../lib/equation-lexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LEXER_TOKEN, LexerToken);
#line 258 "../lib/equation-lexer.vala"
	_g_free0 (self->text);
#line 256 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (lexer_token_parent_class)->finalize (obj);
#line 1413 "equation-lexer.c"
}

static GType
lexer_token_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LexerTokenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lexer_token_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LexerToken), 0, (GInstanceInitFunc) lexer_token_instance_init, NULL };
	GType lexer_token_type_id;
	lexer_token_type_id = g_type_register_static (G_TYPE_OBJECT, "LexerToken", &g_define_type_info, 0);
	return lexer_token_type_id;
}

GType
lexer_token_get_type (void)
{
	static volatile gsize lexer_token_type_id__once = 0;
	if (g_once_init_enter (&lexer_token_type_id__once)) {
		GType lexer_token_type_id;
		lexer_token_type_id = lexer_token_get_type_once ();
		g_once_init_leave (&lexer_token_type_id__once, lexer_token_type_id);
	}
	return lexer_token_type_id__once;
}

static inline gpointer
lexer_get_instance_private (Lexer* self)
{
	return G_STRUCT_MEMBER_P (self, Lexer_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 269 "../lib/equation-lexer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1448 "equation-lexer.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 269 "../lib/equation-lexer.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1456 "equation-lexer.c"
}

static gpointer
_parser_ref0 (gpointer self)
{
#line 278 "../lib/equation-lexer.vala"
	return self ? parser_ref (self) : NULL;
#line 1464 "equation-lexer.c"
}

Lexer*
lexer_construct (GType object_type,
                 const gchar* input,
                 Parser* parser,
                 gint number_base)
{
	Lexer * self = NULL;
	PreLexer* _tmp0_;
	Parser* _tmp1_;
#line 273 "../lib/equation-lexer.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 273 "../lib/equation-lexer.vala"
	g_return_val_if_fail (parser != NULL, NULL);
#line 273 "../lib/equation-lexer.vala"
	self = (Lexer*) g_object_new (object_type, NULL);
#line 275 "../lib/equation-lexer.vala"
	_tmp0_ = pre_lexer_new (input);
#line 275 "../lib/equation-lexer.vala"
	_g_object_unref0 (self->priv->prelexer);
#line 275 "../lib/equation-lexer.vala"
	self->priv->prelexer = _tmp0_;
#line 276 "../lib/equation-lexer.vala"
	(self->tokens == NULL) ? NULL : (self->tokens = (_g_list_free__g_object_unref0_ (self->tokens), NULL));
#line 276 "../lib/equation-lexer.vala"
	self->tokens = NULL;
#line 277 "../lib/equation-lexer.vala"
	self->priv->next_token = (guint) 0;
#line 278 "../lib/equation-lexer.vala"
	_tmp1_ = _parser_ref0 (parser);
#line 278 "../lib/equation-lexer.vala"
	_parser_unref0 (self->priv->parser);
#line 278 "../lib/equation-lexer.vala"
	self->priv->parser = _tmp1_;
#line 279 "../lib/equation-lexer.vala"
	self->priv->number_base = number_base;
#line 273 "../lib/equation-lexer.vala"
	return self;
#line 1504 "equation-lexer.c"
}

Lexer*
lexer_new (const gchar* input,
           Parser* parser,
           gint number_base)
{
#line 273 "../lib/equation-lexer.vala"
	return lexer_construct (TYPE_LEXER, input, parser, number_base);
#line 1514 "equation-lexer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 287 "../lib/equation-lexer.vala"
	return self ? g_object_ref (self) : NULL;
#line 1522 "equation-lexer.c"
}

void
lexer_scan (Lexer* self)
{
#line 282 "../lib/equation-lexer.vala"
	g_return_if_fail (self != NULL);
#line 284 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 1532 "equation-lexer.c"
		LexerToken* token = NULL;
		LexerToken* _tmp0_;
		LexerToken* _tmp1_;
		LexerToken* _tmp2_;
		LexerToken* _tmp3_;
#line 286 "../lib/equation-lexer.vala"
		_tmp0_ = lexer_insert_next_token (self);
#line 286 "../lib/equation-lexer.vala"
		token = _tmp0_;
#line 287 "../lib/equation-lexer.vala"
		_tmp1_ = token;
#line 287 "../lib/equation-lexer.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 287 "../lib/equation-lexer.vala"
		self->tokens = g_list_append (self->tokens, _tmp2_);
#line 288 "../lib/equation-lexer.vala"
		_tmp3_ = token;
#line 288 "../lib/equation-lexer.vala"
		if (_tmp3_->type == LEXER_TOKEN_TYPE_PL_EOS) {
#line 289 "../lib/equation-lexer.vala"
			_g_object_unref0 (token);
#line 289 "../lib/equation-lexer.vala"
			break;
#line 1556 "equation-lexer.c"
		}
#line 284 "../lib/equation-lexer.vala"
		_g_object_unref0 (token);
#line 1560 "equation-lexer.c"
	}
}

LexerToken*
lexer_get_next_token (Lexer* self)
{
	GList* _tmp0_;
	GList* _tmp5_;
	guint _tmp6_;
	gconstpointer _tmp7_;
	LexerToken* _tmp8_;
	LexerToken* result;
#line 294 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 296 "../lib/equation-lexer.vala"
	_tmp0_ = self->tokens;
#line 296 "../lib/equation-lexer.vala"
	if (self->priv->next_token >= g_list_length (_tmp0_)) {
#line 1579 "equation-lexer.c"
		GList* _tmp1_;
		GList* _tmp2_;
		gconstpointer _tmp3_;
		LexerToken* _tmp4_;
#line 297 "../lib/equation-lexer.vala"
		_tmp1_ = self->tokens;
#line 297 "../lib/equation-lexer.vala"
		_tmp2_ = self->tokens;
#line 297 "../lib/equation-lexer.vala"
		_tmp3_ = g_list_nth_data (_tmp1_, g_list_length (_tmp2_) - 1);
#line 297 "../lib/equation-lexer.vala"
		_tmp4_ = _g_object_ref0 ((LexerToken*) _tmp3_);
#line 297 "../lib/equation-lexer.vala"
		result = _tmp4_;
#line 297 "../lib/equation-lexer.vala"
		return result;
#line 1596 "equation-lexer.c"
	}
#line 298 "../lib/equation-lexer.vala"
	_tmp5_ = self->tokens;
#line 298 "../lib/equation-lexer.vala"
	_tmp6_ = self->priv->next_token;
#line 298 "../lib/equation-lexer.vala"
	self->priv->next_token = _tmp6_ + 1;
#line 298 "../lib/equation-lexer.vala"
	_tmp7_ = g_list_nth_data (_tmp5_, _tmp6_);
#line 298 "../lib/equation-lexer.vala"
	_tmp8_ = _g_object_ref0 ((LexerToken*) _tmp7_);
#line 298 "../lib/equation-lexer.vala"
	result = _tmp8_;
#line 298 "../lib/equation-lexer.vala"
	return result;
#line 1612 "equation-lexer.c"
}

void
lexer_roll_back (Lexer* self)
{
#line 302 "../lib/equation-lexer.vala"
	g_return_if_fail (self != NULL);
#line 304 "../lib/equation-lexer.vala"
	if (self->priv->next_token > ((guint) 0)) {
#line 1622 "equation-lexer.c"
		guint _tmp0_;
#line 305 "../lib/equation-lexer.vala"
		_tmp0_ = self->priv->next_token;
#line 305 "../lib/equation-lexer.vala"
		self->priv->next_token = _tmp0_ - 1;
#line 1628 "equation-lexer.c"
	}
}

static gboolean
lexer_check_if_function (Lexer* self)
{
	gchar* name = NULL;
	PreLexer* _tmp0_;
	gchar* _tmp1_;
	Parser* _tmp2_;
	gboolean result;
#line 308 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 310 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 310 "../lib/equation-lexer.vala"
	_tmp1_ = pre_lexer_get_marked_substring (_tmp0_);
#line 310 "../lib/equation-lexer.vala"
	name = _tmp1_;
#line 311 "../lib/equation-lexer.vala"
	_tmp2_ = self->priv->parser;
#line 311 "../lib/equation-lexer.vala"
	result = parser_function_is_defined (_tmp2_, name);
#line 311 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 311 "../lib/equation-lexer.vala"
	return result;
#line 1656 "equation-lexer.c"
}

static gboolean
lexer_check_if_unit (Lexer* self)
{
	gint super_count = 0;
	PreLexer* _tmp2_;
	gchar* name = NULL;
	PreLexer* _tmp3_;
	gchar* _tmp4_;
	Parser* _tmp5_;
	const gchar* _tmp6_;
	PreLexer* _tmp9_;
	gchar* _tmp10_;
	Parser* _tmp11_;
	const gchar* _tmp12_;
	gboolean result;
#line 314 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 316 "../lib/equation-lexer.vala"
	super_count = 0;
#line 317 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 1680 "equation-lexer.c"
		PreLexer* _tmp0_;
		gint _tmp1_;
#line 317 "../lib/equation-lexer.vala"
		_tmp0_ = self->priv->prelexer;
#line 317 "../lib/equation-lexer.vala"
		if (!(pre_lexer_get_next_token (_tmp0_) == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT)) {
#line 317 "../lib/equation-lexer.vala"
			break;
#line 1689 "equation-lexer.c"
		}
#line 318 "../lib/equation-lexer.vala"
		_tmp1_ = super_count;
#line 318 "../lib/equation-lexer.vala"
		super_count = _tmp1_ + 1;
#line 1695 "equation-lexer.c"
	}
#line 320 "../lib/equation-lexer.vala"
	_tmp2_ = self->priv->prelexer;
#line 320 "../lib/equation-lexer.vala"
	pre_lexer_roll_back (_tmp2_);
#line 322 "../lib/equation-lexer.vala"
	_tmp3_ = self->priv->prelexer;
#line 322 "../lib/equation-lexer.vala"
	_tmp4_ = pre_lexer_get_marked_substring (_tmp3_);
#line 322 "../lib/equation-lexer.vala"
	name = _tmp4_;
#line 323 "../lib/equation-lexer.vala"
	_tmp5_ = self->priv->parser;
#line 323 "../lib/equation-lexer.vala"
	_tmp6_ = name;
#line 323 "../lib/equation-lexer.vala"
	if (parser_unit_is_defined (_tmp5_, _tmp6_)) {
#line 324 "../lib/equation-lexer.vala"
		result = TRUE;
#line 324 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 324 "../lib/equation-lexer.vala"
		return result;
#line 1719 "equation-lexer.c"
	}
#line 326 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 1723 "equation-lexer.c"
		gint _tmp7_;
		PreLexer* _tmp8_;
#line 326 "../lib/equation-lexer.vala"
		_tmp7_ = super_count;
#line 326 "../lib/equation-lexer.vala"
		super_count = _tmp7_ - 1;
#line 326 "../lib/equation-lexer.vala"
		if (!(_tmp7_ > 0)) {
#line 326 "../lib/equation-lexer.vala"
			break;
#line 1734 "equation-lexer.c"
		}
#line 327 "../lib/equation-lexer.vala"
		_tmp8_ = self->priv->prelexer;
#line 327 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp8_);
#line 1740 "equation-lexer.c"
	}
#line 329 "../lib/equation-lexer.vala"
	_tmp9_ = self->priv->prelexer;
#line 329 "../lib/equation-lexer.vala"
	_tmp10_ = pre_lexer_get_marked_substring (_tmp9_);
#line 329 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 329 "../lib/equation-lexer.vala"
	name = _tmp10_;
#line 330 "../lib/equation-lexer.vala"
	_tmp11_ = self->priv->parser;
#line 330 "../lib/equation-lexer.vala"
	_tmp12_ = name;
#line 330 "../lib/equation-lexer.vala"
	result = parser_unit_is_defined (_tmp11_, _tmp12_);
#line 330 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 330 "../lib/equation-lexer.vala"
	return result;
#line 1760 "equation-lexer.c"
}

static gboolean
lexer_check_if_literal_base (Lexer* self)
{
	gchar* name = NULL;
	PreLexer* _tmp0_;
	gchar* _tmp1_;
	Parser* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 333 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 335 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 335 "../lib/equation-lexer.vala"
	_tmp1_ = pre_lexer_get_marked_substring (_tmp0_);
#line 335 "../lib/equation-lexer.vala"
	name = _tmp1_;
#line 336 "../lib/equation-lexer.vala"
	_tmp2_ = self->priv->parser;
#line 336 "../lib/equation-lexer.vala"
	_tmp3_ = g_utf8_strdown (name, (gssize) -1);
#line 336 "../lib/equation-lexer.vala"
	_tmp4_ = _tmp3_;
#line 336 "../lib/equation-lexer.vala"
	_tmp5_ = parser_literal_base_is_defined (_tmp2_, _tmp4_);
#line 336 "../lib/equation-lexer.vala"
	_g_free0 (_tmp4_);
#line 336 "../lib/equation-lexer.vala"
	result = _tmp5_;
#line 336 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 336 "../lib/equation-lexer.vala"
	return result;
#line 1798 "equation-lexer.c"
}

static gboolean
lexer_check_if_number (Lexer* self)
{
	gint count = 0;
	gchar* text = NULL;
	PreLexer* _tmp0_;
	gchar* _tmp1_;
	Number* tmp = NULL;
	const gchar* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	gboolean result;
#line 339 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 341 "../lib/equation-lexer.vala"
	count = 0;
#line 342 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 342 "../lib/equation-lexer.vala"
	_tmp1_ = pre_lexer_get_marked_substring (_tmp0_);
#line 342 "../lib/equation-lexer.vala"
	text = _tmp1_;
#line 344 "../lib/equation-lexer.vala"
	_tmp2_ = text;
#line 344 "../lib/equation-lexer.vala"
	_tmp3_ = mp_set_from_string (_tmp2_, self->priv->number_base);
#line 344 "../lib/equation-lexer.vala"
	tmp = _tmp3_;
#line 345 "../lib/equation-lexer.vala"
	_tmp4_ = tmp;
#line 345 "../lib/equation-lexer.vala"
	if (_tmp4_ != NULL) {
#line 346 "../lib/equation-lexer.vala"
		result = TRUE;
#line 346 "../lib/equation-lexer.vala"
		_g_object_unref0 (tmp);
#line 346 "../lib/equation-lexer.vala"
		_g_free0 (text);
#line 346 "../lib/equation-lexer.vala"
		return result;
#line 1841 "equation-lexer.c"
	} else {
#line 350 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 1845 "equation-lexer.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			Number* _tmp7_;
			Number* _tmp8_;
			gint _tmp9_;
			PreLexer* _tmp10_;
			PreLexer* _tmp11_;
			gchar* _tmp12_;
#line 350 "../lib/equation-lexer.vala"
			_tmp5_ = text;
#line 350 "../lib/equation-lexer.vala"
			if (!(g_strcmp0 (_tmp5_, "") != 0)) {
#line 350 "../lib/equation-lexer.vala"
				break;
#line 1860 "equation-lexer.c"
			}
#line 352 "../lib/equation-lexer.vala"
			_tmp6_ = text;
#line 352 "../lib/equation-lexer.vala"
			_tmp7_ = mp_set_from_string (_tmp6_, self->priv->number_base);
#line 352 "../lib/equation-lexer.vala"
			_g_object_unref0 (tmp);
#line 352 "../lib/equation-lexer.vala"
			tmp = _tmp7_;
#line 353 "../lib/equation-lexer.vala"
			_tmp8_ = tmp;
#line 353 "../lib/equation-lexer.vala"
			if (_tmp8_ != NULL) {
#line 354 "../lib/equation-lexer.vala"
				result = TRUE;
#line 354 "../lib/equation-lexer.vala"
				_g_object_unref0 (tmp);
#line 354 "../lib/equation-lexer.vala"
				_g_free0 (text);
#line 354 "../lib/equation-lexer.vala"
				return result;
#line 1882 "equation-lexer.c"
			}
#line 355 "../lib/equation-lexer.vala"
			_tmp9_ = count;
#line 355 "../lib/equation-lexer.vala"
			count = _tmp9_ + 1;
#line 356 "../lib/equation-lexer.vala"
			_tmp10_ = self->priv->prelexer;
#line 356 "../lib/equation-lexer.vala"
			pre_lexer_roll_back (_tmp10_);
#line 357 "../lib/equation-lexer.vala"
			_tmp11_ = self->priv->prelexer;
#line 357 "../lib/equation-lexer.vala"
			_tmp12_ = pre_lexer_get_marked_substring (_tmp11_);
#line 357 "../lib/equation-lexer.vala"
			_g_free0 (text);
#line 357 "../lib/equation-lexer.vala"
			text = _tmp12_;
#line 1900 "equation-lexer.c"
		}
#line 361 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 1904 "equation-lexer.c"
			gint _tmp13_;
			PreLexer* _tmp14_;
#line 361 "../lib/equation-lexer.vala"
			_tmp13_ = count;
#line 361 "../lib/equation-lexer.vala"
			count = _tmp13_ - 1;
#line 361 "../lib/equation-lexer.vala"
			if (!(_tmp13_ > 0)) {
#line 361 "../lib/equation-lexer.vala"
				break;
#line 1915 "equation-lexer.c"
			}
#line 362 "../lib/equation-lexer.vala"
			_tmp14_ = self->priv->prelexer;
#line 362 "../lib/equation-lexer.vala"
			pre_lexer_get_next_token (_tmp14_);
#line 1921 "equation-lexer.c"
		}
#line 364 "../lib/equation-lexer.vala"
		result = FALSE;
#line 364 "../lib/equation-lexer.vala"
		_g_object_unref0 (tmp);
#line 364 "../lib/equation-lexer.vala"
		_g_free0 (text);
#line 364 "../lib/equation-lexer.vala"
		return result;
#line 1931 "equation-lexer.c"
	}
}

static LexerToken*
lexer_insert_token (Lexer* self,
                    LexerTokenType type)
{
	LexerToken* token = NULL;
	LexerToken* _tmp0_;
	PreLexer* _tmp1_;
	gchar* _tmp2_;
	PreLexer* _tmp3_;
	PreLexer* _tmp4_;
	LexerToken* result;
#line 369 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 371 "../lib/equation-lexer.vala"
	_tmp0_ = lexer_token_new ();
#line 371 "../lib/equation-lexer.vala"
	token = _tmp0_;
#line 372 "../lib/equation-lexer.vala"
	_tmp1_ = self->priv->prelexer;
#line 372 "../lib/equation-lexer.vala"
	_tmp2_ = pre_lexer_get_marked_substring (_tmp1_);
#line 372 "../lib/equation-lexer.vala"
	_g_free0 (token->text);
#line 372 "../lib/equation-lexer.vala"
	token->text = _tmp2_;
#line 373 "../lib/equation-lexer.vala"
	_tmp3_ = self->priv->prelexer;
#line 373 "../lib/equation-lexer.vala"
	token->start_index = (guint) _tmp3_->mark_index;
#line 374 "../lib/equation-lexer.vala"
	_tmp4_ = self->priv->prelexer;
#line 374 "../lib/equation-lexer.vala"
	token->end_index = (guint) _tmp4_->index;
#line 375 "../lib/equation-lexer.vala"
	token->type = type;
#line 377 "../lib/equation-lexer.vala"
	result = token;
#line 377 "../lib/equation-lexer.vala"
	return result;
#line 1974 "equation-lexer.c"
}

static LexerToken*
lexer_insert_next_token (Lexer* self)
{
	PreLexer* _tmp0_;
	LexerTokenType type = 0;
	PreLexer* _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	Parser* _tmp61_;
	PreLexer* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	PreLexer* _tmp65_;
	PreLexer* _tmp66_;
	LexerToken* _tmp67_;
	LexerToken* result;
#line 381 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 384 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 384 "../lib/equation-lexer.vala"
	pre_lexer_set_marker (_tmp0_);
#line 387 "../lib/equation-lexer.vala"
	_tmp1_ = self->priv->prelexer;
#line 387 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp1_);
#line 389 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 2032 "equation-lexer.c"
		PreLexer* _tmp2_;
		PreLexer* _tmp3_;
#line 389 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_SKIP)) {
#line 389 "../lib/equation-lexer.vala"
			break;
#line 2039 "equation-lexer.c"
		}
#line 391 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 391 "../lib/equation-lexer.vala"
		pre_lexer_set_marker (_tmp2_);
#line 392 "../lib/equation-lexer.vala"
		_tmp3_ = self->priv->prelexer;
#line 392 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp3_);
#line 2049 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_AND) {
#line 395 "../lib/equation-lexer.vala"
		_tmp32_ = TRUE;
#line 2055 "equation-lexer.c"
	} else {
#line 395 "../lib/equation-lexer.vala"
		_tmp32_ = type == LEXER_TOKEN_TYPE_OR;
#line 2059 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp32_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp31_ = TRUE;
#line 2065 "equation-lexer.c"
	} else {
#line 395 "../lib/equation-lexer.vala"
		_tmp31_ = type == LEXER_TOKEN_TYPE_XOR;
#line 2069 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp31_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp30_ = TRUE;
#line 2075 "equation-lexer.c"
	} else {
#line 395 "../lib/equation-lexer.vala"
		_tmp30_ = type == LEXER_TOKEN_TYPE_NOT;
#line 2079 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp30_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp29_ = TRUE;
#line 2085 "equation-lexer.c"
	} else {
#line 396 "../lib/equation-lexer.vala"
		_tmp29_ = type == LEXER_TOKEN_TYPE_ADD;
#line 2089 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp29_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp28_ = TRUE;
#line 2095 "equation-lexer.c"
	} else {
#line 396 "../lib/equation-lexer.vala"
		_tmp28_ = type == LEXER_TOKEN_TYPE_SUBTRACT;
#line 2099 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp28_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp27_ = TRUE;
#line 2105 "equation-lexer.c"
	} else {
#line 396 "../lib/equation-lexer.vala"
		_tmp27_ = type == LEXER_TOKEN_TYPE_MULTIPLY;
#line 2109 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp27_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp26_ = TRUE;
#line 2115 "equation-lexer.c"
	} else {
#line 396 "../lib/equation-lexer.vala"
		_tmp26_ = type == LEXER_TOKEN_TYPE_DIVIDE;
#line 2119 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp26_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp25_ = TRUE;
#line 2125 "equation-lexer.c"
	} else {
#line 397 "../lib/equation-lexer.vala"
		_tmp25_ = type == LEXER_TOKEN_TYPE_L_FLOOR;
#line 2129 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp25_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp24_ = TRUE;
#line 2135 "equation-lexer.c"
	} else {
#line 397 "../lib/equation-lexer.vala"
		_tmp24_ = type == LEXER_TOKEN_TYPE_R_FLOOR;
#line 2139 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp24_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp23_ = TRUE;
#line 2145 "equation-lexer.c"
	} else {
#line 397 "../lib/equation-lexer.vala"
		_tmp23_ = type == LEXER_TOKEN_TYPE_L_CEILING;
#line 2149 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp23_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp22_ = TRUE;
#line 2155 "equation-lexer.c"
	} else {
#line 397 "../lib/equation-lexer.vala"
		_tmp22_ = type == LEXER_TOKEN_TYPE_R_CEILING;
#line 2159 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp22_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp21_ = TRUE;
#line 2165 "equation-lexer.c"
	} else {
#line 398 "../lib/equation-lexer.vala"
		_tmp21_ = type == LEXER_TOKEN_TYPE_ROOT;
#line 2169 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp21_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp20_ = TRUE;
#line 2175 "equation-lexer.c"
	} else {
#line 398 "../lib/equation-lexer.vala"
		_tmp20_ = type == LEXER_TOKEN_TYPE_ROOT_3;
#line 2179 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp20_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp19_ = TRUE;
#line 2185 "equation-lexer.c"
	} else {
#line 398 "../lib/equation-lexer.vala"
		_tmp19_ = type == LEXER_TOKEN_TYPE_ROOT_4;
#line 2189 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp19_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp18_ = TRUE;
#line 2195 "equation-lexer.c"
	} else {
#line 398 "../lib/equation-lexer.vala"
		_tmp18_ = type == LEXER_TOKEN_TYPE_ASSIGN;
#line 2199 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp18_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp17_ = TRUE;
#line 2205 "equation-lexer.c"
	} else {
#line 399 "../lib/equation-lexer.vala"
		_tmp17_ = type == LEXER_TOKEN_TYPE_L_R_BRACKET;
#line 2209 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp17_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp16_ = TRUE;
#line 2215 "equation-lexer.c"
	} else {
#line 399 "../lib/equation-lexer.vala"
		_tmp16_ = type == LEXER_TOKEN_TYPE_R_R_BRACKET;
#line 2219 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp16_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp15_ = TRUE;
#line 2225 "equation-lexer.c"
	} else {
#line 399 "../lib/equation-lexer.vala"
		_tmp15_ = type == LEXER_TOKEN_TYPE_L_S_BRACKET;
#line 2229 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp15_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp14_ = TRUE;
#line 2235 "equation-lexer.c"
	} else {
#line 400 "../lib/equation-lexer.vala"
		_tmp14_ = type == LEXER_TOKEN_TYPE_R_S_BRACKET;
#line 2239 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp14_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp13_ = TRUE;
#line 2245 "equation-lexer.c"
	} else {
#line 400 "../lib/equation-lexer.vala"
		_tmp13_ = type == LEXER_TOKEN_TYPE_L_C_BRACKET;
#line 2249 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp13_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp12_ = TRUE;
#line 2255 "equation-lexer.c"
	} else {
#line 400 "../lib/equation-lexer.vala"
		_tmp12_ = type == LEXER_TOKEN_TYPE_R_C_BRACKET;
#line 2259 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp12_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp11_ = TRUE;
#line 2265 "equation-lexer.c"
	} else {
#line 401 "../lib/equation-lexer.vala"
		_tmp11_ = type == LEXER_TOKEN_TYPE_ABS;
#line 2269 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp11_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp10_ = TRUE;
#line 2275 "equation-lexer.c"
	} else {
#line 401 "../lib/equation-lexer.vala"
		_tmp10_ = type == LEXER_TOKEN_TYPE_POWER;
#line 2279 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp10_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp9_ = TRUE;
#line 2285 "equation-lexer.c"
	} else {
#line 401 "../lib/equation-lexer.vala"
		_tmp9_ = type == LEXER_TOKEN_TYPE_FACTORIAL;
#line 2289 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp9_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp8_ = TRUE;
#line 2295 "equation-lexer.c"
	} else {
#line 401 "../lib/equation-lexer.vala"
		_tmp8_ = type == LEXER_TOKEN_TYPE_PERCENTAGE;
#line 2299 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp8_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp7_ = TRUE;
#line 2305 "equation-lexer.c"
	} else {
#line 402 "../lib/equation-lexer.vala"
		_tmp7_ = type == LEXER_TOKEN_TYPE_ARGUMENT_SEPARATOR;
#line 2309 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp7_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp6_ = TRUE;
#line 2315 "equation-lexer.c"
	} else {
#line 402 "../lib/equation-lexer.vala"
		_tmp6_ = type == LEXER_TOKEN_TYPE_SHIFT_LEFT;
#line 2319 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp6_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp5_ = TRUE;
#line 2325 "equation-lexer.c"
	} else {
#line 402 "../lib/equation-lexer.vala"
		_tmp5_ = type == LEXER_TOKEN_TYPE_SHIFT_RIGHT;
#line 2329 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp5_) {
#line 395 "../lib/equation-lexer.vala"
		_tmp4_ = TRUE;
#line 2335 "equation-lexer.c"
	} else {
#line 403 "../lib/equation-lexer.vala"
		_tmp4_ = type == LEXER_TOKEN_TYPE_FUNC_DESC_SEPARATOR;
#line 2339 "equation-lexer.c"
	}
#line 395 "../lib/equation-lexer.vala"
	if (_tmp4_) {
#line 2343 "equation-lexer.c"
		LexerToken* _tmp33_;
#line 404 "../lib/equation-lexer.vala"
		_tmp33_ = lexer_insert_token (self, type);
#line 404 "../lib/equation-lexer.vala"
		result = _tmp33_;
#line 404 "../lib/equation-lexer.vala"
		return result;
#line 2351 "equation-lexer.c"
	}
#line 407 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_SUPER_MINUS) {
#line 2355 "equation-lexer.c"
		PreLexer* _tmp34_;
		PreLexer* _tmp43_;
		LexerToken* _tmp44_;
#line 409 "../lib/equation-lexer.vala"
		_tmp34_ = self->priv->prelexer;
#line 409 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp34_);
#line 409 "../lib/equation-lexer.vala"
		if (type != LEXER_TOKEN_TYPE_PL_SUPER_DIGIT) {
#line 2365 "equation-lexer.c"
			Parser* _tmp35_;
			PreLexer* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			PreLexer* _tmp39_;
			PreLexer* _tmp40_;
			LexerToken* _tmp41_;
#line 412 "../lib/equation-lexer.vala"
			_tmp35_ = self->priv->parser;
#line 412 "../lib/equation-lexer.vala"
			_tmp36_ = self->priv->prelexer;
#line 412 "../lib/equation-lexer.vala"
			_tmp37_ = pre_lexer_get_marked_substring (_tmp36_);
#line 412 "../lib/equation-lexer.vala"
			_tmp38_ = _tmp37_;
#line 412 "../lib/equation-lexer.vala"
			_tmp39_ = self->priv->prelexer;
#line 412 "../lib/equation-lexer.vala"
			_tmp40_ = self->priv->prelexer;
#line 412 "../lib/equation-lexer.vala"
			parser_set_error (_tmp35_, ERROR_CODE_MP, _tmp38_, (guint) _tmp39_->mark_index, (guint) _tmp40_->index);
#line 412 "../lib/equation-lexer.vala"
			_g_free0 (_tmp38_);
#line 413 "../lib/equation-lexer.vala"
			_tmp41_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 413 "../lib/equation-lexer.vala"
			result = _tmp41_;
#line 413 "../lib/equation-lexer.vala"
			return result;
#line 2395 "equation-lexer.c"
		}
#line 417 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 2399 "equation-lexer.c"
			PreLexer* _tmp42_;
#line 417 "../lib/equation-lexer.vala"
			_tmp42_ = self->priv->prelexer;
#line 417 "../lib/equation-lexer.vala"
			if (!(pre_lexer_get_next_token (_tmp42_) == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT)) {
#line 417 "../lib/equation-lexer.vala"
				break;
#line 2407 "equation-lexer.c"
			}
		}
#line 418 "../lib/equation-lexer.vala"
		_tmp43_ = self->priv->prelexer;
#line 418 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp43_);
#line 420 "../lib/equation-lexer.vala"
		_tmp44_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NSUP_NUMBER);
#line 420 "../lib/equation-lexer.vala"
		result = _tmp44_;
#line 420 "../lib/equation-lexer.vala"
		return result;
#line 2420 "equation-lexer.c"
	}
#line 424 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT) {
#line 2424 "equation-lexer.c"
		PreLexer* _tmp46_;
		LexerToken* _tmp47_;
#line 426 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 2429 "equation-lexer.c"
			PreLexer* _tmp45_;
#line 426 "../lib/equation-lexer.vala"
			_tmp45_ = self->priv->prelexer;
#line 426 "../lib/equation-lexer.vala"
			if (!(pre_lexer_get_next_token (_tmp45_) == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT)) {
#line 426 "../lib/equation-lexer.vala"
				break;
#line 2437 "equation-lexer.c"
			}
		}
#line 427 "../lib/equation-lexer.vala"
		_tmp46_ = self->priv->prelexer;
#line 427 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp46_);
#line 429 "../lib/equation-lexer.vala"
		_tmp47_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_SUP_NUMBER);
#line 429 "../lib/equation-lexer.vala"
		result = _tmp47_;
#line 429 "../lib/equation-lexer.vala"
		return result;
#line 2450 "equation-lexer.c"
	}
#line 433 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 2454 "equation-lexer.c"
		PreLexer* _tmp49_;
		LexerToken* _tmp50_;
#line 435 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 2459 "equation-lexer.c"
			PreLexer* _tmp48_;
#line 435 "../lib/equation-lexer.vala"
			_tmp48_ = self->priv->prelexer;
#line 435 "../lib/equation-lexer.vala"
			if (!(pre_lexer_get_next_token (_tmp48_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 435 "../lib/equation-lexer.vala"
				break;
#line 2467 "equation-lexer.c"
			}
		}
#line 436 "../lib/equation-lexer.vala"
		_tmp49_ = self->priv->prelexer;
#line 436 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp49_);
#line 438 "../lib/equation-lexer.vala"
		_tmp50_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_SUB_NUMBER);
#line 438 "../lib/equation-lexer.vala"
		result = _tmp50_;
#line 438 "../lib/equation-lexer.vala"
		return result;
#line 2480 "equation-lexer.c"
	}
#line 442 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_FRACTION) {
#line 2484 "equation-lexer.c"
		LexerToken* _tmp51_;
#line 443 "../lib/equation-lexer.vala"
		_tmp51_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 443 "../lib/equation-lexer.vala"
		result = _tmp51_;
#line 443 "../lib/equation-lexer.vala"
		return result;
#line 2492 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 2496 "equation-lexer.c"
		LexerToken* _tmp52_;
#line 446 "../lib/equation-lexer.vala"
		_tmp52_ = lexer_insert_digit (self);
#line 446 "../lib/equation-lexer.vala"
		result = _tmp52_;
#line 446 "../lib/equation-lexer.vala"
		return result;
#line 2504 "equation-lexer.c"
	}
#line 448 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 2508 "equation-lexer.c"
		LexerToken* _tmp53_;
#line 449 "../lib/equation-lexer.vala"
		_tmp53_ = lexer_insert_decimal (self);
#line 449 "../lib/equation-lexer.vala"
		result = _tmp53_;
#line 449 "../lib/equation-lexer.vala"
		return result;
#line 2516 "equation-lexer.c"
	}
#line 451 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 2520 "equation-lexer.c"
		LexerToken* _tmp54_;
#line 452 "../lib/equation-lexer.vala"
		_tmp54_ = lexer_insert_hex (self);
#line 452 "../lib/equation-lexer.vala"
		result = _tmp54_;
#line 452 "../lib/equation-lexer.vala"
		return result;
#line 2528 "equation-lexer.c"
	}
#line 454 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_LETTER) {
#line 2532 "equation-lexer.c"
		LexerToken* _tmp55_;
#line 455 "../lib/equation-lexer.vala"
		_tmp55_ = lexer_insert_letter (self);
#line 455 "../lib/equation-lexer.vala"
		result = _tmp55_;
#line 455 "../lib/equation-lexer.vala"
		return result;
#line 2540 "equation-lexer.c"
	}
#line 457 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DEGREE) {
#line 2544 "equation-lexer.c"
		PreLexer* _tmp56_;
		gboolean _tmp57_ = FALSE;
		gboolean _tmp58_ = FALSE;
#line 459 "../lib/equation-lexer.vala"
		_tmp56_ = self->priv->prelexer;
#line 459 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp56_);
#line 460 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 460 "../lib/equation-lexer.vala"
			_tmp58_ = TRUE;
#line 2556 "equation-lexer.c"
		} else {
#line 460 "../lib/equation-lexer.vala"
			_tmp58_ = type == LEXER_TOKEN_TYPE_PL_LETTER;
#line 2560 "equation-lexer.c"
		}
#line 460 "../lib/equation-lexer.vala"
		if (_tmp58_) {
#line 460 "../lib/equation-lexer.vala"
			_tmp57_ = lexer_check_if_unit (self);
#line 2566 "equation-lexer.c"
		} else {
#line 460 "../lib/equation-lexer.vala"
			_tmp57_ = FALSE;
#line 2570 "equation-lexer.c"
		}
#line 460 "../lib/equation-lexer.vala"
		if (_tmp57_) {
#line 2574 "equation-lexer.c"
			LexerToken* _tmp59_;
#line 461 "../lib/equation-lexer.vala"
			_tmp59_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNIT);
#line 461 "../lib/equation-lexer.vala"
			result = _tmp59_;
#line 461 "../lib/equation-lexer.vala"
			return result;
#line 2582 "equation-lexer.c"
		}
	}
#line 464 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_EOS) {
#line 2587 "equation-lexer.c"
		LexerToken* _tmp60_;
#line 465 "../lib/equation-lexer.vala"
		_tmp60_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_PL_EOS);
#line 465 "../lib/equation-lexer.vala"
		result = _tmp60_;
#line 465 "../lib/equation-lexer.vala"
		return result;
#line 2595 "equation-lexer.c"
	}
#line 468 "../lib/equation-lexer.vala"
	_tmp61_ = self->priv->parser;
#line 468 "../lib/equation-lexer.vala"
	_tmp62_ = self->priv->prelexer;
#line 468 "../lib/equation-lexer.vala"
	_tmp63_ = pre_lexer_get_marked_substring (_tmp62_);
#line 468 "../lib/equation-lexer.vala"
	_tmp64_ = _tmp63_;
#line 468 "../lib/equation-lexer.vala"
	_tmp65_ = self->priv->prelexer;
#line 468 "../lib/equation-lexer.vala"
	_tmp66_ = self->priv->prelexer;
#line 468 "../lib/equation-lexer.vala"
	parser_set_error (_tmp61_, ERROR_CODE_INVALID, _tmp64_, (guint) _tmp65_->mark_index, (guint) _tmp66_->index);
#line 468 "../lib/equation-lexer.vala"
	_g_free0 (_tmp64_);
#line 470 "../lib/equation-lexer.vala"
	_tmp67_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 470 "../lib/equation-lexer.vala"
	result = _tmp67_;
#line 470 "../lib/equation-lexer.vala"
	return result;
#line 2619 "equation-lexer.c"
}

static LexerToken*
lexer_insert_digit (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 473 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 475 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 475 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 476 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 2636 "equation-lexer.c"
		PreLexer* _tmp1_;
#line 476 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 476 "../lib/equation-lexer.vala"
			break;
#line 2642 "equation-lexer.c"
		}
#line 477 "../lib/equation-lexer.vala"
		_tmp1_ = self->priv->prelexer;
#line 477 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp1_);
#line 2648 "equation-lexer.c"
	}
#line 479 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_FRACTION) {
#line 2652 "equation-lexer.c"
		LexerToken* _tmp2_;
#line 480 "../lib/equation-lexer.vala"
		_tmp2_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 480 "../lib/equation-lexer.vala"
		result = _tmp2_;
#line 480 "../lib/equation-lexer.vala"
		return result;
#line 2660 "equation-lexer.c"
	} else {
#line 481 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 2664 "equation-lexer.c"
			PreLexer* _tmp4_;
			LexerToken* _tmp5_;
#line 483 "../lib/equation-lexer.vala"
			while (TRUE) {
#line 2669 "equation-lexer.c"
				PreLexer* _tmp3_;
#line 483 "../lib/equation-lexer.vala"
				_tmp3_ = self->priv->prelexer;
#line 483 "../lib/equation-lexer.vala"
				if (!(pre_lexer_get_next_token (_tmp3_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 483 "../lib/equation-lexer.vala"
					break;
#line 2677 "equation-lexer.c"
				}
			}
#line 484 "../lib/equation-lexer.vala"
			_tmp4_ = self->priv->prelexer;
#line 484 "../lib/equation-lexer.vala"
			pre_lexer_roll_back (_tmp4_);
#line 485 "../lib/equation-lexer.vala"
			_tmp5_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 485 "../lib/equation-lexer.vala"
			result = _tmp5_;
#line 485 "../lib/equation-lexer.vala"
			return result;
#line 2690 "equation-lexer.c"
		} else {
#line 487 "../lib/equation-lexer.vala"
			if (type == LEXER_TOKEN_TYPE_PL_DEGREE) {
#line 2694 "equation-lexer.c"
				PreLexer* _tmp6_;
#line 489 "../lib/equation-lexer.vala"
				_tmp6_ = self->priv->prelexer;
#line 489 "../lib/equation-lexer.vala"
				type = pre_lexer_get_next_token (_tmp6_);
#line 490 "../lib/equation-lexer.vala"
				if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 492 "../lib/equation-lexer.vala"
					while (TRUE) {
#line 2704 "equation-lexer.c"
						PreLexer* _tmp7_;
#line 492 "../lib/equation-lexer.vala"
						_tmp7_ = self->priv->prelexer;
#line 492 "../lib/equation-lexer.vala"
						type = pre_lexer_get_next_token (_tmp7_);
#line 492 "../lib/equation-lexer.vala"
						if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 492 "../lib/equation-lexer.vala"
							break;
#line 2714 "equation-lexer.c"
						}
					}
#line 493 "../lib/equation-lexer.vala"
					if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 2719 "equation-lexer.c"
						LexerToken* _tmp8_;
#line 494 "../lib/equation-lexer.vala"
						_tmp8_ = lexer_insert_angle_num_dm (self);
#line 494 "../lib/equation-lexer.vala"
						result = _tmp8_;
#line 494 "../lib/equation-lexer.vala"
						return result;
#line 2727 "equation-lexer.c"
					} else {
#line 496 "../lib/equation-lexer.vala"
						if (type == LEXER_TOKEN_TYPE_PL_MINUTE) {
#line 2731 "equation-lexer.c"
							PreLexer* _tmp9_;
#line 498 "../lib/equation-lexer.vala"
							_tmp9_ = self->priv->prelexer;
#line 498 "../lib/equation-lexer.vala"
							type = pre_lexer_get_next_token (_tmp9_);
#line 499 "../lib/equation-lexer.vala"
							if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 501 "../lib/equation-lexer.vala"
								while (TRUE) {
#line 2741 "equation-lexer.c"
									PreLexer* _tmp10_;
#line 501 "../lib/equation-lexer.vala"
									_tmp10_ = self->priv->prelexer;
#line 501 "../lib/equation-lexer.vala"
									type = pre_lexer_get_next_token (_tmp10_);
#line 501 "../lib/equation-lexer.vala"
									if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 501 "../lib/equation-lexer.vala"
										break;
#line 2751 "equation-lexer.c"
									}
								}
#line 502 "../lib/equation-lexer.vala"
								if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 2756 "equation-lexer.c"
									LexerToken* _tmp11_;
#line 503 "../lib/equation-lexer.vala"
									_tmp11_ = lexer_insert_angle_num_dms (self);
#line 503 "../lib/equation-lexer.vala"
									result = _tmp11_;
#line 503 "../lib/equation-lexer.vala"
									return result;
#line 2764 "equation-lexer.c"
								} else {
#line 504 "../lib/equation-lexer.vala"
									if (type == LEXER_TOKEN_TYPE_PL_SECOND) {
#line 2768 "equation-lexer.c"
										LexerToken* _tmp12_;
#line 505 "../lib/equation-lexer.vala"
										_tmp12_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 505 "../lib/equation-lexer.vala"
										result = _tmp12_;
#line 505 "../lib/equation-lexer.vala"
										return result;
#line 2776 "equation-lexer.c"
									} else {
										Parser* _tmp13_;
										PreLexer* _tmp14_;
										gchar* _tmp15_;
										gchar* _tmp16_;
										PreLexer* _tmp17_;
										PreLexer* _tmp18_;
										LexerToken* _tmp19_;
#line 509 "../lib/equation-lexer.vala"
										_tmp13_ = self->priv->parser;
#line 509 "../lib/equation-lexer.vala"
										_tmp14_ = self->priv->prelexer;
#line 509 "../lib/equation-lexer.vala"
										_tmp15_ = pre_lexer_get_marked_substring (_tmp14_);
#line 509 "../lib/equation-lexer.vala"
										_tmp16_ = _tmp15_;
#line 509 "../lib/equation-lexer.vala"
										_tmp17_ = self->priv->prelexer;
#line 509 "../lib/equation-lexer.vala"
										_tmp18_ = self->priv->prelexer;
#line 509 "../lib/equation-lexer.vala"
										parser_set_error (_tmp13_, ERROR_CODE_MP, _tmp16_, (guint) _tmp17_->mark_index, (guint) _tmp18_->index);
#line 509 "../lib/equation-lexer.vala"
										_g_free0 (_tmp16_);
#line 510 "../lib/equation-lexer.vala"
										_tmp19_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 510 "../lib/equation-lexer.vala"
										result = _tmp19_;
#line 510 "../lib/equation-lexer.vala"
										return result;
#line 2807 "equation-lexer.c"
									}
								}
							} else {
#line 513 "../lib/equation-lexer.vala"
								if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 2813 "equation-lexer.c"
									LexerToken* _tmp20_;
#line 514 "../lib/equation-lexer.vala"
									_tmp20_ = lexer_insert_angle_num_dms (self);
#line 514 "../lib/equation-lexer.vala"
									result = _tmp20_;
#line 514 "../lib/equation-lexer.vala"
									return result;
#line 2821 "equation-lexer.c"
								} else {
									PreLexer* _tmp21_;
									LexerToken* _tmp22_;
#line 517 "../lib/equation-lexer.vala"
									_tmp21_ = self->priv->prelexer;
#line 517 "../lib/equation-lexer.vala"
									pre_lexer_roll_back (_tmp21_);
#line 518 "../lib/equation-lexer.vala"
									_tmp22_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 518 "../lib/equation-lexer.vala"
									result = _tmp22_;
#line 518 "../lib/equation-lexer.vala"
									return result;
#line 2835 "equation-lexer.c"
								}
							}
						} else {
							Parser* _tmp23_;
							PreLexer* _tmp24_;
							gchar* _tmp25_;
							gchar* _tmp26_;
							PreLexer* _tmp27_;
							PreLexer* _tmp28_;
							LexerToken* _tmp29_;
#line 524 "../lib/equation-lexer.vala"
							_tmp23_ = self->priv->parser;
#line 524 "../lib/equation-lexer.vala"
							_tmp24_ = self->priv->prelexer;
#line 524 "../lib/equation-lexer.vala"
							_tmp25_ = pre_lexer_get_marked_substring (_tmp24_);
#line 524 "../lib/equation-lexer.vala"
							_tmp26_ = _tmp25_;
#line 524 "../lib/equation-lexer.vala"
							_tmp27_ = self->priv->prelexer;
#line 524 "../lib/equation-lexer.vala"
							_tmp28_ = self->priv->prelexer;
#line 524 "../lib/equation-lexer.vala"
							parser_set_error (_tmp23_, ERROR_CODE_MP, _tmp26_, (guint) _tmp27_->mark_index, (guint) _tmp28_->index);
#line 524 "../lib/equation-lexer.vala"
							_g_free0 (_tmp26_);
#line 525 "../lib/equation-lexer.vala"
							_tmp29_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 525 "../lib/equation-lexer.vala"
							result = _tmp29_;
#line 525 "../lib/equation-lexer.vala"
							return result;
#line 2868 "equation-lexer.c"
						}
					}
				} else {
#line 528 "../lib/equation-lexer.vala"
					if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 2874 "equation-lexer.c"
						LexerToken* _tmp30_;
#line 529 "../lib/equation-lexer.vala"
						_tmp30_ = lexer_insert_angle_num_dm (self);
#line 529 "../lib/equation-lexer.vala"
						result = _tmp30_;
#line 529 "../lib/equation-lexer.vala"
						return result;
#line 2882 "equation-lexer.c"
					} else {
						LexerToken* _tmp31_;
#line 531 "../lib/equation-lexer.vala"
						_tmp31_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 531 "../lib/equation-lexer.vala"
						result = _tmp31_;
#line 531 "../lib/equation-lexer.vala"
						return result;
#line 2891 "equation-lexer.c"
					}
				}
			} else {
#line 533 "../lib/equation-lexer.vala"
				if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 2897 "equation-lexer.c"
					LexerToken* _tmp32_;
#line 534 "../lib/equation-lexer.vala"
					_tmp32_ = lexer_insert_decimal (self);
#line 534 "../lib/equation-lexer.vala"
					result = _tmp32_;
#line 534 "../lib/equation-lexer.vala"
					return result;
#line 2905 "equation-lexer.c"
				} else {
#line 535 "../lib/equation-lexer.vala"
					if (lexer_check_if_literal_base (self)) {
#line 2909 "equation-lexer.c"
						LexerToken* _tmp33_;
#line 536 "../lib/equation-lexer.vala"
						_tmp33_ = lexer_insert_hex (self);
#line 536 "../lib/equation-lexer.vala"
						result = _tmp33_;
#line 536 "../lib/equation-lexer.vala"
						return result;
#line 2917 "equation-lexer.c"
					} else {
#line 537 "../lib/equation-lexer.vala"
						if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 2921 "equation-lexer.c"
							LexerToken* _tmp34_;
#line 538 "../lib/equation-lexer.vala"
							_tmp34_ = lexer_insert_hex_dec (self);
#line 538 "../lib/equation-lexer.vala"
							result = _tmp34_;
#line 538 "../lib/equation-lexer.vala"
							return result;
#line 2929 "equation-lexer.c"
						} else {
							PreLexer* _tmp35_;
							LexerToken* _tmp36_;
#line 541 "../lib/equation-lexer.vala"
							_tmp35_ = self->priv->prelexer;
#line 541 "../lib/equation-lexer.vala"
							pre_lexer_roll_back (_tmp35_);
#line 542 "../lib/equation-lexer.vala"
							_tmp36_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 542 "../lib/equation-lexer.vala"
							result = _tmp36_;
#line 542 "../lib/equation-lexer.vala"
							return result;
#line 2943 "equation-lexer.c"
						}
					}
				}
			}
		}
	}
}

static LexerToken*
lexer_insert_angle_num_dm (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	PreLexer* _tmp8_;
	LexerToken* result;
#line 546 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 548 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 548 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 549 "../lib/equation-lexer.vala"
	if (type != LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 2967 "equation-lexer.c"
		Parser* _tmp1_;
		PreLexer* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		PreLexer* _tmp5_;
		PreLexer* _tmp6_;
		LexerToken* _tmp7_;
#line 552 "../lib/equation-lexer.vala"
		_tmp1_ = self->priv->parser;
#line 552 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 552 "../lib/equation-lexer.vala"
		_tmp3_ = pre_lexer_get_marked_substring (_tmp2_);
#line 552 "../lib/equation-lexer.vala"
		_tmp4_ = _tmp3_;
#line 552 "../lib/equation-lexer.vala"
		_tmp5_ = self->priv->prelexer;
#line 552 "../lib/equation-lexer.vala"
		_tmp6_ = self->priv->prelexer;
#line 552 "../lib/equation-lexer.vala"
		parser_set_error (_tmp1_, ERROR_CODE_MP, _tmp4_, (guint) _tmp5_->mark_index, (guint) _tmp6_->index);
#line 552 "../lib/equation-lexer.vala"
		_g_free0 (_tmp4_);
#line 553 "../lib/equation-lexer.vala"
		_tmp7_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 553 "../lib/equation-lexer.vala"
		result = _tmp7_;
#line 553 "../lib/equation-lexer.vala"
		return result;
#line 2997 "equation-lexer.c"
	}
#line 556 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 556 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 556 "../lib/equation-lexer.vala"
			break;
#line 3005 "equation-lexer.c"
		}
	}
#line 557 "../lib/equation-lexer.vala"
	_tmp8_ = self->priv->prelexer;
#line 557 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp8_);
#line 559 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_MINUTE) {
#line 3014 "equation-lexer.c"
		LexerToken* _tmp9_;
#line 560 "../lib/equation-lexer.vala"
		_tmp9_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 560 "../lib/equation-lexer.vala"
		result = _tmp9_;
#line 560 "../lib/equation-lexer.vala"
		return result;
#line 3022 "equation-lexer.c"
	} else {
		Parser* _tmp10_;
		PreLexer* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		PreLexer* _tmp14_;
		PreLexer* _tmp15_;
		LexerToken* _tmp16_;
#line 564 "../lib/equation-lexer.vala"
		_tmp10_ = self->priv->parser;
#line 564 "../lib/equation-lexer.vala"
		_tmp11_ = self->priv->prelexer;
#line 564 "../lib/equation-lexer.vala"
		_tmp12_ = pre_lexer_get_marked_substring (_tmp11_);
#line 564 "../lib/equation-lexer.vala"
		_tmp13_ = _tmp12_;
#line 564 "../lib/equation-lexer.vala"
		_tmp14_ = self->priv->prelexer;
#line 564 "../lib/equation-lexer.vala"
		_tmp15_ = self->priv->prelexer;
#line 564 "../lib/equation-lexer.vala"
		parser_set_error (_tmp10_, ERROR_CODE_MP, _tmp13_, (guint) _tmp14_->mark_index, (guint) _tmp15_->index);
#line 564 "../lib/equation-lexer.vala"
		_g_free0 (_tmp13_);
#line 565 "../lib/equation-lexer.vala"
		_tmp16_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 565 "../lib/equation-lexer.vala"
		result = _tmp16_;
#line 565 "../lib/equation-lexer.vala"
		return result;
#line 3053 "equation-lexer.c"
	}
}

static LexerToken*
lexer_insert_angle_num_dms (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 569 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 571 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 571 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 572 "../lib/equation-lexer.vala"
	if (type != LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 3071 "equation-lexer.c"
		Parser* _tmp1_;
		PreLexer* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		PreLexer* _tmp5_;
		PreLexer* _tmp6_;
		LexerToken* _tmp7_;
#line 575 "../lib/equation-lexer.vala"
		_tmp1_ = self->priv->parser;
#line 575 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 575 "../lib/equation-lexer.vala"
		_tmp3_ = pre_lexer_get_marked_substring (_tmp2_);
#line 575 "../lib/equation-lexer.vala"
		_tmp4_ = _tmp3_;
#line 575 "../lib/equation-lexer.vala"
		_tmp5_ = self->priv->prelexer;
#line 575 "../lib/equation-lexer.vala"
		_tmp6_ = self->priv->prelexer;
#line 575 "../lib/equation-lexer.vala"
		parser_set_error (_tmp1_, ERROR_CODE_MP, _tmp4_, (guint) _tmp5_->mark_index, (guint) _tmp6_->index);
#line 575 "../lib/equation-lexer.vala"
		_g_free0 (_tmp4_);
#line 576 "../lib/equation-lexer.vala"
		_tmp7_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 576 "../lib/equation-lexer.vala"
		result = _tmp7_;
#line 576 "../lib/equation-lexer.vala"
		return result;
#line 3101 "equation-lexer.c"
	}
#line 578 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3105 "equation-lexer.c"
		PreLexer* _tmp8_;
#line 578 "../lib/equation-lexer.vala"
		_tmp8_ = self->priv->prelexer;
#line 578 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp8_);
#line 578 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 578 "../lib/equation-lexer.vala"
			break;
#line 3115 "equation-lexer.c"
		}
	}
#line 579 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_SECOND) {
#line 3120 "equation-lexer.c"
		LexerToken* _tmp9_;
#line 580 "../lib/equation-lexer.vala"
		_tmp9_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 580 "../lib/equation-lexer.vala"
		result = _tmp9_;
#line 580 "../lib/equation-lexer.vala"
		return result;
#line 3128 "equation-lexer.c"
	} else {
		Parser* _tmp10_;
		PreLexer* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		PreLexer* _tmp14_;
		PreLexer* _tmp15_;
		LexerToken* _tmp16_;
#line 584 "../lib/equation-lexer.vala"
		_tmp10_ = self->priv->parser;
#line 584 "../lib/equation-lexer.vala"
		_tmp11_ = self->priv->prelexer;
#line 584 "../lib/equation-lexer.vala"
		_tmp12_ = pre_lexer_get_marked_substring (_tmp11_);
#line 584 "../lib/equation-lexer.vala"
		_tmp13_ = _tmp12_;
#line 584 "../lib/equation-lexer.vala"
		_tmp14_ = self->priv->prelexer;
#line 584 "../lib/equation-lexer.vala"
		_tmp15_ = self->priv->prelexer;
#line 584 "../lib/equation-lexer.vala"
		parser_set_error (_tmp10_, ERROR_CODE_MP, _tmp13_, (guint) _tmp14_->mark_index, (guint) _tmp15_->index);
#line 584 "../lib/equation-lexer.vala"
		_g_free0 (_tmp13_);
#line 585 "../lib/equation-lexer.vala"
		_tmp16_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 585 "../lib/equation-lexer.vala"
		result = _tmp16_;
#line 585 "../lib/equation-lexer.vala"
		return result;
#line 3159 "equation-lexer.c"
	}
}

static LexerToken*
lexer_insert_decimal (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 589 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 591 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 591 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 592 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 594 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 3179 "equation-lexer.c"
			PreLexer* _tmp1_;
#line 594 "../lib/equation-lexer.vala"
			_tmp1_ = self->priv->prelexer;
#line 594 "../lib/equation-lexer.vala"
			type = pre_lexer_get_next_token (_tmp1_);
#line 594 "../lib/equation-lexer.vala"
			if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 594 "../lib/equation-lexer.vala"
				break;
#line 3189 "equation-lexer.c"
			}
		}
#line 595 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_DEGREE) {
#line 3194 "equation-lexer.c"
			LexerToken* _tmp2_;
#line 596 "../lib/equation-lexer.vala"
			_tmp2_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 596 "../lib/equation-lexer.vala"
			result = _tmp2_;
#line 596 "../lib/equation-lexer.vala"
			return result;
#line 3202 "equation-lexer.c"
		} else {
#line 597 "../lib/equation-lexer.vala"
			if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 3206 "equation-lexer.c"
				LexerToken* _tmp3_;
#line 598 "../lib/equation-lexer.vala"
				_tmp3_ = lexer_insert_decimal_hex (self);
#line 598 "../lib/equation-lexer.vala"
				result = _tmp3_;
#line 598 "../lib/equation-lexer.vala"
				return result;
#line 3214 "equation-lexer.c"
			} else {
#line 599 "../lib/equation-lexer.vala"
				if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 3218 "equation-lexer.c"
					PreLexer* _tmp5_;
					LexerToken* _tmp6_;
#line 601 "../lib/equation-lexer.vala"
					while (TRUE) {
#line 3223 "equation-lexer.c"
						PreLexer* _tmp4_;
#line 601 "../lib/equation-lexer.vala"
						_tmp4_ = self->priv->prelexer;
#line 601 "../lib/equation-lexer.vala"
						if (!(pre_lexer_get_next_token (_tmp4_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 601 "../lib/equation-lexer.vala"
							break;
#line 3231 "equation-lexer.c"
						}
					}
#line 602 "../lib/equation-lexer.vala"
					_tmp5_ = self->priv->prelexer;
#line 602 "../lib/equation-lexer.vala"
					pre_lexer_roll_back (_tmp5_);
#line 603 "../lib/equation-lexer.vala"
					_tmp6_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 603 "../lib/equation-lexer.vala"
					result = _tmp6_;
#line 603 "../lib/equation-lexer.vala"
					return result;
#line 3244 "equation-lexer.c"
				} else {
					PreLexer* _tmp7_;
					LexerToken* _tmp8_;
#line 607 "../lib/equation-lexer.vala"
					_tmp7_ = self->priv->prelexer;
#line 607 "../lib/equation-lexer.vala"
					pre_lexer_roll_back (_tmp7_);
#line 608 "../lib/equation-lexer.vala"
					_tmp8_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 608 "../lib/equation-lexer.vala"
					result = _tmp8_;
#line 608 "../lib/equation-lexer.vala"
					return result;
#line 3258 "equation-lexer.c"
				}
			}
		}
	} else {
#line 611 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 3265 "equation-lexer.c"
			LexerToken* _tmp9_;
#line 612 "../lib/equation-lexer.vala"
			_tmp9_ = lexer_insert_decimal_hex (self);
#line 612 "../lib/equation-lexer.vala"
			result = _tmp9_;
#line 612 "../lib/equation-lexer.vala"
			return result;
#line 3273 "equation-lexer.c"
		} else {
			Parser* _tmp10_;
			PreLexer* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			PreLexer* _tmp14_;
			PreLexer* _tmp15_;
			LexerToken* _tmp16_;
#line 616 "../lib/equation-lexer.vala"
			_tmp10_ = self->priv->parser;
#line 616 "../lib/equation-lexer.vala"
			_tmp11_ = self->priv->prelexer;
#line 616 "../lib/equation-lexer.vala"
			_tmp12_ = pre_lexer_get_marked_substring (_tmp11_);
#line 616 "../lib/equation-lexer.vala"
			_tmp13_ = _tmp12_;
#line 616 "../lib/equation-lexer.vala"
			_tmp14_ = self->priv->prelexer;
#line 616 "../lib/equation-lexer.vala"
			_tmp15_ = self->priv->prelexer;
#line 616 "../lib/equation-lexer.vala"
			parser_set_error (_tmp10_, ERROR_CODE_MP, _tmp13_, (guint) _tmp14_->mark_index, (guint) _tmp15_->index);
#line 616 "../lib/equation-lexer.vala"
			_g_free0 (_tmp13_);
#line 617 "../lib/equation-lexer.vala"
			_tmp16_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 617 "../lib/equation-lexer.vala"
			result = _tmp16_;
#line 617 "../lib/equation-lexer.vala"
			return result;
#line 3304 "equation-lexer.c"
		}
	}
}

static LexerToken*
lexer_insert_hex (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 621 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 623 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 623 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 624 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3323 "equation-lexer.c"
		PreLexer* _tmp1_;
#line 624 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_HEX)) {
#line 624 "../lib/equation-lexer.vala"
			break;
#line 3329 "equation-lexer.c"
		}
#line 625 "../lib/equation-lexer.vala"
		_tmp1_ = self->priv->prelexer;
#line 625 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp1_);
#line 3335 "equation-lexer.c"
	}
#line 627 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 3339 "equation-lexer.c"
		LexerToken* _tmp2_;
#line 628 "../lib/equation-lexer.vala"
		_tmp2_ = lexer_insert_hex_dec (self);
#line 628 "../lib/equation-lexer.vala"
		result = _tmp2_;
#line 628 "../lib/equation-lexer.vala"
		return result;
#line 3347 "equation-lexer.c"
	} else {
#line 629 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3351 "equation-lexer.c"
			LexerToken* _tmp3_;
#line 630 "../lib/equation-lexer.vala"
			_tmp3_ = lexer_insert_decimal_hex (self);
#line 630 "../lib/equation-lexer.vala"
			result = _tmp3_;
#line 630 "../lib/equation-lexer.vala"
			return result;
#line 3359 "equation-lexer.c"
		} else {
#line 631 "../lib/equation-lexer.vala"
			if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 3363 "equation-lexer.c"
				PreLexer* _tmp5_;
#line 633 "../lib/equation-lexer.vala"
				while (TRUE) {
#line 3367 "equation-lexer.c"
					PreLexer* _tmp4_;
#line 633 "../lib/equation-lexer.vala"
					_tmp4_ = self->priv->prelexer;
#line 633 "../lib/equation-lexer.vala"
					if (!(pre_lexer_get_next_token (_tmp4_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 633 "../lib/equation-lexer.vala"
						break;
#line 3375 "equation-lexer.c"
					}
				}
#line 634 "../lib/equation-lexer.vala"
				_tmp5_ = self->priv->prelexer;
#line 634 "../lib/equation-lexer.vala"
				pre_lexer_roll_back (_tmp5_);
#line 636 "../lib/equation-lexer.vala"
				if (lexer_check_if_number (self)) {
#line 3384 "equation-lexer.c"
					LexerToken* _tmp6_;
#line 637 "../lib/equation-lexer.vala"
					_tmp6_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 637 "../lib/equation-lexer.vala"
					result = _tmp6_;
#line 637 "../lib/equation-lexer.vala"
					return result;
#line 3392 "equation-lexer.c"
				} else {
#line 640 "../lib/equation-lexer.vala"
					if (lexer_check_if_function (self)) {
#line 3396 "equation-lexer.c"
						LexerToken* _tmp7_;
#line 641 "../lib/equation-lexer.vala"
						_tmp7_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_FUNCTION);
#line 641 "../lib/equation-lexer.vala"
						result = _tmp7_;
#line 641 "../lib/equation-lexer.vala"
						return result;
#line 3404 "equation-lexer.c"
					} else {
#line 642 "../lib/equation-lexer.vala"
						if (lexer_check_if_unit (self)) {
#line 3408 "equation-lexer.c"
							LexerToken* _tmp8_;
#line 643 "../lib/equation-lexer.vala"
							_tmp8_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNIT);
#line 643 "../lib/equation-lexer.vala"
							result = _tmp8_;
#line 643 "../lib/equation-lexer.vala"
							return result;
#line 3416 "equation-lexer.c"
						} else {
							LexerToken* _tmp9_;
#line 645 "../lib/equation-lexer.vala"
							_tmp9_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_VARIABLE);
#line 645 "../lib/equation-lexer.vala"
							result = _tmp9_;
#line 645 "../lib/equation-lexer.vala"
							return result;
#line 3425 "equation-lexer.c"
						}
					}
				}
			} else {
#line 648 "../lib/equation-lexer.vala"
				if (type == LEXER_TOKEN_TYPE_PL_LETTER) {
#line 3432 "equation-lexer.c"
					LexerToken* _tmp10_;
#line 649 "../lib/equation-lexer.vala"
					_tmp10_ = lexer_insert_letter (self);
#line 649 "../lib/equation-lexer.vala"
					result = _tmp10_;
#line 649 "../lib/equation-lexer.vala"
					return result;
#line 3440 "equation-lexer.c"
				} else {
					PreLexer* _tmp11_;
#line 652 "../lib/equation-lexer.vala"
					_tmp11_ = self->priv->prelexer;
#line 652 "../lib/equation-lexer.vala"
					pre_lexer_roll_back (_tmp11_);
#line 653 "../lib/equation-lexer.vala"
					if (lexer_check_if_number (self)) {
#line 3449 "equation-lexer.c"
						LexerToken* _tmp12_;
#line 654 "../lib/equation-lexer.vala"
						_tmp12_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 654 "../lib/equation-lexer.vala"
						result = _tmp12_;
#line 654 "../lib/equation-lexer.vala"
						return result;
#line 3457 "equation-lexer.c"
					} else {
#line 657 "../lib/equation-lexer.vala"
						if (lexer_check_if_function (self)) {
#line 3461 "equation-lexer.c"
							LexerToken* _tmp13_;
#line 658 "../lib/equation-lexer.vala"
							_tmp13_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_FUNCTION);
#line 658 "../lib/equation-lexer.vala"
							result = _tmp13_;
#line 658 "../lib/equation-lexer.vala"
							return result;
#line 3469 "equation-lexer.c"
						} else {
#line 659 "../lib/equation-lexer.vala"
							if (lexer_check_if_unit (self)) {
#line 3473 "equation-lexer.c"
								LexerToken* _tmp14_;
#line 660 "../lib/equation-lexer.vala"
								_tmp14_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNIT);
#line 660 "../lib/equation-lexer.vala"
								result = _tmp14_;
#line 660 "../lib/equation-lexer.vala"
								return result;
#line 3481 "equation-lexer.c"
							} else {
								LexerToken* _tmp15_;
#line 662 "../lib/equation-lexer.vala"
								_tmp15_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_VARIABLE);
#line 662 "../lib/equation-lexer.vala"
								result = _tmp15_;
#line 662 "../lib/equation-lexer.vala"
								return result;
#line 3490 "equation-lexer.c"
							}
						}
					}
				}
			}
		}
	}
}

static LexerToken*
lexer_insert_hex_dec (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 667 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 669 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 669 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 670 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3514 "equation-lexer.c"
		gboolean _tmp1_ = FALSE;
		PreLexer* _tmp2_;
#line 670 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 670 "../lib/equation-lexer.vala"
			_tmp1_ = TRUE;
#line 3521 "equation-lexer.c"
		} else {
#line 670 "../lib/equation-lexer.vala"
			_tmp1_ = type == LEXER_TOKEN_TYPE_PL_HEX;
#line 3525 "equation-lexer.c"
		}
#line 670 "../lib/equation-lexer.vala"
		if (!_tmp1_) {
#line 670 "../lib/equation-lexer.vala"
			break;
#line 3531 "equation-lexer.c"
		}
#line 671 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 671 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp2_);
#line 3537 "equation-lexer.c"
	}
#line 673 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3541 "equation-lexer.c"
		LexerToken* _tmp3_;
#line 674 "../lib/equation-lexer.vala"
		_tmp3_ = lexer_insert_decimal_hex (self);
#line 674 "../lib/equation-lexer.vala"
		result = _tmp3_;
#line 674 "../lib/equation-lexer.vala"
		return result;
#line 3549 "equation-lexer.c"
	} else {
#line 675 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 3553 "equation-lexer.c"
			PreLexer* _tmp5_;
			LexerToken* _tmp6_;
#line 677 "../lib/equation-lexer.vala"
			while (TRUE) {
#line 3558 "equation-lexer.c"
				PreLexer* _tmp4_;
#line 677 "../lib/equation-lexer.vala"
				_tmp4_ = self->priv->prelexer;
#line 677 "../lib/equation-lexer.vala"
				if (!(pre_lexer_get_next_token (_tmp4_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 677 "../lib/equation-lexer.vala"
					break;
#line 3566 "equation-lexer.c"
				}
			}
#line 678 "../lib/equation-lexer.vala"
			_tmp5_ = self->priv->prelexer;
#line 678 "../lib/equation-lexer.vala"
			pre_lexer_roll_back (_tmp5_);
#line 679 "../lib/equation-lexer.vala"
			_tmp6_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 679 "../lib/equation-lexer.vala"
			result = _tmp6_;
#line 679 "../lib/equation-lexer.vala"
			return result;
#line 3579 "equation-lexer.c"
		} else {
			Parser* _tmp8_;
			PreLexer* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			PreLexer* _tmp12_;
			PreLexer* _tmp13_;
			LexerToken* _tmp14_;
#line 683 "../lib/equation-lexer.vala"
			if (lexer_check_if_number (self)) {
#line 3590 "equation-lexer.c"
				LexerToken* _tmp7_;
#line 684 "../lib/equation-lexer.vala"
				_tmp7_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 684 "../lib/equation-lexer.vala"
				result = _tmp7_;
#line 684 "../lib/equation-lexer.vala"
				return result;
#line 3598 "equation-lexer.c"
			}
#line 686 "../lib/equation-lexer.vala"
			_tmp8_ = self->priv->parser;
#line 686 "../lib/equation-lexer.vala"
			_tmp9_ = self->priv->prelexer;
#line 686 "../lib/equation-lexer.vala"
			_tmp10_ = pre_lexer_get_marked_substring (_tmp9_);
#line 686 "../lib/equation-lexer.vala"
			_tmp11_ = _tmp10_;
#line 686 "../lib/equation-lexer.vala"
			_tmp12_ = self->priv->prelexer;
#line 686 "../lib/equation-lexer.vala"
			_tmp13_ = self->priv->prelexer;
#line 686 "../lib/equation-lexer.vala"
			parser_set_error (_tmp8_, ERROR_CODE_MP, _tmp11_, (guint) _tmp12_->mark_index, (guint) _tmp13_->index);
#line 686 "../lib/equation-lexer.vala"
			_g_free0 (_tmp11_);
#line 687 "../lib/equation-lexer.vala"
			_tmp14_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 687 "../lib/equation-lexer.vala"
			result = _tmp14_;
#line 687 "../lib/equation-lexer.vala"
			return result;
#line 3622 "equation-lexer.c"
		}
	}
}

static LexerToken*
lexer_insert_decimal_hex (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	PreLexer* _tmp4_;
	LexerToken* _tmp5_;
	LexerToken* result;
#line 691 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 694 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 694 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 695 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3643 "equation-lexer.c"
		gboolean _tmp1_ = FALSE;
		PreLexer* _tmp2_;
#line 695 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 695 "../lib/equation-lexer.vala"
			_tmp1_ = TRUE;
#line 3650 "equation-lexer.c"
		} else {
#line 695 "../lib/equation-lexer.vala"
			_tmp1_ = type == LEXER_TOKEN_TYPE_PL_HEX;
#line 3654 "equation-lexer.c"
		}
#line 695 "../lib/equation-lexer.vala"
		if (!_tmp1_) {
#line 695 "../lib/equation-lexer.vala"
			break;
#line 3660 "equation-lexer.c"
		}
#line 696 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 696 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp2_);
#line 3666 "equation-lexer.c"
	}
#line 699 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3670 "equation-lexer.c"
		PreLexer* _tmp3_;
#line 699 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 699 "../lib/equation-lexer.vala"
			break;
#line 3676 "equation-lexer.c"
		}
#line 700 "../lib/equation-lexer.vala"
		_tmp3_ = self->priv->prelexer;
#line 700 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp3_);
#line 3682 "equation-lexer.c"
	}
#line 702 "../lib/equation-lexer.vala"
	_tmp4_ = self->priv->prelexer;
#line 702 "../lib/equation-lexer.vala"
	pre_lexer_roll_back (_tmp4_);
#line 704 "../lib/equation-lexer.vala"
	_tmp5_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 704 "../lib/equation-lexer.vala"
	result = _tmp5_;
#line 704 "../lib/equation-lexer.vala"
	return result;
#line 3694 "equation-lexer.c"
}

static LexerToken*
lexer_insert_letter (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	PreLexer* _tmp4_;
	gchar* name = NULL;
	PreLexer* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp12_;
	const gchar* _tmp14_;
	const gchar* _tmp16_;
	const gchar* _tmp18_;
	const gchar* _tmp20_;
	gboolean _tmp22_ = FALSE;
	const gchar* _tmp23_;
	LexerToken* result;
#line 707 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 710 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 710 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 711 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3726 "equation-lexer.c"
		gboolean _tmp1_ = FALSE;
		PreLexer* _tmp2_;
#line 711 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_LETTER) {
#line 711 "../lib/equation-lexer.vala"
			_tmp1_ = TRUE;
#line 3733 "equation-lexer.c"
		} else {
#line 711 "../lib/equation-lexer.vala"
			_tmp1_ = type == LEXER_TOKEN_TYPE_PL_HEX;
#line 3737 "equation-lexer.c"
		}
#line 711 "../lib/equation-lexer.vala"
		if (!_tmp1_) {
#line 711 "../lib/equation-lexer.vala"
			break;
#line 3743 "equation-lexer.c"
		}
#line 712 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 712 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp2_);
#line 3749 "equation-lexer.c"
	}
#line 715 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3753 "equation-lexer.c"
		PreLexer* _tmp3_;
#line 715 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 715 "../lib/equation-lexer.vala"
			break;
#line 3759 "equation-lexer.c"
		}
#line 716 "../lib/equation-lexer.vala"
		_tmp3_ = self->priv->prelexer;
#line 716 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp3_);
#line 3765 "equation-lexer.c"
	}
#line 718 "../lib/equation-lexer.vala"
	_tmp4_ = self->priv->prelexer;
#line 718 "../lib/equation-lexer.vala"
	pre_lexer_roll_back (_tmp4_);
#line 720 "../lib/equation-lexer.vala"
	_tmp5_ = self->priv->prelexer;
#line 720 "../lib/equation-lexer.vala"
	_tmp6_ = pre_lexer_get_marked_substring (_tmp5_);
#line 720 "../lib/equation-lexer.vala"
	_tmp7_ = _tmp6_;
#line 720 "../lib/equation-lexer.vala"
	_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 720 "../lib/equation-lexer.vala"
	_tmp9_ = _tmp8_;
#line 720 "../lib/equation-lexer.vala"
	_g_free0 (_tmp7_);
#line 720 "../lib/equation-lexer.vala"
	name = _tmp9_;
#line 721 "../lib/equation-lexer.vala"
	_tmp10_ = name;
#line 721 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp10_, "mod") == 0) {
#line 3789 "equation-lexer.c"
		LexerToken* _tmp11_;
#line 722 "../lib/equation-lexer.vala"
		_tmp11_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_MOD);
#line 722 "../lib/equation-lexer.vala"
		result = _tmp11_;
#line 722 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 722 "../lib/equation-lexer.vala"
		return result;
#line 3799 "equation-lexer.c"
	}
#line 723 "../lib/equation-lexer.vala"
	_tmp12_ = name;
#line 723 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp12_, "and") == 0) {
#line 3805 "equation-lexer.c"
		LexerToken* _tmp13_;
#line 724 "../lib/equation-lexer.vala"
		_tmp13_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_AND);
#line 724 "../lib/equation-lexer.vala"
		result = _tmp13_;
#line 724 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 724 "../lib/equation-lexer.vala"
		return result;
#line 3815 "equation-lexer.c"
	}
#line 725 "../lib/equation-lexer.vala"
	_tmp14_ = name;
#line 725 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp14_, "\\cdot") == 0) {
#line 3821 "equation-lexer.c"
		LexerToken* _tmp15_;
#line 726 "../lib/equation-lexer.vala"
		_tmp15_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_MULTIPLY);
#line 726 "../lib/equation-lexer.vala"
		result = _tmp15_;
#line 726 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 726 "../lib/equation-lexer.vala"
		return result;
#line 3831 "equation-lexer.c"
	}
#line 727 "../lib/equation-lexer.vala"
	_tmp16_ = name;
#line 727 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp16_, "or") == 0) {
#line 3837 "equation-lexer.c"
		LexerToken* _tmp17_;
#line 728 "../lib/equation-lexer.vala"
		_tmp17_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_OR);
#line 728 "../lib/equation-lexer.vala"
		result = _tmp17_;
#line 728 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 728 "../lib/equation-lexer.vala"
		return result;
#line 3847 "equation-lexer.c"
	}
#line 729 "../lib/equation-lexer.vala"
	_tmp18_ = name;
#line 729 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp18_, "xor") == 0) {
#line 3853 "equation-lexer.c"
		LexerToken* _tmp19_;
#line 730 "../lib/equation-lexer.vala"
		_tmp19_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_XOR);
#line 730 "../lib/equation-lexer.vala"
		result = _tmp19_;
#line 730 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 730 "../lib/equation-lexer.vala"
		return result;
#line 3863 "equation-lexer.c"
	}
#line 731 "../lib/equation-lexer.vala"
	_tmp20_ = name;
#line 731 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp20_, "not") == 0) {
#line 3869 "equation-lexer.c"
		LexerToken* _tmp21_;
#line 732 "../lib/equation-lexer.vala"
		_tmp21_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NOT);
#line 732 "../lib/equation-lexer.vala"
		result = _tmp21_;
#line 732 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 732 "../lib/equation-lexer.vala"
		return result;
#line 3879 "equation-lexer.c"
	}
#line 734 "../lib/equation-lexer.vala"
	_tmp23_ = name;
#line 734 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp23_, _ ("in")) == 0) {
#line 734 "../lib/equation-lexer.vala"
		_tmp22_ = TRUE;
#line 3887 "equation-lexer.c"
	} else {
		const gchar* _tmp24_;
#line 734 "../lib/equation-lexer.vala"
		_tmp24_ = name;
#line 734 "../lib/equation-lexer.vala"
		_tmp22_ = g_strcmp0 (_tmp24_, _ ("to")) == 0;
#line 3894 "equation-lexer.c"
	}
#line 734 "../lib/equation-lexer.vala"
	if (_tmp22_) {
#line 3898 "equation-lexer.c"
		LexerToken* _tmp25_;
#line 735 "../lib/equation-lexer.vala"
		_tmp25_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_IN);
#line 735 "../lib/equation-lexer.vala"
		result = _tmp25_;
#line 735 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 735 "../lib/equation-lexer.vala"
		return result;
#line 3908 "equation-lexer.c"
	}
#line 736 "../lib/equation-lexer.vala"
	if (lexer_check_if_function (self)) {
#line 3912 "equation-lexer.c"
		LexerToken* _tmp26_;
#line 737 "../lib/equation-lexer.vala"
		_tmp26_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_FUNCTION);
#line 737 "../lib/equation-lexer.vala"
		result = _tmp26_;
#line 737 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 737 "../lib/equation-lexer.vala"
		return result;
#line 3922 "equation-lexer.c"
	}
#line 738 "../lib/equation-lexer.vala"
	if (lexer_check_if_unit (self)) {
#line 3926 "equation-lexer.c"
		LexerToken* _tmp27_;
#line 739 "../lib/equation-lexer.vala"
		_tmp27_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNIT);
#line 739 "../lib/equation-lexer.vala"
		result = _tmp27_;
#line 739 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 739 "../lib/equation-lexer.vala"
		return result;
#line 3936 "equation-lexer.c"
	} else {
		LexerToken* _tmp28_;
#line 741 "../lib/equation-lexer.vala"
		_tmp28_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_VARIABLE);
#line 741 "../lib/equation-lexer.vala"
		result = _tmp28_;
#line 741 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 741 "../lib/equation-lexer.vala"
		return result;
#line 3947 "equation-lexer.c"
	}
}

static void
lexer_class_init (LexerClass * klass,
                  gpointer klass_data)
{
#line 265 "../lib/equation-lexer.vala"
	lexer_parent_class = g_type_class_peek_parent (klass);
#line 265 "../lib/equation-lexer.vala"
	g_type_class_adjust_private_offset (klass, &Lexer_private_offset);
#line 265 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (klass)->finalize = lexer_finalize;
#line 3961 "equation-lexer.c"
}

static void
lexer_instance_init (Lexer * self,
                     gpointer klass)
{
#line 265 "../lib/equation-lexer.vala"
	self->priv = lexer_get_instance_private (self);
#line 3970 "equation-lexer.c"
}

static void
lexer_finalize (GObject * obj)
{
	Lexer * self;
#line 265 "../lib/equation-lexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LEXER, Lexer);
#line 267 "../lib/equation-lexer.vala"
	_parser_unref0 (self->priv->parser);
#line 268 "../lib/equation-lexer.vala"
	_g_object_unref0 (self->priv->prelexer);
#line 269 "../lib/equation-lexer.vala"
	(self->tokens == NULL) ? NULL : (self->tokens = (_g_list_free__g_object_unref0_ (self->tokens), NULL));
#line 265 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (lexer_parent_class)->finalize (obj);
#line 3987 "equation-lexer.c"
}

static GType
lexer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LexerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lexer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Lexer), 0, (GInstanceInitFunc) lexer_instance_init, NULL };
	GType lexer_type_id;
	lexer_type_id = g_type_register_static (G_TYPE_OBJECT, "Lexer", &g_define_type_info, 0);
	Lexer_private_offset = g_type_add_instance_private (lexer_type_id, sizeof (LexerPrivate));
	return lexer_type_id;
}

GType
lexer_get_type (void)
{
	static volatile gsize lexer_type_id__once = 0;
	if (g_once_init_enter (&lexer_type_id__once)) {
		GType lexer_type_id;
		lexer_type_id = lexer_get_type_once ();
		g_once_init_leave (&lexer_type_id__once, lexer_type_id);
	}
	return lexer_type_id__once;
}

