/* gcalc-parser.c generated by valac 0.56.16, the Vala compiler
 * generated from gcalc-parser.vala, do not modify */

/* gcalc-gexpresion.vala
 *
 * Copyright (C) 2018  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gcalc/gcalc.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <errno.h>
#include "gcalc.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GCALC_PARSER_0_PROPERTY,
	GCALC_PARSER_NUM_PROPERTIES
};
static GParamSpec* gcalc_parser_properties[GCALC_PARSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_scanner_destroy0(var) ((var == NULL) ? NULL : (var = (g_scanner_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GCalcParserPrivate {
	GCalcMathExpression* current;
	GCalcMathExpression* current_parent;
	GCalcMathExpression* top_parent;
	GCalcEquation* eq;
	GRegex* rg;
	gboolean enable_parameter;
	GeeArrayList* expected;
	GScanner* scanner;
};

static gint GCalcParser_private_offset;
static gpointer gcalc_parser_parent_class = NULL;

static void gcalc_parser_add_constant (GCalcParser* self,
                                GCalcMathConstant* c);
VALA_EXTERN GCalcVariable* gcalc_variable_new (const gchar* name);
VALA_EXTERN GCalcVariable* gcalc_variable_construct (GType object_type,
                                         const gchar* name);
static void gcalc_parser_process_term_operator (GCalcParser* self,
                                         GCalcMathOperator* op,
                                         GCalcEquation* eq,
                                         GError** error);
static void gcalc_parser_process_operator (GCalcParser* self,
                                    GCalcMathOperator* opp,
                                    GCalcEquation* eq,
                                    GError** error);
static GObject * gcalc_parser_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void gcalc_parser_finalize (GObject * obj);
static GType gcalc_parser_get_type_once (void);

static inline gpointer
gcalc_parser_get_instance_private (GCalcParser* self)
{
	return G_STRUCT_MEMBER_P (self, GCalcParser_private_offset);
}

static GType
gcalc_parser_token_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GCALC_PARSER_TOKEN_TYPE_NONE, "GCALC_PARSER_TOKEN_TYPE_NONE", "none"}, {GCALC_PARSER_TOKEN_TYPE_EOF, "GCALC_PARSER_TOKEN_TYPE_EOF", "eof"}, {GCALC_PARSER_TOKEN_TYPE_IDENTIFIER, "GCALC_PARSER_TOKEN_TYPE_IDENTIFIER", "identifier"}, {GCALC_PARSER_TOKEN_TYPE_INTEGER_LITERAL, "GCALC_PARSER_TOKEN_TYPE_INTEGER_LITERAL", "integer-literal"}, {GCALC_PARSER_TOKEN_TYPE_REAL_LITERAL, "GCALC_PARSER_TOKEN_TYPE_REAL_LITERAL", "real-literal"}, {GCALC_PARSER_TOKEN_TYPE_STAR, "GCALC_PARSER_TOKEN_TYPE_STAR", "star"}, {GCALC_PARSER_TOKEN_TYPE_PLUS, "GCALC_PARSER_TOKEN_TYPE_PLUS", "plus"}, {GCALC_PARSER_TOKEN_TYPE_DIV, "GCALC_PARSER_TOKEN_TYPE_DIV", "div"}, {GCALC_PARSER_TOKEN_TYPE_MINUS, "GCALC_PARSER_TOKEN_TYPE_MINUS", "minus"}, {GCALC_PARSER_TOKEN_TYPE_ASSIGN, "GCALC_PARSER_TOKEN_TYPE_ASSIGN", "assign"}, {GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS, "GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS", "open-parens"}, {GCALC_PARSER_TOKEN_TYPE_CLOSE_PARENS, "GCALC_PARSER_TOKEN_TYPE_CLOSE_PARENS", "close-parens"}, {GCALC_PARSER_TOKEN_TYPE_CARRET, "GCALC_PARSER_TOKEN_TYPE_CARRET", "carret"}, {GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACE, "GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACE", "close-brace"}, {GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACKET, "GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACKET", "close-bracket"}, {GCALC_PARSER_TOKEN_TYPE_OPEN_BRACE, "GCALC_PARSER_TOKEN_TYPE_OPEN_BRACE", "open-brace"}, {GCALC_PARSER_TOKEN_TYPE_OPEN_BRACKET, "GCALC_PARSER_TOKEN_TYPE_OPEN_BRACKET", "open-bracket"}, {GCALC_PARSER_TOKEN_TYPE_STRING_LITERAL, "GCALC_PARSER_TOKEN_TYPE_STRING_LITERAL", "string-literal"}, {GCALC_PARSER_TOKEN_TYPE_OP_AND, "GCALC_PARSER_TOKEN_TYPE_OP_AND", "op-and"}, {GCALC_PARSER_TOKEN_TYPE_OP_COALESCING, "GCALC_PARSER_TOKEN_TYPE_OP_COALESCING", "op-coalescing"}, {GCALC_PARSER_TOKEN_TYPE_OP_DEC, "GCALC_PARSER_TOKEN_TYPE_OP_DEC", "op-dec"}, {GCALC_PARSER_TOKEN_TYPE_OP_EQ, "GCALC_PARSER_TOKEN_TYPE_OP_EQ", "op-eq"}, {GCALC_PARSER_TOKEN_TYPE_OP_GE, "GCALC_PARSER_TOKEN_TYPE_OP_GE", "op-ge"}, {GCALC_PARSER_TOKEN_TYPE_OP_GT, "GCALC_PARSER_TOKEN_TYPE_OP_GT", "op-gt"}, {GCALC_PARSER_TOKEN_TYPE_OP_INC, "GCALC_PARSER_TOKEN_TYPE_OP_INC", "op-inc"}, {GCALC_PARSER_TOKEN_TYPE_OP_LE, "GCALC_PARSER_TOKEN_TYPE_OP_LE", "op-le"}, {GCALC_PARSER_TOKEN_TYPE_OP_LT, "GCALC_PARSER_TOKEN_TYPE_OP_LT", "op-lt"}, {GCALC_PARSER_TOKEN_TYPE_OP_NE, "GCALC_PARSER_TOKEN_TYPE_OP_NE", "op-ne"}, {GCALC_PARSER_TOKEN_TYPE_OP_NEG, "GCALC_PARSER_TOKEN_TYPE_OP_NEG", "op-neg"}, {GCALC_PARSER_TOKEN_TYPE_OP_OR, "GCALC_PARSER_TOKEN_TYPE_OP_OR", "op-or"}, {GCALC_PARSER_TOKEN_TYPE_OP_PTR, "GCALC_PARSER_TOKEN_TYPE_OP_PTR", "op-ptr"}, {GCALC_PARSER_TOKEN_TYPE_OP_SHIFT_LEFT, "GCALC_PARSER_TOKEN_TYPE_OP_SHIFT_LEFT", "op-shift-left"}, {GCALC_PARSER_TOKEN_TYPE_SEMICOLON, "GCALC_PARSER_TOKEN_TYPE_SEMICOLON", "semicolon"}, {GCALC_PARSER_TOKEN_TYPE_TILDE, "GCALC_PARSER_TOKEN_TYPE_TILDE", "tilde"}, {GCALC_PARSER_TOKEN_TYPE_COLON, "GCALC_PARSER_TOKEN_TYPE_COLON", "colon"}, {GCALC_PARSER_TOKEN_TYPE_COMMA, "GCALC_PARSER_TOKEN_TYPE_COMMA", "comma"}, {GCALC_PARSER_TOKEN_TYPE_DOUBLE_COLON, "GCALC_PARSER_TOKEN_TYPE_DOUBLE_COLON", "double-colon"}, {GCALC_PARSER_TOKEN_TYPE_DOT, "GCALC_PARSER_TOKEN_TYPE_DOT", "dot"}, {GCALC_PARSER_TOKEN_TYPE_ELLIPSIS, "GCALC_PARSER_TOKEN_TYPE_ELLIPSIS", "ellipsis"}, {GCALC_PARSER_TOKEN_TYPE_INTERR, "GCALC_PARSER_TOKEN_TYPE_INTERR", "interr"}, {GCALC_PARSER_TOKEN_TYPE_HASH, "GCALC_PARSER_TOKEN_TYPE_HASH", "hash"}, {GCALC_PARSER_TOKEN_TYPE_CURRENCY_SYMBOL, "GCALC_PARSER_TOKEN_TYPE_CURRENCY_SYMBOL", "currency-symbol"}, {0, NULL, NULL}};
	GType gcalc_parser_token_type_type_id;
	gcalc_parser_token_type_type_id = g_enum_register_static ("GCalcParserTokenType", values);
	return gcalc_parser_token_type_type_id;
}

GType
gcalc_parser_token_type_get_type (void)
{
	static volatile gsize gcalc_parser_token_type_type_id__once = 0;
	if (g_once_init_enter (&gcalc_parser_token_type_type_id__once)) {
		GType gcalc_parser_token_type_type_id;
		gcalc_parser_token_type_type_id = gcalc_parser_token_type_get_type_once ();
		g_once_init_leave (&gcalc_parser_token_type_type_id__once, gcalc_parser_token_type_type_id);
	}
	return gcalc_parser_token_type_type_id__once;
}

/**
   * Creates a {@link MathEquation} and adds it to given
   * {@link MathEquationManager} including all Variables and
   * parameters found in the parser expression.
   */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1553 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1553 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1553 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1554 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1554 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 143 "gcalc-parser.c"
	} else {
#line 1554 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 147 "gcalc-parser.c"
	}
#line 1554 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1554 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 153 "gcalc-parser.c"
	} else {
#line 1554 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 157 "gcalc-parser.c"
	}
#line 1554 "glib-2.0.vapi"
	if (_tmp0_) {
#line 161 "gcalc-parser.c"
		gchar* _tmp2_;
#line 1555 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1555 "glib-2.0.vapi"
		result = _tmp2_;
#line 1555 "glib-2.0.vapi"
		return result;
#line 169 "gcalc-parser.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1558 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1558 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1558 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1558 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1558 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1558 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1558 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1558 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 197 "gcalc-parser.c"
				goto __catch0_g_regex_error;
			}
#line 1558 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1558 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1558 "glib-2.0.vapi"
			return NULL;
#line 206 "gcalc-parser.c"
		}
#line 1559 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1559 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1559 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1559 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1559 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1559 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 220 "gcalc-parser.c"
				goto __catch0_g_regex_error;
			}
#line 1559 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1559 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1559 "glib-2.0.vapi"
			return NULL;
#line 229 "gcalc-parser.c"
		}
#line 1559 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1559 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1559 "glib-2.0.vapi"
		result = _tmp10_;
#line 1559 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1559 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1559 "glib-2.0.vapi"
		return result;
#line 243 "gcalc-parser.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1557 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1561 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 252 "gcalc-parser.c"
	}
	__finally0:
#line 1557 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1557 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1557 "glib-2.0.vapi"
	return NULL;
#line 261 "gcalc-parser.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 274 "gcalc-parser.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 93 "../gcalc/gcalc-parser.vala"
	return self ? g_object_ref (self) : NULL;
#line 282 "gcalc-parser.c"
}

static gboolean
double_try_parse (const gchar* str,
                  gdouble* _result_,
                  const gchar** unparsed)
{
	gdouble _vala__result_ = 0.0;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gdouble _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 1007 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 1009 "glib-2.0.vapi"
	errno = 0;
#line 1010 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtod (str, &_tmp0_);
#line 1010 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 1010 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 1011 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 1011 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 1011 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1011 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 1012 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 1013 "glib-2.0.vapi"
		result = errno != ERANGE;
#line 1013 "glib-2.0.vapi"
		if (_result_) {
#line 1013 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 325 "gcalc-parser.c"
		}
#line 1013 "glib-2.0.vapi"
		if (unparsed) {
#line 1013 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 331 "gcalc-parser.c"
		}
#line 1013 "glib-2.0.vapi"
		return result;
#line 335 "gcalc-parser.c"
	} else {
		gchar* _tmp5_;
#line 1015 "glib-2.0.vapi"
		_tmp5_ = endptr;
#line 1015 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 1016 "glib-2.0.vapi"
		result = FALSE;
#line 1016 "glib-2.0.vapi"
		if (_result_) {
#line 1016 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 348 "gcalc-parser.c"
		}
#line 1016 "glib-2.0.vapi"
		if (unparsed) {
#line 1016 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 354 "gcalc-parser.c"
		}
#line 1016 "glib-2.0.vapi"
		return result;
#line 358 "gcalc-parser.c"
	}
}

void
gcalc_parser_parse (GCalcParser* self,
                    const gchar* str,
                    GCalcMathEquationManager* eqman,
                    GError** error)
{
	GCalcParserTokenType token = 0;
	GCalcEquation* _tmp0_;
	GScanner* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GCalcExpressionContainer* _tmp368_;
	GCalcExpressionContainer* _tmp369_;
	GCalcEquation* _tmp370_;
	GError* _inner_error0_ = NULL;
#line 59 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (self != NULL);
#line 59 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (str != NULL);
#line 59 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (eqman != NULL);
#line 60 "../gcalc/gcalc-parser.vala"
	token = GCALC_PARSER_TOKEN_TYPE_NONE;
#line 61 "../gcalc/gcalc-parser.vala"
	_tmp0_ = gcalc_equation_new ();
#line 61 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->eq);
#line 61 "../gcalc/gcalc-parser.vala"
	self->priv->eq = _tmp0_;
#line 62 "../gcalc/gcalc-parser.vala"
	_tmp1_ = self->priv->scanner;
#line 62 "../gcalc/gcalc-parser.vala"
	_tmp2_ = strlen (str);
#line 62 "../gcalc/gcalc-parser.vala"
	_tmp3_ = _tmp2_;
#line 62 "../gcalc/gcalc-parser.vala"
	g_scanner_input_text (_tmp1_, str, (guint) _tmp3_);
#line 63 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->current);
#line 63 "../gcalc/gcalc-parser.vala"
	self->priv->current = NULL;
#line 64 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->current_parent);
#line 64 "../gcalc/gcalc-parser.vala"
	self->priv->current_parent = NULL;
#line 65 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->top_parent);
#line 65 "../gcalc/gcalc-parser.vala"
	self->priv->top_parent = NULL;
#line 66 "../gcalc/gcalc-parser.vala"
	self->priv->enable_parameter = FALSE;
#line 67 "../gcalc/gcalc-parser.vala"
	while (TRUE) {
#line 415 "gcalc-parser.c"
		gchar* n = NULL;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 67 "../gcalc/gcalc-parser.vala"
		if (!(token != GCALC_PARSER_TOKEN_TYPE_EOF)) {
#line 67 "../gcalc/gcalc-parser.vala"
			break;
#line 426 "gcalc-parser.c"
		}
#line 68 "../gcalc/gcalc-parser.vala"
		token = gcalc_parser_read_token (self);
#line 69 "../gcalc/gcalc-parser.vala"
		if (token == GCALC_PARSER_TOKEN_TYPE_EOF) {
#line 70 "../gcalc/gcalc-parser.vala"
			break;
#line 434 "gcalc-parser.c"
		}
#line 72 "../gcalc/gcalc-parser.vala"
		_tmp4_ = gcalc_parser_token_to_string (self);
#line 72 "../gcalc/gcalc-parser.vala"
		n = _tmp4_;
#line 73 "../gcalc/gcalc-parser.vala"
		_tmp6_ = self->priv->expected;
#line 73 "../gcalc/gcalc-parser.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 73 "../gcalc/gcalc-parser.vala"
		_tmp8_ = _tmp7_;
#line 73 "../gcalc/gcalc-parser.vala"
		if (_tmp8_ != 0) {
#line 448 "gcalc-parser.c"
			GeeArrayList* _tmp9_;
#line 73 "../gcalc/gcalc-parser.vala"
			_tmp9_ = self->priv->expected;
#line 73 "../gcalc/gcalc-parser.vala"
			_tmp5_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp9_, (gpointer) ((gintptr) token));
#line 454 "gcalc-parser.c"
		} else {
#line 73 "../gcalc/gcalc-parser.vala"
			_tmp5_ = FALSE;
#line 458 "gcalc-parser.c"
		}
#line 73 "../gcalc/gcalc-parser.vala"
		if (_tmp5_) {
#line 462 "gcalc-parser.c"
			GError* _tmp10_;
#line 74 "../gcalc/gcalc-parser.vala"
			_tmp10_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression"));
#line 74 "../gcalc/gcalc-parser.vala"
			_inner_error0_ = _tmp10_;
#line 74 "../gcalc/gcalc-parser.vala"
			g_propagate_error (error, _inner_error0_);
#line 74 "../gcalc/gcalc-parser.vala"
			_g_free0 (n);
#line 74 "../gcalc/gcalc-parser.vala"
			return;
#line 474 "gcalc-parser.c"
		}
#line 76 "../gcalc/gcalc-parser.vala"
		switch (token) {
#line 76 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_IDENTIFIER:
#line 480 "gcalc-parser.c"
			{
				GRegex* _tmp11_;
				const gchar* _tmp12_;
#line 78 "../gcalc/gcalc-parser.vala"
				_tmp11_ = self->priv->rg;
#line 78 "../gcalc/gcalc-parser.vala"
				_tmp12_ = n;
#line 78 "../gcalc/gcalc-parser.vala"
				if (g_regex_match (_tmp11_, _tmp12_, G_REGEX_MATCH_ANCHORED, NULL)) {
#line 490 "gcalc-parser.c"
					gchar* cxn = NULL;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gdouble v = 0.0;
					const gchar* _tmp15_;
					GCalcConstant* cx = NULL;
					GCalcConstant* _tmp16_;
					GCalcConstant* _tmp17_;
#line 79 "../gcalc/gcalc-parser.vala"
					_tmp13_ = n;
#line 79 "../gcalc/gcalc-parser.vala"
					_tmp14_ = string_replace (_tmp13_, "i", "");
#line 79 "../gcalc/gcalc-parser.vala"
					cxn = _tmp14_;
#line 80 "../gcalc/gcalc-parser.vala"
					_tmp15_ = cxn;
#line 80 "../gcalc/gcalc-parser.vala"
					v = double_parse (_tmp15_);
#line 81 "../gcalc/gcalc-parser.vala"
					_tmp16_ = gcalc_constant_new_complex ((gdouble) 0, v);
#line 81 "../gcalc/gcalc-parser.vala"
					cx = _tmp16_;
#line 82 "../gcalc/gcalc-parser.vala"
					_tmp17_ = cx;
#line 82 "../gcalc/gcalc-parser.vala"
					gcalc_parser_add_constant (self, (GCalcMathConstant*) _tmp17_);
#line 78 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (cx);
#line 78 "../gcalc/gcalc-parser.vala"
					_g_free0 (cxn);
#line 521 "gcalc-parser.c"
				} else {
					GCalcMathExpression* sfunc = NULL;
					GCalcExpressionContainer* _tmp18_;
					GCalcExpressionContainer* _tmp19_;
					const gchar* _tmp20_;
					GCalcMathExpression* _tmp21_;
					GCalcMathExpression* _tmp22_;
#line 84 "../gcalc/gcalc-parser.vala"
					_tmp18_ = gcalc_math_equation_manager_get_functions (eqman);
#line 84 "../gcalc/gcalc-parser.vala"
					_tmp19_ = _tmp18_;
#line 84 "../gcalc/gcalc-parser.vala"
					_tmp20_ = n;
#line 84 "../gcalc/gcalc-parser.vala"
					_tmp21_ = gcalc_expression_container_find_named (_tmp19_, _tmp20_);
#line 84 "../gcalc/gcalc-parser.vala"
					sfunc = _tmp21_;
#line 85 "../gcalc/gcalc-parser.vala"
					_tmp22_ = sfunc;
#line 86 "../gcalc/gcalc-parser.vala"
					if (_tmp22_ != NULL) {
#line 543 "gcalc-parser.c"
						GCalcMathExpression* _tmp23_;
						GObject* _tmp24_;
						GObject* _tmp25_;
						GCalcMathExpression* _tmp26_;
						GCalcMathExpression* _tmp27_;
#line 86 "../gcalc/gcalc-parser.vala"
						_tmp23_ = sfunc;
#line 86 "../gcalc/gcalc-parser.vala"
						_tmp24_ = g_object_new (G_TYPE_FROM_INSTANCE ((GObject*) _tmp23_), NULL);
#line 86 "../gcalc/gcalc-parser.vala"
						_tmp25_ = G_IS_INITIALLY_UNOWNED (_tmp24_) ? g_object_ref_sink (_tmp24_) : _tmp24_;
#line 86 "../gcalc/gcalc-parser.vala"
						_tmp26_ = GCALC_IS_MATH_EXPRESSION (_tmp25_) ? ((GCalcMathExpression*) _tmp25_) : NULL;
#line 86 "../gcalc/gcalc-parser.vala"
						if (_tmp26_ == NULL) {
#line 86 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (_tmp25_);
#line 561 "gcalc-parser.c"
						}
#line 86 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (sfunc);
#line 86 "../gcalc/gcalc-parser.vala"
						sfunc = _tmp26_;
#line 87 "../gcalc/gcalc-parser.vala"
						_tmp27_ = self->priv->current;
#line 87 "../gcalc/gcalc-parser.vala"
						if (_tmp27_ == NULL) {
#line 571 "gcalc-parser.c"
							GCalcPolynomial* exp = NULL;
							GCalcPolynomial* _tmp28_;
							GCalcEquation* _tmp29_;
							GCalcExpressionContainer* _tmp30_;
							GCalcExpressionContainer* _tmp31_;
							GCalcPolynomial* _tmp32_;
							GCalcTerm* t = NULL;
							GCalcTerm* _tmp33_;
							GCalcPolynomial* _tmp34_;
							GCalcExpressionContainer* _tmp35_;
							GCalcExpressionContainer* _tmp36_;
							GCalcTerm* _tmp37_;
							GCalcTerm* _tmp38_;
							GCalcExpressionContainer* _tmp39_;
							GCalcExpressionContainer* _tmp40_;
							GCalcMathExpression* _tmp41_;
							GCalcMathExpression* _tmp42_;
							GCalcMathExpression* _tmp43_;
							GCalcTerm* _tmp44_;
							GCalcMathExpression* _tmp45_;
							GCalcPolynomial* _tmp46_;
							GCalcMathExpression* _tmp47_;
							GeeArrayList* _tmp48_;
							GeeArrayList* _tmp49_;
#line 88 "../gcalc/gcalc-parser.vala"
							_tmp28_ = gcalc_polynomial_new ();
#line 88 "../gcalc/gcalc-parser.vala"
							exp = _tmp28_;
#line 89 "../gcalc/gcalc-parser.vala"
							_tmp29_ = self->priv->eq;
#line 89 "../gcalc/gcalc-parser.vala"
							_tmp30_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp29_);
#line 89 "../gcalc/gcalc-parser.vala"
							_tmp31_ = _tmp30_;
#line 89 "../gcalc/gcalc-parser.vala"
							_tmp32_ = exp;
#line 89 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, (GCalcMathExpression*) _tmp32_);
#line 90 "../gcalc/gcalc-parser.vala"
							_tmp33_ = gcalc_term_new ();
#line 90 "../gcalc/gcalc-parser.vala"
							t = _tmp33_;
#line 91 "../gcalc/gcalc-parser.vala"
							_tmp34_ = exp;
#line 91 "../gcalc/gcalc-parser.vala"
							_tmp35_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp34_);
#line 91 "../gcalc/gcalc-parser.vala"
							_tmp36_ = _tmp35_;
#line 91 "../gcalc/gcalc-parser.vala"
							_tmp37_ = t;
#line 91 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, (GCalcMathExpression*) _tmp37_);
#line 92 "../gcalc/gcalc-parser.vala"
							_tmp38_ = t;
#line 92 "../gcalc/gcalc-parser.vala"
							_tmp39_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp38_);
#line 92 "../gcalc/gcalc-parser.vala"
							_tmp40_ = _tmp39_;
#line 92 "../gcalc/gcalc-parser.vala"
							_tmp41_ = sfunc;
#line 92 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, _tmp41_);
#line 93 "../gcalc/gcalc-parser.vala"
							_tmp42_ = sfunc;
#line 93 "../gcalc/gcalc-parser.vala"
							_tmp43_ = _g_object_ref0 (_tmp42_);
#line 93 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->current);
#line 93 "../gcalc/gcalc-parser.vala"
							self->priv->current = _tmp43_;
#line 94 "../gcalc/gcalc-parser.vala"
							_tmp44_ = t;
#line 94 "../gcalc/gcalc-parser.vala"
							_tmp45_ = _g_object_ref0 ((GCalcMathExpression*) _tmp44_);
#line 94 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->current_parent);
#line 94 "../gcalc/gcalc-parser.vala"
							self->priv->current_parent = _tmp45_;
#line 95 "../gcalc/gcalc-parser.vala"
							_tmp46_ = exp;
#line 95 "../gcalc/gcalc-parser.vala"
							_tmp47_ = _g_object_ref0 ((GCalcMathExpression*) _tmp46_);
#line 95 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->top_parent);
#line 95 "../gcalc/gcalc-parser.vala"
							self->priv->top_parent = _tmp47_;
#line 96 "../gcalc/gcalc-parser.vala"
							_tmp48_ = self->priv->expected;
#line 96 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp48_);
#line 97 "../gcalc/gcalc-parser.vala"
							_tmp49_ = self->priv->expected;
#line 97 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, (gpointer) ((gintptr) GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS));
#line 87 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (t);
#line 87 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (exp);
#line 670 "gcalc-parser.c"
						} else {
							gboolean _tmp50_ = FALSE;
							gboolean _tmp51_ = FALSE;
							GCalcMathExpression* _tmp52_;
#line 98 "../gcalc/gcalc-parser.vala"
							_tmp52_ = self->priv->current;
#line 98 "../gcalc/gcalc-parser.vala"
							if (GCALC_IS_MATH_OPERATOR (_tmp52_)) {
#line 679 "gcalc-parser.c"
								GCalcMathExpression* _tmp53_;
#line 98 "../gcalc/gcalc-parser.vala"
								_tmp53_ = self->priv->current_parent;
#line 98 "../gcalc/gcalc-parser.vala"
								_tmp51_ = GCALC_IS_MATH_TERM (_tmp53_);
#line 685 "gcalc-parser.c"
							} else {
#line 98 "../gcalc/gcalc-parser.vala"
								_tmp51_ = FALSE;
#line 689 "gcalc-parser.c"
							}
#line 98 "../gcalc/gcalc-parser.vala"
							if (_tmp51_) {
#line 693 "gcalc-parser.c"
								GCalcMathExpression* _tmp54_;
#line 98 "../gcalc/gcalc-parser.vala"
								_tmp54_ = self->priv->top_parent;
#line 98 "../gcalc/gcalc-parser.vala"
								_tmp50_ = GCALC_IS_MATH_POLYNOMIAL (_tmp54_);
#line 699 "gcalc-parser.c"
							} else {
#line 98 "../gcalc/gcalc-parser.vala"
								_tmp50_ = FALSE;
#line 703 "gcalc-parser.c"
							}
#line 98 "../gcalc/gcalc-parser.vala"
							if (_tmp50_) {
#line 707 "gcalc-parser.c"
								GCalcMathExpression* _tmp55_;
								GCalcExpressionContainer* _tmp56_;
								GCalcExpressionContainer* _tmp57_;
								GCalcMathExpression* _tmp58_;
								GCalcMathExpression* _tmp59_;
								GCalcMathExpression* _tmp60_;
								GeeArrayList* _tmp61_;
#line 99 "../gcalc/gcalc-parser.vala"
								_tmp55_ = self->priv->current_parent;
#line 99 "../gcalc/gcalc-parser.vala"
								_tmp56_ = gcalc_math_expression_get_expressions (_tmp55_);
#line 99 "../gcalc/gcalc-parser.vala"
								_tmp57_ = _tmp56_;
#line 99 "../gcalc/gcalc-parser.vala"
								_tmp58_ = sfunc;
#line 99 "../gcalc/gcalc-parser.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp57_, _tmp58_);
#line 100 "../gcalc/gcalc-parser.vala"
								_tmp59_ = sfunc;
#line 100 "../gcalc/gcalc-parser.vala"
								_tmp60_ = _g_object_ref0 (_tmp59_);
#line 100 "../gcalc/gcalc-parser.vala"
								_g_object_unref0 (self->priv->current);
#line 100 "../gcalc/gcalc-parser.vala"
								self->priv->current = _tmp60_;
#line 101 "../gcalc/gcalc-parser.vala"
								_tmp61_ = self->priv->expected;
#line 101 "../gcalc/gcalc-parser.vala"
								gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp61_);
#line 737 "gcalc-parser.c"
							} else {
								gboolean _tmp62_ = FALSE;
								GCalcMathExpression* _tmp63_;
#line 102 "../gcalc/gcalc-parser.vala"
								_tmp63_ = self->priv->current;
#line 102 "../gcalc/gcalc-parser.vala"
								if (GCALC_IS_MATH_TERM (_tmp63_)) {
#line 745 "gcalc-parser.c"
									GCalcMathExpression* _tmp64_;
#line 102 "../gcalc/gcalc-parser.vala"
									_tmp64_ = self->priv->current_parent;
#line 102 "../gcalc/gcalc-parser.vala"
									_tmp62_ = GCALC_IS_MATH_POLYNOMIAL (_tmp64_);
#line 751 "gcalc-parser.c"
								} else {
#line 102 "../gcalc/gcalc-parser.vala"
									_tmp62_ = FALSE;
#line 755 "gcalc-parser.c"
								}
#line 102 "../gcalc/gcalc-parser.vala"
								if (_tmp62_) {
#line 759 "gcalc-parser.c"
									GCalcMathExpression* _tmp65_;
									GCalcExpressionContainer* _tmp66_;
									GCalcExpressionContainer* _tmp67_;
									GCalcMathExpression* _tmp68_;
									GCalcMathExpression* _tmp69_;
									GCalcMathExpression* _tmp70_;
									GCalcMathExpression* _tmp71_;
									GCalcMathExpression* _tmp72_;
									GCalcMathExpression* _tmp73_;
									GCalcMathExpression* _tmp74_;
									GCalcMathExpression* _tmp75_;
									GCalcMathExpression* _tmp76_;
									GeeArrayList* _tmp77_;
#line 103 "../gcalc/gcalc-parser.vala"
									_tmp65_ = self->priv->current;
#line 103 "../gcalc/gcalc-parser.vala"
									_tmp66_ = gcalc_math_expression_get_expressions (_tmp65_);
#line 103 "../gcalc/gcalc-parser.vala"
									_tmp67_ = _tmp66_;
#line 103 "../gcalc/gcalc-parser.vala"
									_tmp68_ = sfunc;
#line 103 "../gcalc/gcalc-parser.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp67_, _tmp68_);
#line 104 "../gcalc/gcalc-parser.vala"
									_tmp69_ = self->priv->current;
#line 104 "../gcalc/gcalc-parser.vala"
									_tmp70_ = _g_object_ref0 (_tmp69_);
#line 104 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (self->priv->current_parent);
#line 104 "../gcalc/gcalc-parser.vala"
									self->priv->current_parent = _tmp70_;
#line 105 "../gcalc/gcalc-parser.vala"
									_tmp71_ = sfunc;
#line 105 "../gcalc/gcalc-parser.vala"
									_tmp72_ = _g_object_ref0 (_tmp71_);
#line 105 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (self->priv->current);
#line 105 "../gcalc/gcalc-parser.vala"
									self->priv->current = _tmp72_;
#line 106 "../gcalc/gcalc-parser.vala"
									_tmp73_ = self->priv->current_parent;
#line 106 "../gcalc/gcalc-parser.vala"
									_tmp74_ = gcalc_math_expression_get_parent (_tmp73_);
#line 106 "../gcalc/gcalc-parser.vala"
									_tmp75_ = _tmp74_;
#line 106 "../gcalc/gcalc-parser.vala"
									_tmp76_ = _g_object_ref0 (_tmp75_);
#line 106 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (self->priv->top_parent);
#line 106 "../gcalc/gcalc-parser.vala"
									self->priv->top_parent = _tmp76_;
#line 107 "../gcalc/gcalc-parser.vala"
									_tmp77_ = self->priv->expected;
#line 107 "../gcalc/gcalc-parser.vala"
									gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp77_);
#line 815 "gcalc-parser.c"
								}
							}
						}
					} else {
						gboolean _tmp78_ = FALSE;
						const gchar* _tmp79_;
						gchar* _tmp80_;
						gchar* _tmp81_;
						gboolean _tmp82_;
#line 109 "../gcalc/gcalc-parser.vala"
						_tmp79_ = n;
#line 109 "../gcalc/gcalc-parser.vala"
						_tmp80_ = g_utf8_strdown (_tmp79_, (gssize) -1);
#line 109 "../gcalc/gcalc-parser.vala"
						_tmp81_ = _tmp80_;
#line 109 "../gcalc/gcalc-parser.vala"
						_tmp82_ = g_strcmp0 (_tmp81_, "def") == 0;
#line 109 "../gcalc/gcalc-parser.vala"
						_g_free0 (_tmp81_);
#line 109 "../gcalc/gcalc-parser.vala"
						if (_tmp82_) {
#line 837 "gcalc-parser.c"
							GCalcMathExpression* _tmp83_;
#line 109 "../gcalc/gcalc-parser.vala"
							_tmp83_ = self->priv->current;
#line 109 "../gcalc/gcalc-parser.vala"
							_tmp78_ = _tmp83_ == NULL;
#line 843 "gcalc-parser.c"
						} else {
#line 109 "../gcalc/gcalc-parser.vala"
							_tmp78_ = FALSE;
#line 847 "gcalc-parser.c"
						}
#line 109 "../gcalc/gcalc-parser.vala"
						if (_tmp78_) {
#line 851 "gcalc-parser.c"
						} else {
							gboolean _tmp84_ = FALSE;
							const gchar* _tmp85_;
							gchar* _tmp86_;
							gchar* _tmp87_;
							gboolean _tmp88_;
#line 111 "../gcalc/gcalc-parser.vala"
							_tmp85_ = n;
#line 111 "../gcalc/gcalc-parser.vala"
							_tmp86_ = g_utf8_strdown (_tmp85_, (gssize) -1);
#line 111 "../gcalc/gcalc-parser.vala"
							_tmp87_ = _tmp86_;
#line 111 "../gcalc/gcalc-parser.vala"
							_tmp88_ = g_strcmp0 (_tmp87_, "def") == 0;
#line 111 "../gcalc/gcalc-parser.vala"
							_g_free0 (_tmp87_);
#line 111 "../gcalc/gcalc-parser.vala"
							if (_tmp88_) {
#line 870 "gcalc-parser.c"
								GCalcMathExpression* _tmp89_;
#line 111 "../gcalc/gcalc-parser.vala"
								_tmp89_ = self->priv->current;
#line 111 "../gcalc/gcalc-parser.vala"
								_tmp84_ = GCALC_IS_MATH_FUNCTION (_tmp89_);
#line 876 "gcalc-parser.c"
							} else {
#line 111 "../gcalc/gcalc-parser.vala"
								_tmp84_ = FALSE;
#line 880 "gcalc-parser.c"
							}
#line 111 "../gcalc/gcalc-parser.vala"
							if (_tmp84_) {
#line 884 "gcalc-parser.c"
								GError* _tmp90_;
#line 112 "../gcalc/gcalc-parser.vala"
								_tmp90_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected function definition expression"));
#line 112 "../gcalc/gcalc-parser.vala"
								_inner_error0_ = _tmp90_;
#line 112 "../gcalc/gcalc-parser.vala"
								g_propagate_error (error, _inner_error0_);
#line 112 "../gcalc/gcalc-parser.vala"
								_g_object_unref0 (sfunc);
#line 112 "../gcalc/gcalc-parser.vala"
								_g_free0 (n);
#line 112 "../gcalc/gcalc-parser.vala"
								return;
#line 898 "gcalc-parser.c"
							} else {
								GCalcMathExpression* v = NULL;
								const gchar* _tmp91_;
								GCalcVariable* _tmp92_;
								GCalcMathExpression* _tmp93_;
								GCalcMathVariable* sv = NULL;
								const gchar* _tmp97_;
								GCalcMathVariable* _tmp98_;
								GCalcMathVariable* _tmp99_;
								GCalcMathVariable* _tmp100_;
								GCalcMathExpression* _tmp116_;
#line 114 "../gcalc/gcalc-parser.vala"
								_tmp91_ = n;
#line 114 "../gcalc/gcalc-parser.vala"
								_tmp92_ = gcalc_variable_new (_tmp91_);
#line 114 "../gcalc/gcalc-parser.vala"
								_tmp93_ = GCALC_IS_MATH_EXPRESSION (_tmp92_) ? ((GCalcMathExpression*) _tmp92_) : NULL;
#line 114 "../gcalc/gcalc-parser.vala"
								if (_tmp93_ == NULL) {
#line 114 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (_tmp92_);
#line 920 "gcalc-parser.c"
								}
#line 114 "../gcalc/gcalc-parser.vala"
								v = _tmp93_;
#line 115 "../gcalc/gcalc-parser.vala"
								if (self->priv->enable_parameter) {
#line 926 "gcalc-parser.c"
									const gchar* _tmp94_;
									GCalcParameter* _tmp95_;
									GCalcMathExpression* _tmp96_;
#line 116 "../gcalc/gcalc-parser.vala"
									_tmp94_ = n;
#line 116 "../gcalc/gcalc-parser.vala"
									_tmp95_ = gcalc_parameter_new (_tmp94_);
#line 116 "../gcalc/gcalc-parser.vala"
									_tmp96_ = GCALC_IS_MATH_EXPRESSION (_tmp95_) ? ((GCalcMathExpression*) _tmp95_) : NULL;
#line 116 "../gcalc/gcalc-parser.vala"
									if (_tmp96_ == NULL) {
#line 116 "../gcalc/gcalc-parser.vala"
										_g_object_unref0 (_tmp95_);
#line 940 "gcalc-parser.c"
									}
#line 116 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (v);
#line 116 "../gcalc/gcalc-parser.vala"
									v = _tmp96_;
#line 117 "../gcalc/gcalc-parser.vala"
									self->priv->enable_parameter = FALSE;
#line 948 "gcalc-parser.c"
								}
#line 119 "../gcalc/gcalc-parser.vala"
								_tmp97_ = n;
#line 119 "../gcalc/gcalc-parser.vala"
								_tmp98_ = gcalc_math_equation_manager_find_variable (eqman, _tmp97_);
#line 119 "../gcalc/gcalc-parser.vala"
								_tmp99_ = GCALC_IS_MATH_VARIABLE (_tmp98_) ? ((GCalcMathVariable*) _tmp98_) : NULL;
#line 119 "../gcalc/gcalc-parser.vala"
								if (_tmp99_ == NULL) {
#line 119 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (_tmp98_);
#line 960 "gcalc-parser.c"
								}
#line 119 "../gcalc/gcalc-parser.vala"
								sv = _tmp99_;
#line 120 "../gcalc/gcalc-parser.vala"
								_tmp100_ = sv;
#line 120 "../gcalc/gcalc-parser.vala"
								if (_tmp100_ == NULL) {
#line 968 "gcalc-parser.c"
									GCalcEquation* _tmp101_;
									GCalcExpressionHashMap* _tmp102_;
									GCalcExpressionHashMap* _tmp103_;
									const gchar* _tmp104_;
									GCalcMathExpression* _tmp105_;
									GCalcMathVariable* _tmp106_;
									GCalcMathVariable* _tmp107_;
#line 121 "../gcalc/gcalc-parser.vala"
									_tmp101_ = self->priv->eq;
#line 121 "../gcalc/gcalc-parser.vala"
									_tmp102_ = gcalc_math_equation_get_variables ((GCalcMathEquation*) _tmp101_);
#line 121 "../gcalc/gcalc-parser.vala"
									_tmp103_ = _tmp102_;
#line 121 "../gcalc/gcalc-parser.vala"
									_tmp104_ = n;
#line 121 "../gcalc/gcalc-parser.vala"
									_tmp105_ = gcalc_expression_hash_map_find_named (_tmp103_, _tmp104_);
#line 121 "../gcalc/gcalc-parser.vala"
									_tmp106_ = GCALC_IS_MATH_VARIABLE (_tmp105_) ? ((GCalcMathVariable*) _tmp105_) : NULL;
#line 121 "../gcalc/gcalc-parser.vala"
									if (_tmp106_ == NULL) {
#line 121 "../gcalc/gcalc-parser.vala"
										_g_object_unref0 (_tmp105_);
#line 992 "gcalc-parser.c"
									}
#line 121 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (sv);
#line 121 "../gcalc/gcalc-parser.vala"
									sv = _tmp106_;
#line 122 "../gcalc/gcalc-parser.vala"
									_tmp107_ = sv;
#line 122 "../gcalc/gcalc-parser.vala"
									if (_tmp107_ == NULL) {
#line 1002 "gcalc-parser.c"
										GCalcEquation* _tmp108_;
										GCalcExpressionHashMap* _tmp109_;
										GCalcExpressionHashMap* _tmp110_;
										GCalcMathExpression* _tmp111_;
#line 123 "../gcalc/gcalc-parser.vala"
										_tmp108_ = self->priv->eq;
#line 123 "../gcalc/gcalc-parser.vala"
										_tmp109_ = gcalc_math_equation_get_variables ((GCalcMathEquation*) _tmp108_);
#line 123 "../gcalc/gcalc-parser.vala"
										_tmp110_ = _tmp109_;
#line 123 "../gcalc/gcalc-parser.vala"
										_tmp111_ = v;
#line 123 "../gcalc/gcalc-parser.vala"
										gcalc_expression_hash_map_add (_tmp110_, _tmp111_);
#line 1017 "gcalc-parser.c"
									} else {
										GCalcMathExpression* _tmp112_;
										GCalcMathVariable* _tmp113_;
#line 125 "../gcalc/gcalc-parser.vala"
										_tmp112_ = v;
#line 125 "../gcalc/gcalc-parser.vala"
										_tmp113_ = sv;
#line 125 "../gcalc/gcalc-parser.vala"
										gcalc_math_variable_set_bind (G_TYPE_CHECK_INSTANCE_CAST (_tmp112_, GCALC_TYPE_MATH_VARIABLE, GCalcMathVariable), _tmp113_);
#line 1027 "gcalc-parser.c"
									}
								} else {
									GCalcMathExpression* _tmp114_;
									GCalcMathVariable* _tmp115_;
#line 128 "../gcalc/gcalc-parser.vala"
									_tmp114_ = v;
#line 128 "../gcalc/gcalc-parser.vala"
									_tmp115_ = sv;
#line 128 "../gcalc/gcalc-parser.vala"
									gcalc_math_variable_set_bind (G_TYPE_CHECK_INSTANCE_CAST (_tmp114_, GCALC_TYPE_MATH_VARIABLE, GCalcMathVariable), _tmp115_);
#line 1038 "gcalc-parser.c"
								}
#line 130 "../gcalc/gcalc-parser.vala"
								_tmp116_ = self->priv->current;
#line 130 "../gcalc/gcalc-parser.vala"
								if (_tmp116_ == NULL) {
#line 1044 "gcalc-parser.c"
									GCalcPolynomial* exp = NULL;
									GCalcPolynomial* _tmp117_;
									GCalcEquation* _tmp118_;
									GCalcExpressionContainer* _tmp119_;
									GCalcExpressionContainer* _tmp120_;
									GCalcPolynomial* _tmp121_;
									GCalcTerm* t = NULL;
									GCalcTerm* _tmp122_;
									GCalcPolynomial* _tmp123_;
									GCalcExpressionContainer* _tmp124_;
									GCalcExpressionContainer* _tmp125_;
									GCalcTerm* _tmp126_;
									GCalcTerm* _tmp127_;
									GCalcExpressionContainer* _tmp128_;
									GCalcExpressionContainer* _tmp129_;
									GCalcMathExpression* _tmp130_;
									GCalcMathExpression* _tmp131_;
									GCalcMathExpression* _tmp132_;
									GCalcMathExpression* _tmp133_;
									GCalcMathExpression* _tmp134_;
									GCalcMathExpression* _tmp135_;
									GCalcMathExpression* _tmp136_;
									GCalcMathExpression* _tmp137_;
									GCalcMathExpression* _tmp138_;
									GCalcMathExpression* _tmp139_;
									GCalcMathExpression* _tmp140_;
									GeeArrayList* _tmp141_;
#line 131 "../gcalc/gcalc-parser.vala"
									_tmp117_ = gcalc_polynomial_new ();
#line 131 "../gcalc/gcalc-parser.vala"
									exp = _tmp117_;
#line 132 "../gcalc/gcalc-parser.vala"
									_tmp118_ = self->priv->eq;
#line 132 "../gcalc/gcalc-parser.vala"
									_tmp119_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp118_);
#line 132 "../gcalc/gcalc-parser.vala"
									_tmp120_ = _tmp119_;
#line 132 "../gcalc/gcalc-parser.vala"
									_tmp121_ = exp;
#line 132 "../gcalc/gcalc-parser.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp120_, (GCalcMathExpression*) _tmp121_);
#line 133 "../gcalc/gcalc-parser.vala"
									_tmp122_ = gcalc_term_new ();
#line 133 "../gcalc/gcalc-parser.vala"
									t = _tmp122_;
#line 134 "../gcalc/gcalc-parser.vala"
									_tmp123_ = exp;
#line 134 "../gcalc/gcalc-parser.vala"
									_tmp124_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp123_);
#line 134 "../gcalc/gcalc-parser.vala"
									_tmp125_ = _tmp124_;
#line 134 "../gcalc/gcalc-parser.vala"
									_tmp126_ = t;
#line 134 "../gcalc/gcalc-parser.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp125_, (GCalcMathExpression*) _tmp126_);
#line 135 "../gcalc/gcalc-parser.vala"
									_tmp127_ = t;
#line 135 "../gcalc/gcalc-parser.vala"
									_tmp128_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp127_);
#line 135 "../gcalc/gcalc-parser.vala"
									_tmp129_ = _tmp128_;
#line 135 "../gcalc/gcalc-parser.vala"
									_tmp130_ = v;
#line 135 "../gcalc/gcalc-parser.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp129_, _tmp130_);
#line 136 "../gcalc/gcalc-parser.vala"
									_tmp131_ = v;
#line 136 "../gcalc/gcalc-parser.vala"
									_tmp132_ = _g_object_ref0 (_tmp131_);
#line 136 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (self->priv->current);
#line 136 "../gcalc/gcalc-parser.vala"
									self->priv->current = _tmp132_;
#line 137 "../gcalc/gcalc-parser.vala"
									_tmp133_ = v;
#line 137 "../gcalc/gcalc-parser.vala"
									_tmp134_ = gcalc_math_expression_get_parent (_tmp133_);
#line 137 "../gcalc/gcalc-parser.vala"
									_tmp135_ = _tmp134_;
#line 137 "../gcalc/gcalc-parser.vala"
									_tmp136_ = _g_object_ref0 (_tmp135_);
#line 137 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (self->priv->current_parent);
#line 137 "../gcalc/gcalc-parser.vala"
									self->priv->current_parent = _tmp136_;
#line 138 "../gcalc/gcalc-parser.vala"
									_tmp137_ = self->priv->current_parent;
#line 138 "../gcalc/gcalc-parser.vala"
									_tmp138_ = gcalc_math_expression_get_parent (_tmp137_);
#line 138 "../gcalc/gcalc-parser.vala"
									_tmp139_ = _tmp138_;
#line 138 "../gcalc/gcalc-parser.vala"
									_tmp140_ = _g_object_ref0 (_tmp139_);
#line 138 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (self->priv->top_parent);
#line 138 "../gcalc/gcalc-parser.vala"
									self->priv->top_parent = _tmp140_;
#line 139 "../gcalc/gcalc-parser.vala"
									_tmp141_ = self->priv->expected;
#line 139 "../gcalc/gcalc-parser.vala"
									gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp141_);
#line 130 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (t);
#line 130 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (exp);
#line 1150 "gcalc-parser.c"
								} else {
									gboolean _tmp142_ = FALSE;
									gboolean _tmp143_ = FALSE;
									GCalcMathExpression* _tmp144_;
#line 140 "../gcalc/gcalc-parser.vala"
									_tmp144_ = self->priv->current;
#line 140 "../gcalc/gcalc-parser.vala"
									if (GCALC_IS_MATH_OPERATOR (_tmp144_)) {
#line 1159 "gcalc-parser.c"
										GCalcMathExpression* _tmp145_;
#line 140 "../gcalc/gcalc-parser.vala"
										_tmp145_ = self->priv->current_parent;
#line 140 "../gcalc/gcalc-parser.vala"
										_tmp143_ = GCALC_IS_MATH_TERM (_tmp145_);
#line 1165 "gcalc-parser.c"
									} else {
#line 140 "../gcalc/gcalc-parser.vala"
										_tmp143_ = FALSE;
#line 1169 "gcalc-parser.c"
									}
#line 140 "../gcalc/gcalc-parser.vala"
									if (_tmp143_) {
#line 1173 "gcalc-parser.c"
										GCalcMathExpression* _tmp146_;
#line 140 "../gcalc/gcalc-parser.vala"
										_tmp146_ = self->priv->top_parent;
#line 140 "../gcalc/gcalc-parser.vala"
										_tmp142_ = GCALC_IS_MATH_POLYNOMIAL (_tmp146_);
#line 1179 "gcalc-parser.c"
									} else {
#line 140 "../gcalc/gcalc-parser.vala"
										_tmp142_ = FALSE;
#line 1183 "gcalc-parser.c"
									}
#line 140 "../gcalc/gcalc-parser.vala"
									if (_tmp142_) {
#line 1187 "gcalc-parser.c"
										GCalcMathExpression* _tmp147_;
										GCalcExpressionContainer* _tmp148_;
										GCalcExpressionContainer* _tmp149_;
										GCalcMathExpression* _tmp150_;
										GCalcMathExpression* _tmp151_;
										GCalcMathExpression* _tmp152_;
										GeeArrayList* _tmp153_;
#line 141 "../gcalc/gcalc-parser.vala"
										_tmp147_ = self->priv->current_parent;
#line 141 "../gcalc/gcalc-parser.vala"
										_tmp148_ = gcalc_math_expression_get_expressions (_tmp147_);
#line 141 "../gcalc/gcalc-parser.vala"
										_tmp149_ = _tmp148_;
#line 141 "../gcalc/gcalc-parser.vala"
										_tmp150_ = v;
#line 141 "../gcalc/gcalc-parser.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp149_, _tmp150_);
#line 142 "../gcalc/gcalc-parser.vala"
										_tmp151_ = v;
#line 142 "../gcalc/gcalc-parser.vala"
										_tmp152_ = _g_object_ref0 (_tmp151_);
#line 142 "../gcalc/gcalc-parser.vala"
										_g_object_unref0 (self->priv->current);
#line 142 "../gcalc/gcalc-parser.vala"
										self->priv->current = _tmp152_;
#line 143 "../gcalc/gcalc-parser.vala"
										_tmp153_ = self->priv->expected;
#line 143 "../gcalc/gcalc-parser.vala"
										gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp153_);
#line 1217 "gcalc-parser.c"
									} else {
										GCalcMathExpression* _tmp154_;
#line 144 "../gcalc/gcalc-parser.vala"
										_tmp154_ = self->priv->current;
#line 144 "../gcalc/gcalc-parser.vala"
										if (GCALC_IS_MATH_TERM (_tmp154_)) {
#line 1224 "gcalc-parser.c"
											GCalcMathExpression* _tmp155_;
											GCalcExpressionContainer* _tmp156_;
											GCalcExpressionContainer* _tmp157_;
											GCalcMathExpression* _tmp158_;
											GCalcMathExpression* _tmp159_;
											GCalcMathExpression* _tmp160_;
											GCalcMathExpression* _tmp161_;
											GCalcMathExpression* _tmp162_;
											GCalcMathExpression* _tmp163_;
											GCalcMathExpression* _tmp164_;
											GCalcMathExpression* _tmp165_;
											GCalcMathExpression* _tmp166_;
											GCalcMathExpression* _tmp167_;
											GCalcMathExpression* _tmp168_;
											GeeArrayList* _tmp169_;
#line 145 "../gcalc/gcalc-parser.vala"
											_tmp155_ = self->priv->current;
#line 145 "../gcalc/gcalc-parser.vala"
											_tmp156_ = gcalc_math_expression_get_expressions (_tmp155_);
#line 145 "../gcalc/gcalc-parser.vala"
											_tmp157_ = _tmp156_;
#line 145 "../gcalc/gcalc-parser.vala"
											_tmp158_ = v;
#line 145 "../gcalc/gcalc-parser.vala"
											gee_abstract_collection_add ((GeeAbstractCollection*) _tmp157_, _tmp158_);
#line 146 "../gcalc/gcalc-parser.vala"
											_tmp159_ = v;
#line 146 "../gcalc/gcalc-parser.vala"
											_tmp160_ = _g_object_ref0 (_tmp159_);
#line 146 "../gcalc/gcalc-parser.vala"
											_g_object_unref0 (self->priv->current);
#line 146 "../gcalc/gcalc-parser.vala"
											self->priv->current = _tmp160_;
#line 147 "../gcalc/gcalc-parser.vala"
											_tmp161_ = v;
#line 147 "../gcalc/gcalc-parser.vala"
											_tmp162_ = gcalc_math_expression_get_parent (_tmp161_);
#line 147 "../gcalc/gcalc-parser.vala"
											_tmp163_ = _tmp162_;
#line 147 "../gcalc/gcalc-parser.vala"
											_tmp164_ = _g_object_ref0 (_tmp163_);
#line 147 "../gcalc/gcalc-parser.vala"
											_g_object_unref0 (self->priv->current_parent);
#line 147 "../gcalc/gcalc-parser.vala"
											self->priv->current_parent = _tmp164_;
#line 148 "../gcalc/gcalc-parser.vala"
											_tmp165_ = self->priv->current_parent;
#line 148 "../gcalc/gcalc-parser.vala"
											_tmp166_ = gcalc_math_expression_get_parent (_tmp165_);
#line 148 "../gcalc/gcalc-parser.vala"
											_tmp167_ = _tmp166_;
#line 148 "../gcalc/gcalc-parser.vala"
											_tmp168_ = _g_object_ref0 (_tmp167_);
#line 148 "../gcalc/gcalc-parser.vala"
											_g_object_unref0 (self->priv->top_parent);
#line 148 "../gcalc/gcalc-parser.vala"
											self->priv->top_parent = _tmp168_;
#line 149 "../gcalc/gcalc-parser.vala"
											_tmp169_ = self->priv->expected;
#line 149 "../gcalc/gcalc-parser.vala"
											gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp169_);
#line 1286 "gcalc-parser.c"
										}
									}
								}
#line 111 "../gcalc/gcalc-parser.vala"
								_g_object_unref0 (sv);
#line 111 "../gcalc/gcalc-parser.vala"
								_g_object_unref0 (v);
#line 1294 "gcalc-parser.c"
							}
						}
					}
#line 85 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (sfunc);
#line 1300 "gcalc-parser.c"
				}
#line 153 "../gcalc/gcalc-parser.vala"
				break;
#line 1304 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_INTEGER_LITERAL:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_REAL_LITERAL:
#line 1310 "gcalc-parser.c"
			{
				gdouble res = 0.0;
				const gchar* _tmp170_;
				gdouble _tmp171_ = 0.0;
				gboolean _tmp172_;
				GCalcConstant* cexp = NULL;
				const gchar* _tmp174_;
				GCalcConstant* _tmp175_;
				GCalcConstant* _tmp176_;
#line 156 "../gcalc/gcalc-parser.vala"
				res = (gdouble) 0;
#line 157 "../gcalc/gcalc-parser.vala"
				_tmp170_ = n;
#line 157 "../gcalc/gcalc-parser.vala"
				_tmp172_ = double_try_parse (_tmp170_, &_tmp171_, NULL);
#line 157 "../gcalc/gcalc-parser.vala"
				res = _tmp171_;
#line 157 "../gcalc/gcalc-parser.vala"
				if (!_tmp172_) {
#line 1330 "gcalc-parser.c"
					GError* _tmp173_;
#line 158 "../gcalc/gcalc-parser.vala"
					_tmp173_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression for a constant"));
#line 158 "../gcalc/gcalc-parser.vala"
					_inner_error0_ = _tmp173_;
#line 158 "../gcalc/gcalc-parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 158 "../gcalc/gcalc-parser.vala"
					_g_free0 (n);
#line 158 "../gcalc/gcalc-parser.vala"
					return;
#line 1342 "gcalc-parser.c"
				}
#line 160 "../gcalc/gcalc-parser.vala"
				_tmp174_ = n;
#line 160 "../gcalc/gcalc-parser.vala"
				_tmp175_ = gcalc_constant_new_double (double_parse (_tmp174_));
#line 160 "../gcalc/gcalc-parser.vala"
				cexp = _tmp175_;
#line 161 "../gcalc/gcalc-parser.vala"
				_tmp176_ = cexp;
#line 161 "../gcalc/gcalc-parser.vala"
				gcalc_parser_add_constant (self, (GCalcMathConstant*) _tmp176_);
#line 162 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (cexp);
#line 162 "../gcalc/gcalc-parser.vala"
				break;
#line 1358 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_STAR:
#line 1362 "gcalc-parser.c"
			{
				GCalcMultiply* op = NULL;
				GCalcMultiply* _tmp177_;
				GCalcMultiply* _tmp178_;
				GCalcEquation* _tmp179_;
#line 164 "../gcalc/gcalc-parser.vala"
				_tmp177_ = gcalc_multiply_new ();
#line 164 "../gcalc/gcalc-parser.vala"
				op = _tmp177_;
#line 165 "../gcalc/gcalc-parser.vala"
				_tmp178_ = op;
#line 165 "../gcalc/gcalc-parser.vala"
				_tmp179_ = self->priv->eq;
#line 165 "../gcalc/gcalc-parser.vala"
				gcalc_parser_process_term_operator (self, (GCalcMathOperator*) _tmp178_, _tmp179_, &_inner_error0_);
#line 165 "../gcalc/gcalc-parser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "../gcalc/gcalc-parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 165 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (op);
#line 165 "../gcalc/gcalc-parser.vala"
					_g_free0 (n);
#line 165 "../gcalc/gcalc-parser.vala"
					return;
#line 1388 "gcalc-parser.c"
				}
#line 166 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (op);
#line 166 "../gcalc/gcalc-parser.vala"
				break;
#line 1394 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_PLUS:
#line 1398 "gcalc-parser.c"
			{
				GCalcPlus* opp = NULL;
				GCalcPlus* _tmp180_;
				GCalcPlus* _tmp181_;
				GCalcEquation* _tmp182_;
#line 168 "../gcalc/gcalc-parser.vala"
				_tmp180_ = gcalc_plus_new ();
#line 168 "../gcalc/gcalc-parser.vala"
				opp = _tmp180_;
#line 169 "../gcalc/gcalc-parser.vala"
				_tmp181_ = opp;
#line 169 "../gcalc/gcalc-parser.vala"
				_tmp182_ = self->priv->eq;
#line 169 "../gcalc/gcalc-parser.vala"
				gcalc_parser_process_operator (self, (GCalcMathOperator*) _tmp181_, _tmp182_, &_inner_error0_);
#line 169 "../gcalc/gcalc-parser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../gcalc/gcalc-parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 169 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (opp);
#line 169 "../gcalc/gcalc-parser.vala"
					_g_free0 (n);
#line 169 "../gcalc/gcalc-parser.vala"
					return;
#line 1424 "gcalc-parser.c"
				}
#line 170 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (opp);
#line 170 "../gcalc/gcalc-parser.vala"
				break;
#line 1430 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_DIV:
#line 1434 "gcalc-parser.c"
			{
				GCalcDivision* op = NULL;
				GCalcDivision* _tmp183_;
				GCalcDivision* _tmp184_;
				GCalcEquation* _tmp185_;
#line 172 "../gcalc/gcalc-parser.vala"
				_tmp183_ = gcalc_division_new ();
#line 172 "../gcalc/gcalc-parser.vala"
				op = _tmp183_;
#line 173 "../gcalc/gcalc-parser.vala"
				_tmp184_ = op;
#line 173 "../gcalc/gcalc-parser.vala"
				_tmp185_ = self->priv->eq;
#line 173 "../gcalc/gcalc-parser.vala"
				gcalc_parser_process_term_operator (self, (GCalcMathOperator*) _tmp184_, _tmp185_, &_inner_error0_);
#line 173 "../gcalc/gcalc-parser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../gcalc/gcalc-parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 173 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (op);
#line 173 "../gcalc/gcalc-parser.vala"
					_g_free0 (n);
#line 173 "../gcalc/gcalc-parser.vala"
					return;
#line 1460 "gcalc-parser.c"
				}
#line 174 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (op);
#line 174 "../gcalc/gcalc-parser.vala"
				break;
#line 1466 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_MINUS:
#line 1470 "gcalc-parser.c"
			{
				GCalcMinus* opp = NULL;
				GCalcMinus* _tmp186_;
				GCalcMinus* _tmp187_;
				GCalcEquation* _tmp188_;
#line 176 "../gcalc/gcalc-parser.vala"
				_tmp186_ = gcalc_minus_new ();
#line 176 "../gcalc/gcalc-parser.vala"
				opp = _tmp186_;
#line 177 "../gcalc/gcalc-parser.vala"
				_tmp187_ = opp;
#line 177 "../gcalc/gcalc-parser.vala"
				_tmp188_ = self->priv->eq;
#line 177 "../gcalc/gcalc-parser.vala"
				gcalc_parser_process_operator (self, (GCalcMathOperator*) _tmp187_, _tmp188_, &_inner_error0_);
#line 177 "../gcalc/gcalc-parser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 177 "../gcalc/gcalc-parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 177 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (opp);
#line 177 "../gcalc/gcalc-parser.vala"
					_g_free0 (n);
#line 177 "../gcalc/gcalc-parser.vala"
					return;
#line 1496 "gcalc-parser.c"
				}
#line 178 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (opp);
#line 178 "../gcalc/gcalc-parser.vala"
				break;
#line 1502 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_ASSIGN:
#line 1506 "gcalc-parser.c"
			{
				GCalcMathExpression* _tmp189_;
#line 180 "../gcalc/gcalc-parser.vala"
				_tmp189_ = self->priv->current;
#line 180 "../gcalc/gcalc-parser.vala"
				if (_tmp189_ == NULL) {
#line 1513 "gcalc-parser.c"
					GError* _tmp190_;
#line 181 "../gcalc/gcalc-parser.vala"
					_tmp190_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression for an assignment"));
#line 181 "../gcalc/gcalc-parser.vala"
					_inner_error0_ = _tmp190_;
#line 181 "../gcalc/gcalc-parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 181 "../gcalc/gcalc-parser.vala"
					_g_free0 (n);
#line 181 "../gcalc/gcalc-parser.vala"
					return;
#line 1525 "gcalc-parser.c"
				} else {
					GCalcMathExpression* _tmp191_;
#line 182 "../gcalc/gcalc-parser.vala"
					_tmp191_ = self->priv->current;
#line 182 "../gcalc/gcalc-parser.vala"
					if (GCALC_IS_MATH_POLYNOMIAL (_tmp191_)) {
#line 1532 "gcalc-parser.c"
						GError* _tmp192_;
#line 183 "../gcalc/gcalc-parser.vala"
						_tmp192_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression: can't set a value to a polynomial"));
#line 183 "../gcalc/gcalc-parser.vala"
						_inner_error0_ = _tmp192_;
#line 183 "../gcalc/gcalc-parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 183 "../gcalc/gcalc-parser.vala"
						_g_free0 (n);
#line 183 "../gcalc/gcalc-parser.vala"
						return;
#line 1544 "gcalc-parser.c"
					} else {
						GCalcMathExpression* _tmp193_;
#line 184 "../gcalc/gcalc-parser.vala"
						_tmp193_ = self->priv->current;
#line 184 "../gcalc/gcalc-parser.vala"
						if (GCALC_IS_MATH_VARIABLE (_tmp193_)) {
#line 1551 "gcalc-parser.c"
							gboolean removed = FALSE;
							GCalcMathExpression* _tmp194_;
							GCalcMathExpression* _tmp195_;
							GCalcMathExpression* _tmp196_;
							GCalcAssign* expa = NULL;
							GCalcAssign* _tmp229_;
							GCalcEquation* _tmp230_;
							GCalcExpressionContainer* _tmp231_;
							GCalcExpressionContainer* _tmp232_;
							GCalcAssign* _tmp233_;
							GCalcAssign* _tmp234_;
							GCalcExpressionContainer* _tmp235_;
							GCalcExpressionContainer* _tmp236_;
							GCalcMathExpression* _tmp237_;
							GCalcPolynomial* exp = NULL;
							GCalcPolynomial* _tmp238_;
							GCalcAssign* _tmp239_;
							GCalcExpressionContainer* _tmp240_;
							GCalcExpressionContainer* _tmp241_;
							GCalcPolynomial* _tmp242_;
							GCalcTerm* t = NULL;
							GCalcTerm* _tmp243_;
							GCalcPolynomial* _tmp244_;
							GCalcExpressionContainer* _tmp245_;
							GCalcExpressionContainer* _tmp246_;
							GCalcTerm* _tmp247_;
							GCalcTerm* _tmp248_;
							GCalcMathExpression* _tmp249_;
							GCalcTerm* _tmp250_;
							GCalcMathExpression* _tmp251_;
							GCalcPolynomial* _tmp252_;
							GCalcMathExpression* _tmp253_;
							GeeArrayList* _tmp254_;
#line 185 "../gcalc/gcalc-parser.vala"
							removed = FALSE;
#line 186 "../gcalc/gcalc-parser.vala"
							_tmp194_ = self->priv->current;
#line 186 "../gcalc/gcalc-parser.vala"
							_tmp195_ = gcalc_math_expression_get_parent (_tmp194_);
#line 186 "../gcalc/gcalc-parser.vala"
							_tmp196_ = _tmp195_;
#line 186 "../gcalc/gcalc-parser.vala"
							if (_tmp196_ != NULL) {
#line 1595 "gcalc-parser.c"
								GCalcMathExpression* _tmp197_;
								GCalcMathExpression* _tmp198_;
								GCalcMathExpression* _tmp199_;
#line 187 "../gcalc/gcalc-parser.vala"
								_tmp197_ = self->priv->current;
#line 187 "../gcalc/gcalc-parser.vala"
								_tmp198_ = gcalc_math_expression_get_parent (_tmp197_);
#line 187 "../gcalc/gcalc-parser.vala"
								_tmp199_ = _tmp198_;
#line 187 "../gcalc/gcalc-parser.vala"
								if (GCALC_IS_MATH_TERM (_tmp199_)) {
#line 1607 "gcalc-parser.c"
									GCalcMathExpression* t = NULL;
									GCalcMathExpression* _tmp200_;
									GCalcMathExpression* _tmp201_;
									GCalcMathExpression* _tmp202_;
									GCalcMathExpression* _tmp203_;
									GCalcMathExpression* _tmp204_;
									GCalcMathExpression* _tmp205_;
									GCalcMathExpression* _tmp206_;
#line 188 "../gcalc/gcalc-parser.vala"
									_tmp200_ = self->priv->current;
#line 188 "../gcalc/gcalc-parser.vala"
									_tmp201_ = gcalc_math_expression_get_parent (_tmp200_);
#line 188 "../gcalc/gcalc-parser.vala"
									_tmp202_ = _tmp201_;
#line 188 "../gcalc/gcalc-parser.vala"
									_tmp203_ = _g_object_ref0 (_tmp202_);
#line 188 "../gcalc/gcalc-parser.vala"
									t = _tmp203_;
#line 189 "../gcalc/gcalc-parser.vala"
									_tmp204_ = t;
#line 189 "../gcalc/gcalc-parser.vala"
									_tmp205_ = gcalc_math_expression_get_parent (_tmp204_);
#line 189 "../gcalc/gcalc-parser.vala"
									_tmp206_ = _tmp205_;
#line 189 "../gcalc/gcalc-parser.vala"
									if (_tmp206_ != NULL) {
#line 1634 "gcalc-parser.c"
										GCalcMathExpression* _tmp207_;
										GCalcMathExpression* _tmp208_;
										GCalcMathExpression* _tmp209_;
#line 190 "../gcalc/gcalc-parser.vala"
										_tmp207_ = t;
#line 190 "../gcalc/gcalc-parser.vala"
										_tmp208_ = gcalc_math_expression_get_parent (_tmp207_);
#line 190 "../gcalc/gcalc-parser.vala"
										_tmp209_ = _tmp208_;
#line 190 "../gcalc/gcalc-parser.vala"
										if (GCALC_IS_MATH_POLYNOMIAL (_tmp209_)) {
#line 1646 "gcalc-parser.c"
											GCalcMathExpression* p = NULL;
											GCalcMathExpression* _tmp210_;
											GCalcMathExpression* _tmp211_;
											GCalcMathExpression* _tmp212_;
											GCalcMathExpression* _tmp213_;
											GCalcMathExpression* _tmp214_;
											GCalcMathExpression* _tmp215_;
											GCalcMathExpression* _tmp216_;
#line 191 "../gcalc/gcalc-parser.vala"
											_tmp210_ = t;
#line 191 "../gcalc/gcalc-parser.vala"
											_tmp211_ = gcalc_math_expression_get_parent (_tmp210_);
#line 191 "../gcalc/gcalc-parser.vala"
											_tmp212_ = _tmp211_;
#line 191 "../gcalc/gcalc-parser.vala"
											_tmp213_ = _g_object_ref0 (_tmp212_);
#line 191 "../gcalc/gcalc-parser.vala"
											p = _tmp213_;
#line 192 "../gcalc/gcalc-parser.vala"
											_tmp214_ = p;
#line 192 "../gcalc/gcalc-parser.vala"
											_tmp215_ = gcalc_math_expression_get_parent (_tmp214_);
#line 192 "../gcalc/gcalc-parser.vala"
											_tmp216_ = _tmp215_;
#line 192 "../gcalc/gcalc-parser.vala"
											if (_tmp216_ != NULL) {
#line 1673 "gcalc-parser.c"
												GCalcMathExpression* _tmp217_;
												GCalcMathExpression* _tmp218_;
												GCalcMathExpression* _tmp219_;
#line 193 "../gcalc/gcalc-parser.vala"
												_tmp217_ = p;
#line 193 "../gcalc/gcalc-parser.vala"
												_tmp218_ = gcalc_math_expression_get_parent (_tmp217_);
#line 193 "../gcalc/gcalc-parser.vala"
												_tmp219_ = _tmp218_;
#line 193 "../gcalc/gcalc-parser.vala"
												if (GCALC_IS_MATH_EQUATION (_tmp219_)) {
#line 1685 "gcalc-parser.c"
													GCalcEquation* _tmp220_;
													GCalcExpressionContainer* _tmp221_;
													GCalcExpressionContainer* _tmp222_;
													GCalcMathExpression* _tmp223_;
													GCalcMathExpression* _tmp224_;
													GCalcExpressionContainer* _tmp225_;
													GCalcExpressionContainer* _tmp226_;
													GCalcMathExpression* _tmp227_;
#line 194 "../gcalc/gcalc-parser.vala"
													_tmp220_ = self->priv->eq;
#line 194 "../gcalc/gcalc-parser.vala"
													_tmp221_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp220_);
#line 194 "../gcalc/gcalc-parser.vala"
													_tmp222_ = _tmp221_;
#line 194 "../gcalc/gcalc-parser.vala"
													_tmp223_ = p;
#line 194 "../gcalc/gcalc-parser.vala"
													gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp222_, _tmp223_);
#line 195 "../gcalc/gcalc-parser.vala"
													_tmp224_ = p;
#line 195 "../gcalc/gcalc-parser.vala"
													_tmp225_ = gcalc_math_expression_get_expressions (_tmp224_);
#line 195 "../gcalc/gcalc-parser.vala"
													_tmp226_ = _tmp225_;
#line 195 "../gcalc/gcalc-parser.vala"
													_tmp227_ = t;
#line 195 "../gcalc/gcalc-parser.vala"
													gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp226_, _tmp227_);
#line 196 "../gcalc/gcalc-parser.vala"
													removed = TRUE;
#line 1716 "gcalc-parser.c"
												}
											}
#line 190 "../gcalc/gcalc-parser.vala"
											_g_object_unref0 (p);
#line 1721 "gcalc-parser.c"
										}
									}
#line 187 "../gcalc/gcalc-parser.vala"
									_g_object_unref0 (t);
#line 1726 "gcalc-parser.c"
								}
							}
#line 203 "../gcalc/gcalc-parser.vala"
							if (!removed) {
#line 1731 "gcalc-parser.c"
								GError* _tmp228_;
#line 204 "../gcalc/gcalc-parser.vala"
								_tmp228_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_EXPRESSION_ERROR, _ ("Found an unexpected expression for an assignment. Assignment should be" \
" done on variables"));
#line 204 "../gcalc/gcalc-parser.vala"
								_inner_error0_ = _tmp228_;
#line 204 "../gcalc/gcalc-parser.vala"
								g_propagate_error (error, _inner_error0_);
#line 204 "../gcalc/gcalc-parser.vala"
								_g_free0 (n);
#line 204 "../gcalc/gcalc-parser.vala"
								return;
#line 1743 "gcalc-parser.c"
							}
#line 206 "../gcalc/gcalc-parser.vala"
							_tmp229_ = gcalc_assign_new ();
#line 206 "../gcalc/gcalc-parser.vala"
							expa = _tmp229_;
#line 207 "../gcalc/gcalc-parser.vala"
							_tmp230_ = self->priv->eq;
#line 207 "../gcalc/gcalc-parser.vala"
							_tmp231_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp230_);
#line 207 "../gcalc/gcalc-parser.vala"
							_tmp232_ = _tmp231_;
#line 207 "../gcalc/gcalc-parser.vala"
							_tmp233_ = expa;
#line 207 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp232_, (GCalcMathExpression*) _tmp233_);
#line 208 "../gcalc/gcalc-parser.vala"
							_tmp234_ = expa;
#line 208 "../gcalc/gcalc-parser.vala"
							_tmp235_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp234_);
#line 208 "../gcalc/gcalc-parser.vala"
							_tmp236_ = _tmp235_;
#line 208 "../gcalc/gcalc-parser.vala"
							_tmp237_ = self->priv->current;
#line 208 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp236_, _tmp237_);
#line 209 "../gcalc/gcalc-parser.vala"
							_tmp238_ = gcalc_polynomial_new ();
#line 209 "../gcalc/gcalc-parser.vala"
							exp = _tmp238_;
#line 210 "../gcalc/gcalc-parser.vala"
							_tmp239_ = expa;
#line 210 "../gcalc/gcalc-parser.vala"
							_tmp240_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp239_);
#line 210 "../gcalc/gcalc-parser.vala"
							_tmp241_ = _tmp240_;
#line 210 "../gcalc/gcalc-parser.vala"
							_tmp242_ = exp;
#line 210 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp241_, (GCalcMathExpression*) _tmp242_);
#line 211 "../gcalc/gcalc-parser.vala"
							_tmp243_ = gcalc_term_new ();
#line 211 "../gcalc/gcalc-parser.vala"
							t = _tmp243_;
#line 212 "../gcalc/gcalc-parser.vala"
							_tmp244_ = exp;
#line 212 "../gcalc/gcalc-parser.vala"
							_tmp245_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp244_);
#line 212 "../gcalc/gcalc-parser.vala"
							_tmp246_ = _tmp245_;
#line 212 "../gcalc/gcalc-parser.vala"
							_tmp247_ = t;
#line 212 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp246_, (GCalcMathExpression*) _tmp247_);
#line 213 "../gcalc/gcalc-parser.vala"
							_tmp248_ = t;
#line 213 "../gcalc/gcalc-parser.vala"
							_tmp249_ = _g_object_ref0 ((GCalcMathExpression*) _tmp248_);
#line 213 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->current);
#line 213 "../gcalc/gcalc-parser.vala"
							self->priv->current = _tmp249_;
#line 214 "../gcalc/gcalc-parser.vala"
							_tmp250_ = t;
#line 214 "../gcalc/gcalc-parser.vala"
							_tmp251_ = _g_object_ref0 ((GCalcMathExpression*) _tmp250_);
#line 214 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->current_parent);
#line 214 "../gcalc/gcalc-parser.vala"
							self->priv->current_parent = _tmp251_;
#line 215 "../gcalc/gcalc-parser.vala"
							_tmp252_ = exp;
#line 215 "../gcalc/gcalc-parser.vala"
							_tmp253_ = _g_object_ref0 ((GCalcMathExpression*) _tmp252_);
#line 215 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->top_parent);
#line 215 "../gcalc/gcalc-parser.vala"
							self->priv->top_parent = _tmp253_;
#line 216 "../gcalc/gcalc-parser.vala"
							_tmp254_ = self->priv->expected;
#line 216 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp254_);
#line 184 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (t);
#line 184 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (exp);
#line 184 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (expa);
#line 1831 "gcalc-parser.c"
						}
					}
				}
#line 218 "../gcalc/gcalc-parser.vala"
				break;
#line 1837 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS:
#line 1841 "gcalc-parser.c"
			{
				GCalcMathExpression* _tmp255_;
#line 220 "../gcalc/gcalc-parser.vala"
				_tmp255_ = self->priv->current;
#line 220 "../gcalc/gcalc-parser.vala"
				if (_tmp255_ == NULL) {
#line 1848 "gcalc-parser.c"
					GCalcPolynomial* exp = NULL;
					GCalcPolynomial* _tmp256_;
					GCalcEquation* _tmp257_;
					GCalcExpressionContainer* _tmp258_;
					GCalcExpressionContainer* _tmp259_;
					GCalcPolynomial* _tmp260_;
					GCalcTerm* t = NULL;
					GCalcTerm* _tmp261_;
					GCalcPolynomial* _tmp262_;
					GCalcExpressionContainer* _tmp263_;
					GCalcExpressionContainer* _tmp264_;
					GCalcTerm* _tmp265_;
					GCalcGroup* g = NULL;
					GCalcGroup* _tmp266_;
					GCalcTerm* _tmp267_;
					GCalcExpressionContainer* _tmp268_;
					GCalcExpressionContainer* _tmp269_;
					GCalcGroup* _tmp270_;
					GCalcPolynomial* exp2 = NULL;
					GCalcPolynomial* _tmp271_;
					GCalcTerm* t2 = NULL;
					GCalcTerm* _tmp272_;
					GCalcPolynomial* _tmp273_;
					GCalcExpressionContainer* _tmp274_;
					GCalcExpressionContainer* _tmp275_;
					GCalcTerm* _tmp276_;
					GCalcGroup* _tmp277_;
					GCalcExpressionContainer* _tmp278_;
					GCalcExpressionContainer* _tmp279_;
					GCalcPolynomial* _tmp280_;
					GCalcTerm* _tmp281_;
					GCalcMathExpression* _tmp282_;
					GCalcPolynomial* _tmp283_;
					GCalcMathExpression* _tmp284_;
					GCalcGroup* _tmp285_;
					GCalcMathExpression* _tmp286_;
#line 221 "../gcalc/gcalc-parser.vala"
					_tmp256_ = gcalc_polynomial_new ();
#line 221 "../gcalc/gcalc-parser.vala"
					exp = _tmp256_;
#line 222 "../gcalc/gcalc-parser.vala"
					_tmp257_ = self->priv->eq;
#line 222 "../gcalc/gcalc-parser.vala"
					_tmp258_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp257_);
#line 222 "../gcalc/gcalc-parser.vala"
					_tmp259_ = _tmp258_;
#line 222 "../gcalc/gcalc-parser.vala"
					_tmp260_ = exp;
#line 222 "../gcalc/gcalc-parser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp259_, (GCalcMathExpression*) _tmp260_);
#line 223 "../gcalc/gcalc-parser.vala"
					_tmp261_ = gcalc_term_new ();
#line 223 "../gcalc/gcalc-parser.vala"
					t = _tmp261_;
#line 224 "../gcalc/gcalc-parser.vala"
					_tmp262_ = exp;
#line 224 "../gcalc/gcalc-parser.vala"
					_tmp263_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp262_);
#line 224 "../gcalc/gcalc-parser.vala"
					_tmp264_ = _tmp263_;
#line 224 "../gcalc/gcalc-parser.vala"
					_tmp265_ = t;
#line 224 "../gcalc/gcalc-parser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp264_, (GCalcMathExpression*) _tmp265_);
#line 225 "../gcalc/gcalc-parser.vala"
					_tmp266_ = gcalc_group_new ();
#line 225 "../gcalc/gcalc-parser.vala"
					g = _tmp266_;
#line 226 "../gcalc/gcalc-parser.vala"
					_tmp267_ = t;
#line 226 "../gcalc/gcalc-parser.vala"
					_tmp268_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp267_);
#line 226 "../gcalc/gcalc-parser.vala"
					_tmp269_ = _tmp268_;
#line 226 "../gcalc/gcalc-parser.vala"
					_tmp270_ = g;
#line 226 "../gcalc/gcalc-parser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp269_, (GCalcMathExpression*) _tmp270_);
#line 227 "../gcalc/gcalc-parser.vala"
					_tmp271_ = gcalc_polynomial_new ();
#line 227 "../gcalc/gcalc-parser.vala"
					exp2 = _tmp271_;
#line 228 "../gcalc/gcalc-parser.vala"
					_tmp272_ = gcalc_term_new ();
#line 228 "../gcalc/gcalc-parser.vala"
					t2 = _tmp272_;
#line 229 "../gcalc/gcalc-parser.vala"
					_tmp273_ = exp2;
#line 229 "../gcalc/gcalc-parser.vala"
					_tmp274_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp273_);
#line 229 "../gcalc/gcalc-parser.vala"
					_tmp275_ = _tmp274_;
#line 229 "../gcalc/gcalc-parser.vala"
					_tmp276_ = t2;
#line 229 "../gcalc/gcalc-parser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp275_, (GCalcMathExpression*) _tmp276_);
#line 230 "../gcalc/gcalc-parser.vala"
					_tmp277_ = g;
#line 230 "../gcalc/gcalc-parser.vala"
					_tmp278_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp277_);
#line 230 "../gcalc/gcalc-parser.vala"
					_tmp279_ = _tmp278_;
#line 230 "../gcalc/gcalc-parser.vala"
					_tmp280_ = exp2;
#line 230 "../gcalc/gcalc-parser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp279_, (GCalcMathExpression*) _tmp280_);
#line 231 "../gcalc/gcalc-parser.vala"
					_tmp281_ = t2;
#line 231 "../gcalc/gcalc-parser.vala"
					_tmp282_ = _g_object_ref0 ((GCalcMathExpression*) _tmp281_);
#line 231 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->current);
#line 231 "../gcalc/gcalc-parser.vala"
					self->priv->current = _tmp282_;
#line 232 "../gcalc/gcalc-parser.vala"
					_tmp283_ = exp2;
#line 232 "../gcalc/gcalc-parser.vala"
					_tmp284_ = _g_object_ref0 ((GCalcMathExpression*) _tmp283_);
#line 232 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->current_parent);
#line 232 "../gcalc/gcalc-parser.vala"
					self->priv->current_parent = _tmp284_;
#line 233 "../gcalc/gcalc-parser.vala"
					_tmp285_ = g;
#line 233 "../gcalc/gcalc-parser.vala"
					_tmp286_ = _g_object_ref0 ((GCalcMathExpression*) _tmp285_);
#line 233 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->top_parent);
#line 233 "../gcalc/gcalc-parser.vala"
					self->priv->top_parent = _tmp286_;
#line 220 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (t2);
#line 220 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (exp2);
#line 220 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (g);
#line 220 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (t);
#line 220 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (exp);
#line 1989 "gcalc-parser.c"
				} else {
					GCalcMathExpression* _tmp287_;
#line 234 "../gcalc/gcalc-parser.vala"
					_tmp287_ = self->priv->current;
#line 234 "../gcalc/gcalc-parser.vala"
					if (GCALC_IS_MATH_FUNCTION (_tmp287_)) {
#line 1996 "gcalc-parser.c"
						GCalcPolynomial* fexp = NULL;
						GCalcPolynomial* _tmp288_;
						GCalcTerm* t = NULL;
						GCalcTerm* _tmp289_;
						GCalcPolynomial* _tmp290_;
						GCalcExpressionContainer* _tmp291_;
						GCalcExpressionContainer* _tmp292_;
						GCalcTerm* _tmp293_;
						GCalcMathExpression* _tmp294_;
						GCalcExpressionContainer* _tmp295_;
						GCalcExpressionContainer* _tmp296_;
						GCalcPolynomial* _tmp297_;
						GCalcMathExpression* _tmp298_;
						GCalcMathExpression* _tmp299_;
						GCalcTerm* _tmp300_;
						GCalcMathExpression* _tmp301_;
						GCalcPolynomial* _tmp302_;
						GCalcMathExpression* _tmp303_;
						GeeArrayList* _tmp304_;
#line 235 "../gcalc/gcalc-parser.vala"
						_tmp288_ = gcalc_polynomial_new ();
#line 235 "../gcalc/gcalc-parser.vala"
						fexp = _tmp288_;
#line 236 "../gcalc/gcalc-parser.vala"
						_tmp289_ = gcalc_term_new ();
#line 236 "../gcalc/gcalc-parser.vala"
						t = _tmp289_;
#line 237 "../gcalc/gcalc-parser.vala"
						_tmp290_ = fexp;
#line 237 "../gcalc/gcalc-parser.vala"
						_tmp291_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp290_);
#line 237 "../gcalc/gcalc-parser.vala"
						_tmp292_ = _tmp291_;
#line 237 "../gcalc/gcalc-parser.vala"
						_tmp293_ = t;
#line 237 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp292_, (GCalcMathExpression*) _tmp293_);
#line 238 "../gcalc/gcalc-parser.vala"
						_tmp294_ = self->priv->current;
#line 238 "../gcalc/gcalc-parser.vala"
						_tmp295_ = gcalc_math_expression_get_expressions (_tmp294_);
#line 238 "../gcalc/gcalc-parser.vala"
						_tmp296_ = _tmp295_;
#line 238 "../gcalc/gcalc-parser.vala"
						_tmp297_ = fexp;
#line 238 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp296_, (GCalcMathExpression*) _tmp297_);
#line 239 "../gcalc/gcalc-parser.vala"
						_tmp298_ = self->priv->current;
#line 239 "../gcalc/gcalc-parser.vala"
						_tmp299_ = _g_object_ref0 (_tmp298_);
#line 239 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (self->priv->top_parent);
#line 239 "../gcalc/gcalc-parser.vala"
						self->priv->top_parent = _tmp299_;
#line 240 "../gcalc/gcalc-parser.vala"
						_tmp300_ = t;
#line 240 "../gcalc/gcalc-parser.vala"
						_tmp301_ = _g_object_ref0 ((GCalcMathExpression*) _tmp300_);
#line 240 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (self->priv->current);
#line 240 "../gcalc/gcalc-parser.vala"
						self->priv->current = _tmp301_;
#line 241 "../gcalc/gcalc-parser.vala"
						_tmp302_ = fexp;
#line 241 "../gcalc/gcalc-parser.vala"
						_tmp303_ = _g_object_ref0 ((GCalcMathExpression*) _tmp302_);
#line 241 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (self->priv->current_parent);
#line 241 "../gcalc/gcalc-parser.vala"
						self->priv->current_parent = _tmp303_;
#line 242 "../gcalc/gcalc-parser.vala"
						_tmp304_ = self->priv->expected;
#line 242 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp304_);
#line 234 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (t);
#line 234 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (fexp);
#line 2076 "gcalc-parser.c"
					} else {
						gboolean _tmp305_ = FALSE;
						gboolean _tmp306_ = FALSE;
						GCalcMathExpression* _tmp307_;
#line 243 "../gcalc/gcalc-parser.vala"
						_tmp307_ = self->priv->current;
#line 243 "../gcalc/gcalc-parser.vala"
						if (GCALC_IS_MATH_OPERATOR (_tmp307_)) {
#line 2085 "gcalc-parser.c"
							GCalcMathExpression* _tmp308_;
#line 243 "../gcalc/gcalc-parser.vala"
							_tmp308_ = self->priv->current_parent;
#line 243 "../gcalc/gcalc-parser.vala"
							_tmp306_ = GCALC_IS_MATH_TERM (_tmp308_);
#line 2091 "gcalc-parser.c"
						} else {
#line 243 "../gcalc/gcalc-parser.vala"
							_tmp306_ = FALSE;
#line 2095 "gcalc-parser.c"
						}
#line 243 "../gcalc/gcalc-parser.vala"
						if (_tmp306_) {
#line 2099 "gcalc-parser.c"
							GCalcMathExpression* _tmp309_;
#line 243 "../gcalc/gcalc-parser.vala"
							_tmp309_ = self->priv->top_parent;
#line 243 "../gcalc/gcalc-parser.vala"
							_tmp305_ = GCALC_IS_MATH_POLYNOMIAL (_tmp309_);
#line 2105 "gcalc-parser.c"
						} else {
#line 243 "../gcalc/gcalc-parser.vala"
							_tmp305_ = FALSE;
#line 2109 "gcalc-parser.c"
						}
#line 243 "../gcalc/gcalc-parser.vala"
						if (_tmp305_) {
#line 2113 "gcalc-parser.c"
							GCalcGroup* g = NULL;
							GCalcGroup* _tmp310_;
							GCalcMathExpression* _tmp311_;
							GCalcExpressionContainer* _tmp312_;
							GCalcExpressionContainer* _tmp313_;
							GCalcGroup* _tmp314_;
							GCalcPolynomial* exp = NULL;
							GCalcPolynomial* _tmp315_;
							GCalcGroup* _tmp316_;
							GCalcExpressionContainer* _tmp317_;
							GCalcExpressionContainer* _tmp318_;
							GCalcPolynomial* _tmp319_;
							GCalcTerm* t = NULL;
							GCalcTerm* _tmp320_;
							GCalcPolynomial* _tmp321_;
							GCalcExpressionContainer* _tmp322_;
							GCalcExpressionContainer* _tmp323_;
							GCalcTerm* _tmp324_;
							GCalcTerm* _tmp325_;
							GCalcMathExpression* _tmp326_;
							GCalcPolynomial* _tmp327_;
							GCalcMathExpression* _tmp328_;
							GCalcGroup* _tmp329_;
							GCalcMathExpression* _tmp330_;
#line 244 "../gcalc/gcalc-parser.vala"
							_tmp310_ = gcalc_group_new ();
#line 244 "../gcalc/gcalc-parser.vala"
							g = _tmp310_;
#line 245 "../gcalc/gcalc-parser.vala"
							_tmp311_ = self->priv->current_parent;
#line 245 "../gcalc/gcalc-parser.vala"
							_tmp312_ = gcalc_math_expression_get_expressions (_tmp311_);
#line 245 "../gcalc/gcalc-parser.vala"
							_tmp313_ = _tmp312_;
#line 245 "../gcalc/gcalc-parser.vala"
							_tmp314_ = g;
#line 245 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp313_, (GCalcMathExpression*) _tmp314_);
#line 246 "../gcalc/gcalc-parser.vala"
							_tmp315_ = gcalc_polynomial_new ();
#line 246 "../gcalc/gcalc-parser.vala"
							exp = _tmp315_;
#line 247 "../gcalc/gcalc-parser.vala"
							_tmp316_ = g;
#line 247 "../gcalc/gcalc-parser.vala"
							_tmp317_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp316_);
#line 247 "../gcalc/gcalc-parser.vala"
							_tmp318_ = _tmp317_;
#line 247 "../gcalc/gcalc-parser.vala"
							_tmp319_ = exp;
#line 247 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp318_, (GCalcMathExpression*) _tmp319_);
#line 248 "../gcalc/gcalc-parser.vala"
							_tmp320_ = gcalc_term_new ();
#line 248 "../gcalc/gcalc-parser.vala"
							t = _tmp320_;
#line 249 "../gcalc/gcalc-parser.vala"
							_tmp321_ = exp;
#line 249 "../gcalc/gcalc-parser.vala"
							_tmp322_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp321_);
#line 249 "../gcalc/gcalc-parser.vala"
							_tmp323_ = _tmp322_;
#line 249 "../gcalc/gcalc-parser.vala"
							_tmp324_ = t;
#line 249 "../gcalc/gcalc-parser.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp323_, (GCalcMathExpression*) _tmp324_);
#line 250 "../gcalc/gcalc-parser.vala"
							_tmp325_ = t;
#line 250 "../gcalc/gcalc-parser.vala"
							_tmp326_ = _g_object_ref0 ((GCalcMathExpression*) _tmp325_);
#line 250 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->current);
#line 250 "../gcalc/gcalc-parser.vala"
							self->priv->current = _tmp326_;
#line 251 "../gcalc/gcalc-parser.vala"
							_tmp327_ = exp;
#line 251 "../gcalc/gcalc-parser.vala"
							_tmp328_ = _g_object_ref0 ((GCalcMathExpression*) _tmp327_);
#line 251 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->current_parent);
#line 251 "../gcalc/gcalc-parser.vala"
							self->priv->current_parent = _tmp328_;
#line 252 "../gcalc/gcalc-parser.vala"
							_tmp329_ = g;
#line 252 "../gcalc/gcalc-parser.vala"
							_tmp330_ = _g_object_ref0 ((GCalcMathExpression*) _tmp329_);
#line 252 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (self->priv->top_parent);
#line 252 "../gcalc/gcalc-parser.vala"
							self->priv->top_parent = _tmp330_;
#line 243 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (t);
#line 243 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (exp);
#line 243 "../gcalc/gcalc-parser.vala"
							_g_object_unref0 (g);
#line 2210 "gcalc-parser.c"
						}
					}
				}
#line 254 "../gcalc/gcalc-parser.vala"
				break;
#line 2216 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_CLOSE_PARENS:
#line 2220 "gcalc-parser.c"
			{
				GCalcMathExpression* _tmp331_;
				gboolean foundp = FALSE;
				GCalcMathExpression* par = NULL;
				GCalcMathExpression* _tmp333_;
				GCalcMathExpression* _tmp334_;
#line 256 "../gcalc/gcalc-parser.vala"
				_tmp331_ = self->priv->current;
#line 256 "../gcalc/gcalc-parser.vala"
				if (_tmp331_ == NULL) {
#line 2231 "gcalc-parser.c"
					GError* _tmp332_;
#line 257 "../gcalc/gcalc-parser.vala"
					_tmp332_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression while closing parenthesis"));
#line 257 "../gcalc/gcalc-parser.vala"
					_inner_error0_ = _tmp332_;
#line 257 "../gcalc/gcalc-parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 257 "../gcalc/gcalc-parser.vala"
					_g_free0 (n);
#line 257 "../gcalc/gcalc-parser.vala"
					return;
#line 2243 "gcalc-parser.c"
				}
#line 259 "../gcalc/gcalc-parser.vala"
				foundp = FALSE;
#line 260 "../gcalc/gcalc-parser.vala"
				_tmp333_ = self->priv->current;
#line 260 "../gcalc/gcalc-parser.vala"
				_tmp334_ = _g_object_ref0 (_tmp333_);
#line 260 "../gcalc/gcalc-parser.vala"
				par = _tmp334_;
#line 261 "../gcalc/gcalc-parser.vala"
				while (TRUE) {
#line 2255 "gcalc-parser.c"
					GCalcMathExpression* _tmp335_;
					GCalcMathExpression* _tmp336_;
					GCalcMathExpression* _tmp341_;
					GCalcMathExpression* _tmp346_;
					GCalcMathExpression* _tmp347_;
					GCalcMathExpression* _tmp348_;
					GCalcMathExpression* _tmp349_;
#line 261 "../gcalc/gcalc-parser.vala"
					_tmp335_ = par;
#line 261 "../gcalc/gcalc-parser.vala"
					if (!(_tmp335_ != NULL)) {
#line 261 "../gcalc/gcalc-parser.vala"
						break;
#line 2269 "gcalc-parser.c"
					}
#line 262 "../gcalc/gcalc-parser.vala"
					_tmp336_ = par;
#line 262 "../gcalc/gcalc-parser.vala"
					if (GCALC_IS_MATH_GROUP (_tmp336_)) {
#line 2275 "gcalc-parser.c"
						GCalcMathExpression* _tmp337_;
						gboolean _tmp338_;
						gboolean _tmp339_;
#line 263 "../gcalc/gcalc-parser.vala"
						_tmp337_ = par;
#line 263 "../gcalc/gcalc-parser.vala"
						_tmp338_ = gcalc_math_group_get_closed (G_TYPE_CHECK_INSTANCE_CAST (_tmp337_, GCALC_TYPE_MATH_GROUP, GCalcMathGroup));
#line 263 "../gcalc/gcalc-parser.vala"
						_tmp339_ = _tmp338_;
#line 263 "../gcalc/gcalc-parser.vala"
						if (!_tmp339_) {
#line 2287 "gcalc-parser.c"
							GCalcMathExpression* _tmp340_;
#line 264 "../gcalc/gcalc-parser.vala"
							foundp = TRUE;
#line 265 "../gcalc/gcalc-parser.vala"
							_tmp340_ = par;
#line 265 "../gcalc/gcalc-parser.vala"
							gcalc_math_group_set_closed (G_TYPE_CHECK_INSTANCE_CAST (_tmp340_, GCALC_TYPE_MATH_GROUP, GCalcMathGroup), TRUE);
#line 266 "../gcalc/gcalc-parser.vala"
							break;
#line 2297 "gcalc-parser.c"
						}
					}
#line 269 "../gcalc/gcalc-parser.vala"
					_tmp341_ = par;
#line 269 "../gcalc/gcalc-parser.vala"
					if (GCALC_IS_MATH_FUNCTION (_tmp341_)) {
#line 2304 "gcalc-parser.c"
						GCalcMathExpression* _tmp342_;
						gboolean _tmp343_;
						gboolean _tmp344_;
#line 270 "../gcalc/gcalc-parser.vala"
						_tmp342_ = par;
#line 270 "../gcalc/gcalc-parser.vala"
						_tmp343_ = gcalc_math_function_get_closed (G_TYPE_CHECK_INSTANCE_CAST (_tmp342_, GCALC_TYPE_MATH_FUNCTION, GCalcMathFunction));
#line 270 "../gcalc/gcalc-parser.vala"
						_tmp344_ = _tmp343_;
#line 270 "../gcalc/gcalc-parser.vala"
						if (!_tmp344_) {
#line 2316 "gcalc-parser.c"
							GCalcMathExpression* _tmp345_;
#line 271 "../gcalc/gcalc-parser.vala"
							foundp = TRUE;
#line 272 "../gcalc/gcalc-parser.vala"
							_tmp345_ = par;
#line 272 "../gcalc/gcalc-parser.vala"
							gcalc_math_function_set_closed (G_TYPE_CHECK_INSTANCE_CAST (_tmp345_, GCALC_TYPE_MATH_FUNCTION, GCalcMathFunction), TRUE);
#line 273 "../gcalc/gcalc-parser.vala"
							break;
#line 2326 "gcalc-parser.c"
						}
					}
#line 276 "../gcalc/gcalc-parser.vala"
					_tmp346_ = par;
#line 276 "../gcalc/gcalc-parser.vala"
					_tmp347_ = gcalc_math_expression_get_parent (_tmp346_);
#line 276 "../gcalc/gcalc-parser.vala"
					_tmp348_ = _tmp347_;
#line 276 "../gcalc/gcalc-parser.vala"
					_tmp349_ = _g_object_ref0 (_tmp348_);
#line 276 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (par);
#line 276 "../gcalc/gcalc-parser.vala"
					par = _tmp349_;
#line 2341 "gcalc-parser.c"
				}
#line 278 "../gcalc/gcalc-parser.vala"
				if (foundp) {
#line 2345 "gcalc-parser.c"
					GCalcMathExpression* _tmp350_;
					GCalcMathExpression* _tmp351_;
					GCalcMathExpression* _tmp352_;
					GCalcMathExpression* _tmp353_;
					GCalcMathExpression* _tmp354_;
					GCalcMathExpression* _tmp355_;
					GCalcMathExpression* _tmp356_;
					GCalcMathExpression* _tmp357_;
					GCalcMathExpression* _tmp358_;
					GCalcMathExpression* _tmp359_;
#line 279 "../gcalc/gcalc-parser.vala"
					_tmp350_ = par;
#line 279 "../gcalc/gcalc-parser.vala"
					_tmp351_ = _g_object_ref0 (_tmp350_);
#line 279 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->current);
#line 279 "../gcalc/gcalc-parser.vala"
					self->priv->current = _tmp351_;
#line 280 "../gcalc/gcalc-parser.vala"
					_tmp352_ = par;
#line 280 "../gcalc/gcalc-parser.vala"
					_tmp353_ = gcalc_math_expression_get_parent (_tmp352_);
#line 280 "../gcalc/gcalc-parser.vala"
					_tmp354_ = _tmp353_;
#line 280 "../gcalc/gcalc-parser.vala"
					_tmp355_ = _g_object_ref0 (_tmp354_);
#line 280 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->current_parent);
#line 280 "../gcalc/gcalc-parser.vala"
					self->priv->current_parent = _tmp355_;
#line 281 "../gcalc/gcalc-parser.vala"
					_tmp356_ = self->priv->current_parent;
#line 281 "../gcalc/gcalc-parser.vala"
					_tmp357_ = gcalc_math_expression_get_parent (_tmp356_);
#line 281 "../gcalc/gcalc-parser.vala"
					_tmp358_ = _tmp357_;
#line 281 "../gcalc/gcalc-parser.vala"
					_tmp359_ = _g_object_ref0 (_tmp358_);
#line 281 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->top_parent);
#line 281 "../gcalc/gcalc-parser.vala"
					self->priv->top_parent = _tmp359_;
#line 2388 "gcalc-parser.c"
				}
#line 283 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (par);
#line 283 "../gcalc/gcalc-parser.vala"
				break;
#line 2394 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_CARRET:
#line 2398 "gcalc-parser.c"
			{
				GCalcPow* op = NULL;
				GCalcPow* _tmp360_;
				GCalcMathExpression* _tmp361_;
#line 285 "../gcalc/gcalc-parser.vala"
				_tmp360_ = gcalc_pow_new ();
#line 285 "../gcalc/gcalc-parser.vala"
				op = _tmp360_;
#line 286 "../gcalc/gcalc-parser.vala"
				_tmp361_ = self->priv->current;
#line 286 "../gcalc/gcalc-parser.vala"
				if (_tmp361_ == NULL) {
#line 2411 "gcalc-parser.c"
					GError* _tmp362_;
#line 287 "../gcalc/gcalc-parser.vala"
					_tmp362_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression trying power expression"));
#line 287 "../gcalc/gcalc-parser.vala"
					_inner_error0_ = _tmp362_;
#line 287 "../gcalc/gcalc-parser.vala"
					g_propagate_error (error, _inner_error0_);
#line 287 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (op);
#line 287 "../gcalc/gcalc-parser.vala"
					_g_free0 (n);
#line 287 "../gcalc/gcalc-parser.vala"
					return;
#line 2425 "gcalc-parser.c"
				} else {
					GCalcPow* _tmp363_;
					GCalcEquation* _tmp364_;
#line 289 "../gcalc/gcalc-parser.vala"
					_tmp363_ = op;
#line 289 "../gcalc/gcalc-parser.vala"
					_tmp364_ = self->priv->eq;
#line 289 "../gcalc/gcalc-parser.vala"
					gcalc_parser_process_term_operator (self, (GCalcMathOperator*) _tmp363_, _tmp364_, &_inner_error0_);
#line 289 "../gcalc/gcalc-parser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 289 "../gcalc/gcalc-parser.vala"
						g_propagate_error (error, _inner_error0_);
#line 289 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (op);
#line 289 "../gcalc/gcalc-parser.vala"
						_g_free0 (n);
#line 289 "../gcalc/gcalc-parser.vala"
						return;
#line 2445 "gcalc-parser.c"
					}
				}
#line 291 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (op);
#line 291 "../gcalc/gcalc-parser.vala"
				break;
#line 2452 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACE:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACKET:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OPEN_BRACE:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OPEN_BRACKET:
#line 2462 "gcalc-parser.c"
			{
#line 297 "../gcalc/gcalc-parser.vala"
				break;
#line 2466 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_STRING_LITERAL:
#line 2470 "gcalc-parser.c"
			{
#line 299 "../gcalc/gcalc-parser.vala"
				break;
#line 2474 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_AND:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_COALESCING:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_DEC:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_EQ:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_GE:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_GT:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_INC:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_LE:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_LT:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_NE:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_NEG:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_OR:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_PTR:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_OP_SHIFT_LEFT:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_SEMICOLON:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_TILDE:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_COLON:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_COMMA:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_DOUBLE_COLON:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_DOT:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_ELLIPSIS:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_INTERR:
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_HASH:
#line 2522 "gcalc-parser.c"
			{
				GEnumValue* _tmp365_;
				GError* _tmp366_;
#line 324 "../gcalc/gcalc-parser.vala"
				_tmp365_ = g_enum_get_value (g_type_class_ref (GCALC_PARSER_TYPE_TOKEN_TYPE), token);
#line 324 "../gcalc/gcalc-parser.vala"
				_tmp366_ = g_error_new (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression: '%s'"), (_tmp365_ != NULL) ? _tmp365_->value_name : NULL);
#line 324 "../gcalc/gcalc-parser.vala"
				_inner_error0_ = _tmp366_;
#line 324 "../gcalc/gcalc-parser.vala"
				g_propagate_error (error, _inner_error0_);
#line 324 "../gcalc/gcalc-parser.vala"
				_g_free0 (n);
#line 324 "../gcalc/gcalc-parser.vala"
				return;
#line 2538 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_CURRENCY_SYMBOL:
#line 2542 "gcalc-parser.c"
			{
#line 326 "../gcalc/gcalc-parser.vala"
				self->priv->enable_parameter = TRUE;
#line 327 "../gcalc/gcalc-parser.vala"
				break;
#line 2548 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_EOF:
#line 2552 "gcalc-parser.c"
			{
				GError* _tmp367_;
#line 329 "../gcalc/gcalc-parser.vala"
				_tmp367_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected end of file"));
#line 329 "../gcalc/gcalc-parser.vala"
				_inner_error0_ = _tmp367_;
#line 329 "../gcalc/gcalc-parser.vala"
				g_propagate_error (error, _inner_error0_);
#line 329 "../gcalc/gcalc-parser.vala"
				_g_free0 (n);
#line 329 "../gcalc/gcalc-parser.vala"
				return;
#line 2565 "gcalc-parser.c"
			}
#line 78 "../gcalc/gcalc-parser.vala"
			case GCALC_PARSER_TOKEN_TYPE_NONE:
#line 2569 "gcalc-parser.c"
			{
#line 331 "../gcalc/gcalc-parser.vala"
				break;
#line 2573 "gcalc-parser.c"
			}
			default:
#line 78 "../gcalc/gcalc-parser.vala"
			break;
#line 2578 "gcalc-parser.c"
		}
#line 76 "../gcalc/gcalc-parser.vala"
		_g_free0 (n);
#line 2582 "gcalc-parser.c"
	}
#line 334 "../gcalc/gcalc-parser.vala"
	_tmp368_ = gcalc_math_equation_manager_get_equations (eqman);
#line 334 "../gcalc/gcalc-parser.vala"
	_tmp369_ = _tmp368_;
#line 334 "../gcalc/gcalc-parser.vala"
	_tmp370_ = self->priv->eq;
#line 334 "../gcalc/gcalc-parser.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp369_, (GCalcMathExpression*) _tmp370_);
#line 2592 "gcalc-parser.c"
}

static void
gcalc_parser_process_operator (GCalcParser* self,
                               GCalcMathOperator* opp,
                               GCalcEquation* eq,
                               GError** error)
{
	GCalcMathExpression* _tmp0_;
	GCalcMathExpression* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 336 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (self != NULL);
#line 336 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (opp != NULL);
#line 336 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (eq != NULL);
#line 337 "../gcalc/gcalc-parser.vala"
	_tmp0_ = self->priv->current;
#line 337 "../gcalc/gcalc-parser.vala"
	if (GCALC_IS_MATH_BINARY_OPERATOR (_tmp0_)) {
#line 2614 "gcalc-parser.c"
		GError* _tmp1_;
#line 338 "../gcalc/gcalc-parser.vala"
		_tmp1_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression for a plus operator"));
#line 338 "../gcalc/gcalc-parser.vala"
		_inner_error0_ = _tmp1_;
#line 338 "../gcalc/gcalc-parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 338 "../gcalc/gcalc-parser.vala"
		return;
#line 2624 "gcalc-parser.c"
	}
#line 340 "../gcalc/gcalc-parser.vala"
	_tmp2_ = self->priv->current;
#line 340 "../gcalc/gcalc-parser.vala"
	if (_tmp2_ == NULL) {
#line 2630 "gcalc-parser.c"
		GCalcPolynomial* exp = NULL;
		GCalcPolynomial* _tmp3_;
		GCalcTerm* t = NULL;
		GCalcTerm* _tmp4_;
		GCalcTerm* _tmp5_;
		GCalcExpressionContainer* _tmp6_;
		GCalcExpressionContainer* _tmp7_;
		GCalcPolynomial* _tmp8_;
		GCalcExpressionContainer* _tmp9_;
		GCalcExpressionContainer* _tmp10_;
		GCalcTerm* _tmp11_;
		GCalcMathExpression* _tmp12_;
		GCalcTerm* _tmp13_;
		GCalcMathExpression* _tmp14_;
		GCalcPolynomial* _tmp15_;
		GCalcMathExpression* _tmp16_;
		GCalcExpressionContainer* _tmp17_;
		GCalcExpressionContainer* _tmp18_;
		GCalcPolynomial* _tmp19_;
		GeeArrayList* _tmp20_;
#line 341 "../gcalc/gcalc-parser.vala"
		_tmp3_ = gcalc_polynomial_new ();
#line 341 "../gcalc/gcalc-parser.vala"
		exp = _tmp3_;
#line 342 "../gcalc/gcalc-parser.vala"
		_tmp4_ = gcalc_term_new ();
#line 342 "../gcalc/gcalc-parser.vala"
		t = _tmp4_;
#line 343 "../gcalc/gcalc-parser.vala"
		_tmp5_ = t;
#line 343 "../gcalc/gcalc-parser.vala"
		_tmp6_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp5_);
#line 343 "../gcalc/gcalc-parser.vala"
		_tmp7_ = _tmp6_;
#line 343 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, (GCalcMathExpression*) opp);
#line 344 "../gcalc/gcalc-parser.vala"
		_tmp8_ = exp;
#line 344 "../gcalc/gcalc-parser.vala"
		_tmp9_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp8_);
#line 344 "../gcalc/gcalc-parser.vala"
		_tmp10_ = _tmp9_;
#line 344 "../gcalc/gcalc-parser.vala"
		_tmp11_ = t;
#line 344 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, (GCalcMathExpression*) _tmp11_);
#line 345 "../gcalc/gcalc-parser.vala"
		_tmp12_ = _g_object_ref0 ((GCalcMathExpression*) opp);
#line 345 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (self->priv->current);
#line 345 "../gcalc/gcalc-parser.vala"
		self->priv->current = _tmp12_;
#line 346 "../gcalc/gcalc-parser.vala"
		_tmp13_ = t;
#line 346 "../gcalc/gcalc-parser.vala"
		_tmp14_ = _g_object_ref0 ((GCalcMathExpression*) _tmp13_);
#line 346 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (self->priv->current_parent);
#line 346 "../gcalc/gcalc-parser.vala"
		self->priv->current_parent = _tmp14_;
#line 347 "../gcalc/gcalc-parser.vala"
		_tmp15_ = exp;
#line 347 "../gcalc/gcalc-parser.vala"
		_tmp16_ = _g_object_ref0 ((GCalcMathExpression*) _tmp15_);
#line 347 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (self->priv->top_parent);
#line 347 "../gcalc/gcalc-parser.vala"
		self->priv->top_parent = _tmp16_;
#line 348 "../gcalc/gcalc-parser.vala"
		_tmp17_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) eq);
#line 348 "../gcalc/gcalc-parser.vala"
		_tmp18_ = _tmp17_;
#line 348 "../gcalc/gcalc-parser.vala"
		_tmp19_ = exp;
#line 348 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, (GCalcMathExpression*) _tmp19_);
#line 349 "../gcalc/gcalc-parser.vala"
		_tmp20_ = self->priv->expected;
#line 349 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp20_);
#line 340 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (t);
#line 340 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (exp);
#line 2715 "gcalc-parser.c"
	} else {
		gboolean _tmp21_ = FALSE;
		GCalcMathExpression* _tmp22_;
#line 350 "../gcalc/gcalc-parser.vala"
		_tmp22_ = self->priv->current_parent;
#line 350 "../gcalc/gcalc-parser.vala"
		if (GCALC_IS_MATH_POLYNOMIAL (_tmp22_)) {
#line 2723 "gcalc-parser.c"
			GCalcMathExpression* _tmp23_;
#line 350 "../gcalc/gcalc-parser.vala"
			_tmp23_ = self->priv->current;
#line 350 "../gcalc/gcalc-parser.vala"
			_tmp21_ = GCALC_IS_MATH_TERM (_tmp23_);
#line 2729 "gcalc-parser.c"
		} else {
#line 350 "../gcalc/gcalc-parser.vala"
			_tmp21_ = FALSE;
#line 2733 "gcalc-parser.c"
		}
#line 350 "../gcalc/gcalc-parser.vala"
		if (_tmp21_) {
#line 2737 "gcalc-parser.c"
			GCalcMathExpression* _tmp24_;
			GCalcExpressionContainer* _tmp25_;
			GCalcExpressionContainer* _tmp26_;
			GCalcMathExpression* _tmp27_;
			GCalcMathExpression* _tmp28_;
			GCalcMathExpression* _tmp29_;
			GCalcMathExpression* _tmp30_;
			GCalcMathExpression* _tmp31_;
			GeeArrayList* _tmp32_;
#line 351 "../gcalc/gcalc-parser.vala"
			_tmp24_ = self->priv->current;
#line 351 "../gcalc/gcalc-parser.vala"
			_tmp25_ = gcalc_math_expression_get_expressions (_tmp24_);
#line 351 "../gcalc/gcalc-parser.vala"
			_tmp26_ = _tmp25_;
#line 351 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, (GCalcMathExpression*) opp);
#line 352 "../gcalc/gcalc-parser.vala"
			_tmp27_ = self->priv->current_parent;
#line 352 "../gcalc/gcalc-parser.vala"
			_tmp28_ = _g_object_ref0 (_tmp27_);
#line 352 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (self->priv->top_parent);
#line 352 "../gcalc/gcalc-parser.vala"
			self->priv->top_parent = _tmp28_;
#line 353 "../gcalc/gcalc-parser.vala"
			_tmp29_ = self->priv->current;
#line 353 "../gcalc/gcalc-parser.vala"
			_tmp30_ = _g_object_ref0 (_tmp29_);
#line 353 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (self->priv->current_parent);
#line 353 "../gcalc/gcalc-parser.vala"
			self->priv->current_parent = _tmp30_;
#line 354 "../gcalc/gcalc-parser.vala"
			_tmp31_ = _g_object_ref0 ((GCalcMathExpression*) opp);
#line 354 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (self->priv->current);
#line 354 "../gcalc/gcalc-parser.vala"
			self->priv->current = _tmp31_;
#line 355 "../gcalc/gcalc-parser.vala"
			_tmp32_ = self->priv->expected;
#line 355 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp32_);
#line 2781 "gcalc-parser.c"
		} else {
			gboolean _tmp33_ = FALSE;
			gboolean _tmp34_ = FALSE;
			gboolean _tmp35_ = FALSE;
			GCalcMathExpression* _tmp36_;
#line 356 "../gcalc/gcalc-parser.vala"
			_tmp36_ = self->priv->current;
#line 356 "../gcalc/gcalc-parser.vala"
			if (GCALC_IS_MATH_CONSTANT (_tmp36_)) {
#line 356 "../gcalc/gcalc-parser.vala"
				_tmp35_ = TRUE;
#line 2793 "gcalc-parser.c"
			} else {
				GCalcMathExpression* _tmp37_;
#line 356 "../gcalc/gcalc-parser.vala"
				_tmp37_ = self->priv->current;
#line 356 "../gcalc/gcalc-parser.vala"
				_tmp35_ = GCALC_IS_MATH_VARIABLE (_tmp37_);
#line 2800 "gcalc-parser.c"
			}
#line 356 "../gcalc/gcalc-parser.vala"
			if (_tmp35_) {
#line 2804 "gcalc-parser.c"
				GCalcMathExpression* _tmp38_;
#line 357 "../gcalc/gcalc-parser.vala"
				_tmp38_ = self->priv->current_parent;
#line 357 "../gcalc/gcalc-parser.vala"
				_tmp34_ = GCALC_IS_MATH_TERM (_tmp38_);
#line 2810 "gcalc-parser.c"
			} else {
#line 356 "../gcalc/gcalc-parser.vala"
				_tmp34_ = FALSE;
#line 2814 "gcalc-parser.c"
			}
#line 356 "../gcalc/gcalc-parser.vala"
			if (_tmp34_) {
#line 2818 "gcalc-parser.c"
				GCalcMathExpression* _tmp39_;
#line 357 "../gcalc/gcalc-parser.vala"
				_tmp39_ = self->priv->top_parent;
#line 357 "../gcalc/gcalc-parser.vala"
				_tmp33_ = GCALC_IS_MATH_POLYNOMIAL (_tmp39_);
#line 2824 "gcalc-parser.c"
			} else {
#line 356 "../gcalc/gcalc-parser.vala"
				_tmp33_ = FALSE;
#line 2828 "gcalc-parser.c"
			}
#line 356 "../gcalc/gcalc-parser.vala"
			if (_tmp33_) {
#line 2832 "gcalc-parser.c"
				GCalcTerm* t = NULL;
				GCalcTerm* _tmp40_;
				GCalcTerm* _tmp41_;
				GCalcExpressionContainer* _tmp42_;
				GCalcExpressionContainer* _tmp43_;
				GCalcMathExpression* _tmp44_;
				GCalcExpressionContainer* _tmp45_;
				GCalcExpressionContainer* _tmp46_;
				GCalcTerm* _tmp47_;
				GCalcMathExpression* _tmp48_;
				GCalcTerm* _tmp49_;
				GCalcMathExpression* _tmp50_;
				GeeArrayList* _tmp51_;
#line 359 "../gcalc/gcalc-parser.vala"
				_tmp40_ = gcalc_term_new ();
#line 359 "../gcalc/gcalc-parser.vala"
				t = _tmp40_;
#line 360 "../gcalc/gcalc-parser.vala"
				_tmp41_ = t;
#line 360 "../gcalc/gcalc-parser.vala"
				_tmp42_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp41_);
#line 360 "../gcalc/gcalc-parser.vala"
				_tmp43_ = _tmp42_;
#line 360 "../gcalc/gcalc-parser.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, (GCalcMathExpression*) opp);
#line 361 "../gcalc/gcalc-parser.vala"
				_tmp44_ = self->priv->top_parent;
#line 361 "../gcalc/gcalc-parser.vala"
				_tmp45_ = gcalc_math_expression_get_expressions (_tmp44_);
#line 361 "../gcalc/gcalc-parser.vala"
				_tmp46_ = _tmp45_;
#line 361 "../gcalc/gcalc-parser.vala"
				_tmp47_ = t;
#line 361 "../gcalc/gcalc-parser.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp46_, (GCalcMathExpression*) _tmp47_);
#line 362 "../gcalc/gcalc-parser.vala"
				_tmp48_ = _g_object_ref0 ((GCalcMathExpression*) opp);
#line 362 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (self->priv->current);
#line 362 "../gcalc/gcalc-parser.vala"
				self->priv->current = _tmp48_;
#line 363 "../gcalc/gcalc-parser.vala"
				_tmp49_ = t;
#line 363 "../gcalc/gcalc-parser.vala"
				_tmp50_ = _g_object_ref0 ((GCalcMathExpression*) _tmp49_);
#line 363 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (self->priv->current_parent);
#line 363 "../gcalc/gcalc-parser.vala"
				self->priv->current_parent = _tmp50_;
#line 364 "../gcalc/gcalc-parser.vala"
				_tmp51_ = self->priv->expected;
#line 364 "../gcalc/gcalc-parser.vala"
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp51_);
#line 356 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (t);
#line 2888 "gcalc-parser.c"
			} else {
				gboolean _tmp52_ = FALSE;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_ = FALSE;
				GCalcMathExpression* _tmp55_;
#line 365 "../gcalc/gcalc-parser.vala"
				_tmp55_ = self->priv->current;
#line 365 "../gcalc/gcalc-parser.vala"
				if (GCALC_IS_MATH_GROUP (_tmp55_)) {
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp54_ = TRUE;
#line 2900 "gcalc-parser.c"
				} else {
					GCalcMathExpression* _tmp56_;
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp56_ = self->priv->current;
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp54_ = GCALC_IS_MATH_FUNCTION (_tmp56_);
#line 2907 "gcalc-parser.c"
				}
#line 365 "../gcalc/gcalc-parser.vala"
				if (_tmp54_) {
#line 2911 "gcalc-parser.c"
					GCalcMathExpression* _tmp57_;
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp57_ = self->priv->current_parent;
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp53_ = GCALC_IS_MATH_TERM (_tmp57_);
#line 2917 "gcalc-parser.c"
				} else {
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp53_ = FALSE;
#line 2921 "gcalc-parser.c"
				}
#line 365 "../gcalc/gcalc-parser.vala"
				if (_tmp53_) {
#line 2925 "gcalc-parser.c"
					GCalcMathExpression* _tmp58_;
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp58_ = self->priv->top_parent;
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp52_ = GCALC_IS_MATH_POLYNOMIAL (_tmp58_);
#line 2931 "gcalc-parser.c"
				} else {
#line 365 "../gcalc/gcalc-parser.vala"
					_tmp52_ = FALSE;
#line 2935 "gcalc-parser.c"
				}
#line 365 "../gcalc/gcalc-parser.vala"
				if (_tmp52_) {
#line 2939 "gcalc-parser.c"
					GCalcTerm* t = NULL;
					GCalcTerm* _tmp59_;
					GCalcTerm* _tmp60_;
					GCalcExpressionContainer* _tmp61_;
					GCalcExpressionContainer* _tmp62_;
					GCalcMathExpression* _tmp63_;
					GCalcExpressionContainer* _tmp64_;
					GCalcExpressionContainer* _tmp65_;
					GCalcTerm* _tmp66_;
					GCalcMathExpression* _tmp67_;
					GCalcTerm* _tmp68_;
					GCalcMathExpression* _tmp69_;
					GCalcMathExpression* _tmp70_;
					GCalcMathExpression* _tmp71_;
					GCalcMathExpression* _tmp72_;
					GCalcMathExpression* _tmp73_;
					GeeArrayList* _tmp74_;
#line 367 "../gcalc/gcalc-parser.vala"
					_tmp59_ = gcalc_term_new ();
#line 367 "../gcalc/gcalc-parser.vala"
					t = _tmp59_;
#line 368 "../gcalc/gcalc-parser.vala"
					_tmp60_ = t;
#line 368 "../gcalc/gcalc-parser.vala"
					_tmp61_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp60_);
#line 368 "../gcalc/gcalc-parser.vala"
					_tmp62_ = _tmp61_;
#line 368 "../gcalc/gcalc-parser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp62_, (GCalcMathExpression*) opp);
#line 369 "../gcalc/gcalc-parser.vala"
					_tmp63_ = self->priv->top_parent;
#line 369 "../gcalc/gcalc-parser.vala"
					_tmp64_ = gcalc_math_expression_get_expressions (_tmp63_);
#line 369 "../gcalc/gcalc-parser.vala"
					_tmp65_ = _tmp64_;
#line 369 "../gcalc/gcalc-parser.vala"
					_tmp66_ = t;
#line 369 "../gcalc/gcalc-parser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp65_, (GCalcMathExpression*) _tmp66_);
#line 370 "../gcalc/gcalc-parser.vala"
					_tmp67_ = _g_object_ref0 ((GCalcMathExpression*) opp);
#line 370 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->current);
#line 370 "../gcalc/gcalc-parser.vala"
					self->priv->current = _tmp67_;
#line 371 "../gcalc/gcalc-parser.vala"
					_tmp68_ = t;
#line 371 "../gcalc/gcalc-parser.vala"
					_tmp69_ = _g_object_ref0 ((GCalcMathExpression*) _tmp68_);
#line 371 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->current_parent);
#line 371 "../gcalc/gcalc-parser.vala"
					self->priv->current_parent = _tmp69_;
#line 372 "../gcalc/gcalc-parser.vala"
					_tmp70_ = self->priv->current_parent;
#line 372 "../gcalc/gcalc-parser.vala"
					_tmp71_ = gcalc_math_expression_get_parent (_tmp70_);
#line 372 "../gcalc/gcalc-parser.vala"
					_tmp72_ = _tmp71_;
#line 372 "../gcalc/gcalc-parser.vala"
					_tmp73_ = _g_object_ref0 (_tmp72_);
#line 372 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (self->priv->top_parent);
#line 372 "../gcalc/gcalc-parser.vala"
					self->priv->top_parent = _tmp73_;
#line 373 "../gcalc/gcalc-parser.vala"
					_tmp74_ = self->priv->expected;
#line 373 "../gcalc/gcalc-parser.vala"
					gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp74_);
#line 365 "../gcalc/gcalc-parser.vala"
					_g_object_unref0 (t);
#line 3011 "gcalc-parser.c"
				} else {
					gboolean _tmp75_ = FALSE;
					GCalcMathExpression* _tmp76_;
#line 374 "../gcalc/gcalc-parser.vala"
					_tmp76_ = self->priv->current;
#line 374 "../gcalc/gcalc-parser.vala"
					if (GCALC_IS_MATH_VARIABLE (_tmp76_)) {
#line 3019 "gcalc-parser.c"
						GCalcMathExpression* _tmp77_;
#line 374 "../gcalc/gcalc-parser.vala"
						_tmp77_ = self->priv->current_parent;
#line 374 "../gcalc/gcalc-parser.vala"
						_tmp75_ = _tmp77_ == NULL;
#line 3025 "gcalc-parser.c"
					} else {
#line 374 "../gcalc/gcalc-parser.vala"
						_tmp75_ = FALSE;
#line 3029 "gcalc-parser.c"
					}
#line 374 "../gcalc/gcalc-parser.vala"
					if (_tmp75_) {
#line 3033 "gcalc-parser.c"
						GCalcPolynomial* exp = NULL;
						GCalcPolynomial* _tmp78_;
						GCalcExpressionContainer* _tmp79_;
						GCalcExpressionContainer* _tmp80_;
						GCalcPolynomial* _tmp81_;
						GCalcTerm* t = NULL;
						GCalcTerm* _tmp82_;
						GCalcPolynomial* _tmp83_;
						GCalcExpressionContainer* _tmp84_;
						GCalcExpressionContainer* _tmp85_;
						GCalcTerm* _tmp86_;
						GCalcTerm* _tmp87_;
						GCalcExpressionContainer* _tmp88_;
						GCalcExpressionContainer* _tmp89_;
						GCalcMathExpression* _tmp90_;
						GCalcTerm* t2 = NULL;
						GCalcTerm* _tmp91_;
						GCalcPolynomial* _tmp92_;
						GCalcExpressionContainer* _tmp93_;
						GCalcExpressionContainer* _tmp94_;
						GCalcTerm* _tmp95_;
						GCalcTerm* _tmp96_;
						GCalcExpressionContainer* _tmp97_;
						GCalcExpressionContainer* _tmp98_;
						GCalcMathExpression* _tmp99_;
						GCalcTerm* _tmp100_;
						GCalcMathExpression* _tmp101_;
						GCalcPolynomial* _tmp102_;
						GCalcMathExpression* _tmp103_;
						GeeArrayList* _tmp104_;
#line 376 "../gcalc/gcalc-parser.vala"
						_tmp78_ = gcalc_polynomial_new ();
#line 376 "../gcalc/gcalc-parser.vala"
						exp = _tmp78_;
#line 377 "../gcalc/gcalc-parser.vala"
						_tmp79_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) eq);
#line 377 "../gcalc/gcalc-parser.vala"
						_tmp80_ = _tmp79_;
#line 377 "../gcalc/gcalc-parser.vala"
						_tmp81_ = exp;
#line 377 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp80_, (GCalcMathExpression*) _tmp81_);
#line 378 "../gcalc/gcalc-parser.vala"
						_tmp82_ = gcalc_term_new ();
#line 378 "../gcalc/gcalc-parser.vala"
						t = _tmp82_;
#line 379 "../gcalc/gcalc-parser.vala"
						_tmp83_ = exp;
#line 379 "../gcalc/gcalc-parser.vala"
						_tmp84_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp83_);
#line 379 "../gcalc/gcalc-parser.vala"
						_tmp85_ = _tmp84_;
#line 379 "../gcalc/gcalc-parser.vala"
						_tmp86_ = t;
#line 379 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp85_, (GCalcMathExpression*) _tmp86_);
#line 380 "../gcalc/gcalc-parser.vala"
						_tmp87_ = t;
#line 380 "../gcalc/gcalc-parser.vala"
						_tmp88_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp87_);
#line 380 "../gcalc/gcalc-parser.vala"
						_tmp89_ = _tmp88_;
#line 380 "../gcalc/gcalc-parser.vala"
						_tmp90_ = self->priv->current;
#line 380 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp89_, _tmp90_);
#line 381 "../gcalc/gcalc-parser.vala"
						_tmp91_ = gcalc_term_new ();
#line 381 "../gcalc/gcalc-parser.vala"
						t2 = _tmp91_;
#line 382 "../gcalc/gcalc-parser.vala"
						_tmp92_ = exp;
#line 382 "../gcalc/gcalc-parser.vala"
						_tmp93_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp92_);
#line 382 "../gcalc/gcalc-parser.vala"
						_tmp94_ = _tmp93_;
#line 382 "../gcalc/gcalc-parser.vala"
						_tmp95_ = t2;
#line 382 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp94_, (GCalcMathExpression*) _tmp95_);
#line 383 "../gcalc/gcalc-parser.vala"
						_tmp96_ = t2;
#line 383 "../gcalc/gcalc-parser.vala"
						_tmp97_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp96_);
#line 383 "../gcalc/gcalc-parser.vala"
						_tmp98_ = _tmp97_;
#line 383 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp98_, (GCalcMathExpression*) opp);
#line 384 "../gcalc/gcalc-parser.vala"
						_tmp99_ = _g_object_ref0 ((GCalcMathExpression*) opp);
#line 384 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (self->priv->current);
#line 384 "../gcalc/gcalc-parser.vala"
						self->priv->current = _tmp99_;
#line 385 "../gcalc/gcalc-parser.vala"
						_tmp100_ = t2;
#line 385 "../gcalc/gcalc-parser.vala"
						_tmp101_ = _g_object_ref0 ((GCalcMathExpression*) _tmp100_);
#line 385 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (self->priv->current_parent);
#line 385 "../gcalc/gcalc-parser.vala"
						self->priv->current_parent = _tmp101_;
#line 386 "../gcalc/gcalc-parser.vala"
						_tmp102_ = exp;
#line 386 "../gcalc/gcalc-parser.vala"
						_tmp103_ = _g_object_ref0 ((GCalcMathExpression*) _tmp102_);
#line 386 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (self->priv->top_parent);
#line 386 "../gcalc/gcalc-parser.vala"
						self->priv->top_parent = _tmp103_;
#line 387 "../gcalc/gcalc-parser.vala"
						_tmp104_ = self->priv->expected;
#line 387 "../gcalc/gcalc-parser.vala"
						gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp104_);
#line 374 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (t2);
#line 374 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (t);
#line 374 "../gcalc/gcalc-parser.vala"
						_g_object_unref0 (exp);
#line 3154 "gcalc-parser.c"
					}
				}
			}
		}
	}
}

static void
gcalc_parser_process_term_operator (GCalcParser* self,
                                    GCalcMathOperator* op,
                                    GCalcEquation* eq,
                                    GError** error)
{
	GCalcMathExpression* _tmp0_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	GCalcMathExpression* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 390 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (self != NULL);
#line 390 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (op != NULL);
#line 390 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (eq != NULL);
#line 391 "../gcalc/gcalc-parser.vala"
	_tmp0_ = self->priv->current;
#line 391 "../gcalc/gcalc-parser.vala"
	if (GCALC_IS_MATH_OPERATOR (_tmp0_)) {
#line 3186 "gcalc-parser.c"
		GError* _tmp1_;
#line 392 "../gcalc/gcalc-parser.vala"
		_tmp1_ = g_error_new_literal (GCALC_PARSER_ERROR, GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, _ ("Found an unexpected expression for a multiply operator"));
#line 392 "../gcalc/gcalc-parser.vala"
		_inner_error0_ = _tmp1_;
#line 392 "../gcalc/gcalc-parser.vala"
		g_propagate_error (error, _inner_error0_);
#line 392 "../gcalc/gcalc-parser.vala"
		return;
#line 3196 "gcalc-parser.c"
	}
#line 394 "../gcalc/gcalc-parser.vala"
	_tmp7_ = self->priv->current;
#line 394 "../gcalc/gcalc-parser.vala"
	if (GCALC_IS_MATH_CONSTANT (_tmp7_)) {
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp6_ = TRUE;
#line 3204 "gcalc-parser.c"
	} else {
		GCalcMathExpression* _tmp8_;
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp8_ = self->priv->current;
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp6_ = GCALC_IS_MATH_VARIABLE (_tmp8_);
#line 3211 "gcalc-parser.c"
	}
#line 394 "../gcalc/gcalc-parser.vala"
	if (_tmp6_) {
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp5_ = TRUE;
#line 3217 "gcalc-parser.c"
	} else {
		GCalcMathExpression* _tmp9_;
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp9_ = self->priv->current;
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp5_ = GCALC_IS_MATH_GROUP (_tmp9_);
#line 3224 "gcalc-parser.c"
	}
#line 394 "../gcalc/gcalc-parser.vala"
	if (_tmp5_) {
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp4_ = TRUE;
#line 3230 "gcalc-parser.c"
	} else {
		GCalcMathExpression* _tmp10_;
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp10_ = self->priv->current;
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp4_ = GCALC_IS_MATH_FUNCTION (_tmp10_);
#line 3237 "gcalc-parser.c"
	}
#line 394 "../gcalc/gcalc-parser.vala"
	if (_tmp4_) {
#line 3241 "gcalc-parser.c"
		GCalcMathExpression* _tmp11_;
#line 395 "../gcalc/gcalc-parser.vala"
		_tmp11_ = self->priv->current_parent;
#line 395 "../gcalc/gcalc-parser.vala"
		_tmp3_ = GCALC_IS_MATH_TERM (_tmp11_);
#line 3247 "gcalc-parser.c"
	} else {
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp3_ = FALSE;
#line 3251 "gcalc-parser.c"
	}
#line 394 "../gcalc/gcalc-parser.vala"
	if (_tmp3_) {
#line 3255 "gcalc-parser.c"
		GCalcMathExpression* _tmp12_;
#line 395 "../gcalc/gcalc-parser.vala"
		_tmp12_ = self->priv->top_parent;
#line 395 "../gcalc/gcalc-parser.vala"
		_tmp2_ = GCALC_IS_MATH_POLYNOMIAL (_tmp12_);
#line 3261 "gcalc-parser.c"
	} else {
#line 394 "../gcalc/gcalc-parser.vala"
		_tmp2_ = FALSE;
#line 3265 "gcalc-parser.c"
	}
#line 394 "../gcalc/gcalc-parser.vala"
	if (_tmp2_) {
#line 3269 "gcalc-parser.c"
		GCalcMathExpression* _tmp13_;
		GCalcExpressionContainer* _tmp14_;
		GCalcExpressionContainer* _tmp15_;
		GCalcMathExpression* _tmp16_;
		GeeArrayList* _tmp17_;
#line 396 "../gcalc/gcalc-parser.vala"
		_tmp13_ = self->priv->current_parent;
#line 396 "../gcalc/gcalc-parser.vala"
		_tmp14_ = gcalc_math_expression_get_expressions (_tmp13_);
#line 396 "../gcalc/gcalc-parser.vala"
		_tmp15_ = _tmp14_;
#line 396 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, (GCalcMathExpression*) op);
#line 397 "../gcalc/gcalc-parser.vala"
		_tmp16_ = _g_object_ref0 ((GCalcMathExpression*) op);
#line 397 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (self->priv->current);
#line 397 "../gcalc/gcalc-parser.vala"
		self->priv->current = _tmp16_;
#line 398 "../gcalc/gcalc-parser.vala"
		_tmp17_ = self->priv->expected;
#line 398 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp17_);
#line 3293 "gcalc-parser.c"
	} else {
		gboolean _tmp18_ = FALSE;
		GCalcMathExpression* _tmp19_;
#line 399 "../gcalc/gcalc-parser.vala"
		_tmp19_ = self->priv->current;
#line 399 "../gcalc/gcalc-parser.vala"
		if (GCALC_IS_MATH_VARIABLE (_tmp19_)) {
#line 3301 "gcalc-parser.c"
			GCalcMathExpression* _tmp20_;
#line 399 "../gcalc/gcalc-parser.vala"
			_tmp20_ = self->priv->current_parent;
#line 399 "../gcalc/gcalc-parser.vala"
			_tmp18_ = _tmp20_ == NULL;
#line 3307 "gcalc-parser.c"
		} else {
#line 399 "../gcalc/gcalc-parser.vala"
			_tmp18_ = FALSE;
#line 3311 "gcalc-parser.c"
		}
#line 399 "../gcalc/gcalc-parser.vala"
		if (_tmp18_) {
#line 3315 "gcalc-parser.c"
			GCalcPolynomial* exp = NULL;
			GCalcPolynomial* _tmp21_;
			GCalcExpressionContainer* _tmp22_;
			GCalcExpressionContainer* _tmp23_;
			GCalcPolynomial* _tmp24_;
			GCalcTerm* t = NULL;
			GCalcTerm* _tmp25_;
			GCalcPolynomial* _tmp26_;
			GCalcExpressionContainer* _tmp27_;
			GCalcExpressionContainer* _tmp28_;
			GCalcTerm* _tmp29_;
			GCalcTerm* _tmp30_;
			GCalcExpressionContainer* _tmp31_;
			GCalcExpressionContainer* _tmp32_;
			GCalcMathExpression* _tmp33_;
			GCalcTerm* _tmp34_;
			GCalcExpressionContainer* _tmp35_;
			GCalcExpressionContainer* _tmp36_;
			GCalcMathExpression* _tmp37_;
			GCalcTerm* _tmp38_;
			GCalcMathExpression* _tmp39_;
			GCalcPolynomial* _tmp40_;
			GCalcMathExpression* _tmp41_;
			GeeArrayList* _tmp42_;
#line 401 "../gcalc/gcalc-parser.vala"
			_tmp21_ = gcalc_polynomial_new ();
#line 401 "../gcalc/gcalc-parser.vala"
			exp = _tmp21_;
#line 402 "../gcalc/gcalc-parser.vala"
			_tmp22_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) eq);
#line 402 "../gcalc/gcalc-parser.vala"
			_tmp23_ = _tmp22_;
#line 402 "../gcalc/gcalc-parser.vala"
			_tmp24_ = exp;
#line 402 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, (GCalcMathExpression*) _tmp24_);
#line 403 "../gcalc/gcalc-parser.vala"
			_tmp25_ = gcalc_term_new ();
#line 403 "../gcalc/gcalc-parser.vala"
			t = _tmp25_;
#line 404 "../gcalc/gcalc-parser.vala"
			_tmp26_ = exp;
#line 404 "../gcalc/gcalc-parser.vala"
			_tmp27_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp26_);
#line 404 "../gcalc/gcalc-parser.vala"
			_tmp28_ = _tmp27_;
#line 404 "../gcalc/gcalc-parser.vala"
			_tmp29_ = t;
#line 404 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, (GCalcMathExpression*) _tmp29_);
#line 405 "../gcalc/gcalc-parser.vala"
			_tmp30_ = t;
#line 405 "../gcalc/gcalc-parser.vala"
			_tmp31_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp30_);
#line 405 "../gcalc/gcalc-parser.vala"
			_tmp32_ = _tmp31_;
#line 405 "../gcalc/gcalc-parser.vala"
			_tmp33_ = self->priv->current;
#line 405 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 406 "../gcalc/gcalc-parser.vala"
			_tmp34_ = t;
#line 406 "../gcalc/gcalc-parser.vala"
			_tmp35_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp34_);
#line 406 "../gcalc/gcalc-parser.vala"
			_tmp36_ = _tmp35_;
#line 406 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, (GCalcMathExpression*) op);
#line 407 "../gcalc/gcalc-parser.vala"
			_tmp37_ = _g_object_ref0 ((GCalcMathExpression*) op);
#line 407 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (self->priv->current);
#line 407 "../gcalc/gcalc-parser.vala"
			self->priv->current = _tmp37_;
#line 408 "../gcalc/gcalc-parser.vala"
			_tmp38_ = t;
#line 408 "../gcalc/gcalc-parser.vala"
			_tmp39_ = _g_object_ref0 ((GCalcMathExpression*) _tmp38_);
#line 408 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (self->priv->current_parent);
#line 408 "../gcalc/gcalc-parser.vala"
			self->priv->current_parent = _tmp39_;
#line 409 "../gcalc/gcalc-parser.vala"
			_tmp40_ = exp;
#line 409 "../gcalc/gcalc-parser.vala"
			_tmp41_ = _g_object_ref0 ((GCalcMathExpression*) _tmp40_);
#line 409 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (self->priv->top_parent);
#line 409 "../gcalc/gcalc-parser.vala"
			self->priv->top_parent = _tmp41_;
#line 410 "../gcalc/gcalc-parser.vala"
			_tmp42_ = self->priv->expected;
#line 410 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp42_);
#line 399 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (t);
#line 399 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (exp);
#line 3414 "gcalc-parser.c"
		}
	}
}

static void
gcalc_parser_add_constant (GCalcParser* self,
                           GCalcMathConstant* c)
{
	GCalcMathExpression* _tmp0_;
#line 413 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (self != NULL);
#line 413 "../gcalc/gcalc-parser.vala"
	g_return_if_fail (c != NULL);
#line 414 "../gcalc/gcalc-parser.vala"
	_tmp0_ = self->priv->current;
#line 414 "../gcalc/gcalc-parser.vala"
	if (_tmp0_ == NULL) {
#line 3432 "gcalc-parser.c"
		GCalcPolynomial* exp = NULL;
		GCalcPolynomial* _tmp1_;
		GCalcEquation* _tmp2_;
		GCalcExpressionContainer* _tmp3_;
		GCalcExpressionContainer* _tmp4_;
		GCalcPolynomial* _tmp5_;
		GCalcTerm* t = NULL;
		GCalcTerm* _tmp6_;
		GCalcPolynomial* _tmp7_;
		GCalcExpressionContainer* _tmp8_;
		GCalcExpressionContainer* _tmp9_;
		GCalcTerm* _tmp10_;
		GCalcTerm* _tmp11_;
		GCalcExpressionContainer* _tmp12_;
		GCalcExpressionContainer* _tmp13_;
		GCalcMathExpression* _tmp14_;
		GCalcTerm* _tmp15_;
		GCalcMathExpression* _tmp16_;
		GCalcPolynomial* _tmp17_;
		GCalcMathExpression* _tmp18_;
#line 415 "../gcalc/gcalc-parser.vala"
		_tmp1_ = gcalc_polynomial_new ();
#line 415 "../gcalc/gcalc-parser.vala"
		exp = _tmp1_;
#line 416 "../gcalc/gcalc-parser.vala"
		_tmp2_ = self->priv->eq;
#line 416 "../gcalc/gcalc-parser.vala"
		_tmp3_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp2_);
#line 416 "../gcalc/gcalc-parser.vala"
		_tmp4_ = _tmp3_;
#line 416 "../gcalc/gcalc-parser.vala"
		_tmp5_ = exp;
#line 416 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, (GCalcMathExpression*) _tmp5_);
#line 417 "../gcalc/gcalc-parser.vala"
		_tmp6_ = gcalc_term_new ();
#line 417 "../gcalc/gcalc-parser.vala"
		t = _tmp6_;
#line 418 "../gcalc/gcalc-parser.vala"
		_tmp7_ = exp;
#line 418 "../gcalc/gcalc-parser.vala"
		_tmp8_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp7_);
#line 418 "../gcalc/gcalc-parser.vala"
		_tmp9_ = _tmp8_;
#line 418 "../gcalc/gcalc-parser.vala"
		_tmp10_ = t;
#line 418 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (GCalcMathExpression*) _tmp10_);
#line 419 "../gcalc/gcalc-parser.vala"
		_tmp11_ = t;
#line 419 "../gcalc/gcalc-parser.vala"
		_tmp12_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) _tmp11_);
#line 419 "../gcalc/gcalc-parser.vala"
		_tmp13_ = _tmp12_;
#line 419 "../gcalc/gcalc-parser.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, (GCalcMathExpression*) c);
#line 420 "../gcalc/gcalc-parser.vala"
		_tmp14_ = _g_object_ref0 ((GCalcMathExpression*) c);
#line 420 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (self->priv->current);
#line 420 "../gcalc/gcalc-parser.vala"
		self->priv->current = _tmp14_;
#line 421 "../gcalc/gcalc-parser.vala"
		_tmp15_ = t;
#line 421 "../gcalc/gcalc-parser.vala"
		_tmp16_ = _g_object_ref0 ((GCalcMathExpression*) _tmp15_);
#line 421 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (self->priv->current_parent);
#line 421 "../gcalc/gcalc-parser.vala"
		self->priv->current_parent = _tmp16_;
#line 422 "../gcalc/gcalc-parser.vala"
		_tmp17_ = exp;
#line 422 "../gcalc/gcalc-parser.vala"
		_tmp18_ = _g_object_ref0 ((GCalcMathExpression*) _tmp17_);
#line 422 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (self->priv->top_parent);
#line 422 "../gcalc/gcalc-parser.vala"
		self->priv->top_parent = _tmp18_;
#line 414 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (t);
#line 414 "../gcalc/gcalc-parser.vala"
		_g_object_unref0 (exp);
#line 3515 "gcalc-parser.c"
	} else {
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_ = FALSE;
		GCalcMathExpression* _tmp22_;
#line 423 "../gcalc/gcalc-parser.vala"
		_tmp22_ = self->priv->current;
#line 423 "../gcalc/gcalc-parser.vala"
		if (GCALC_IS_MATH_OPERATOR (_tmp22_)) {
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp21_ = TRUE;
#line 3527 "gcalc-parser.c"
		} else {
			GCalcMathExpression* _tmp23_;
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp23_ = self->priv->current;
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp21_ = GCALC_IS_MATH_TERM (_tmp23_);
#line 3534 "gcalc-parser.c"
		}
#line 423 "../gcalc/gcalc-parser.vala"
		if (_tmp21_) {
#line 3538 "gcalc-parser.c"
			GCalcMathExpression* _tmp24_;
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp24_ = self->priv->current_parent;
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp20_ = GCALC_IS_MATH_TERM (_tmp24_);
#line 3544 "gcalc-parser.c"
		} else {
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp20_ = FALSE;
#line 3548 "gcalc-parser.c"
		}
#line 423 "../gcalc/gcalc-parser.vala"
		if (_tmp20_) {
#line 3552 "gcalc-parser.c"
			GCalcMathExpression* _tmp25_;
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp25_ = self->priv->top_parent;
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp19_ = GCALC_IS_MATH_POLYNOMIAL (_tmp25_);
#line 3558 "gcalc-parser.c"
		} else {
#line 423 "../gcalc/gcalc-parser.vala"
			_tmp19_ = FALSE;
#line 3562 "gcalc-parser.c"
		}
#line 423 "../gcalc/gcalc-parser.vala"
		if (_tmp19_) {
#line 3566 "gcalc-parser.c"
			GCalcMathExpression* _tmp26_;
			GCalcExpressionContainer* _tmp27_;
			GCalcExpressionContainer* _tmp28_;
			GeeArrayList* _tmp29_;
			GCalcMathExpression* _tmp30_;
#line 424 "../gcalc/gcalc-parser.vala"
			_tmp26_ = self->priv->current_parent;
#line 424 "../gcalc/gcalc-parser.vala"
			_tmp27_ = gcalc_math_expression_get_expressions (_tmp26_);
#line 424 "../gcalc/gcalc-parser.vala"
			_tmp28_ = _tmp27_;
#line 424 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, (GCalcMathExpression*) c);
#line 425 "../gcalc/gcalc-parser.vala"
			_tmp29_ = self->priv->expected;
#line 425 "../gcalc/gcalc-parser.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp29_);
#line 426 "../gcalc/gcalc-parser.vala"
			_tmp30_ = _g_object_ref0 ((GCalcMathExpression*) c);
#line 426 "../gcalc/gcalc-parser.vala"
			_g_object_unref0 (self->priv->current);
#line 426 "../gcalc/gcalc-parser.vala"
			self->priv->current = _tmp30_;
#line 3590 "gcalc-parser.c"
		} else {
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			GCalcMathExpression* _tmp33_;
#line 427 "../gcalc/gcalc-parser.vala"
			_tmp33_ = self->priv->current;
#line 427 "../gcalc/gcalc-parser.vala"
			if (GCALC_IS_MATH_TERM (_tmp33_)) {
#line 3599 "gcalc-parser.c"
				GCalcMathExpression* _tmp34_;
#line 427 "../gcalc/gcalc-parser.vala"
				_tmp34_ = self->priv->current_parent;
#line 427 "../gcalc/gcalc-parser.vala"
				_tmp32_ = GCALC_IS_MATH_POLYNOMIAL (_tmp34_);
#line 3605 "gcalc-parser.c"
			} else {
#line 427 "../gcalc/gcalc-parser.vala"
				_tmp32_ = FALSE;
#line 3609 "gcalc-parser.c"
			}
#line 427 "../gcalc/gcalc-parser.vala"
			if (_tmp32_) {
#line 3613 "gcalc-parser.c"
				gboolean _tmp35_ = FALSE;
				GCalcMathExpression* _tmp36_;
#line 427 "../gcalc/gcalc-parser.vala"
				_tmp36_ = self->priv->top_parent;
#line 427 "../gcalc/gcalc-parser.vala"
				if (GCALC_IS_MATH_GROUP (_tmp36_)) {
#line 427 "../gcalc/gcalc-parser.vala"
					_tmp35_ = TRUE;
#line 3622 "gcalc-parser.c"
				} else {
					GCalcMathExpression* _tmp37_;
#line 427 "../gcalc/gcalc-parser.vala"
					_tmp37_ = self->priv->top_parent;
#line 427 "../gcalc/gcalc-parser.vala"
					_tmp35_ = GCALC_IS_MATH_FUNCTION (_tmp37_);
#line 3629 "gcalc-parser.c"
				}
#line 427 "../gcalc/gcalc-parser.vala"
				_tmp31_ = _tmp35_;
#line 3633 "gcalc-parser.c"
			} else {
#line 427 "../gcalc/gcalc-parser.vala"
				_tmp31_ = FALSE;
#line 3637 "gcalc-parser.c"
			}
#line 427 "../gcalc/gcalc-parser.vala"
			if (_tmp31_) {
#line 3641 "gcalc-parser.c"
				GCalcMathExpression* _tmp38_;
				GCalcExpressionContainer* _tmp39_;
				GCalcExpressionContainer* _tmp40_;
				GCalcMathExpression* _tmp41_;
				GCalcMathExpression* _tmp42_;
				GCalcMathExpression* _tmp43_;
				GCalcMathExpression* _tmp44_;
				GCalcMathExpression* _tmp45_;
				GeeArrayList* _tmp46_;
#line 428 "../gcalc/gcalc-parser.vala"
				_tmp38_ = self->priv->current;
#line 428 "../gcalc/gcalc-parser.vala"
				_tmp39_ = gcalc_math_expression_get_expressions (_tmp38_);
#line 428 "../gcalc/gcalc-parser.vala"
				_tmp40_ = _tmp39_;
#line 428 "../gcalc/gcalc-parser.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, (GCalcMathExpression*) c);
#line 429 "../gcalc/gcalc-parser.vala"
				_tmp41_ = self->priv->current_parent;
#line 429 "../gcalc/gcalc-parser.vala"
				_tmp42_ = _g_object_ref0 (_tmp41_);
#line 429 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (self->priv->top_parent);
#line 429 "../gcalc/gcalc-parser.vala"
				self->priv->top_parent = _tmp42_;
#line 430 "../gcalc/gcalc-parser.vala"
				_tmp43_ = self->priv->current;
#line 430 "../gcalc/gcalc-parser.vala"
				_tmp44_ = _g_object_ref0 (_tmp43_);
#line 430 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (self->priv->current_parent);
#line 430 "../gcalc/gcalc-parser.vala"
				self->priv->current_parent = _tmp44_;
#line 431 "../gcalc/gcalc-parser.vala"
				_tmp45_ = _g_object_ref0 ((GCalcMathExpression*) c);
#line 431 "../gcalc/gcalc-parser.vala"
				_g_object_unref0 (self->priv->current);
#line 431 "../gcalc/gcalc-parser.vala"
				self->priv->current = _tmp45_;
#line 432 "../gcalc/gcalc-parser.vala"
				_tmp46_ = self->priv->expected;
#line 432 "../gcalc/gcalc-parser.vala"
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp46_);
#line 3685 "gcalc-parser.c"
			}
		}
	}
}

/**
   * Reads a token at a given position
   */
GCalcParserTokenType
gcalc_parser_read_token (GCalcParser* self)
{
	GTokenType t = 0;
	GScanner* _tmp0_;
	GCalcParserTokenType result;
#line 438 "../gcalc/gcalc-parser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 439 "../gcalc/gcalc-parser.vala"
	_tmp0_ = self->priv->scanner;
#line 439 "../gcalc/gcalc-parser.vala"
	t = g_scanner_get_next_token (_tmp0_);
#line 440 "../gcalc/gcalc-parser.vala"
	switch (t) {
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_IDENTIFIER:
#line 3710 "gcalc-parser.c"
		{
#line 442 "../gcalc/gcalc-parser.vala"
			result = GCALC_PARSER_TOKEN_TYPE_IDENTIFIER;
#line 442 "../gcalc/gcalc-parser.vala"
			return result;
#line 3716 "gcalc-parser.c"
		}
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_INT:
#line 3720 "gcalc-parser.c"
		{
#line 444 "../gcalc/gcalc-parser.vala"
			result = GCALC_PARSER_TOKEN_TYPE_INTEGER_LITERAL;
#line 444 "../gcalc/gcalc-parser.vala"
			return result;
#line 3726 "gcalc-parser.c"
		}
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_FLOAT:
#line 3730 "gcalc-parser.c"
		{
#line 446 "../gcalc/gcalc-parser.vala"
			result = GCALC_PARSER_TOKEN_TYPE_REAL_LITERAL;
#line 446 "../gcalc/gcalc-parser.vala"
			return result;
#line 3736 "gcalc-parser.c"
		}
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_STRING:
#line 3740 "gcalc-parser.c"
		{
#line 448 "../gcalc/gcalc-parser.vala"
			result = GCALC_PARSER_TOKEN_TYPE_STRING_LITERAL;
#line 448 "../gcalc/gcalc-parser.vala"
			return result;
#line 3746 "gcalc-parser.c"
		}
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_EOF:
#line 3750 "gcalc-parser.c"
		{
#line 450 "../gcalc/gcalc-parser.vala"
			result = GCALC_PARSER_TOKEN_TYPE_EOF;
#line 450 "../gcalc/gcalc-parser.vala"
			return result;
#line 3756 "gcalc-parser.c"
		}
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_CHAR:
#line 3760 "gcalc-parser.c"
		{
			guchar v = '\0';
			GScanner* _tmp1_;
#line 452 "../gcalc/gcalc-parser.vala"
			_tmp1_ = self->priv->scanner;
#line 452 "../gcalc/gcalc-parser.vala"
			v = g_scanner_cur_value (_tmp1_).v_char;
#line 453 "../gcalc/gcalc-parser.vala"
			if (g_ascii_isalpha ((gchar) v)) {
#line 454 "../gcalc/gcalc-parser.vala"
				result = GCALC_PARSER_TOKEN_TYPE_IDENTIFIER;
#line 454 "../gcalc/gcalc-parser.vala"
				return result;
#line 3774 "gcalc-parser.c"
			}
#line 456 "../gcalc/gcalc-parser.vala"
			switch (v) {
#line 456 "../gcalc/gcalc-parser.vala"
				case '*':
#line 3780 "gcalc-parser.c"
				{
#line 458 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_STAR;
#line 458 "../gcalc/gcalc-parser.vala"
					return result;
#line 3786 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '/':
#line 3790 "gcalc-parser.c"
				{
#line 460 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_DIV;
#line 460 "../gcalc/gcalc-parser.vala"
					return result;
#line 3796 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '+':
#line 3800 "gcalc-parser.c"
				{
#line 462 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_PLUS;
#line 462 "../gcalc/gcalc-parser.vala"
					return result;
#line 3806 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '-':
#line 3810 "gcalc-parser.c"
				{
#line 464 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_MINUS;
#line 464 "../gcalc/gcalc-parser.vala"
					return result;
#line 3816 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '^':
#line 3820 "gcalc-parser.c"
				{
#line 466 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_CARRET;
#line 466 "../gcalc/gcalc-parser.vala"
					return result;
#line 3826 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case ')':
#line 3830 "gcalc-parser.c"
				{
#line 468 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_CLOSE_PARENS;
#line 468 "../gcalc/gcalc-parser.vala"
					return result;
#line 3836 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '(':
#line 3840 "gcalc-parser.c"
				{
#line 470 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_OPEN_PARENS;
#line 470 "../gcalc/gcalc-parser.vala"
					return result;
#line 3846 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '=':
#line 3850 "gcalc-parser.c"
				{
#line 472 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_ASSIGN;
#line 472 "../gcalc/gcalc-parser.vala"
					return result;
#line 3856 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '{':
#line 3860 "gcalc-parser.c"
				{
#line 474 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_OPEN_BRACE;
#line 474 "../gcalc/gcalc-parser.vala"
					return result;
#line 3866 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '}':
#line 3870 "gcalc-parser.c"
				{
#line 476 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACE;
#line 476 "../gcalc/gcalc-parser.vala"
					return result;
#line 3876 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '[':
#line 3880 "gcalc-parser.c"
				{
#line 478 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_OPEN_BRACKET;
#line 478 "../gcalc/gcalc-parser.vala"
					return result;
#line 3886 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case ']':
#line 3890 "gcalc-parser.c"
				{
#line 480 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_CLOSE_BRACKET;
#line 480 "../gcalc/gcalc-parser.vala"
					return result;
#line 3896 "gcalc-parser.c"
				}
#line 456 "../gcalc/gcalc-parser.vala"
				case '$':
#line 3900 "gcalc-parser.c"
				{
#line 482 "../gcalc/gcalc-parser.vala"
					result = GCALC_PARSER_TOKEN_TYPE_CURRENCY_SYMBOL;
#line 482 "../gcalc/gcalc-parser.vala"
					return result;
#line 3906 "gcalc-parser.c"
				}
				default:
#line 456 "../gcalc/gcalc-parser.vala"
				break;
#line 3911 "gcalc-parser.c"
			}
#line 484 "../gcalc/gcalc-parser.vala"
			break;
#line 3915 "gcalc-parser.c"
		}
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_RIGHT_PAREN:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_LEFT_PAREN:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_LEFT_BRACE:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_LEFT_CURLY:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_OCTAL:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_COMMENT_MULTI:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_COMMA:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_IDENTIFIER_NULL:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_LAST:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_RIGHT_BRACE:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_NONE:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_SYMBOL:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_BINARY:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_COMMENT_SINGLE:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_RIGHT_CURLY:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_HEX:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_EQUAL_SIGN:
#line 440 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_ERROR:
#line 3953 "gcalc-parser.c"
		{
#line 503 "../gcalc/gcalc-parser.vala"
			break;
#line 3957 "gcalc-parser.c"
		}
		default:
#line 440 "../gcalc/gcalc-parser.vala"
		break;
#line 3962 "gcalc-parser.c"
	}
#line 505 "../gcalc/gcalc-parser.vala"
	result = GCALC_PARSER_TOKEN_TYPE_NONE;
#line 505 "../gcalc/gcalc-parser.vala"
	return result;
#line 3968 "gcalc-parser.c"
}

/**
   * Creates a string representation of the current {@link TokenType}
   */
gchar*
gcalc_parser_token_to_string (GCalcParser* self)
{
	GTokenType t = 0;
	GScanner* _tmp0_;
	gchar* _tmp18_;
	gchar* result;
#line 510 "../gcalc/gcalc-parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 511 "../gcalc/gcalc-parser.vala"
	_tmp0_ = self->priv->scanner;
#line 511 "../gcalc/gcalc-parser.vala"
	t = g_scanner_cur_token (_tmp0_);
#line 512 "../gcalc/gcalc-parser.vala"
	switch (t) {
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_IDENTIFIER:
#line 3991 "gcalc-parser.c"
		{
			GScanner* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 514 "../gcalc/gcalc-parser.vala"
			_tmp1_ = self->priv->scanner;
#line 514 "../gcalc/gcalc-parser.vala"
			_tmp2_ = g_scanner_cur_value (_tmp1_).v_identifier;
#line 514 "../gcalc/gcalc-parser.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 514 "../gcalc/gcalc-parser.vala"
			result = _tmp3_;
#line 514 "../gcalc/gcalc-parser.vala"
			return result;
#line 4006 "gcalc-parser.c"
		}
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_INT:
#line 4010 "gcalc-parser.c"
		{
			GScanner* _tmp4_;
			gchar* _tmp5_;
#line 516 "../gcalc/gcalc-parser.vala"
			_tmp4_ = self->priv->scanner;
#line 516 "../gcalc/gcalc-parser.vala"
			_tmp5_ = g_strdup_printf ("%lu", g_scanner_cur_value (_tmp4_).v_int);
#line 516 "../gcalc/gcalc-parser.vala"
			result = _tmp5_;
#line 516 "../gcalc/gcalc-parser.vala"
			return result;
#line 4022 "gcalc-parser.c"
		}
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_FLOAT:
#line 4026 "gcalc-parser.c"
		{
			GScanner* _tmp6_;
			gchar* _tmp7_;
#line 518 "../gcalc/gcalc-parser.vala"
			_tmp6_ = self->priv->scanner;
#line 518 "../gcalc/gcalc-parser.vala"
			_tmp7_ = g_strdup_printf ("%g", g_scanner_cur_value (_tmp6_).v_float);
#line 518 "../gcalc/gcalc-parser.vala"
			result = _tmp7_;
#line 518 "../gcalc/gcalc-parser.vala"
			return result;
#line 4038 "gcalc-parser.c"
		}
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_EOF:
#line 4042 "gcalc-parser.c"
		{
			gchar* _tmp8_;
#line 520 "../gcalc/gcalc-parser.vala"
			_tmp8_ = g_strdup ("");
#line 520 "../gcalc/gcalc-parser.vala"
			result = _tmp8_;
#line 520 "../gcalc/gcalc-parser.vala"
			return result;
#line 4051 "gcalc-parser.c"
		}
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_CHAR:
#line 4055 "gcalc-parser.c"
		{
			GString* str = NULL;
			GString* _tmp9_;
			GString* _tmp10_;
			GScanner* _tmp11_;
			GString* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
#line 522 "../gcalc/gcalc-parser.vala"
			_tmp9_ = g_string_new ("");
#line 522 "../gcalc/gcalc-parser.vala"
			str = _tmp9_;
#line 523 "../gcalc/gcalc-parser.vala"
			_tmp10_ = str;
#line 523 "../gcalc/gcalc-parser.vala"
			_tmp11_ = self->priv->scanner;
#line 523 "../gcalc/gcalc-parser.vala"
			g_string_append_c (_tmp10_, (gchar) g_scanner_cur_value (_tmp11_).v_char);
#line 524 "../gcalc/gcalc-parser.vala"
			_tmp12_ = str;
#line 524 "../gcalc/gcalc-parser.vala"
			_tmp13_ = _tmp12_->str;
#line 524 "../gcalc/gcalc-parser.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 524 "../gcalc/gcalc-parser.vala"
			result = _tmp14_;
#line 524 "../gcalc/gcalc-parser.vala"
			_g_string_free0 (str);
#line 524 "../gcalc/gcalc-parser.vala"
			return result;
#line 4086 "gcalc-parser.c"
		}
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_STRING:
#line 4090 "gcalc-parser.c"
		{
			GScanner* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 526 "../gcalc/gcalc-parser.vala"
			_tmp15_ = self->priv->scanner;
#line 526 "../gcalc/gcalc-parser.vala"
			_tmp16_ = g_scanner_cur_value (_tmp15_).v_string;
#line 526 "../gcalc/gcalc-parser.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 526 "../gcalc/gcalc-parser.vala"
			result = _tmp17_;
#line 526 "../gcalc/gcalc-parser.vala"
			return result;
#line 4105 "gcalc-parser.c"
		}
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_RIGHT_PAREN:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_LEFT_PAREN:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_LEFT_BRACE:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_LEFT_CURLY:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_OCTAL:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_COMMENT_MULTI:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_COMMA:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_IDENTIFIER_NULL:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_LAST:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_RIGHT_BRACE:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_NONE:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_SYMBOL:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_BINARY:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_COMMENT_SINGLE:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_RIGHT_CURLY:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_HEX:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_EQUAL_SIGN:
#line 512 "../gcalc/gcalc-parser.vala"
		case G_TOKEN_ERROR:
#line 4143 "gcalc-parser.c"
		{
#line 545 "../gcalc/gcalc-parser.vala"
			break;
#line 4147 "gcalc-parser.c"
		}
		default:
#line 512 "../gcalc/gcalc-parser.vala"
		break;
#line 4152 "gcalc-parser.c"
	}
#line 547 "../gcalc/gcalc-parser.vala"
	_tmp18_ = g_strdup ("");
#line 547 "../gcalc/gcalc-parser.vala"
	result = _tmp18_;
#line 547 "../gcalc/gcalc-parser.vala"
	return result;
#line 4160 "gcalc-parser.c"
}

GCalcParser*
gcalc_parser_construct (GType object_type)
{
	GCalcParser * self = NULL;
#line 25 "../gcalc/gcalc-parser.vala"
	self = (GCalcParser*) g_object_new (object_type, NULL);
#line 25 "../gcalc/gcalc-parser.vala"
	return self;
#line 4171 "gcalc-parser.c"
}

GCalcParser*
gcalc_parser_new (void)
{
#line 25 "../gcalc/gcalc-parser.vala"
	return gcalc_parser_construct (GCALC_TYPE_PARSER);
#line 4179 "gcalc-parser.c"
}

static GObject *
gcalc_parser_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GCalcParser * self;
	GScanner* _tmp0_;
	GScanner* _tmp1_;
	GScanner* _tmp2_;
	GScannerConfig* _tmp3_;
	GScanner* _tmp4_;
	GScannerConfig* _tmp5_;
	GScanner* _tmp6_;
	GScannerConfig* _tmp7_;
	GScanner* _tmp8_;
	GScannerConfig* _tmp9_;
	GScanner* _tmp10_;
	GScannerConfig* _tmp11_;
	GScanner* _tmp12_;
	GScannerConfig* _tmp13_;
	GScanner* _tmp14_;
	GScannerConfig* _tmp15_;
	GScanner* _tmp16_;
	GScannerConfig* _tmp17_;
	GScanner* _tmp18_;
	GScannerConfig* _tmp19_;
	GScanner* _tmp20_;
	GScannerConfig* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 35 "../gcalc/gcalc-parser.vala"
	parent_class = G_OBJECT_CLASS (gcalc_parser_parent_class);
#line 35 "../gcalc/gcalc-parser.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "../gcalc/gcalc-parser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GCALC_TYPE_PARSER, GCalcParser);
#line 36 "../gcalc/gcalc-parser.vala"
	_tmp0_ = g_scanner_new (NULL);
#line 36 "../gcalc/gcalc-parser.vala"
	_g_scanner_destroy0 (self->priv->scanner);
#line 36 "../gcalc/gcalc-parser.vala"
	self->priv->scanner = _tmp0_;
#line 37 "../gcalc/gcalc-parser.vala"
	_tmp1_ = self->priv->scanner;
#line 37 "../gcalc/gcalc-parser.vala"
	_tmp1_->input_name = "GCalc";
#line 38 "../gcalc/gcalc-parser.vala"
	_tmp2_ = self->priv->scanner;
#line 38 "../gcalc/gcalc-parser.vala"
	_tmp3_ = _tmp2_->config;
#line 38 "../gcalc/gcalc-parser.vala"
	(*_tmp3_).cpair_comment_single = "\n";
#line 39 "../gcalc/gcalc-parser.vala"
	_tmp4_ = self->priv->scanner;
#line 39 "../gcalc/gcalc-parser.vala"
	_tmp5_ = _tmp4_->config;
#line 39 "../gcalc/gcalc-parser.vala"
	(*_tmp5_).skip_comment_multi = FALSE;
#line 40 "../gcalc/gcalc-parser.vala"
	_tmp6_ = self->priv->scanner;
#line 40 "../gcalc/gcalc-parser.vala"
	_tmp7_ = _tmp6_->config;
#line 40 "../gcalc/gcalc-parser.vala"
	(*_tmp7_).skip_comment_single = FALSE;
#line 41 "../gcalc/gcalc-parser.vala"
	_tmp8_ = self->priv->scanner;
#line 41 "../gcalc/gcalc-parser.vala"
	_tmp9_ = _tmp8_->config;
#line 41 "../gcalc/gcalc-parser.vala"
	(*_tmp9_).char_2_token = FALSE;
#line 42 "../gcalc/gcalc-parser.vala"
	_tmp10_ = self->priv->scanner;
#line 42 "../gcalc/gcalc-parser.vala"
	_tmp11_ = _tmp10_->config;
#line 42 "../gcalc/gcalc-parser.vala"
	(*_tmp11_).scan_binary = FALSE;
#line 43 "../gcalc/gcalc-parser.vala"
	_tmp12_ = self->priv->scanner;
#line 43 "../gcalc/gcalc-parser.vala"
	_tmp13_ = _tmp12_->config;
#line 43 "../gcalc/gcalc-parser.vala"
	(*_tmp13_).scan_octal = FALSE;
#line 44 "../gcalc/gcalc-parser.vala"
	_tmp14_ = self->priv->scanner;
#line 44 "../gcalc/gcalc-parser.vala"
	_tmp15_ = _tmp14_->config;
#line 44 "../gcalc/gcalc-parser.vala"
	(*_tmp15_).scan_float = FALSE;
#line 45 "../gcalc/gcalc-parser.vala"
	_tmp16_ = self->priv->scanner;
#line 45 "../gcalc/gcalc-parser.vala"
	_tmp17_ = _tmp16_->config;
#line 45 "../gcalc/gcalc-parser.vala"
	(*_tmp17_).scan_hex = FALSE;
#line 46 "../gcalc/gcalc-parser.vala"
	_tmp18_ = self->priv->scanner;
#line 46 "../gcalc/gcalc-parser.vala"
	_tmp19_ = _tmp18_->config;
#line 46 "../gcalc/gcalc-parser.vala"
	(*_tmp19_).scan_hex_dollar = FALSE;
#line 47 "../gcalc/gcalc-parser.vala"
	_tmp20_ = self->priv->scanner;
#line 47 "../gcalc/gcalc-parser.vala"
	_tmp21_ = _tmp20_->config;
#line 47 "../gcalc/gcalc-parser.vala"
	(*_tmp21_).numbers_2_int = FALSE;
#line 4289 "gcalc-parser.c"
	{
		GRegex* _tmp22_ = NULL;
		GRegex* _tmp23_;
		GRegex* _tmp24_;
#line 49 "../gcalc/gcalc-parser.vala"
		_tmp23_ = g_regex_new ("^i\\d", G_REGEX_ANCHORED, G_REGEX_MATCH_ANCHORED, &_inner_error0_);
#line 49 "../gcalc/gcalc-parser.vala"
		_tmp22_ = _tmp23_;
#line 49 "../gcalc/gcalc-parser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4300 "gcalc-parser.c"
			goto __catch0_g_error;
		}
#line 49 "../gcalc/gcalc-parser.vala"
		_tmp24_ = _tmp22_;
#line 49 "../gcalc/gcalc-parser.vala"
		_tmp22_ = NULL;
#line 49 "../gcalc/gcalc-parser.vala"
		_g_regex_unref0 (self->priv->rg);
#line 49 "../gcalc/gcalc-parser.vala"
		self->priv->rg = _tmp24_;
#line 48 "../gcalc/gcalc-parser.vala"
		_g_regex_unref0 (_tmp22_);
#line 4313 "gcalc-parser.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 48 "../gcalc/gcalc-parser.vala"
		e = _inner_error0_;
#line 48 "../gcalc/gcalc-parser.vala"
		_inner_error0_ = NULL;
#line 51 "../gcalc/gcalc-parser.vala"
		_tmp25_ = e;
#line 51 "../gcalc/gcalc-parser.vala"
		_tmp26_ = _tmp25_->message;
#line 51 "../gcalc/gcalc-parser.vala"
		g_message ("gcalc-parser.vala:51: Error on compile regular expression: %s", _tmp26_);
#line 48 "../gcalc/gcalc-parser.vala"
		_g_error_free0 (e);
#line 4333 "gcalc-parser.c"
	}
	__finally0:
#line 48 "../gcalc/gcalc-parser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../gcalc/gcalc-parser.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../gcalc/gcalc-parser.vala"
		g_clear_error (&_inner_error0_);
#line 4342 "gcalc-parser.c"
	}
#line 35 "../gcalc/gcalc-parser.vala"
	return obj;
#line 4346 "gcalc-parser.c"
}

static void
gcalc_parser_class_init (GCalcParserClass * klass,
                         gpointer klass_data)
{
#line 25 "../gcalc/gcalc-parser.vala"
	gcalc_parser_parent_class = g_type_class_peek_parent (klass);
#line 25 "../gcalc/gcalc-parser.vala"
	g_type_class_adjust_private_offset (klass, &GCalcParser_private_offset);
#line 25 "../gcalc/gcalc-parser.vala"
	G_OBJECT_CLASS (klass)->constructor = gcalc_parser_constructor;
#line 25 "../gcalc/gcalc-parser.vala"
	G_OBJECT_CLASS (klass)->finalize = gcalc_parser_finalize;
#line 4361 "gcalc-parser.c"
}

static void
gcalc_parser_instance_init (GCalcParser * self,
                            gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 25 "../gcalc/gcalc-parser.vala"
	self->priv = gcalc_parser_get_instance_private (self);
#line 26 "../gcalc/gcalc-parser.vala"
	self->priv->current = NULL;
#line 27 "../gcalc/gcalc-parser.vala"
	self->priv->current_parent = NULL;
#line 28 "../gcalc/gcalc-parser.vala"
	self->priv->top_parent = NULL;
#line 29 "../gcalc/gcalc-parser.vala"
	self->priv->eq = NULL;
#line 31 "../gcalc/gcalc-parser.vala"
	self->priv->enable_parameter = FALSE;
#line 32 "../gcalc/gcalc-parser.vala"
	_tmp0_ = gee_array_list_new (GCALC_PARSER_TYPE_TOKEN_TYPE, NULL, NULL, NULL, NULL, NULL);
#line 32 "../gcalc/gcalc-parser.vala"
	self->priv->expected = _tmp0_;
#line 4385 "gcalc-parser.c"
}

static void
gcalc_parser_finalize (GObject * obj)
{
	GCalcParser * self;
#line 25 "../gcalc/gcalc-parser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GCALC_TYPE_PARSER, GCalcParser);
#line 26 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->current);
#line 27 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->current_parent);
#line 28 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->top_parent);
#line 29 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->eq);
#line 30 "../gcalc/gcalc-parser.vala"
	_g_regex_unref0 (self->priv->rg);
#line 32 "../gcalc/gcalc-parser.vala"
	_g_object_unref0 (self->priv->expected);
#line 33 "../gcalc/gcalc-parser.vala"
	_g_scanner_destroy0 (self->priv->scanner);
#line 59 "../gcalc/gcalc-parser.vala"
	G_OBJECT_CLASS (gcalc_parser_parent_class)->finalize (obj);
#line 4410 "gcalc-parser.c"
}

/**
 * Takes a string an create a tree of {@link MathExpression} objects representing
 * a math equation.
 */
static GType
gcalc_parser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GCalcParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gcalc_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GCalcParser), 0, (GInstanceInitFunc) gcalc_parser_instance_init, NULL };
	GType gcalc_parser_type_id;
	gcalc_parser_type_id = g_type_register_static (G_TYPE_OBJECT, "GCalcParser", &g_define_type_info, 0);
	GCalcParser_private_offset = g_type_add_instance_private (gcalc_parser_type_id, sizeof (GCalcParserPrivate));
	return gcalc_parser_type_id;
}

GType
gcalc_parser_get_type (void)
{
	static volatile gsize gcalc_parser_type_id__once = 0;
	if (g_once_init_enter (&gcalc_parser_type_id__once)) {
		GType gcalc_parser_type_id;
		gcalc_parser_type_id = gcalc_parser_get_type_once ();
		g_once_init_leave (&gcalc_parser_type_id__once, gcalc_parser_type_id);
	}
	return gcalc_parser_type_id__once;
}

GQuark
gcalc_parser_error_quark (void)
{
#line 25 "../gcalc/gcalc-parser.vala"
	return g_quark_from_static_string ("gcalc-parser-error-quark");
#line 4444 "gcalc-parser.c"
}

static GType
gcalc_parser_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR, "GCALC_PARSER_ERROR_INVALID_TOKEN_ERROR", "invalid-token-error"}, {GCALC_PARSER_ERROR_INVALID_EXPRESSION_ERROR, "GCALC_PARSER_ERROR_INVALID_EXPRESSION_ERROR", "invalid-expression-error"}, {0, NULL, NULL}};
	GType gcalc_parser_error_type_id;
	gcalc_parser_error_type_id = g_enum_register_static ("GCalcParserError", values);
	return gcalc_parser_error_type_id;
}

GType
gcalc_parser_error_get_type (void)
{
	static volatile gsize gcalc_parser_error_type_id__once = 0;
	if (g_once_init_enter (&gcalc_parser_error_type_id__once)) {
		GType gcalc_parser_error_type_id;
		gcalc_parser_error_type_id = gcalc_parser_error_get_type_once ();
		g_once_init_leave (&gcalc_parser_error_type_id__once, gcalc_parser_error_type_id);
	}
	return gcalc_parser_error_type_id__once;
}

