/* number.c generated by valac 0.56.16, the Vala compiler
 * generated from number.vala, do not modify */

/*
 * Copyright (C) 1987-2008 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/*  This maths library is based on the MP multi-precision floating-point
 *  arithmetic package originally written in FORTRAN by Richard Brent,
 *  Computer Centre, Australian National University in the 1970's.
 *
 *  It has been converted from FORTRAN into C using the freely available
 *  f2c translator, available via netlib on research.att.com.
 *
 *  The subsequently converted C code has then been tidied up, mainly to
 *  remove any dependencies on the libI77 and libF77 support libraries.
 *
 *  FOR A GENERAL DESCRIPTION OF THE PHILOSOPHY AND DESIGN OF MP,
 *  SEE - R. P. BRENT, A FORTRAN MULTIPLE-PRECISION ARITHMETIC
 *  SOME ADDITIONAL DETAILS ARE GIVEN IN THE SAME ISSUE, 71-81.
 *  FOR DETAILS OF THE IMPLEMENTATION, CALLING SEQUENCES ETC. SEE
 *  THE MP USERS GUIDE.
 */

#include <glib.h>
#include "calculator.h"
#include "mpc.h"
#include "mpfr.h"
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include "mpfrg.h"
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef gint (*BitwiseFunc) (gint v1, gint v2, gpointer user_data);
enum  {
	NUMBER_0_PROPERTY,
	NUMBER_NUM_PROPERTIES
};
static GParamSpec* number_properties[NUMBER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NumberPrivate {
	__mpc_struct num;
};

static gint Number_private_offset;
static gpointer number_parent_class = NULL;
static mpfr_prec_t number__precision;
static mpfr_prec_t number__precision = (mpfr_prec_t) 1000;
static gchar* number__error;
static gchar* number__error = NULL;

static void number_mpc_from_radians (__mpc_struct* res,
                              __mpc_struct* op,
                              AngleUnit unit);
static Number* number_copy (Number* self);
static void number_mpc_to_radians (__mpc_struct* res,
                            __mpc_struct* op,
                            AngleUnit unit);
static Number* number_to_radians (Number* self,
                           AngleUnit unit);
static Number* number_bitwise (Number* self,
                        Number* y,
                        BitwiseFunc bitwise_operator,
                        gpointer bitwise_operator_target,
                        gint wordlen);
static gint __lambda4_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda4__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda5_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda5__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda6_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda6__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda7_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda7__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gchar* number_to_hex_string (Number* self);
static gint __lambda8_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda8__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gboolean number_is_sprp (Number* self,
                         Number* p,
                         guint64 b);
static gboolean number_is_prime (Number* self,
                          Number* x);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean _mpc_equal (const __mpc_struct * s1,
                     const __mpc_struct * s2);
static gint number_hex_to_int (Number* self,
                        gchar digit);
static void number_finalize (GObject * obj);
static GType number_get_type_once (void);
static void _vala_number_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_number_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
VALA_EXTERN gint parse_literal_prefix (const gchar* str,
                           gint* prefix_len);
VALA_EXTERN Number* set_from_sexagesimal (const gchar* str);
VALA_EXTERN gint char_val (gunichar c,
               gint number_base);

static GType
angle_unit_get_type_once (void)
{
	static const GEnumValue values[] = {{ANGLE_UNIT_RADIANS, "ANGLE_UNIT_RADIANS", "radians"}, {ANGLE_UNIT_DEGREES, "ANGLE_UNIT_DEGREES", "degrees"}, {ANGLE_UNIT_GRADIANS, "ANGLE_UNIT_GRADIANS", "gradians"}, {0, NULL, NULL}};
	GType angle_unit_type_id;
	angle_unit_type_id = g_enum_register_static ("AngleUnit", values);
	return angle_unit_type_id;
}

GType
angle_unit_get_type (void)
{
	static volatile gsize angle_unit_type_id__once = 0;
	if (g_once_init_enter (&angle_unit_type_id__once)) {
		GType angle_unit_type_id;
		angle_unit_type_id = angle_unit_get_type_once ();
		g_once_init_leave (&angle_unit_type_id__once, angle_unit_type_id);
	}
	return angle_unit_type_id__once;
}

static inline gpointer
number_get_instance_private (Number* self)
{
	return G_STRUCT_MEMBER_P (self, Number_private_offset);
}

Number*
number_construct_integer (GType object_type,
                          gint64 real,
                          gint64 imag)
{
	Number * self = NULL;
#line 51 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 53 "../lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) real, (glong) imag, MPC_RNDNN);
#line 51 "../lib/number.vala"
	return self;
#line 184 "number.c"
}

Number*
number_new_integer (gint64 real,
                    gint64 imag)
{
#line 51 "../lib/number.vala"
	return number_construct_integer (TYPE_NUMBER, real, imag);
#line 193 "number.c"
}

Number*
number_construct_unsigned_integer (GType object_type,
                                   guint64 real,
                                   guint64 imag)
{
	Number * self = NULL;
#line 56 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 58 "../lib/number.vala"
	mpc_set_ui_ui (&self->priv->num, (gulong) real, (gulong) imag, MPC_RNDNN);
#line 56 "../lib/number.vala"
	return self;
#line 208 "number.c"
}

Number*
number_new_unsigned_integer (guint64 real,
                             guint64 imag)
{
#line 56 "../lib/number.vala"
	return number_construct_unsigned_integer (TYPE_NUMBER, real, imag);
#line 217 "number.c"
}

Number*
number_construct_fraction (GType object_type,
                           gint64 numerator,
                           gint64 denominator)
{
	Number * self = NULL;
#line 63 "../lib/number.vala"
	if (denominator < ((gint64) 0)) {
#line 65 "../lib/number.vala"
		numerator = -numerator;
#line 66 "../lib/number.vala"
		denominator = -denominator;
#line 232 "number.c"
	}
#line 69 "../lib/number.vala"
	self = (Number*) number_construct_integer (object_type, numerator, (gint64) 0);
#line 70 "../lib/number.vala"
	if (denominator != ((gint64) 1)) {
#line 72 "../lib/number.vala"
		mpc_div_ui (&self->priv->num, &self->priv->num, (gulong) ((glong) denominator), MPC_RNDNN);
#line 240 "number.c"
	}
#line 61 "../lib/number.vala"
	return self;
#line 244 "number.c"
}

Number*
number_new_fraction (gint64 numerator,
                     gint64 denominator)
{
#line 61 "../lib/number.vala"
	return number_construct_fraction (TYPE_NUMBER, numerator, denominator);
#line 253 "number.c"
}

static gint
mpc_set_mpreal (__mpc_struct *self,
                __mpfr_struct* re,
                __mpfr_struct* im,
                mpc_rnd_t rnd)
{
	__mpfr_struct _tmp1_;
	__mpfr_struct _tmp2_;
	gint result;
#line 61 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	g_return_val_if_fail (re != NULL, 0);
#line 63 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	if (im == NULL) {
#line 269 "number.c"
		__mpfr_struct _tmp0_;
#line 64 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
		_tmp0_ = *re;
#line 64 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
		result = mpc_set_fr (&(*self), &_tmp0_, rnd);
#line 64 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
		return result;
#line 277 "number.c"
	}
#line 66 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	_tmp1_ = *re;
#line 66 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	_tmp2_ = *im;
#line 66 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	result = mpc_set_fr_fr (&(*self), &_tmp1_, &_tmp2_, rnd);
#line 66 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	return result;
#line 287 "number.c"
}

Number*
number_construct_mpreal (GType object_type,
                         __mpfr_struct* real,
                         __mpfr_struct* imag)
{
	Number * self = NULL;
	__mpfr_struct _tmp0_;
#line 77 "../lib/number.vala"
	g_return_val_if_fail (real != NULL, NULL);
#line 77 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 79 "../lib/number.vala"
	_tmp0_ = *real;
#line 79 "../lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_, imag, MPC_RNDNN);
#line 77 "../lib/number.vala"
	return self;
#line 307 "number.c"
}

Number*
number_new_mpreal (__mpfr_struct* real,
                   __mpfr_struct* imag)
{
#line 77 "../lib/number.vala"
	return number_construct_mpreal (TYPE_NUMBER, real, imag);
#line 316 "number.c"
}

Number*
number_construct_double (GType object_type,
                         gdouble real,
                         gdouble imag)
{
	Number * self = NULL;
#line 82 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 84 "../lib/number.vala"
	mpc_set_d_d (&self->priv->num, real, imag, MPC_RNDNN);
#line 82 "../lib/number.vala"
	return self;
#line 331 "number.c"
}

Number*
number_new_double (gdouble real,
                   gdouble imag)
{
#line 82 "../lib/number.vala"
	return number_construct_double (TYPE_NUMBER, real, imag);
#line 340 "number.c"
}

Number*
number_construct_complex (GType object_type,
                          Number* r,
                          Number* i)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 87 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 87 "../lib/number.vala"
	g_return_val_if_fail (i != NULL, NULL);
#line 87 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 89 "../lib/number.vala"
	_tmp0_ = mpc_realref (&r->priv->num);
#line 89 "../lib/number.vala"
	_tmp1_ = mpc_realref (&i->priv->num);
#line 89 "../lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_->val, &_tmp1_->val, MPC_RNDNN);
#line 87 "../lib/number.vala"
	return self;
#line 365 "number.c"
}

Number*
number_new_complex (Number* r,
                    Number* i)
{
#line 87 "../lib/number.vala"
	return number_construct_complex (TYPE_NUMBER, r, i);
#line 374 "number.c"
}

Number*
number_construct_polar (GType object_type,
                        Number* r,
                        Number* theta,
                        AngleUnit unit)
{
	Number * self = NULL;
	Number* x = NULL;
	Number* _tmp0_;
	Number* y = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 92 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 92 "../lib/number.vala"
	g_return_val_if_fail (theta != NULL, NULL);
#line 94 "../lib/number.vala"
	_tmp0_ = number_cos (theta, unit);
#line 94 "../lib/number.vala"
	x = _tmp0_;
#line 95 "../lib/number.vala"
	_tmp1_ = number_sin (theta, unit);
#line 95 "../lib/number.vala"
	y = _tmp1_;
#line 96 "../lib/number.vala"
	_tmp2_ = number_multiply (x, r);
#line 96 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 96 "../lib/number.vala"
	_tmp4_ = number_multiply (y, r);
#line 96 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 96 "../lib/number.vala"
	self = (Number*) number_construct_complex (object_type, _tmp3_, _tmp5_);
#line 96 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 96 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 92 "../lib/number.vala"
	_g_object_unref0 (y);
#line 92 "../lib/number.vala"
	_g_object_unref0 (x);
#line 92 "../lib/number.vala"
	return self;
#line 424 "number.c"
}

Number*
number_new_polar (Number* r,
                  Number* theta,
                  AngleUnit unit)
{
#line 92 "../lib/number.vala"
	return number_construct_polar (TYPE_NUMBER, r, theta, unit);
#line 434 "number.c"
}

Number*
number_construct_eulers (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
#line 99 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 101 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 101 "../lib/number.vala"
	mpfr_set_ui (&_tmp0_->val, (gulong) 1, MPFR_RNDN);
#line 103 "../lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 103 "../lib/number.vala"
	_tmp2_ = mpc_realref (&self->priv->num);
#line 103 "../lib/number.vala"
	mpfr_exp (&_tmp1_->val, &_tmp2_->val, MPFR_RNDN);
#line 104 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&self->priv->num);
#line 104 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 99 "../lib/number.vala"
	return self;
#line 463 "number.c"
}

Number*
number_new_eulers (void)
{
#line 99 "../lib/number.vala"
	return number_construct_eulers (TYPE_NUMBER);
#line 471 "number.c"
}

Number*
number_construct_i (GType object_type)
{
	Number * self = NULL;
#line 107 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 109 "../lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) 0, (glong) 1, MPC_RNDNN);
#line 107 "../lib/number.vala"
	return self;
#line 484 "number.c"
}

Number*
number_new_i (void)
{
#line 107 "../lib/number.vala"
	return number_construct_i (TYPE_NUMBER);
#line 492 "number.c"
}

Number*
number_construct_pi (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 112 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 114 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 114 "../lib/number.vala"
	mpfr_const_pi (&_tmp0_->val, MPFR_RNDN);
#line 115 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 115 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 112 "../lib/number.vala"
	return self;
#line 513 "number.c"
}

Number*
number_new_pi (void)
{
#line 112 "../lib/number.vala"
	return number_construct_pi (TYPE_NUMBER);
#line 521 "number.c"
}

static gint
mpfr_const_tau (__mpfr_struct *self,
                mpfr_rnd_t rnd)
{
	gint i = 0;
	gint result;
#line 78 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpfr.vapi"
	i = mpfr_const_pi (&(*self), rnd);
#line 79 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpfr.vapi"
	mpfr_mul_si (&(*self), &(*self), (glong) 2, rnd);
#line 80 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpfr.vapi"
	result = i;
#line 80 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpfr.vapi"
	return result;
#line 538 "number.c"
}

Number*
number_construct_tau (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 118 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 120 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 120 "../lib/number.vala"
	mpfr_const_tau (&_tmp0_->val, MPFR_RNDN);
#line 121 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 121 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 118 "../lib/number.vala"
	return self;
#line 559 "number.c"
}

Number*
number_new_tau (void)
{
#line 118 "../lib/number.vala"
	return number_construct_tau (TYPE_NUMBER);
#line 567 "number.c"
}

Number*
number_construct_random (GType object_type)
{
	Number * self = NULL;
#line 127 "../lib/number.vala"
	self = (Number*) number_construct_double (object_type, g_random_double (), (gdouble) 0);
#line 125 "../lib/number.vala"
	return self;
#line 578 "number.c"
}

Number*
number_new_random (void)
{
#line 125 "../lib/number.vala"
	return number_construct_random (TYPE_NUMBER);
#line 586 "number.c"
}

gint64
number_to_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gint64 result;
#line 130 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 132 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 132 "../lib/number.vala"
	result = (gint64) mpfr_get_si (&_tmp0_->val, MPFR_RNDN);
#line 132 "../lib/number.vala"
	return result;
#line 602 "number.c"
}

guint64
number_to_unsigned_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	guint64 result;
#line 135 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 137 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 137 "../lib/number.vala"
	result = (guint64) mpfr_get_ui (&_tmp0_->val, MPFR_RNDN);
#line 137 "../lib/number.vala"
	return result;
#line 618 "number.c"
}

gfloat
number_to_float (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gfloat result;
#line 140 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 142 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 142 "../lib/number.vala"
	result = mpfr_get_flt (&_tmp0_->val, MPFR_RNDN);
#line 142 "../lib/number.vala"
	return result;
#line 634 "number.c"
}

gdouble
number_to_double (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gdouble result;
#line 145 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 147 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 147 "../lib/number.vala"
	result = mpfr_get_d (&_tmp0_->val, MPFR_RNDN);
#line 147 "../lib/number.vala"
	return result;
#line 650 "number.c"
}

static gboolean
mpc_is_zero (__mpc_struct *self)
{
	gint res = 0;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 74 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	res = mpc_cmp_si_si (&(*self), (glong) 0, (glong) 0);
#line 74 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	if (MPC_INEX_RE (res) == 0) {
#line 74 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
		_tmp0_ = MPC_INEX_IM (res) == 0;
#line 665 "number.c"
	} else {
#line 74 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
		_tmp0_ = FALSE;
#line 669 "number.c"
	}
#line 74 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	result = _tmp0_;
#line 74 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	return result;
#line 675 "number.c"
}

gboolean
number_is_zero (Number* self)
{
	gboolean result;
#line 151 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "../lib/number.vala"
	result = mpc_is_zero (&self->priv->num);
#line 153 "../lib/number.vala"
	return result;
#line 688 "number.c"
}

gboolean
number_is_negative (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 157 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 159 "../lib/number.vala"
	result = mpfr_sgn (&_tmp0_->val) < 0;
#line 159 "../lib/number.vala"
	return result;
#line 704 "number.c"
}

gboolean
number_is_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 163 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 166 "../lib/number.vala"
		result = FALSE;
#line 166 "../lib/number.vala"
		return result;
#line 720 "number.c"
	}
#line 168 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 168 "../lib/number.vala"
	result = mpfr_integer_p (&_tmp0_->val) != 0;
#line 168 "../lib/number.vala"
	return result;
#line 728 "number.c"
}

gboolean
number_is_positive_integer (Number* self)
{
	gboolean result;
#line 172 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 174 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 175 "../lib/number.vala"
		result = FALSE;
#line 175 "../lib/number.vala"
		return result;
#line 743 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRGRealRef* _tmp1_;
#line 177 "../lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 177 "../lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) >= 0) {
#line 177 "../lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 753 "number.c"
		} else {
#line 177 "../lib/number.vala"
			_tmp0_ = FALSE;
#line 757 "number.c"
		}
#line 177 "../lib/number.vala"
		result = _tmp0_;
#line 177 "../lib/number.vala"
		return result;
#line 763 "number.c"
	}
}

gboolean
number_is_natural (Number* self)
{
	gboolean result;
#line 181 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 183 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 184 "../lib/number.vala"
		result = FALSE;
#line 184 "../lib/number.vala"
		return result;
#line 779 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRGRealRef* _tmp1_;
#line 186 "../lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 186 "../lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) > 0) {
#line 186 "../lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 789 "number.c"
		} else {
#line 186 "../lib/number.vala"
			_tmp0_ = FALSE;
#line 793 "number.c"
		}
#line 186 "../lib/number.vala"
		result = _tmp0_;
#line 186 "../lib/number.vala"
		return result;
#line 799 "number.c"
	}
}

gboolean
number_is_complex (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 190 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 192 "../lib/number.vala"
	_tmp0_ = mpc_imagref (&self->priv->num);
#line 192 "../lib/number.vala"
	result = !mpfr_zero_p (&_tmp0_->val);
#line 192 "../lib/number.vala"
	return result;
#line 816 "number.c"
}

void
number_check_flags (void)
{
#line 198 "../lib/number.vala"
	if (mpfr_underflow_p () != 0) {
#line 201 "../lib/number.vala"
		number_set_error (_ ("Underflow error"));
#line 826 "number.c"
	} else {
#line 203 "../lib/number.vala"
		if (mpfr_overflow_p () != 0) {
#line 206 "../lib/number.vala"
			number_set_error (_ ("Overflow error"));
#line 832 "number.c"
		}
	}
}

static gboolean
mpc_is_equal (__mpc_struct *self,
              __mpc_struct* c)
{
	gint res = 0;
	__mpc_struct _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 75 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	g_return_val_if_fail (c != NULL, FALSE);
#line 75 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	_tmp0_ = *c;
#line 75 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	res = mpc_cmp (&(*self), &_tmp0_);
#line 75 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	if (MPC_INEX_RE (res) == 0) {
#line 75 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
		_tmp1_ = MPC_INEX_IM (res) == 0;
#line 855 "number.c"
	} else {
#line 75 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
		_tmp1_ = FALSE;
#line 859 "number.c"
	}
#line 75 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	result = _tmp1_;
#line 75 "/home/iurt/rpmbuild/BUILD/gnome-calculator-46.0/vapi/mpc.vapi"
	return result;
#line 865 "number.c"
}

gboolean
number_equals (Number* self,
               Number* y)
{
	gboolean result;
#line 211 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, FALSE);
#line 213 "../lib/number.vala"
	result = mpc_is_equal (&self->priv->num, &y->priv->num);
#line 213 "../lib/number.vala"
	return result;
#line 881 "number.c"
}

gint
number_compare (Number* self,
                Number* y)
{
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
	gint result;
#line 221 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 221 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, 0);
#line 223 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 223 "../lib/number.vala"
	_tmp1_ = mpc_realref (&y->priv->num);
#line 223 "../lib/number.vala"
	result = mpfr_cmp (&_tmp0_->val, &_tmp1_->val);
#line 223 "../lib/number.vala"
	return result;
#line 903 "number.c"
}

Number*
number_sgn (Number* self)
{
	Number* z = NULL;
	MPFRGRealRef* _tmp0_;
	Number* _tmp1_;
	Number* result;
#line 227 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 229 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) mpfr_sgn (&_tmp0_->val), (gint64) 0);
#line 229 "../lib/number.vala"
	z = _tmp1_;
#line 230 "../lib/number.vala"
	result = z;
#line 230 "../lib/number.vala"
	return result;
#line 925 "number.c"
}

Number*
number_invert_sign (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 234 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 236 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 236 "../lib/number.vala"
	z = _tmp0_;
#line 237 "../lib/number.vala"
	mpc_neg (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 238 "../lib/number.vala"
	result = z;
#line 238 "../lib/number.vala"
	return result;
#line 946 "number.c"
}

Number*
number_abs (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	Number* result;
#line 242 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 244 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 244 "../lib/number.vala"
	z = _tmp0_;
#line 245 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 245 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 246 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 246 "../lib/number.vala"
	mpc_abs (&_tmp2_->val, &self->priv->num, MPFR_RNDN);
#line 247 "../lib/number.vala"
	result = z;
#line 247 "../lib/number.vala"
	return result;
#line 975 "number.c"
}

Number*
number_arg (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* _tmp4_;
	MPFRGRealRef* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	gboolean _tmp8_ = FALSE;
	Number* result;
#line 251 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 996 "number.c"
		Number* _tmp0_;
#line 256 "../lib/number.vala"
		number_set_error (_ ("Argument not defined for zero"));
#line 257 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 257 "../lib/number.vala"
		result = _tmp0_;
#line 257 "../lib/number.vala"
		return result;
#line 1006 "number.c"
	}
#line 259 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 259 "../lib/number.vala"
	z = _tmp1_;
#line 260 "../lib/number.vala"
	_tmp2_ = z;
#line 260 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&_tmp2_->priv->num);
#line 260 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 261 "../lib/number.vala"
	_tmp4_ = z;
#line 261 "../lib/number.vala"
	_tmp5_ = mpc_realref (&_tmp4_->priv->num);
#line 261 "../lib/number.vala"
	mpc_arg (&_tmp5_->val, &self->priv->num, MPFR_RNDN);
#line 262 "../lib/number.vala"
	_tmp6_ = z;
#line 262 "../lib/number.vala"
	_tmp7_ = z;
#line 262 "../lib/number.vala"
	number_mpc_from_radians (&_tmp6_->priv->num, &_tmp7_->priv->num, unit);
#line 267 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 267 "../lib/number.vala"
		_tmp8_ = number_is_negative (self);
#line 1034 "number.c"
	} else {
#line 267 "../lib/number.vala"
		_tmp8_ = FALSE;
#line 1038 "number.c"
	}
#line 267 "../lib/number.vala"
	if (_tmp8_) {
#line 1042 "number.c"
		Number* _tmp9_;
		MPFRGRealRef* _tmp10_;
		Number* _tmp11_;
		MPFRGRealRef* _tmp12_;
#line 268 "../lib/number.vala"
		_tmp9_ = z;
#line 268 "../lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 268 "../lib/number.vala"
		_tmp11_ = z;
#line 268 "../lib/number.vala"
		_tmp12_ = mpc_realref (&_tmp11_->priv->num);
#line 268 "../lib/number.vala"
		mpfr_abs (&_tmp10_->val, &_tmp12_->val, MPFR_RNDN);
#line 1057 "number.c"
	}
#line 270 "../lib/number.vala"
	result = z;
#line 270 "../lib/number.vala"
	return result;
#line 1063 "number.c"
}

Number*
number_conjugate (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 274 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 276 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 276 "../lib/number.vala"
	z = _tmp0_;
#line 277 "../lib/number.vala"
	mpc_conj (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 278 "../lib/number.vala"
	result = z;
#line 278 "../lib/number.vala"
	return result;
#line 1084 "number.c"
}

Number*
number_real_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 282 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 284 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 284 "../lib/number.vala"
	z = _tmp0_;
#line 285 "../lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 285 "../lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 286 "../lib/number.vala"
	result = z;
#line 286 "../lib/number.vala"
	return result;
#line 1108 "number.c"
}

Number*
number_imaginary_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 290 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 293 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 293 "../lib/number.vala"
	z = _tmp0_;
#line 294 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 294 "../lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 295 "../lib/number.vala"
	result = z;
#line 295 "../lib/number.vala"
	return result;
#line 1132 "number.c"
}

Number*
number_integer_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 298 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 300 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 300 "../lib/number.vala"
	z = _tmp0_;
#line 301 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 301 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 302 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 302 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 302 "../lib/number.vala"
	mpfr_trunc (&_tmp2_->val, &_tmp3_->val);
#line 303 "../lib/number.vala"
	result = z;
#line 303 "../lib/number.vala"
	return result;
#line 1164 "number.c"
}

Number*
number_fractional_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 307 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 309 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 309 "../lib/number.vala"
	z = _tmp0_;
#line 310 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 310 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 311 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 311 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 311 "../lib/number.vala"
	mpfr_frac (&_tmp2_->val, &_tmp3_->val, MPFR_RNDN);
#line 312 "../lib/number.vala"
	result = z;
#line 312 "../lib/number.vala"
	return result;
#line 1196 "number.c"
}

Number*
number_fractional_part (Number* self)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 316 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 318 "../lib/number.vala"
	_tmp0_ = number_floor (self);
#line 318 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 318 "../lib/number.vala"
	_tmp2_ = number_subtract (self, _tmp1_);
#line 318 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 318 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 318 "../lib/number.vala"
	result = _tmp3_;
#line 318 "../lib/number.vala"
	return result;
#line 1223 "number.c"
}

Number*
number_floor (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 322 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 324 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 324 "../lib/number.vala"
	z = _tmp0_;
#line 325 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 325 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 326 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 326 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 326 "../lib/number.vala"
	mpfr_floor (&_tmp2_->val, &_tmp3_->val);
#line 327 "../lib/number.vala"
	result = z;
#line 327 "../lib/number.vala"
	return result;
#line 1255 "number.c"
}

Number*
number_ceiling (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 331 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 333 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 333 "../lib/number.vala"
	z = _tmp0_;
#line 334 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 334 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 335 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 335 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 335 "../lib/number.vala"
	mpfr_ceil (&_tmp2_->val, &_tmp3_->val);
#line 336 "../lib/number.vala"
	result = z;
#line 336 "../lib/number.vala"
	return result;
#line 1287 "number.c"
}

Number*
number_round (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 340 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 342 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 342 "../lib/number.vala"
	z = _tmp0_;
#line 343 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 343 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 344 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 344 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 344 "../lib/number.vala"
	mpfr_round (&_tmp2_->val, &_tmp3_->val);
#line 345 "../lib/number.vala"
	result = z;
#line 345 "../lib/number.vala"
	return result;
#line 1319 "number.c"
}

Number*
number_reciprocal (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 349 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 351 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 351 "../lib/number.vala"
	z = _tmp0_;
#line 352 "../lib/number.vala"
	mpc_set_si_si (&z->priv->num, (glong) 1, (glong) 0, MPC_RNDNN);
#line 353 "../lib/number.vala"
	_tmp1_ = mpc_realref (&z->priv->num);
#line 353 "../lib/number.vala"
	mpc_fr_div (&z->priv->num, &_tmp1_->val, &self->priv->num, MPC_RNDNN);
#line 354 "../lib/number.vala"
	result = z;
#line 354 "../lib/number.vala"
	return result;
#line 1345 "number.c"
}

Number*
number_epowy (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 358 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 360 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 360 "../lib/number.vala"
	z = _tmp0_;
#line 361 "../lib/number.vala"
	mpc_exp (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 362 "../lib/number.vala"
	result = z;
#line 362 "../lib/number.vala"
	return result;
#line 1366 "number.c"
}

Number*
number_xpowy (Number* self,
              Number* y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	Number* z = NULL;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* result;
#line 366 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 366 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 369 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 369 "../lib/number.vala"
		_tmp0_ = number_is_negative (y);
#line 1389 "number.c"
	} else {
#line 369 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 1393 "number.c"
	}
#line 369 "../lib/number.vala"
	if (_tmp0_) {
#line 1397 "number.c"
		Number* _tmp1_;
#line 372 "../lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 373 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 373 "../lib/number.vala"
		result = _tmp1_;
#line 373 "../lib/number.vala"
		return result;
#line 1407 "number.c"
	}
#line 377 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 377 "../lib/number.vala"
		_tmp2_ = number_is_zero (y);
#line 1413 "number.c"
	} else {
#line 377 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 1417 "number.c"
	}
#line 377 "../lib/number.vala"
	if (_tmp2_) {
#line 1421 "number.c"
		Number* _tmp3_;
#line 380 "../lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 381 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 381 "../lib/number.vala"
		result = _tmp3_;
#line 381 "../lib/number.vala"
		return result;
#line 1431 "number.c"
	}
#line 383 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 383 "../lib/number.vala"
		_tmp5_ = !number_is_complex (y);
#line 1437 "number.c"
	} else {
#line 383 "../lib/number.vala"
		_tmp5_ = FALSE;
#line 1441 "number.c"
	}
#line 383 "../lib/number.vala"
	if (_tmp5_) {
#line 383 "../lib/number.vala"
		_tmp4_ = !number_is_integer (y);
#line 1447 "number.c"
	} else {
#line 383 "../lib/number.vala"
		_tmp4_ = FALSE;
#line 1451 "number.c"
	}
#line 383 "../lib/number.vala"
	if (_tmp4_) {
#line 1455 "number.c"
		Number* reciprocal = NULL;
		Number* _tmp6_;
		Number* _tmp7_;
#line 385 "../lib/number.vala"
		_tmp6_ = number_reciprocal (y);
#line 385 "../lib/number.vala"
		reciprocal = _tmp6_;
#line 386 "../lib/number.vala"
		_tmp7_ = reciprocal;
#line 386 "../lib/number.vala"
		if (number_is_integer (_tmp7_)) {
#line 1467 "number.c"
			Number* _tmp8_;
			Number* _tmp9_;
#line 387 "../lib/number.vala"
			_tmp8_ = reciprocal;
#line 387 "../lib/number.vala"
			_tmp9_ = number_root (self, number_to_integer (_tmp8_));
#line 387 "../lib/number.vala"
			result = _tmp9_;
#line 387 "../lib/number.vala"
			_g_object_unref0 (reciprocal);
#line 387 "../lib/number.vala"
			return result;
#line 1480 "number.c"
		}
#line 383 "../lib/number.vala"
		_g_object_unref0 (reciprocal);
#line 1484 "number.c"
	}
#line 390 "../lib/number.vala"
	_tmp10_ = number_new ();
#line 390 "../lib/number.vala"
	z = _tmp10_;
#line 391 "../lib/number.vala"
	_tmp11_ = z;
#line 391 "../lib/number.vala"
	mpc_pow (&_tmp11_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 392 "../lib/number.vala"
	result = z;
#line 392 "../lib/number.vala"
	return result;
#line 1498 "number.c"
}

Number*
number_xpowy_integer (Number* self,
                      gint64 n)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Number* z = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 396 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 399 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 399 "../lib/number.vala"
		_tmp0_ = n < ((gint64) 0);
#line 1517 "number.c"
	} else {
#line 399 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 1521 "number.c"
	}
#line 399 "../lib/number.vala"
	if (_tmp0_) {
#line 1525 "number.c"
		Number* _tmp1_;
#line 402 "../lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 403 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 403 "../lib/number.vala"
		result = _tmp1_;
#line 403 "../lib/number.vala"
		return result;
#line 1535 "number.c"
	}
#line 407 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 407 "../lib/number.vala"
		_tmp2_ = n == ((gint64) 0);
#line 1541 "number.c"
	} else {
#line 407 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 1545 "number.c"
	}
#line 407 "../lib/number.vala"
	if (_tmp2_) {
#line 1549 "number.c"
		Number* _tmp3_;
#line 410 "../lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 411 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 411 "../lib/number.vala"
		result = _tmp3_;
#line 411 "../lib/number.vala"
		return result;
#line 1559 "number.c"
	}
#line 413 "../lib/number.vala"
	_tmp4_ = number_new ();
#line 413 "../lib/number.vala"
	z = _tmp4_;
#line 414 "../lib/number.vala"
	_tmp5_ = z;
#line 414 "../lib/number.vala"
	mpc_pow_si (&_tmp5_->priv->num, &self->priv->num, (glong) n, MPC_RNDNN);
#line 415 "../lib/number.vala"
	result = z;
#line 415 "../lib/number.vala"
	return result;
#line 1573 "number.c"
}

Number*
number_root (Number* self,
             gint64 n)
{
	guint64 p = 0ULL;
	Number* z = NULL;
	Number* _tmp0_;
	gboolean _tmp4_ = FALSE;
	Number* result;
#line 419 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 422 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 422 "../lib/number.vala"
	z = _tmp0_;
#line 423 "../lib/number.vala"
	if (n < ((gint64) 0)) {
#line 1593 "number.c"
		Number* _tmp1_;
#line 425 "../lib/number.vala"
		_tmp1_ = z;
#line 425 "../lib/number.vala"
		mpc_ui_div (&_tmp1_->priv->num, (gulong) 1, &self->priv->num, MPC_RNDNN);
#line 426 "../lib/number.vala"
		if (n == G_MININT64) {
#line 427 "../lib/number.vala"
			p = ((guint64) G_MAXINT64) + 1;
#line 1603 "number.c"
		} else {
#line 429 "../lib/number.vala"
			p = (guint64) (-n);
#line 1607 "number.c"
		}
	} else {
#line 430 "../lib/number.vala"
		if (n > ((gint64) 0)) {
#line 1612 "number.c"
			Number* _tmp2_;
#line 431 "../lib/number.vala"
			_tmp2_ = z;
#line 431 "../lib/number.vala"
			mpc_set (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 432 "../lib/number.vala"
			p = (guint64) n;
#line 1620 "number.c"
		} else {
			Number* _tmp3_;
#line 434 "../lib/number.vala"
			number_set_error (_ ("The zeroth root of a number is undefined"));
#line 435 "../lib/number.vala"
			_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 435 "../lib/number.vala"
			result = _tmp3_;
#line 435 "../lib/number.vala"
			_g_object_unref0 (z);
#line 435 "../lib/number.vala"
			return result;
#line 1633 "number.c"
		}
	}
#line 438 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 1638 "number.c"
		gboolean _tmp5_ = FALSE;
#line 438 "../lib/number.vala"
		if (!number_is_negative (self)) {
#line 438 "../lib/number.vala"
			_tmp5_ = TRUE;
#line 1644 "number.c"
		} else {
#line 438 "../lib/number.vala"
			_tmp5_ = (p & 1) == ((guint64) 1);
#line 1648 "number.c"
		}
#line 438 "../lib/number.vala"
		_tmp4_ = _tmp5_;
#line 1652 "number.c"
	} else {
#line 438 "../lib/number.vala"
		_tmp4_ = FALSE;
#line 1656 "number.c"
	}
#line 438 "../lib/number.vala"
	if (_tmp4_) {
#line 1660 "number.c"
		Number* _tmp6_;
		MPFRGRealRef* _tmp7_;
		Number* _tmp8_;
		MPFRGRealRef* _tmp9_;
		Number* _tmp10_;
		MPFRGRealRef* _tmp11_;
#line 440 "../lib/number.vala"
		_tmp6_ = z;
#line 440 "../lib/number.vala"
		_tmp7_ = mpc_realref (&_tmp6_->priv->num);
#line 440 "../lib/number.vala"
		_tmp8_ = z;
#line 440 "../lib/number.vala"
		_tmp9_ = mpc_realref (&_tmp8_->priv->num);
#line 440 "../lib/number.vala"
		mpfr_root (&_tmp7_->val, &_tmp9_->val, (gulong) p, MPFR_RNDN);
#line 441 "../lib/number.vala"
		_tmp10_ = z;
#line 441 "../lib/number.vala"
		_tmp11_ = mpc_imagref (&_tmp10_->priv->num);
#line 441 "../lib/number.vala"
		mpfr_set_zero (&_tmp11_->val, MPFR_RNDN);
#line 1683 "number.c"
	} else {
		__mpfr_struct tmp = {0};
		mpfr_prec_t _tmp12_;
		mpfr_prec_t _tmp13_;
		Number* _tmp14_;
		Number* _tmp15_;
#line 443 "../lib/number.vala"
		_tmp12_ = number_get_precision ();
#line 443 "../lib/number.vala"
		_tmp13_ = _tmp12_;
#line 443 "../lib/number.vala"
		mpfr_init2 (&tmp, _tmp13_);
#line 444 "../lib/number.vala"
		mpfr_set_ui (&tmp, (gulong) p, MPFR_RNDN);
#line 445 "../lib/number.vala"
		mpfr_ui_div (&tmp, (gulong) 1, &tmp, MPFR_RNDN);
#line 446 "../lib/number.vala"
		_tmp14_ = z;
#line 446 "../lib/number.vala"
		_tmp15_ = z;
#line 446 "../lib/number.vala"
		mpc_pow_fr (&_tmp14_->priv->num, &_tmp15_->priv->num, &tmp, MPC_RNDNN);
#line 438 "../lib/number.vala"
		mpfr_clear (&tmp);
#line 1708 "number.c"
	}
#line 448 "../lib/number.vala"
	result = z;
#line 448 "../lib/number.vala"
	return result;
#line 1714 "number.c"
}

Number*
number_sqrt (Number* self)
{
	Number* _tmp0_;
	Number* result;
#line 452 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 454 "../lib/number.vala"
	_tmp0_ = number_root (self, (gint64) 2);
#line 454 "../lib/number.vala"
	result = _tmp0_;
#line 454 "../lib/number.vala"
	return result;
#line 1730 "number.c"
}

Number*
number_ln (Number* self)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Number* result;
#line 458 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1745 "number.c"
		Number* _tmp0_;
#line 464 "../lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 465 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 465 "../lib/number.vala"
		result = _tmp0_;
#line 465 "../lib/number.vala"
		return result;
#line 1755 "number.c"
	}
#line 477 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 477 "../lib/number.vala"
	z = _tmp1_;
#line 478 "../lib/number.vala"
	_tmp2_ = z;
#line 478 "../lib/number.vala"
	mpc_log (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 482 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 482 "../lib/number.vala"
		_tmp3_ = number_is_negative (self);
#line 1769 "number.c"
	} else {
#line 482 "../lib/number.vala"
		_tmp3_ = FALSE;
#line 1773 "number.c"
	}
#line 482 "../lib/number.vala"
	if (_tmp3_) {
#line 1777 "number.c"
		Number* _tmp4_;
		MPFRGRealRef* _tmp5_;
		Number* _tmp6_;
		MPFRGRealRef* _tmp7_;
#line 483 "../lib/number.vala"
		_tmp4_ = z;
#line 483 "../lib/number.vala"
		_tmp5_ = mpc_imagref (&_tmp4_->priv->num);
#line 483 "../lib/number.vala"
		_tmp6_ = z;
#line 483 "../lib/number.vala"
		_tmp7_ = mpc_imagref (&_tmp6_->priv->num);
#line 483 "../lib/number.vala"
		mpfr_abs (&_tmp5_->val, &_tmp7_->val, MPFR_RNDN);
#line 1792 "number.c"
	}
#line 485 "../lib/number.vala"
	result = z;
#line 485 "../lib/number.vala"
	return result;
#line 1798 "number.c"
}

Number*
number_logarithm (Number* self,
                  gint64 n)
{
	Number* t1 = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* result;
#line 489 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 492 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1819 "number.c"
		Number* _tmp0_;
#line 495 "../lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 496 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 496 "../lib/number.vala"
		result = _tmp0_;
#line 496 "../lib/number.vala"
		return result;
#line 1829 "number.c"
	}
#line 500 "../lib/number.vala"
	_tmp1_ = number_new_integer (n, (gint64) 0);
#line 500 "../lib/number.vala"
	t1 = _tmp1_;
#line 501 "../lib/number.vala"
	_tmp2_ = number_ln (self);
#line 501 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 501 "../lib/number.vala"
	_tmp4_ = t1;
#line 501 "../lib/number.vala"
	_tmp5_ = number_ln (_tmp4_);
#line 501 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 501 "../lib/number.vala"
	_tmp7_ = number_divide (_tmp3_, _tmp6_);
#line 501 "../lib/number.vala"
	_tmp8_ = _tmp7_;
#line 501 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 501 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 501 "../lib/number.vala"
	result = _tmp8_;
#line 501 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 501 "../lib/number.vala"
	return result;
#line 1859 "number.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 532 "../lib/number.vala"
	return self ? g_object_ref (self) : NULL;
#line 1867 "number.c"
}

Number*
number_factorial (Number* self)
{
	gint64 value = 0LL;
	Number* z = NULL;
	Number* _tmp12_;
	Number* result;
#line 505 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 508 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1881 "number.c"
		Number* _tmp0_;
#line 509 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 509 "../lib/number.vala"
		result = _tmp0_;
#line 509 "../lib/number.vala"
		return result;
#line 1889 "number.c"
	}
#line 510 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 1893 "number.c"
		gboolean _tmp1_ = FALSE;
		Number* tmp = NULL;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
		Number* _tmp6_;
		__mpfr_struct tmp2 = {0};
		mpfr_prec_t _tmp7_;
		mpfr_prec_t _tmp8_;
		Number* _tmp9_;
		MPFRGRealRef* _tmp10_;
		Number* _tmp11_;
#line 514 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 514 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 1910 "number.c"
		} else {
#line 514 "../lib/number.vala"
			_tmp1_ = number_is_complex (self);
#line 1914 "number.c"
		}
#line 514 "../lib/number.vala"
		if (_tmp1_) {
#line 1918 "number.c"
			Number* _tmp2_;
#line 517 "../lib/number.vala"
			number_set_error (_ ("Factorial is only defined for non-negative real numbers"));
#line 518 "../lib/number.vala"
			_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 518 "../lib/number.vala"
			result = _tmp2_;
#line 518 "../lib/number.vala"
			return result;
#line 1928 "number.c"
		}
#line 521 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 521 "../lib/number.vala"
		_tmp4_ = _tmp3_;
#line 521 "../lib/number.vala"
		_tmp5_ = number_add (self, _tmp4_);
#line 521 "../lib/number.vala"
		_tmp6_ = _tmp5_;
#line 521 "../lib/number.vala"
		_g_object_unref0 (_tmp4_);
#line 521 "../lib/number.vala"
		tmp = _tmp6_;
#line 522 "../lib/number.vala"
		_tmp7_ = number_get_precision ();
#line 522 "../lib/number.vala"
		_tmp8_ = _tmp7_;
#line 522 "../lib/number.vala"
		mpfr_init2 (&tmp2, _tmp8_);
#line 525 "../lib/number.vala"
		_tmp9_ = tmp;
#line 525 "../lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 525 "../lib/number.vala"
		mpfr_gamma (&tmp2, &_tmp10_->val, MPFR_RNDN);
#line 527 "../lib/number.vala"
		_tmp11_ = number_new_mpreal (&tmp2, NULL);
#line 527 "../lib/number.vala"
		result = _tmp11_;
#line 527 "../lib/number.vala"
		mpfr_clear (&tmp2);
#line 527 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 527 "../lib/number.vala"
		return result;
#line 1964 "number.c"
	}
#line 531 "../lib/number.vala"
	value = number_to_integer (self);
#line 532 "../lib/number.vala"
	_tmp12_ = _g_object_ref0 (self);
#line 532 "../lib/number.vala"
	z = _tmp12_;
#line 1972 "number.c"
	{
		gint i = 0;
#line 533 "../lib/number.vala"
		i = 2;
#line 1977 "number.c"
		{
			gboolean _tmp13_ = FALSE;
#line 533 "../lib/number.vala"
			_tmp13_ = TRUE;
#line 533 "../lib/number.vala"
			while (TRUE) {
#line 1984 "number.c"
				Number* _tmp15_;
				Number* _tmp16_;
#line 533 "../lib/number.vala"
				if (!_tmp13_) {
#line 1989 "number.c"
					gint _tmp14_;
#line 533 "../lib/number.vala"
					_tmp14_ = i;
#line 533 "../lib/number.vala"
					i = _tmp14_ + 1;
#line 1995 "number.c"
				}
#line 533 "../lib/number.vala"
				_tmp13_ = FALSE;
#line 533 "../lib/number.vala"
				if (!(((gint64) i) < value)) {
#line 533 "../lib/number.vala"
					break;
#line 2003 "number.c"
				}
#line 534 "../lib/number.vala"
				_tmp15_ = z;
#line 534 "../lib/number.vala"
				_tmp16_ = number_multiply_integer (_tmp15_, (gint64) i);
#line 534 "../lib/number.vala"
				_g_object_unref0 (z);
#line 534 "../lib/number.vala"
				z = _tmp16_;
#line 2013 "number.c"
			}
		}
	}
#line 536 "../lib/number.vala"
	result = z;
#line 536 "../lib/number.vala"
	return result;
#line 2021 "number.c"
}

Number*
number_add (Number* self,
            Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 540 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 540 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 542 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 542 "../lib/number.vala"
	z = _tmp0_;
#line 543 "../lib/number.vala"
	mpc_add (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 544 "../lib/number.vala"
	result = z;
#line 544 "../lib/number.vala"
	return result;
#line 2045 "number.c"
}

Number*
number_subtract (Number* self,
                 Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 548 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 548 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 550 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 550 "../lib/number.vala"
	z = _tmp0_;
#line 551 "../lib/number.vala"
	mpc_sub (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 552 "../lib/number.vala"
	result = z;
#line 552 "../lib/number.vala"
	return result;
#line 2069 "number.c"
}

Number*
number_multiply (Number* self,
                 Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 556 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 556 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 558 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 558 "../lib/number.vala"
	z = _tmp0_;
#line 559 "../lib/number.vala"
	mpc_mul (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 560 "../lib/number.vala"
	result = z;
#line 560 "../lib/number.vala"
	return result;
#line 2093 "number.c"
}

Number*
number_multiply_integer (Number* self,
                         gint64 y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 564 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 566 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 566 "../lib/number.vala"
	z = _tmp0_;
#line 567 "../lib/number.vala"
	mpc_mul_si (&z->priv->num, &self->priv->num, (glong) y, MPC_RNDNN);
#line 568 "../lib/number.vala"
	result = z;
#line 568 "../lib/number.vala"
	return result;
#line 2115 "number.c"
}

Number*
number_divide (Number* self,
               Number* y)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* result;
#line 572 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 572 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 574 "../lib/number.vala"
	if (number_is_zero (y)) {
#line 2132 "number.c"
		Number* _tmp0_;
#line 577 "../lib/number.vala"
		number_set_error (_ ("Division by zero is undefined"));
#line 578 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 578 "../lib/number.vala"
		result = _tmp0_;
#line 578 "../lib/number.vala"
		return result;
#line 2142 "number.c"
	}
#line 581 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 581 "../lib/number.vala"
	z = _tmp1_;
#line 582 "../lib/number.vala"
	_tmp2_ = z;
#line 582 "../lib/number.vala"
	mpc_div (&_tmp2_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 583 "../lib/number.vala"
	result = z;
#line 583 "../lib/number.vala"
	return result;
#line 2156 "number.c"
}

Number*
number_divide_integer (Number* self,
                       gint64 y)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 587 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 589 "../lib/number.vala"
	_tmp0_ = number_new_integer (y, (gint64) 0);
#line 589 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 589 "../lib/number.vala"
	_tmp2_ = number_divide (self, _tmp1_);
#line 589 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 589 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 589 "../lib/number.vala"
	result = _tmp3_;
#line 589 "../lib/number.vala"
	return result;
#line 2184 "number.c"
}

Number*
number_modulus_divide (Number* self,
                       Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* t1 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t2 = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* z = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	Number* _tmp13_;
	Number* result;
#line 593 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 593 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 595 "../lib/number.vala"
	if (!number_is_integer (self)) {
#line 595 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2216 "number.c"
	} else {
#line 595 "../lib/number.vala"
		_tmp0_ = !number_is_integer (y);
#line 2220 "number.c"
	}
#line 595 "../lib/number.vala"
	if (_tmp0_) {
#line 2224 "number.c"
		Number* _tmp1_;
#line 598 "../lib/number.vala"
		number_set_error (_ ("Modulus division is only defined for integers"));
#line 599 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 599 "../lib/number.vala"
		result = _tmp1_;
#line 599 "../lib/number.vala"
		return result;
#line 2234 "number.c"
	}
#line 602 "../lib/number.vala"
	_tmp2_ = number_divide (self, y);
#line 602 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 602 "../lib/number.vala"
	_tmp4_ = number_floor (_tmp3_);
#line 602 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 602 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 602 "../lib/number.vala"
	t1 = _tmp5_;
#line 603 "../lib/number.vala"
	_tmp6_ = t1;
#line 603 "../lib/number.vala"
	_tmp7_ = number_multiply (_tmp6_, y);
#line 603 "../lib/number.vala"
	t2 = _tmp7_;
#line 604 "../lib/number.vala"
	_tmp8_ = t2;
#line 604 "../lib/number.vala"
	_tmp9_ = number_subtract (self, _tmp8_);
#line 604 "../lib/number.vala"
	z = _tmp9_;
#line 606 "../lib/number.vala"
	_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 606 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 606 "../lib/number.vala"
	t1 = _tmp10_;
#line 607 "../lib/number.vala"
	_tmp13_ = t1;
#line 607 "../lib/number.vala"
	if (number_compare (y, _tmp13_) < 0) {
#line 2270 "number.c"
		Number* _tmp14_;
		Number* _tmp15_;
#line 607 "../lib/number.vala"
		_tmp14_ = z;
#line 607 "../lib/number.vala"
		_tmp15_ = t1;
#line 607 "../lib/number.vala"
		_tmp12_ = number_compare (_tmp14_, _tmp15_) > 0;
#line 2279 "number.c"
	} else {
#line 607 "../lib/number.vala"
		_tmp12_ = FALSE;
#line 2283 "number.c"
	}
#line 607 "../lib/number.vala"
	if (_tmp12_) {
#line 607 "../lib/number.vala"
		_tmp11_ = TRUE;
#line 2289 "number.c"
	} else {
		gboolean _tmp16_ = FALSE;
		Number* _tmp17_;
#line 607 "../lib/number.vala"
		_tmp17_ = t1;
#line 607 "../lib/number.vala"
		if (number_compare (y, _tmp17_) > 0) {
#line 2297 "number.c"
			Number* _tmp18_;
			Number* _tmp19_;
#line 607 "../lib/number.vala"
			_tmp18_ = z;
#line 607 "../lib/number.vala"
			_tmp19_ = t1;
#line 607 "../lib/number.vala"
			_tmp16_ = number_compare (_tmp18_, _tmp19_) < 0;
#line 2306 "number.c"
		} else {
#line 607 "../lib/number.vala"
			_tmp16_ = FALSE;
#line 2310 "number.c"
		}
#line 607 "../lib/number.vala"
		_tmp11_ = _tmp16_;
#line 2314 "number.c"
	}
#line 607 "../lib/number.vala"
	if (_tmp11_) {
#line 2318 "number.c"
		Number* _tmp20_;
		Number* _tmp21_;
#line 608 "../lib/number.vala"
		_tmp20_ = z;
#line 608 "../lib/number.vala"
		_tmp21_ = number_add (_tmp20_, y);
#line 608 "../lib/number.vala"
		_g_object_unref0 (z);
#line 608 "../lib/number.vala"
		z = _tmp21_;
#line 2329 "number.c"
	}
#line 610 "../lib/number.vala"
	result = z;
#line 610 "../lib/number.vala"
	_g_object_unref0 (t2);
#line 610 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 610 "../lib/number.vala"
	return result;
#line 2339 "number.c"
}

Number*
number_modular_exponentiation (Number* self,
                               Number* exp,
                               Number* mod)
{
	Number* base_value = NULL;
	Number* _tmp0_;
	Number* exp_value = NULL;
	Number* _tmp3_;
	Number* ans = NULL;
	Number* _tmp4_;
	Number* two = NULL;
	Number* _tmp5_;
	Number* _tmp26_;
	Number* _tmp27_;
	Number* result;
#line 614 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 614 "../lib/number.vala"
	g_return_val_if_fail (exp != NULL, NULL);
#line 614 "../lib/number.vala"
	g_return_val_if_fail (mod != NULL, NULL);
#line 616 "../lib/number.vala"
	_tmp0_ = number_copy (self);
#line 616 "../lib/number.vala"
	base_value = _tmp0_;
#line 617 "../lib/number.vala"
	if (number_is_negative (exp)) {
#line 2370 "number.c"
		Number* _tmp1_;
		Number* _tmp2_;
#line 618 "../lib/number.vala"
		_tmp1_ = base_value;
#line 618 "../lib/number.vala"
		_tmp2_ = number_reciprocal (_tmp1_);
#line 618 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 618 "../lib/number.vala"
		base_value = _tmp2_;
#line 2381 "number.c"
	}
#line 619 "../lib/number.vala"
	_tmp3_ = number_abs (exp);
#line 619 "../lib/number.vala"
	exp_value = _tmp3_;
#line 620 "../lib/number.vala"
	_tmp4_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 620 "../lib/number.vala"
	ans = _tmp4_;
#line 621 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 621 "../lib/number.vala"
	two = _tmp5_;
#line 622 "../lib/number.vala"
	while (TRUE) {
#line 2397 "number.c"
		Number* _tmp6_;
		gboolean is_even = FALSE;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
		Number* _tmp10_;
		gboolean _tmp11_;
		Number* _tmp17_;
		Number* _tmp18_;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
		Number* _tmp25_;
#line 622 "../lib/number.vala"
		_tmp6_ = exp_value;
#line 622 "../lib/number.vala"
		if (!(!number_is_zero (_tmp6_))) {
#line 622 "../lib/number.vala"
			break;
#line 2420 "number.c"
		}
#line 624 "../lib/number.vala"
		_tmp7_ = exp_value;
#line 624 "../lib/number.vala"
		_tmp8_ = two;
#line 624 "../lib/number.vala"
		_tmp9_ = number_modulus_divide (_tmp7_, _tmp8_);
#line 624 "../lib/number.vala"
		_tmp10_ = _tmp9_;
#line 624 "../lib/number.vala"
		_tmp11_ = number_is_zero (_tmp10_);
#line 624 "../lib/number.vala"
		_g_object_unref0 (_tmp10_);
#line 624 "../lib/number.vala"
		is_even = _tmp11_;
#line 625 "../lib/number.vala"
		if (!is_even) {
#line 2438 "number.c"
			Number* _tmp12_;
			Number* _tmp13_;
			Number* _tmp14_;
			Number* _tmp15_;
			Number* _tmp16_;
#line 627 "../lib/number.vala"
			_tmp12_ = ans;
#line 627 "../lib/number.vala"
			_tmp13_ = base_value;
#line 627 "../lib/number.vala"
			_tmp14_ = number_multiply (_tmp12_, _tmp13_);
#line 627 "../lib/number.vala"
			_g_object_unref0 (ans);
#line 627 "../lib/number.vala"
			ans = _tmp14_;
#line 628 "../lib/number.vala"
			_tmp15_ = ans;
#line 628 "../lib/number.vala"
			_tmp16_ = number_modulus_divide (_tmp15_, mod);
#line 628 "../lib/number.vala"
			_g_object_unref0 (ans);
#line 628 "../lib/number.vala"
			ans = _tmp16_;
#line 2462 "number.c"
		}
#line 630 "../lib/number.vala"
		_tmp17_ = base_value;
#line 630 "../lib/number.vala"
		_tmp18_ = base_value;
#line 630 "../lib/number.vala"
		_tmp19_ = number_multiply (_tmp17_, _tmp18_);
#line 630 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 630 "../lib/number.vala"
		base_value = _tmp19_;
#line 631 "../lib/number.vala"
		_tmp20_ = base_value;
#line 631 "../lib/number.vala"
		_tmp21_ = number_modulus_divide (_tmp20_, mod);
#line 631 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 631 "../lib/number.vala"
		base_value = _tmp21_;
#line 632 "../lib/number.vala"
		_tmp22_ = exp_value;
#line 632 "../lib/number.vala"
		_tmp23_ = number_divide_integer (_tmp22_, (gint64) 2);
#line 632 "../lib/number.vala"
		_tmp24_ = _tmp23_;
#line 632 "../lib/number.vala"
		_tmp25_ = number_floor (_tmp24_);
#line 632 "../lib/number.vala"
		_g_object_unref0 (exp_value);
#line 632 "../lib/number.vala"
		exp_value = _tmp25_;
#line 632 "../lib/number.vala"
		_g_object_unref0 (_tmp24_);
#line 2496 "number.c"
	}
#line 634 "../lib/number.vala"
	_tmp26_ = ans;
#line 634 "../lib/number.vala"
	_tmp27_ = number_modulus_divide (_tmp26_, mod);
#line 634 "../lib/number.vala"
	result = _tmp27_;
#line 634 "../lib/number.vala"
	_g_object_unref0 (two);
#line 634 "../lib/number.vala"
	_g_object_unref0 (ans);
#line 634 "../lib/number.vala"
	_g_object_unref0 (exp_value);
#line 634 "../lib/number.vala"
	_g_object_unref0 (base_value);
#line 634 "../lib/number.vala"
	return result;
#line 2514 "number.c"
}

Number*
number_sin (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 638 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 640 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 640 "../lib/number.vala"
	z = _tmp0_;
#line 641 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2534 "number.c"
		Number* _tmp1_;
#line 642 "../lib/number.vala"
		_tmp1_ = z;
#line 642 "../lib/number.vala"
		mpc_set (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2540 "number.c"
	} else {
		Number* _tmp2_;
#line 644 "../lib/number.vala"
		_tmp2_ = z;
#line 644 "../lib/number.vala"
		number_mpc_to_radians (&_tmp2_->priv->num, &self->priv->num, unit);
#line 2547 "number.c"
	}
#line 645 "../lib/number.vala"
	_tmp3_ = z;
#line 645 "../lib/number.vala"
	_tmp4_ = z;
#line 645 "../lib/number.vala"
	mpc_sin (&_tmp3_->priv->num, &_tmp4_->priv->num, MPC_RNDNN);
#line 646 "../lib/number.vala"
	result = z;
#line 646 "../lib/number.vala"
	return result;
#line 2559 "number.c"
}

Number*
number_cos (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 650 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 652 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 652 "../lib/number.vala"
	z = _tmp0_;
#line 653 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2579 "number.c"
		Number* _tmp1_;
#line 654 "../lib/number.vala"
		_tmp1_ = z;
#line 654 "../lib/number.vala"
		mpc_set (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2585 "number.c"
	} else {
		Number* _tmp2_;
#line 656 "../lib/number.vala"
		_tmp2_ = z;
#line 656 "../lib/number.vala"
		number_mpc_to_radians (&_tmp2_->priv->num, &self->priv->num, unit);
#line 2592 "number.c"
	}
#line 657 "../lib/number.vala"
	_tmp3_ = z;
#line 657 "../lib/number.vala"
	_tmp4_ = z;
#line 657 "../lib/number.vala"
	mpc_cos (&_tmp3_->priv->num, &_tmp4_->priv->num, MPC_RNDNN);
#line 658 "../lib/number.vala"
	result = z;
#line 658 "../lib/number.vala"
	return result;
#line 2604 "number.c"
}

Number*
number_tan (Number* self,
            AngleUnit unit)
{
	Number* x_radians = NULL;
	Number* _tmp0_;
	Number* check = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* z = NULL;
	Number* _tmp14_;
	Number* _tmp17_;
	Number* _tmp18_;
	Number* result;
#line 662 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 665 "../lib/number.vala"
	_tmp0_ = number_to_radians (self, unit);
#line 665 "../lib/number.vala"
	x_radians = _tmp0_;
#line 666 "../lib/number.vala"
	_tmp1_ = x_radians;
#line 666 "../lib/number.vala"
	_tmp2_ = number_new_pi ();
#line 666 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 666 "../lib/number.vala"
	_tmp4_ = number_divide_integer (_tmp3_, (gint64) 2);
#line 666 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 666 "../lib/number.vala"
	_tmp6_ = number_subtract (_tmp1_, _tmp5_);
#line 666 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 666 "../lib/number.vala"
	_tmp8_ = number_new_pi ();
#line 666 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 666 "../lib/number.vala"
	_tmp10_ = number_divide (_tmp7_, _tmp9_);
#line 666 "../lib/number.vala"
	_tmp11_ = _tmp10_;
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp9_);
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp7_);
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 666 "../lib/number.vala"
	check = _tmp11_;
#line 668 "../lib/number.vala"
	_tmp12_ = check;
#line 668 "../lib/number.vala"
	if (number_is_integer (_tmp12_)) {
#line 2673 "number.c"
		Number* _tmp13_;
#line 671 "../lib/number.vala"
		number_set_error (_ ("Tangent is undefined for angles that are multiples of π (180°) from π∕" \
"2 (90°)"));
#line 672 "../lib/number.vala"
		_tmp13_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 672 "../lib/number.vala"
		result = _tmp13_;
#line 672 "../lib/number.vala"
		_g_object_unref0 (check);
#line 672 "../lib/number.vala"
		_g_object_unref0 (x_radians);
#line 672 "../lib/number.vala"
		return result;
#line 2687 "number.c"
	}
#line 675 "../lib/number.vala"
	_tmp14_ = number_new ();
#line 675 "../lib/number.vala"
	z = _tmp14_;
#line 676 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2695 "number.c"
		Number* _tmp15_;
#line 677 "../lib/number.vala"
		_tmp15_ = z;
#line 677 "../lib/number.vala"
		mpc_set (&_tmp15_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2701 "number.c"
	} else {
		Number* _tmp16_;
#line 679 "../lib/number.vala"
		_tmp16_ = z;
#line 679 "../lib/number.vala"
		number_mpc_to_radians (&_tmp16_->priv->num, &self->priv->num, unit);
#line 2708 "number.c"
	}
#line 680 "../lib/number.vala"
	_tmp17_ = z;
#line 680 "../lib/number.vala"
	_tmp18_ = z;
#line 680 "../lib/number.vala"
	mpc_tan (&_tmp17_->priv->num, &_tmp18_->priv->num, MPC_RNDNN);
#line 681 "../lib/number.vala"
	result = z;
#line 681 "../lib/number.vala"
	_g_object_unref0 (check);
#line 681 "../lib/number.vala"
	_g_object_unref0 (x_radians);
#line 681 "../lib/number.vala"
	return result;
#line 2724 "number.c"
}

Number*
number_asin (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 685 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 687 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 687 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 687 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) > 0;
#line 687 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 687 "../lib/number.vala"
	if (_tmp3_) {
#line 687 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2754 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 687 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 687 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 687 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) < 0;
#line 687 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 2766 "number.c"
	}
#line 687 "../lib/number.vala"
	if (_tmp0_) {
#line 2770 "number.c"
		Number* _tmp6_;
#line 690 "../lib/number.vala"
		number_set_error (_ ("Inverse sine is undefined for values outside [-1, 1]"));
#line 691 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 691 "../lib/number.vala"
		result = _tmp6_;
#line 691 "../lib/number.vala"
		return result;
#line 2780 "number.c"
	}
#line 694 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 694 "../lib/number.vala"
	z = _tmp7_;
#line 695 "../lib/number.vala"
	_tmp8_ = z;
#line 695 "../lib/number.vala"
	mpc_asin (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 696 "../lib/number.vala"
	_tmp9_ = z;
#line 696 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 2794 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 697 "../lib/number.vala"
		_tmp10_ = z;
#line 697 "../lib/number.vala"
		_tmp11_ = z;
#line 697 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 2803 "number.c"
	}
#line 698 "../lib/number.vala"
	result = z;
#line 698 "../lib/number.vala"
	return result;
#line 2809 "number.c"
}

Number*
number_acos (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 702 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 704 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 704 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 704 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) > 0;
#line 704 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 704 "../lib/number.vala"
	if (_tmp3_) {
#line 704 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2839 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 704 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 704 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 704 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) < 0;
#line 704 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 2851 "number.c"
	}
#line 704 "../lib/number.vala"
	if (_tmp0_) {
#line 2855 "number.c"
		Number* _tmp6_;
#line 707 "../lib/number.vala"
		number_set_error (_ ("Inverse cosine is undefined for values outside [-1, 1]"));
#line 708 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 708 "../lib/number.vala"
		result = _tmp6_;
#line 708 "../lib/number.vala"
		return result;
#line 2865 "number.c"
	}
#line 711 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 711 "../lib/number.vala"
	z = _tmp7_;
#line 712 "../lib/number.vala"
	_tmp8_ = z;
#line 712 "../lib/number.vala"
	mpc_acos (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 713 "../lib/number.vala"
	_tmp9_ = z;
#line 713 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 2879 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 714 "../lib/number.vala"
		_tmp10_ = z;
#line 714 "../lib/number.vala"
		_tmp11_ = z;
#line 714 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 2888 "number.c"
	}
#line 715 "../lib/number.vala"
	result = z;
#line 715 "../lib/number.vala"
	return result;
#line 2894 "number.c"
}

Number*
number_atan (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 719 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 722 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 0, (gint64) 1);
#line 722 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 722 "../lib/number.vala"
	_tmp3_ = number_equals (self, _tmp2_);
#line 722 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 722 "../lib/number.vala"
	if (_tmp3_) {
#line 722 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2924 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 722 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) 0, (gint64) -1);
#line 722 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 722 "../lib/number.vala"
		_tmp0_ = number_equals (self, _tmp5_);
#line 722 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 2936 "number.c"
	}
#line 722 "../lib/number.vala"
	if (_tmp0_) {
#line 2940 "number.c"
		Number* _tmp6_;
#line 725 "../lib/number.vala"
		number_set_error (_ ("Arctangent function is undefined for values i and -i"));
#line 726 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 726 "../lib/number.vala"
		result = _tmp6_;
#line 726 "../lib/number.vala"
		return result;
#line 2950 "number.c"
	}
#line 728 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 728 "../lib/number.vala"
	z = _tmp7_;
#line 729 "../lib/number.vala"
	_tmp8_ = z;
#line 729 "../lib/number.vala"
	mpc_atan (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 730 "../lib/number.vala"
	_tmp9_ = z;
#line 730 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 2964 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 731 "../lib/number.vala"
		_tmp10_ = z;
#line 731 "../lib/number.vala"
		_tmp11_ = z;
#line 731 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 2973 "number.c"
	}
#line 732 "../lib/number.vala"
	result = z;
#line 732 "../lib/number.vala"
	return result;
#line 2979 "number.c"
}

Number*
number_sinh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 736 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 738 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 738 "../lib/number.vala"
	z = _tmp0_;
#line 739 "../lib/number.vala"
	mpc_sinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 740 "../lib/number.vala"
	result = z;
#line 740 "../lib/number.vala"
	return result;
#line 3000 "number.c"
}

Number*
number_cosh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 744 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 746 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 746 "../lib/number.vala"
	z = _tmp0_;
#line 747 "../lib/number.vala"
	mpc_cosh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 748 "../lib/number.vala"
	result = z;
#line 748 "../lib/number.vala"
	return result;
#line 3021 "number.c"
}

Number*
number_tanh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 752 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 754 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 754 "../lib/number.vala"
	z = _tmp0_;
#line 755 "../lib/number.vala"
	mpc_tanh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 756 "../lib/number.vala"
	result = z;
#line 756 "../lib/number.vala"
	return result;
#line 3042 "number.c"
}

Number*
number_asinh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 760 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 762 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 762 "../lib/number.vala"
	z = _tmp0_;
#line 763 "../lib/number.vala"
	mpc_asinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 764 "../lib/number.vala"
	result = z;
#line 764 "../lib/number.vala"
	return result;
#line 3063 "number.c"
}

Number*
number_acosh (Number* self)
{
	Number* t = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* z = NULL;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 768 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 771 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 771 "../lib/number.vala"
	t = _tmp0_;
#line 772 "../lib/number.vala"
	_tmp1_ = t;
#line 772 "../lib/number.vala"
	if (number_compare (self, _tmp1_) < 0) {
#line 3086 "number.c"
		Number* _tmp2_;
#line 775 "../lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic cosine is undefined for values less than one"));
#line 776 "../lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 776 "../lib/number.vala"
		result = _tmp2_;
#line 776 "../lib/number.vala"
		_g_object_unref0 (t);
#line 776 "../lib/number.vala"
		return result;
#line 3098 "number.c"
	}
#line 779 "../lib/number.vala"
	_tmp3_ = number_new ();
#line 779 "../lib/number.vala"
	z = _tmp3_;
#line 780 "../lib/number.vala"
	_tmp4_ = z;
#line 780 "../lib/number.vala"
	mpc_acosh (&_tmp4_->priv->num, &self->priv->num, MPC_RNDNN);
#line 781 "../lib/number.vala"
	result = z;
#line 781 "../lib/number.vala"
	_g_object_unref0 (t);
#line 781 "../lib/number.vala"
	return result;
#line 3114 "number.c"
}

Number*
number_atanh (Number* self)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* result;
#line 785 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 788 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 788 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 788 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) >= 0;
#line 788 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 788 "../lib/number.vala"
	if (_tmp3_) {
#line 788 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3142 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 788 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 788 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 788 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) <= 0;
#line 788 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 3154 "number.c"
	}
#line 788 "../lib/number.vala"
	if (_tmp0_) {
#line 3158 "number.c"
		Number* _tmp6_;
#line 791 "../lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic tangent is undefined for values outside [-1, 1]"));
#line 792 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 792 "../lib/number.vala"
		result = _tmp6_;
#line 792 "../lib/number.vala"
		return result;
#line 3168 "number.c"
	}
#line 795 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 795 "../lib/number.vala"
	z = _tmp7_;
#line 796 "../lib/number.vala"
	_tmp8_ = z;
#line 796 "../lib/number.vala"
	mpc_atanh (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 797 "../lib/number.vala"
	result = z;
#line 797 "../lib/number.vala"
	return result;
#line 3182 "number.c"
}

static gint
__lambda4_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 810 "../lib/number.vala"
	result = v1 & v2;
#line 810 "../lib/number.vala"
	return result;
#line 3195 "number.c"
}

static gint
___lambda4__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda4_ ((Number*) self, v1, v2);
#line 810 "../lib/number.vala"
	return result;
#line 3207 "number.c"
}

Number*
number_and (Number* self,
            Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 801 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 801 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 803 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 803 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3225 "number.c"
	} else {
#line 804 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3229 "number.c"
	}
#line 803 "../lib/number.vala"
	if (_tmp0_) {
#line 807 "../lib/number.vala"
		number_set_error (_ ("Boolean AND is only defined for positive integers"));
#line 3235 "number.c"
	}
#line 810 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda4__bitwise_func, self, 0);
#line 810 "../lib/number.vala"
	result = _tmp1_;
#line 810 "../lib/number.vala"
	return result;
#line 3243 "number.c"
}

static gint
__lambda5_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 822 "../lib/number.vala"
	result = v1 | v2;
#line 822 "../lib/number.vala"
	return result;
#line 3256 "number.c"
}

static gint
___lambda5__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda5_ ((Number*) self, v1, v2);
#line 822 "../lib/number.vala"
	return result;
#line 3268 "number.c"
}

Number*
number_or (Number* self,
           Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 814 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 814 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 816 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 816 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3286 "number.c"
	} else {
#line 816 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3290 "number.c"
	}
#line 816 "../lib/number.vala"
	if (_tmp0_) {
#line 819 "../lib/number.vala"
		number_set_error (_ ("Boolean OR is only defined for positive integers"));
#line 3296 "number.c"
	}
#line 822 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda5__bitwise_func, self, 0);
#line 822 "../lib/number.vala"
	result = _tmp1_;
#line 822 "../lib/number.vala"
	return result;
#line 3304 "number.c"
}

static gint
__lambda6_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 834 "../lib/number.vala"
	result = v1 ^ v2;
#line 834 "../lib/number.vala"
	return result;
#line 3317 "number.c"
}

static gint
___lambda6__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda6_ ((Number*) self, v1, v2);
#line 834 "../lib/number.vala"
	return result;
#line 3329 "number.c"
}

Number*
number_xor (Number* self,
            Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 826 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 826 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 828 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 828 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3347 "number.c"
	} else {
#line 828 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3351 "number.c"
	}
#line 828 "../lib/number.vala"
	if (_tmp0_) {
#line 831 "../lib/number.vala"
		number_set_error (_ ("Boolean XOR is only defined for positive integers"));
#line 3357 "number.c"
	}
#line 834 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda6__bitwise_func, self, 0);
#line 834 "../lib/number.vala"
	result = _tmp1_;
#line 834 "../lib/number.vala"
	return result;
#line 3365 "number.c"
}

static gint
__lambda7_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 846 "../lib/number.vala"
	result = v1 ^ 0xF;
#line 846 "../lib/number.vala"
	return result;
#line 3378 "number.c"
}

static gint
___lambda7__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda7_ ((Number*) self, v1, v2);
#line 846 "../lib/number.vala"
	return result;
#line 3390 "number.c"
}

Number*
number_not (Number* self,
            gint wordlen)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 838 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 840 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 843 "../lib/number.vala"
		number_set_error (_ ("Boolean NOT is only defined for positive integers"));
#line 3408 "number.c"
	}
#line 846 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 846 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 846 "../lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda7__bitwise_func, self, wordlen);
#line 846 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 846 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 846 "../lib/number.vala"
	result = _tmp3_;
#line 846 "../lib/number.vala"
	return result;
#line 3424 "number.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1466 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1466 "glib-2.0.vapi"
	end = _tmp0_;
#line 1467 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1467 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1468 "glib-2.0.vapi"
		result = maxlen;
#line 1468 "glib-2.0.vapi"
		return result;
#line 3447 "number.c"
	} else {
		gchar* _tmp2_;
#line 1470 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1470 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1470 "glib-2.0.vapi"
		return result;
#line 3456 "number.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1479 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 3475 "number.c"
	} else {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3479 "number.c"
	}
#line 1479 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1481 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 3485 "number.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1483 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1483 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1483 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 3495 "number.c"
	}
#line 1486 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1487 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1488 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 3503 "number.c"
	} else {
#line 1490 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 3507 "number.c"
	}
#line 1492 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1493 "glib-2.0.vapi"
		len = string_length - offset;
#line 3513 "number.c"
	}
#line 1495 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1496 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1496 "glib-2.0.vapi"
	result = _tmp3_;
#line 1496 "glib-2.0.vapi"
	return result;
#line 3523 "number.c"
}

Number*
number_mask (Number* self,
             Number* x,
             gint wordlen)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gint len = 0;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint offset = 0;
	gint _tmp4_ = 0;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 850 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 850 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 853 "../lib/number.vala"
	_tmp0_ = number_to_hex_string (x);
#line 853 "../lib/number.vala"
	text = _tmp0_;
#line 854 "../lib/number.vala"
	_tmp1_ = text;
#line 854 "../lib/number.vala"
	_tmp2_ = strlen (_tmp1_);
#line 854 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 854 "../lib/number.vala"
	len = _tmp3_;
#line 855 "../lib/number.vala"
	offset = wordlen / 4;
#line 856 "../lib/number.vala"
	if (len > offset) {
#line 856 "../lib/number.vala"
		_tmp4_ = ((gint) len) - offset;
#line 3567 "number.c"
	} else {
#line 856 "../lib/number.vala"
		_tmp4_ = 0;
#line 3571 "number.c"
	}
#line 856 "../lib/number.vala"
	offset = _tmp4_;
#line 857 "../lib/number.vala"
	_tmp5_ = text;
#line 857 "../lib/number.vala"
	_tmp6_ = string_substring (_tmp5_, (glong) offset, (glong) -1);
#line 857 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 857 "../lib/number.vala"
	_tmp8_ = mp_set_from_string (_tmp7_, 16);
#line 857 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 857 "../lib/number.vala"
	_g_free0 (_tmp7_);
#line 857 "../lib/number.vala"
	result = _tmp9_;
#line 857 "../lib/number.vala"
	_g_free0 (text);
#line 857 "../lib/number.vala"
	return result;
#line 3593 "number.c"
}

Number*
number_shift (Number* self,
              gint64 count)
{
	Number* operand = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 861 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 863 "../lib/number.vala"
	if (!number_is_integer (self)) {
#line 3610 "number.c"
		Number* _tmp0_;
#line 866 "../lib/number.vala"
		number_set_error (_ ("Shift is only possible on integer values"));
#line 867 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 867 "../lib/number.vala"
		result = _tmp0_;
#line 867 "../lib/number.vala"
		return result;
#line 3620 "number.c"
	}
#line 871 "../lib/number.vala"
	_tmp1_ = number_new_unsigned_integer ((guint64) 2, (guint64) 0);
#line 871 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 871 "../lib/number.vala"
	_tmp3_ = number_xpowy_integer (_tmp2_, llabs (count));
#line 871 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 871 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 871 "../lib/number.vala"
	operand = _tmp4_;
#line 873 "../lib/number.vala"
	if (count >= ((gint64) 0)) {
#line 3636 "number.c"
		Number* _tmp5_;
		Number* _tmp6_;
#line 875 "../lib/number.vala"
		_tmp5_ = operand;
#line 875 "../lib/number.vala"
		_tmp6_ = number_multiply (self, _tmp5_);
#line 875 "../lib/number.vala"
		result = _tmp6_;
#line 875 "../lib/number.vala"
		_g_object_unref0 (operand);
#line 875 "../lib/number.vala"
		return result;
#line 3649 "number.c"
	} else {
		Number* _tmp7_;
		Number* _tmp9_;
		Number* _tmp10_;
		Number* _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
#line 880 "../lib/number.vala"
		_tmp7_ = operand;
#line 880 "../lib/number.vala"
		if (number_compare (self, _tmp7_) < 0) {
#line 3661 "number.c"
			Number* _tmp8_;
#line 881 "../lib/number.vala"
			_tmp8_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 881 "../lib/number.vala"
			result = _tmp8_;
#line 881 "../lib/number.vala"
			_g_object_unref0 (operand);
#line 881 "../lib/number.vala"
			return result;
#line 3671 "number.c"
		}
#line 883 "../lib/number.vala"
		_tmp9_ = operand;
#line 883 "../lib/number.vala"
		_tmp10_ = number_divide (self, _tmp9_);
#line 883 "../lib/number.vala"
		_tmp11_ = _tmp10_;
#line 883 "../lib/number.vala"
		_tmp12_ = number_floor (_tmp11_);
#line 883 "../lib/number.vala"
		_tmp13_ = _tmp12_;
#line 883 "../lib/number.vala"
		_g_object_unref0 (_tmp11_);
#line 883 "../lib/number.vala"
		result = _tmp13_;
#line 883 "../lib/number.vala"
		_g_object_unref0 (operand);
#line 883 "../lib/number.vala"
		return result;
#line 3691 "number.c"
	}
}

static gint
__lambda8_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 890 "../lib/number.vala"
	result = v1 ^ v2;
#line 890 "../lib/number.vala"
	return result;
#line 3705 "number.c"
}

static gint
___lambda8__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda8_ ((Number*) self, v1, v2);
#line 890 "../lib/number.vala"
	return result;
#line 3717 "number.c"
}

Number*
number_ones_complement (Number* self,
                        gint wordlen)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 888 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 890 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 890 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 890 "../lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda8__bitwise_func, self, wordlen);
#line 890 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 890 "../lib/number.vala"
	_tmp4_ = number_not (_tmp3_, wordlen);
#line 890 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 890 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 890 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 890 "../lib/number.vala"
	result = _tmp5_;
#line 890 "../lib/number.vala"
	return result;
#line 3753 "number.c"
}

Number*
number_twos_complement (Number* self,
                        gint wordlen)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 894 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 896 "../lib/number.vala"
	_tmp0_ = number_ones_complement (self, wordlen);
#line 896 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 896 "../lib/number.vala"
	_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 896 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 896 "../lib/number.vala"
	_tmp4_ = number_add (_tmp1_, _tmp3_);
#line 896 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 896 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 896 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 896 "../lib/number.vala"
	result = _tmp5_;
#line 896 "../lib/number.vala"
	return result;
#line 3789 "number.c"
}

static gboolean
number_is_sprp (Number* self,
                Number* p,
                guint64 b)
{
	Number* unit = NULL;
	Number* _tmp0_;
	Number* pminus = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* d = NULL;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* two = NULL;
	Number* _tmp5_;
	guint64 twofactor = 0ULL;
	Number* x = NULL;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* _tmp16_;
	gboolean _tmp17_ = FALSE;
	Number* _tmp18_;
	Number* _tmp19_;
	gboolean result;
#line 901 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 901 "../lib/number.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 903 "../lib/number.vala"
	_tmp0_ = number_new_unsigned_integer ((guint64) 1, (guint64) 0);
#line 903 "../lib/number.vala"
	unit = _tmp0_;
#line 904 "../lib/number.vala"
	_tmp1_ = unit;
#line 904 "../lib/number.vala"
	_tmp2_ = number_subtract (p, _tmp1_);
#line 904 "../lib/number.vala"
	pminus = _tmp2_;
#line 905 "../lib/number.vala"
	_tmp3_ = pminus;
#line 905 "../lib/number.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 905 "../lib/number.vala"
	d = _tmp4_;
#line 906 "../lib/number.vala"
	_tmp5_ = number_new_unsigned_integer ((guint64) 2, (guint64) 0);
#line 906 "../lib/number.vala"
	two = _tmp5_;
#line 908 "../lib/number.vala"
	twofactor = (guint64) 0;
#line 910 "../lib/number.vala"
	while (TRUE) {
#line 3846 "number.c"
		Number* tmp = NULL;
		Number* _tmp6_;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
#line 912 "../lib/number.vala"
		_tmp6_ = d;
#line 912 "../lib/number.vala"
		_tmp7_ = two;
#line 912 "../lib/number.vala"
		_tmp8_ = number_divide (_tmp6_, _tmp7_);
#line 912 "../lib/number.vala"
		tmp = _tmp8_;
#line 913 "../lib/number.vala"
		_tmp9_ = tmp;
#line 913 "../lib/number.vala"
		if (number_is_integer (_tmp9_)) {
#line 3864 "number.c"
			Number* _tmp10_;
			Number* _tmp11_;
#line 915 "../lib/number.vala"
			_tmp10_ = tmp;
#line 915 "../lib/number.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 915 "../lib/number.vala"
			_g_object_unref0 (d);
#line 915 "../lib/number.vala"
			d = _tmp11_;
#line 916 "../lib/number.vala"
			twofactor = twofactor + 1;
#line 3877 "number.c"
		} else {
#line 919 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 919 "../lib/number.vala"
			break;
#line 3883 "number.c"
		}
#line 910 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 3887 "number.c"
	}
#line 922 "../lib/number.vala"
	_tmp12_ = number_new_unsigned_integer (b, (guint64) 0);
#line 922 "../lib/number.vala"
	_tmp13_ = _tmp12_;
#line 922 "../lib/number.vala"
	_tmp14_ = d;
#line 922 "../lib/number.vala"
	_tmp15_ = number_modular_exponentiation (_tmp13_, _tmp14_, p);
#line 922 "../lib/number.vala"
	_tmp16_ = _tmp15_;
#line 922 "../lib/number.vala"
	_g_object_unref0 (_tmp13_);
#line 922 "../lib/number.vala"
	x = _tmp16_;
#line 924 "../lib/number.vala"
	_tmp18_ = x;
#line 924 "../lib/number.vala"
	_tmp19_ = unit;
#line 924 "../lib/number.vala"
	if (number_equals (_tmp18_, _tmp19_)) {
#line 924 "../lib/number.vala"
		_tmp17_ = TRUE;
#line 3911 "number.c"
	} else {
		Number* _tmp20_;
		Number* _tmp21_;
#line 924 "../lib/number.vala"
		_tmp20_ = x;
#line 924 "../lib/number.vala"
		_tmp21_ = pminus;
#line 924 "../lib/number.vala"
		_tmp17_ = number_equals (_tmp20_, _tmp21_);
#line 3921 "number.c"
	}
#line 924 "../lib/number.vala"
	if (_tmp17_) {
#line 925 "../lib/number.vala"
		result = TRUE;
#line 925 "../lib/number.vala"
		_g_object_unref0 (x);
#line 925 "../lib/number.vala"
		_g_object_unref0 (two);
#line 925 "../lib/number.vala"
		_g_object_unref0 (d);
#line 925 "../lib/number.vala"
		_g_object_unref0 (pminus);
#line 925 "../lib/number.vala"
		_g_object_unref0 (unit);
#line 925 "../lib/number.vala"
		return result;
#line 3939 "number.c"
	}
	{
		gint i = 0;
#line 928 "../lib/number.vala"
		i = 1;
#line 3945 "number.c"
		{
			gboolean _tmp22_ = FALSE;
#line 928 "../lib/number.vala"
			_tmp22_ = TRUE;
#line 928 "../lib/number.vala"
			while (TRUE) {
#line 3952 "number.c"
				Number* _tmp24_;
				Number* _tmp25_;
				Number* _tmp26_;
				Number* _tmp27_;
				Number* _tmp28_;
				Number* _tmp29_;
				Number* _tmp30_;
#line 928 "../lib/number.vala"
				if (!_tmp22_) {
#line 3962 "number.c"
					gint _tmp23_;
#line 928 "../lib/number.vala"
					_tmp23_ = i;
#line 928 "../lib/number.vala"
					i = _tmp23_ + 1;
#line 3968 "number.c"
				}
#line 928 "../lib/number.vala"
				_tmp22_ = FALSE;
#line 928 "../lib/number.vala"
				if (!(((guint64) i) < twofactor)) {
#line 928 "../lib/number.vala"
					break;
#line 3976 "number.c"
				}
#line 930 "../lib/number.vala"
				_tmp24_ = x;
#line 930 "../lib/number.vala"
				_tmp25_ = x;
#line 930 "../lib/number.vala"
				_tmp26_ = number_multiply (_tmp24_, _tmp25_);
#line 930 "../lib/number.vala"
				_g_object_unref0 (x);
#line 930 "../lib/number.vala"
				x = _tmp26_;
#line 931 "../lib/number.vala"
				_tmp27_ = x;
#line 931 "../lib/number.vala"
				_tmp28_ = number_modulus_divide (_tmp27_, p);
#line 931 "../lib/number.vala"
				_g_object_unref0 (x);
#line 931 "../lib/number.vala"
				x = _tmp28_;
#line 933 "../lib/number.vala"
				_tmp29_ = x;
#line 933 "../lib/number.vala"
				_tmp30_ = pminus;
#line 933 "../lib/number.vala"
				if (number_equals (_tmp29_, _tmp30_)) {
#line 935 "../lib/number.vala"
					result = TRUE;
#line 935 "../lib/number.vala"
					_g_object_unref0 (x);
#line 935 "../lib/number.vala"
					_g_object_unref0 (two);
#line 935 "../lib/number.vala"
					_g_object_unref0 (d);
#line 935 "../lib/number.vala"
					_g_object_unref0 (pminus);
#line 935 "../lib/number.vala"
					_g_object_unref0 (unit);
#line 935 "../lib/number.vala"
					return result;
#line 4016 "number.c"
				}
			}
		}
	}
#line 938 "../lib/number.vala"
	result = FALSE;
#line 938 "../lib/number.vala"
	_g_object_unref0 (x);
#line 938 "../lib/number.vala"
	_g_object_unref0 (two);
#line 938 "../lib/number.vala"
	_g_object_unref0 (d);
#line 938 "../lib/number.vala"
	_g_object_unref0 (pminus);
#line 938 "../lib/number.vala"
	_g_object_unref0 (unit);
#line 938 "../lib/number.vala"
	return result;
#line 4035 "number.c"
}

static gboolean
number_is_prime (Number* self,
                 Number* x)
{
#line 949 "../lib/number.vala"
	static const guint64 BASES[13] = {(guint64) 2, (guint64) 3, (guint64) 5, (guint64) 7, (guint64) 11, (guint64) 13, (guint64) 17, (guint64) 19, (guint64) 23, (guint64) 29, (guint64) 31, (guint64) 37, (guint64) 41};
#line 4044 "number.c"
	guint64 sup = 0ULL;
	Number* _tmp0_;
	Number* _tmp1_;
	guint64 _tmp2_;
	gboolean result;
#line 947 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 947 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, FALSE);
#line 951 "../lib/number.vala"
	_tmp0_ = number_ln (x);
#line 951 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 951 "../lib/number.vala"
	_tmp2_ = number_to_unsigned_integer (_tmp1_) + 1;
#line 951 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 951 "../lib/number.vala"
	sup = _tmp2_;
#line 953 "../lib/number.vala"
	if (sup < ((guint64) 56)) {
#line 4066 "number.c"
		{
			gint i = 0;
#line 955 "../lib/number.vala"
			i = 0;
#line 4071 "number.c"
			{
				gboolean _tmp3_ = FALSE;
#line 955 "../lib/number.vala"
				_tmp3_ = TRUE;
#line 955 "../lib/number.vala"
				while (TRUE) {
#line 4078 "number.c"
					guint64 _tmp5_;
#line 955 "../lib/number.vala"
					if (!_tmp3_) {
#line 4082 "number.c"
						gint _tmp4_;
#line 955 "../lib/number.vala"
						_tmp4_ = i;
#line 955 "../lib/number.vala"
						i = _tmp4_ + 1;
#line 4088 "number.c"
					}
#line 955 "../lib/number.vala"
					_tmp3_ = FALSE;
#line 955 "../lib/number.vala"
					if (!(i < 13)) {
#line 955 "../lib/number.vala"
						break;
#line 4096 "number.c"
					}
#line 957 "../lib/number.vala"
					_tmp5_ = BASES[i];
#line 957 "../lib/number.vala"
					if (!number_is_sprp (self, x, _tmp5_)) {
#line 958 "../lib/number.vala"
						result = FALSE;
#line 958 "../lib/number.vala"
						return result;
#line 4106 "number.c"
					}
				}
			}
		}
#line 961 "../lib/number.vala"
		result = TRUE;
#line 961 "../lib/number.vala"
		return result;
#line 4115 "number.c"
	} else {
#line 965 "../lib/number.vala"
		sup = (sup * sup) * 2;
#line 4119 "number.c"
		{
			gint i = 0;
#line 967 "../lib/number.vala"
			i = 0;
#line 4124 "number.c"
			{
				gboolean _tmp6_ = FALSE;
#line 967 "../lib/number.vala"
				_tmp6_ = TRUE;
#line 967 "../lib/number.vala"
				while (TRUE) {
#line 967 "../lib/number.vala"
					if (!_tmp6_) {
#line 4133 "number.c"
						gint _tmp7_;
#line 967 "../lib/number.vala"
						_tmp7_ = i;
#line 967 "../lib/number.vala"
						i = _tmp7_ + 1;
#line 4139 "number.c"
					}
#line 967 "../lib/number.vala"
					_tmp6_ = FALSE;
#line 967 "../lib/number.vala"
					if (!(((guint64) i) < sup)) {
#line 967 "../lib/number.vala"
						break;
#line 4147 "number.c"
					}
#line 969 "../lib/number.vala"
					if (!number_is_sprp (self, x, (guint64) i)) {
#line 971 "../lib/number.vala"
						result = FALSE;
#line 971 "../lib/number.vala"
						return result;
#line 4155 "number.c"
					}
				}
			}
		}
#line 974 "../lib/number.vala"
		result = TRUE;
#line 974 "../lib/number.vala"
		return result;
#line 4164 "number.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 1015 "../lib/number.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 4173 "number.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 1015 "../lib/number.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 4181 "number.c"
}

GList*
number_factorize (Number* self)
{
	GList* factors = NULL;
	Number* value = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	gboolean _tmp7_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	gboolean _tmp12_;
	Number* int_max = NULL;
	Number* _tmp16_;
	Number* _tmp17_;
	Number* _tmp18_;
	Number* divisor = NULL;
	Number* _tmp25_;
	Number* _tmp34_;
	Number* root = NULL;
	Number* _tmp35_;
	Number* _tmp36_;
	Number* _tmp55_;
	Number* _tmp56_;
	Number* _tmp57_;
	gboolean _tmp58_;
	GList* result;
#line 980 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 982 "../lib/number.vala"
	factors = NULL;
#line 984 "../lib/number.vala"
	_tmp0_ = number_abs (self);
#line 984 "../lib/number.vala"
	value = _tmp0_;
#line 986 "../lib/number.vala"
	_tmp1_ = value;
#line 986 "../lib/number.vala"
	if (number_is_zero (_tmp1_)) {
#line 4226 "number.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 988 "../lib/number.vala"
		_tmp2_ = value;
#line 988 "../lib/number.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 988 "../lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 989 "../lib/number.vala"
		result = factors;
#line 989 "../lib/number.vala"
		_g_object_unref0 (value);
#line 989 "../lib/number.vala"
		return result;
#line 4241 "number.c"
	}
#line 992 "../lib/number.vala"
	_tmp4_ = value;
#line 992 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 992 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 992 "../lib/number.vala"
	_tmp7_ = number_equals (_tmp4_, _tmp6_);
#line 992 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 992 "../lib/number.vala"
	if (_tmp7_) {
#line 4255 "number.c"
		Number* _tmp8_;
#line 994 "../lib/number.vala"
		_tmp8_ = _g_object_ref0 (self);
#line 994 "../lib/number.vala"
		factors = g_list_append (factors, _tmp8_);
#line 995 "../lib/number.vala"
		result = factors;
#line 995 "../lib/number.vala"
		_g_object_unref0 (value);
#line 995 "../lib/number.vala"
		return result;
#line 4267 "number.c"
	}
#line 998 "../lib/number.vala"
	_tmp9_ = value;
#line 998 "../lib/number.vala"
	_tmp10_ = number_new_integer (0xFFFFFFFFLL, (gint64) 0);
#line 998 "../lib/number.vala"
	_tmp11_ = _tmp10_;
#line 998 "../lib/number.vala"
	_tmp12_ = number_compare (_tmp9_, _tmp11_) > 0;
#line 998 "../lib/number.vala"
	_g_object_unref0 (_tmp11_);
#line 998 "../lib/number.vala"
	if (_tmp12_) {
#line 4281 "number.c"
		Number* _tmp13_;
#line 1000 "../lib/number.vala"
		_tmp13_ = value;
#line 1000 "../lib/number.vala"
		if (number_is_prime (self, _tmp13_)) {
#line 4287 "number.c"
			Number* _tmp14_;
			Number* _tmp15_;
#line 1002 "../lib/number.vala"
			_tmp14_ = value;
#line 1002 "../lib/number.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1002 "../lib/number.vala"
			factors = g_list_append (factors, _tmp15_);
#line 1003 "../lib/number.vala"
			result = factors;
#line 1003 "../lib/number.vala"
			_g_object_unref0 (value);
#line 1003 "../lib/number.vala"
			return result;
#line 4302 "number.c"
		}
	}
#line 1008 "../lib/number.vala"
	_tmp16_ = number_new_unsigned_integer ((guint64) 0xFFFFFFFFFFFFFFFFLL, (guint64) 0);
#line 1008 "../lib/number.vala"
	int_max = _tmp16_;
#line 1010 "../lib/number.vala"
	_tmp17_ = value;
#line 1010 "../lib/number.vala"
	_tmp18_ = int_max;
#line 1010 "../lib/number.vala"
	if (number_compare (_tmp17_, _tmp18_) <= 0) {
#line 4315 "number.c"
		GList* factors_int64 = NULL;
		Number* _tmp19_;
		GList* _tmp20_;
#line 1012 "../lib/number.vala"
		_tmp19_ = value;
#line 1012 "../lib/number.vala"
		_tmp20_ = number_factorize_uint64 (self, number_to_unsigned_integer (_tmp19_));
#line 1012 "../lib/number.vala"
		factors_int64 = _tmp20_;
#line 1013 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 4327 "number.c"
			GList* _tmp21_;
			GList* _tmp22_;
			gconstpointer _tmp23_;
			Number* _tmp24_;
#line 1014 "../lib/number.vala"
			_tmp21_ = factors_int64;
#line 1014 "../lib/number.vala"
			_tmp22_ = factors_int64;
#line 1014 "../lib/number.vala"
			_tmp23_ = _tmp22_->data;
#line 1014 "../lib/number.vala"
			_tmp24_ = number_invert_sign ((Number*) _tmp23_);
#line 1014 "../lib/number.vala"
			_g_object_unref0 (_tmp21_->data);
#line 1014 "../lib/number.vala"
			_tmp21_->data = _tmp24_;
#line 4344 "number.c"
		}
#line 1015 "../lib/number.vala"
		result = factors_int64;
#line 1015 "../lib/number.vala"
		_g_object_unref0 (int_max);
#line 1015 "../lib/number.vala"
		_g_object_unref0 (value);
#line 1015 "../lib/number.vala"
		(factors == NULL) ? NULL : (factors = (_g_list_free__g_object_unref0_ (factors), NULL));
#line 1015 "../lib/number.vala"
		return result;
#line 4356 "number.c"
	}
#line 1018 "../lib/number.vala"
	_tmp25_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1018 "../lib/number.vala"
	divisor = _tmp25_;
#line 1019 "../lib/number.vala"
	while (TRUE) {
#line 4364 "number.c"
		Number* tmp = NULL;
		Number* _tmp26_;
		Number* _tmp27_;
		Number* _tmp28_;
		Number* _tmp29_;
#line 1021 "../lib/number.vala"
		_tmp26_ = value;
#line 1021 "../lib/number.vala"
		_tmp27_ = divisor;
#line 1021 "../lib/number.vala"
		_tmp28_ = number_divide (_tmp26_, _tmp27_);
#line 1021 "../lib/number.vala"
		tmp = _tmp28_;
#line 1022 "../lib/number.vala"
		_tmp29_ = tmp;
#line 1022 "../lib/number.vala"
		if (number_is_integer (_tmp29_)) {
#line 4382 "number.c"
			Number* _tmp30_;
			Number* _tmp31_;
			Number* _tmp32_;
			Number* _tmp33_;
#line 1024 "../lib/number.vala"
			_tmp30_ = tmp;
#line 1024 "../lib/number.vala"
			_tmp31_ = _g_object_ref0 (_tmp30_);
#line 1024 "../lib/number.vala"
			_g_object_unref0 (value);
#line 1024 "../lib/number.vala"
			value = _tmp31_;
#line 1025 "../lib/number.vala"
			_tmp32_ = divisor;
#line 1025 "../lib/number.vala"
			_tmp33_ = _g_object_ref0 (_tmp32_);
#line 1025 "../lib/number.vala"
			factors = g_list_append (factors, _tmp33_);
#line 4401 "number.c"
		} else {
#line 1028 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 1028 "../lib/number.vala"
			break;
#line 4407 "number.c"
		}
#line 1019 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 4411 "number.c"
	}
#line 1031 "../lib/number.vala"
	_tmp34_ = number_new_integer ((gint64) 3, (gint64) 0);
#line 1031 "../lib/number.vala"
	_g_object_unref0 (divisor);
#line 1031 "../lib/number.vala"
	divisor = _tmp34_;
#line 1032 "../lib/number.vala"
	_tmp35_ = value;
#line 1032 "../lib/number.vala"
	_tmp36_ = number_sqrt (_tmp35_);
#line 1032 "../lib/number.vala"
	root = _tmp36_;
#line 1033 "../lib/number.vala"
	while (TRUE) {
#line 4427 "number.c"
		Number* _tmp37_;
		Number* _tmp38_;
		Number* tmp = NULL;
		Number* _tmp39_;
		Number* _tmp40_;
		Number* _tmp41_;
		Number* _tmp42_;
#line 1033 "../lib/number.vala"
		_tmp37_ = divisor;
#line 1033 "../lib/number.vala"
		_tmp38_ = root;
#line 1033 "../lib/number.vala"
		if (!(number_compare (_tmp37_, _tmp38_) <= 0)) {
#line 1033 "../lib/number.vala"
			break;
#line 4443 "number.c"
		}
#line 1035 "../lib/number.vala"
		_tmp39_ = value;
#line 1035 "../lib/number.vala"
		_tmp40_ = divisor;
#line 1035 "../lib/number.vala"
		_tmp41_ = number_divide (_tmp39_, _tmp40_);
#line 1035 "../lib/number.vala"
		tmp = _tmp41_;
#line 1036 "../lib/number.vala"
		_tmp42_ = tmp;
#line 1036 "../lib/number.vala"
		if (number_is_integer (_tmp42_)) {
#line 4457 "number.c"
			Number* _tmp43_;
			Number* _tmp44_;
			Number* _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
#line 1038 "../lib/number.vala"
			_tmp43_ = tmp;
#line 1038 "../lib/number.vala"
			_tmp44_ = _g_object_ref0 (_tmp43_);
#line 1038 "../lib/number.vala"
			_g_object_unref0 (value);
#line 1038 "../lib/number.vala"
			value = _tmp44_;
#line 1039 "../lib/number.vala"
			_tmp45_ = value;
#line 1039 "../lib/number.vala"
			_tmp46_ = number_sqrt (_tmp45_);
#line 1039 "../lib/number.vala"
			_g_object_unref0 (root);
#line 1039 "../lib/number.vala"
			root = _tmp46_;
#line 1040 "../lib/number.vala"
			_tmp47_ = divisor;
#line 1040 "../lib/number.vala"
			_tmp48_ = _g_object_ref0 (_tmp47_);
#line 1040 "../lib/number.vala"
			factors = g_list_append (factors, _tmp48_);
#line 4486 "number.c"
		} else {
			Number* _tmp49_;
			Number* _tmp50_;
			Number* _tmp51_;
			Number* _tmp52_;
			Number* _tmp53_;
			Number* _tmp54_;
#line 1044 "../lib/number.vala"
			_tmp49_ = divisor;
#line 1044 "../lib/number.vala"
			_tmp50_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1044 "../lib/number.vala"
			_tmp51_ = _tmp50_;
#line 1044 "../lib/number.vala"
			_tmp52_ = number_add (_tmp49_, _tmp51_);
#line 1044 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 1044 "../lib/number.vala"
			tmp = _tmp52_;
#line 1044 "../lib/number.vala"
			_g_object_unref0 (_tmp51_);
#line 1045 "../lib/number.vala"
			_tmp53_ = tmp;
#line 1045 "../lib/number.vala"
			_tmp54_ = _g_object_ref0 (_tmp53_);
#line 1045 "../lib/number.vala"
			_g_object_unref0 (divisor);
#line 1045 "../lib/number.vala"
			divisor = _tmp54_;
#line 4516 "number.c"
		}
#line 1033 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 4520 "number.c"
	}
#line 1049 "../lib/number.vala"
	_tmp55_ = value;
#line 1049 "../lib/number.vala"
	_tmp56_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1049 "../lib/number.vala"
	_tmp57_ = _tmp56_;
#line 1049 "../lib/number.vala"
	_tmp58_ = number_compare (_tmp55_, _tmp57_) > 0;
#line 1049 "../lib/number.vala"
	_g_object_unref0 (_tmp57_);
#line 1049 "../lib/number.vala"
	if (_tmp58_) {
#line 4534 "number.c"
		Number* _tmp59_;
		Number* _tmp60_;
#line 1050 "../lib/number.vala"
		_tmp59_ = value;
#line 1050 "../lib/number.vala"
		_tmp60_ = _g_object_ref0 (_tmp59_);
#line 1050 "../lib/number.vala"
		factors = g_list_append (factors, _tmp60_);
#line 4543 "number.c"
	}
#line 1052 "../lib/number.vala"
	if (number_is_negative (self)) {
#line 4547 "number.c"
		GList* _tmp61_;
		GList* _tmp62_;
		gconstpointer _tmp63_;
		Number* _tmp64_;
#line 1053 "../lib/number.vala"
		_tmp61_ = factors;
#line 1053 "../lib/number.vala"
		_tmp62_ = factors;
#line 1053 "../lib/number.vala"
		_tmp63_ = _tmp62_->data;
#line 1053 "../lib/number.vala"
		_tmp64_ = number_invert_sign ((Number*) _tmp63_);
#line 1053 "../lib/number.vala"
		_g_object_unref0 (_tmp61_->data);
#line 1053 "../lib/number.vala"
		_tmp61_->data = _tmp64_;
#line 4564 "number.c"
	}
#line 1055 "../lib/number.vala"
	result = factors;
#line 1055 "../lib/number.vala"
	_g_object_unref0 (root);
#line 1055 "../lib/number.vala"
	_g_object_unref0 (divisor);
#line 1055 "../lib/number.vala"
	_g_object_unref0 (int_max);
#line 1055 "../lib/number.vala"
	_g_object_unref0 (value);
#line 1055 "../lib/number.vala"
	return result;
#line 4578 "number.c"
}

GList*
number_factorize_uint64 (Number* self,
                         guint64 n)
{
	GList* factors = NULL;
	GList* result;
#line 1058 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1060 "../lib/number.vala"
	factors = NULL;
#line 1061 "../lib/number.vala"
	while (TRUE) {
#line 4593 "number.c"
		Number* _tmp0_;
#line 1061 "../lib/number.vala"
		if (!((n % 2) == ((guint64) 0))) {
#line 1061 "../lib/number.vala"
			break;
#line 4599 "number.c"
		}
#line 1063 "../lib/number.vala"
		n = n / 2;
#line 1064 "../lib/number.vala"
		_tmp0_ = number_new_unsigned_integer ((guint64) 2, (guint64) 0);
#line 1064 "../lib/number.vala"
		factors = g_list_append (factors, _tmp0_);
#line 4607 "number.c"
	}
	{
		guint64 divisor = 0ULL;
#line 1067 "../lib/number.vala"
		divisor = (guint64) 3;
#line 4613 "number.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1067 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 1067 "../lib/number.vala"
			while (TRUE) {
#line 1067 "../lib/number.vala"
				if (!_tmp1_) {
#line 1067 "../lib/number.vala"
					divisor += (guint64) 2;
#line 4624 "number.c"
				}
#line 1067 "../lib/number.vala"
				_tmp1_ = FALSE;
#line 1067 "../lib/number.vala"
				if (!(divisor <= (n / divisor))) {
#line 1067 "../lib/number.vala"
					break;
#line 4632 "number.c"
				}
#line 1069 "../lib/number.vala"
				while (TRUE) {
#line 4636 "number.c"
					Number* _tmp2_;
#line 1069 "../lib/number.vala"
					if (!((n % divisor) == ((guint64) 0))) {
#line 1069 "../lib/number.vala"
						break;
#line 4642 "number.c"
					}
#line 1071 "../lib/number.vala"
					n = n / divisor;
#line 1072 "../lib/number.vala"
					_tmp2_ = number_new_unsigned_integer (divisor, (guint64) 0);
#line 1072 "../lib/number.vala"
					factors = g_list_append (factors, _tmp2_);
#line 4650 "number.c"
				}
			}
		}
	}
#line 1076 "../lib/number.vala"
	if (n > ((guint64) 1)) {
#line 4657 "number.c"
		Number* _tmp3_;
#line 1077 "../lib/number.vala"
		_tmp3_ = number_new_unsigned_integer (n, (guint64) 0);
#line 1077 "../lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 4663 "number.c"
	}
#line 1078 "../lib/number.vala"
	result = factors;
#line 1078 "../lib/number.vala"
	return result;
#line 4669 "number.c"
}

static Number*
number_copy (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 1081 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1083 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 1083 "../lib/number.vala"
	z = _tmp0_;
#line 1084 "../lib/number.vala"
	mpc_set (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 1085 "../lib/number.vala"
	result = z;
#line 1085 "../lib/number.vala"
	return result;
#line 4690 "number.c"
}

static gboolean
_mpc_equal (const __mpc_struct * s1,
            const __mpc_struct * s2)
{
#line 1096 "../lib/number.vala"
	if (s1 == s2) {
#line 1096 "../lib/number.vala"
		return TRUE;
#line 4701 "number.c"
	}
#line 1096 "../lib/number.vala"
	if (s1 == NULL) {
#line 1096 "../lib/number.vala"
		return FALSE;
#line 4707 "number.c"
	}
#line 1096 "../lib/number.vala"
	if (s2 == NULL) {
#line 1096 "../lib/number.vala"
		return FALSE;
#line 4713 "number.c"
	}
#line 1096 "../lib/number.vala"
	return FALSE;
#line 4717 "number.c"
}

static void
number_mpc_from_radians (__mpc_struct* res,
                         __mpc_struct* op,
                         AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	__mpc_struct _tmp3_;
#line 1088 "../lib/number.vala"
	g_return_if_fail (res != NULL);
#line 1088 "../lib/number.vala"
	g_return_if_fail (op != NULL);
#line 1092 "../lib/number.vala"
	switch (unit) {
#line 4736 "number.c"
		default:
#line 1092 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 4740 "number.c"
		{
#line 1096 "../lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 4744 "number.c"
				__mpc_struct _tmp0_;
#line 1097 "../lib/number.vala"
				_tmp0_ = *op;
#line 1097 "../lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 4750 "number.c"
			}
#line 1098 "../lib/number.vala"
			return;
#line 4754 "number.c"
		}
#line 1092 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 4758 "number.c"
		{
#line 1101 "../lib/number.vala"
			i = 180;
#line 1102 "../lib/number.vala"
			break;
#line 4764 "number.c"
		}
#line 1092 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 4768 "number.c"
		{
#line 1105 "../lib/number.vala"
			i = 200;
#line 1106 "../lib/number.vala"
			break;
#line 4774 "number.c"
		}
	}
#line 1109 "../lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1109 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1109 "../lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1110 "../lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1111 "../lib/number.vala"
	mpfr_si_div (&scale, (glong) i, &scale, MPFR_RNDN);
#line 1112 "../lib/number.vala"
	_tmp3_ = *op;
#line 1112 "../lib/number.vala"
	mpc_mul_fr (res, &_tmp3_, &scale, MPC_RNDNN);
#line 1088 "../lib/number.vala"
	mpfr_clear (&scale);
#line 4793 "number.c"
}

static void
number_mpc_to_radians (__mpc_struct* res,
                       __mpc_struct* op,
                       AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	__mpc_struct _tmp3_;
#line 1115 "../lib/number.vala"
	g_return_if_fail (res != NULL);
#line 1115 "../lib/number.vala"
	g_return_if_fail (op != NULL);
#line 1119 "../lib/number.vala"
	switch (unit) {
#line 4812 "number.c"
		default:
#line 1119 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 4816 "number.c"
		{
#line 1123 "../lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 4820 "number.c"
				__mpc_struct _tmp0_;
#line 1124 "../lib/number.vala"
				_tmp0_ = *op;
#line 1124 "../lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 4826 "number.c"
			}
#line 1125 "../lib/number.vala"
			return;
#line 4830 "number.c"
		}
#line 1119 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 4834 "number.c"
		{
#line 1128 "../lib/number.vala"
			i = 180;
#line 1129 "../lib/number.vala"
			break;
#line 4840 "number.c"
		}
#line 1119 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 4844 "number.c"
		{
#line 1132 "../lib/number.vala"
			i = 200;
#line 1133 "../lib/number.vala"
			break;
#line 4850 "number.c"
		}
	}
#line 1135 "../lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1135 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1135 "../lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1136 "../lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1137 "../lib/number.vala"
	mpfr_div_si (&scale, &scale, (glong) i, MPFR_RNDN);
#line 1138 "../lib/number.vala"
	_tmp3_ = *op;
#line 1138 "../lib/number.vala"
	mpc_mul_fr (res, &_tmp3_, &scale, MPC_RNDNN);
#line 1115 "../lib/number.vala"
	mpfr_clear (&scale);
#line 4869 "number.c"
}

static Number*
number_to_radians (Number* self,
                   AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 1142 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1144 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 1144 "../lib/number.vala"
	z = _tmp0_;
#line 1145 "../lib/number.vala"
	number_mpc_to_radians (&z->priv->num, &self->priv->num, unit);
#line 1146 "../lib/number.vala"
	result = z;
#line 1146 "../lib/number.vala"
	return result;
#line 4891 "number.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1248 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1249 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1249 "glib-2.0.vapi"
	result = _tmp0_;
#line 1249 "glib-2.0.vapi"
	return result;
#line 4908 "number.c"
}

static Number*
number_bitwise (Number* self,
                Number* y,
                BitwiseFunc bitwise_operator,
                gpointer bitwise_operator_target,
                gint wordlen)
{
	gchar* text1 = NULL;
	gchar* _tmp0_;
	gchar* text2 = NULL;
	gchar* _tmp1_;
	gint offset1 = 0;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint offset2 = 0;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint offset_out = 0;
	gboolean _tmp9_ = FALSE;
	gchar* text_out = NULL;
	gchar* _tmp12_;
	gint text_out_length1;
	gint _text_out_size_;
	gchar* _tmp22_;
	gint _tmp22__length1;
	Number* _tmp23_;
	Number* result;
#line 1149 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1149 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 1151 "../lib/number.vala"
	_tmp0_ = number_to_hex_string (self);
#line 1151 "../lib/number.vala"
	text1 = _tmp0_;
#line 1152 "../lib/number.vala"
	_tmp1_ = number_to_hex_string (y);
#line 1152 "../lib/number.vala"
	text2 = _tmp1_;
#line 1153 "../lib/number.vala"
	_tmp2_ = text1;
#line 1153 "../lib/number.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1153 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1153 "../lib/number.vala"
	offset1 = _tmp4_ - 1;
#line 1154 "../lib/number.vala"
	_tmp5_ = text2;
#line 1154 "../lib/number.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1154 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1154 "../lib/number.vala"
	offset2 = _tmp7_ - 1;
#line 1155 "../lib/number.vala"
	offset_out = (wordlen / 4) - 1;
#line 1156 "../lib/number.vala"
	if (offset_out <= 0) {
#line 4972 "number.c"
		gint _tmp8_ = 0;
#line 1157 "../lib/number.vala"
		if (offset1 > offset2) {
#line 1157 "../lib/number.vala"
			_tmp8_ = offset1;
#line 4978 "number.c"
		} else {
#line 1157 "../lib/number.vala"
			_tmp8_ = offset2;
#line 4982 "number.c"
		}
#line 1157 "../lib/number.vala"
		offset_out = _tmp8_;
#line 4986 "number.c"
	}
#line 1158 "../lib/number.vala"
	if (offset_out > 0) {
#line 4990 "number.c"
		gboolean _tmp10_ = FALSE;
#line 1158 "../lib/number.vala"
		if (offset_out < offset1) {
#line 1158 "../lib/number.vala"
			_tmp10_ = TRUE;
#line 4996 "number.c"
		} else {
#line 1158 "../lib/number.vala"
			_tmp10_ = offset_out < offset2;
#line 5000 "number.c"
		}
#line 1158 "../lib/number.vala"
		_tmp9_ = _tmp10_;
#line 5004 "number.c"
	} else {
#line 1158 "../lib/number.vala"
		_tmp9_ = FALSE;
#line 5008 "number.c"
	}
#line 1158 "../lib/number.vala"
	if (_tmp9_) {
#line 5012 "number.c"
		Number* _tmp11_;
#line 1160 "../lib/number.vala"
		number_set_error ("Overflow. Try a bigger word size");
#line 1161 "../lib/number.vala"
		_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1161 "../lib/number.vala"
		result = _tmp11_;
#line 1161 "../lib/number.vala"
		_g_free0 (text2);
#line 1161 "../lib/number.vala"
		_g_free0 (text1);
#line 1161 "../lib/number.vala"
		return result;
#line 5026 "number.c"
	}
#line 1164 "../lib/number.vala"
	_tmp12_ = g_new0 (gchar, offset_out + 2);
#line 1164 "../lib/number.vala"
	text_out = _tmp12_;
#line 1164 "../lib/number.vala"
	text_out_length1 = offset_out + 2;
#line 1164 "../lib/number.vala"
	_text_out_size_ = text_out_length1;
#line 5036 "number.c"
	{
		gchar* _tmp13_;
		gint _tmp13__length1;
		gboolean _tmp14_ = FALSE;
#line 1167 "../lib/number.vala"
		_tmp13_ = text_out;
#line 1167 "../lib/number.vala"
		_tmp13__length1 = text_out_length1;
#line 1167 "../lib/number.vala"
		_tmp13_[offset_out + 1] = '\0';
#line 1167 "../lib/number.vala"
		_tmp14_ = TRUE;
#line 1167 "../lib/number.vala"
		while (TRUE) {
#line 5051 "number.c"
			gint v1 = 0;
			gint v2 = 0;
#line 1170 "../lib/number.vala"
			static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 5056 "number.c"
			gchar* _tmp20_;
			gint _tmp20__length1;
			gchar _tmp21_;
#line 1167 "../lib/number.vala"
			if (!_tmp14_) {
#line 5062 "number.c"
				gint _tmp15_;
#line 1167 "../lib/number.vala"
				_tmp15_ = offset_out;
#line 1167 "../lib/number.vala"
				offset_out = _tmp15_ - 1;
#line 5068 "number.c"
			}
#line 1167 "../lib/number.vala"
			_tmp14_ = FALSE;
#line 1167 "../lib/number.vala"
			if (!(offset_out >= 0)) {
#line 1167 "../lib/number.vala"
				break;
#line 5076 "number.c"
			}
#line 1169 "../lib/number.vala"
			v1 = 0;
#line 1169 "../lib/number.vala"
			v2 = 0;
#line 1172 "../lib/number.vala"
			if (offset1 >= 0) {
#line 5084 "number.c"
				const gchar* _tmp16_;
				gint _tmp17_;
#line 1174 "../lib/number.vala"
				_tmp16_ = text1;
#line 1174 "../lib/number.vala"
				v1 = number_hex_to_int (self, string_get (_tmp16_, (glong) offset1));
#line 1175 "../lib/number.vala"
				_tmp17_ = offset1;
#line 1175 "../lib/number.vala"
				offset1 = _tmp17_ - 1;
#line 5095 "number.c"
			}
#line 1177 "../lib/number.vala"
			if (offset2 >= 0) {
#line 5099 "number.c"
				const gchar* _tmp18_;
				gint _tmp19_;
#line 1179 "../lib/number.vala"
				_tmp18_ = text2;
#line 1179 "../lib/number.vala"
				v2 = number_hex_to_int (self, string_get (_tmp18_, (glong) offset2));
#line 1180 "../lib/number.vala"
				_tmp19_ = offset2;
#line 1180 "../lib/number.vala"
				offset2 = _tmp19_ - 1;
#line 5110 "number.c"
			}
#line 1182 "../lib/number.vala"
			_tmp20_ = text_out;
#line 1182 "../lib/number.vala"
			_tmp20__length1 = text_out_length1;
#line 1182 "../lib/number.vala"
			_tmp21_ = digits[bitwise_operator (v1, v2, bitwise_operator_target)];
#line 1182 "../lib/number.vala"
			_tmp20_[offset_out] = _tmp21_;
#line 5120 "number.c"
		}
	}
#line 1185 "../lib/number.vala"
	_tmp22_ = text_out;
#line 1185 "../lib/number.vala"
	_tmp22__length1 = text_out_length1;
#line 1185 "../lib/number.vala"
	_tmp23_ = mp_set_from_string ((const gchar*) _tmp22_, 16);
#line 1185 "../lib/number.vala"
	result = _tmp23_;
#line 1185 "../lib/number.vala"
	text_out = (g_free (text_out), NULL);
#line 1185 "../lib/number.vala"
	_g_free0 (text2);
#line 1185 "../lib/number.vala"
	_g_free0 (text1);
#line 1185 "../lib/number.vala"
	return result;
#line 5139 "number.c"
}

static gint
number_hex_to_int (Number* self,
                   gchar digit)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint result;
#line 1188 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1190 "../lib/number.vala"
	if (digit >= '0') {
#line 1190 "../lib/number.vala"
		_tmp0_ = digit <= '9';
#line 5156 "number.c"
	} else {
#line 1190 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 5160 "number.c"
	}
#line 1190 "../lib/number.vala"
	if (_tmp0_) {
#line 1191 "../lib/number.vala"
		result = (gint) (digit - '0');
#line 1191 "../lib/number.vala"
		return result;
#line 5168 "number.c"
	}
#line 1192 "../lib/number.vala"
	if (digit >= 'A') {
#line 1192 "../lib/number.vala"
		_tmp1_ = digit <= 'F';
#line 5174 "number.c"
	} else {
#line 1192 "../lib/number.vala"
		_tmp1_ = FALSE;
#line 5178 "number.c"
	}
#line 1192 "../lib/number.vala"
	if (_tmp1_) {
#line 1193 "../lib/number.vala"
		result = (digit - 'A') + 10;
#line 1193 "../lib/number.vala"
		return result;
#line 5186 "number.c"
	}
#line 1194 "../lib/number.vala"
	if (digit >= 'a') {
#line 1194 "../lib/number.vala"
		_tmp2_ = digit <= 'f';
#line 5192 "number.c"
	} else {
#line 1194 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 5196 "number.c"
	}
#line 1194 "../lib/number.vala"
	if (_tmp2_) {
#line 1195 "../lib/number.vala"
		result = (digit - 'a') + 10;
#line 1195 "../lib/number.vala"
		return result;
#line 5204 "number.c"
	}
#line 1196 "../lib/number.vala"
	result = 0;
#line 1196 "../lib/number.vala"
	return result;
#line 5210 "number.c"
}

static gchar*
number_to_hex_string (Number* self)
{
	Serializer* serializer = NULL;
	Serializer* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 1199 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1201 "../lib/number.vala"
	_tmp0_ = serializer_new (DISPLAY_FORMAT_FIXED, 16, 0);
#line 1201 "../lib/number.vala"
	serializer = _tmp0_;
#line 1202 "../lib/number.vala"
	_tmp1_ = serializer_to_string (serializer, self);
#line 1202 "../lib/number.vala"
	result = _tmp1_;
#line 1202 "../lib/number.vala"
	_g_object_unref0 (serializer);
#line 1202 "../lib/number.vala"
	return result;
#line 5234 "number.c"
}

Number*
number_construct (GType object_type)
{
	Number * self = NULL;
#line 41 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 41 "../lib/number.vala"
	return self;
#line 5245 "number.c"
}

Number*
number_new (void)
{
#line 41 "../lib/number.vala"
	return number_construct (TYPE_NUMBER);
#line 5253 "number.c"
}

mpfr_prec_t
number_get_precision (void)
{
	mpfr_prec_t result;
#line 46 "../lib/number.vala"
	result = number__precision;
#line 46 "../lib/number.vala"
	return result;
#line 5264 "number.c"
}

void
number_set_precision (mpfr_prec_t value)
{
#line 46 "../lib/number.vala"
	number__precision = value;
#line 5272 "number.c"
}

const gchar*
number_get_error (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../lib/number.vala"
	_tmp0_ = number__error;
#line 49 "../lib/number.vala"
	result = _tmp0_;
#line 49 "../lib/number.vala"
	return result;
#line 5286 "number.c"
}

void
number_set_error (const gchar* value)
{
	gchar* _tmp0_;
#line 49 "../lib/number.vala"
	_tmp0_ = g_strdup (value);
#line 49 "../lib/number.vala"
	_g_free0 (number__error);
#line 49 "../lib/number.vala"
	number__error = _tmp0_;
#line 5299 "number.c"
}

static void
number_class_init (NumberClass * klass,
                   gpointer klass_data)
{
#line 41 "../lib/number.vala"
	number_parent_class = g_type_class_peek_parent (klass);
#line 41 "../lib/number.vala"
	g_type_class_adjust_private_offset (klass, &Number_private_offset);
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_number_get_property;
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_number_set_property;
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->finalize = number_finalize;
#line 5316 "number.c"
}

static void
number_instance_init (Number * self,
                      gpointer klass)
{
	mpfr_prec_t _tmp0_;
	mpfr_prec_t _tmp1_;
#line 41 "../lib/number.vala"
	self->priv = number_get_instance_private (self);
#line 44 "../lib/number.vala"
	_tmp0_ = number_get_precision ();
#line 44 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 44 "../lib/number.vala"
	mpc_init2 (&self->priv->num, _tmp1_);
#line 5333 "number.c"
}

static void
number_finalize (GObject * obj)
{
	Number * self;
#line 41 "../lib/number.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER, Number);
#line 44 "../lib/number.vala"
	mpc_clear (&self->priv->num);
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (number_parent_class)->finalize (obj);
#line 5346 "number.c"
}

static GType
number_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NumberClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Number), 0, (GInstanceInitFunc) number_instance_init, NULL };
	GType number_type_id;
	number_type_id = g_type_register_static (G_TYPE_OBJECT, "Number", &g_define_type_info, 0);
	Number_private_offset = g_type_add_instance_private (number_type_id, sizeof (NumberPrivate));
	return number_type_id;
}

GType
number_get_type (void)
{
	static volatile gsize number_type_id__once = 0;
	if (g_once_init_enter (&number_type_id__once)) {
		GType number_type_id;
		number_type_id = number_get_type_once ();
		g_once_init_leave (&number_type_id__once, number_type_id);
	}
	return number_type_id__once;
}

static void
_vala_number_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 41 "../lib/number.vala"
	switch (property_id) {
#line 5381 "number.c"
		default:
#line 41 "../lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../lib/number.vala"
		break;
#line 5387 "number.c"
	}
}

static void
_vala_number_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 41 "../lib/number.vala"
	switch (property_id) {
#line 5401 "number.c"
		default:
#line 41 "../lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../lib/number.vala"
		break;
#line 5407 "number.c"
	}
}

gint
parse_literal_prefix (const gchar* str,
                      gint* prefix_len)
{
	gint new_base = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gchar prefix = '\0';
	gint result;
#line 1206 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 1208 "../lib/number.vala"
	new_base = 0;
#line 1210 "../lib/number.vala"
	_tmp1_ = strlen (str);
#line 1210 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1210 "../lib/number.vala"
	if (_tmp2_ < 3) {
#line 1210 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 5433 "number.c"
	} else {
#line 1210 "../lib/number.vala"
		_tmp0_ = string_get (str, (glong) 0) != '0';
#line 5437 "number.c"
	}
#line 1210 "../lib/number.vala"
	if (_tmp0_) {
#line 1211 "../lib/number.vala"
		result = new_base;
#line 1211 "../lib/number.vala"
		return result;
#line 5445 "number.c"
	}
#line 1213 "../lib/number.vala"
	prefix = g_ascii_tolower (string_get (str, (glong) 1));
#line 1215 "../lib/number.vala"
	if (prefix == 'b') {
#line 1216 "../lib/number.vala"
		new_base = 2;
#line 5453 "number.c"
	} else {
#line 1217 "../lib/number.vala"
		if (prefix == 'o') {
#line 1218 "../lib/number.vala"
			new_base = 8;
#line 5459 "number.c"
		} else {
#line 1219 "../lib/number.vala"
			if (prefix == 'x') {
#line 1220 "../lib/number.vala"
				new_base = 16;
#line 5465 "number.c"
			}
		}
	}
#line 1222 "../lib/number.vala"
	if (new_base != 0) {
#line 1223 "../lib/number.vala"
		*prefix_len = 2;
#line 5473 "number.c"
	}
#line 1225 "../lib/number.vala"
	result = new_base;
#line 1225 "../lib/number.vala"
	return result;
#line 5479 "number.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1169 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1170 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1170 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1172 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1172 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 5501 "number.c"
		gchar* _tmp2_;
#line 1173 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1173 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1173 "glib-2.0.vapi"
		return result;
#line 5509 "number.c"
	} else {
#line 1175 "glib-2.0.vapi"
		result = -1;
#line 1175 "glib-2.0.vapi"
		return result;
#line 5515 "number.c"
	}
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1267 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1268 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1269 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 5532 "number.c"
		gchar* _tmp0_;
#line 1270 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1270 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1271 "glib-2.0.vapi"
		result = TRUE;
#line 1271 "glib-2.0.vapi"
		if (c) {
#line 1271 "glib-2.0.vapi"
			*c = _vala_c;
#line 5544 "number.c"
		}
#line 1271 "glib-2.0.vapi"
		return result;
#line 5548 "number.c"
	} else {
#line 1273 "glib-2.0.vapi"
		result = FALSE;
#line 1273 "glib-2.0.vapi"
		if (c) {
#line 1273 "glib-2.0.vapi"
			*c = _vala_c;
#line 5556 "number.c"
		}
#line 1273 "glib-2.0.vapi"
		return result;
#line 5560 "number.c"
	}
}

static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1306 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1307 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 5575 "number.c"
		gchar* _tmp0_;
#line 1308 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1308 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1309 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1310 "glib-2.0.vapi"
		result = TRUE;
#line 1310 "glib-2.0.vapi"
		if (c) {
#line 1310 "glib-2.0.vapi"
			*c = _vala_c;
#line 5589 "number.c"
		}
#line 1310 "glib-2.0.vapi"
		return result;
#line 5593 "number.c"
	} else {
#line 1312 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1313 "glib-2.0.vapi"
		result = FALSE;
#line 1313 "glib-2.0.vapi"
		if (c) {
#line 1313 "glib-2.0.vapi"
			*c = _vala_c;
#line 5603 "number.c"
		}
#line 1313 "glib-2.0.vapi"
		return result;
#line 5607 "number.c"
	}
}

Number*
mp_set_from_string (const gchar* str,
                    gint default_base)
{
#line 1239 "../lib/number.vala"
	static const gunichar base_digits[10] = {8320U, 8321U, 8322U, 8323U, 8324U, 8325U, 8326U, 8327U, 8328U, 8329U};
#line 5617 "number.c"
	gint index = 0;
	gint base_prefix = 0;
	gunichar c = 0U;
	gint end = 0;
	gint number_base = 0;
	gint literal_base = 0;
	gint base_multiplier = 0;
	gint _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean negate = FALSE;
	gunichar _tmp12_ = 0U;
	Number* z = NULL;
	Number* _tmp15_;
#line 1304 "../lib/number.vala"
	static const gunichar fractions[15] = {189U, 8531U, 8532U, 188U, 190U, 8533U, 8534U, 8535U, 8536U, 8537U, 8538U, 8539U, 8540U, 8541U, 8542U};
#line 1305 "../lib/number.vala"
	static const gint numerators[15] = {1, 1, 2, 1, 3, 1, 2, 3, 4, 1, 5, 1, 3, 5, 7};
#line 1306 "../lib/number.vala"
	static const gint denominators[15] = {2, 3, 3, 4, 4, 5, 5, 5, 5, 6, 6, 8, 8, 8, 8};
#line 5638 "number.c"
	gboolean has_fraction = FALSE;
	gunichar _tmp25_ = 0U;
	gboolean _tmp26_;
	Number* result;
#line 1233 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1235 "../lib/number.vala"
	if (string_index_of_char (str, 176U, 0) >= 0) {
#line 5647 "number.c"
		Number* _tmp0_;
#line 1236 "../lib/number.vala"
		_tmp0_ = set_from_sexagesimal (str);
#line 1236 "../lib/number.vala"
		result = _tmp0_;
#line 1236 "../lib/number.vala"
		return result;
#line 5655 "number.c"
	}
#line 1240 "../lib/number.vala"
	index = 0;
#line 1241 "../lib/number.vala"
	base_prefix = 0;
#line 1243 "../lib/number.vala"
	while (TRUE) {
#line 5663 "number.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 1243 "../lib/number.vala"
		_tmp2_ = string_get_next_char (str, &index, &_tmp1_);
#line 1243 "../lib/number.vala"
		c = _tmp1_;
#line 1243 "../lib/number.vala"
		if (!_tmp2_) {
#line 1243 "../lib/number.vala"
			break;
#line 5674 "number.c"
		}
	}
#line 1244 "../lib/number.vala"
	end = index;
#line 1245 "../lib/number.vala"
	number_base = 0;
#line 1246 "../lib/number.vala"
	literal_base = 0;
#line 1247 "../lib/number.vala"
	base_multiplier = 1;
#line 1248 "../lib/number.vala"
	while (TRUE) {
#line 5687 "number.c"
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gint value = 0;
#line 1248 "../lib/number.vala"
		_tmp4_ = string_get_prev_char (str, &index, &_tmp3_);
#line 1248 "../lib/number.vala"
		c = _tmp3_;
#line 1248 "../lib/number.vala"
		if (!_tmp4_) {
#line 1248 "../lib/number.vala"
			break;
#line 5699 "number.c"
		}
#line 1250 "../lib/number.vala"
		value = -1;
#line 5703 "number.c"
		{
			gint i = 0;
#line 1251 "../lib/number.vala"
			i = 0;
#line 5708 "number.c"
			{
				gboolean _tmp5_ = FALSE;
#line 1251 "../lib/number.vala"
				_tmp5_ = TRUE;
#line 1251 "../lib/number.vala"
				while (TRUE) {
#line 5715 "number.c"
					gunichar _tmp7_;
#line 1251 "../lib/number.vala"
					if (!_tmp5_) {
#line 5719 "number.c"
						gint _tmp6_;
#line 1251 "../lib/number.vala"
						_tmp6_ = i;
#line 1251 "../lib/number.vala"
						i = _tmp6_ + 1;
#line 5725 "number.c"
					}
#line 1251 "../lib/number.vala"
					_tmp5_ = FALSE;
#line 1251 "../lib/number.vala"
					if (!(i < G_N_ELEMENTS (base_digits))) {
#line 1251 "../lib/number.vala"
						break;
#line 5733 "number.c"
					}
#line 1253 "../lib/number.vala"
					_tmp7_ = base_digits[i];
#line 1253 "../lib/number.vala"
					if (c == _tmp7_) {
#line 1255 "../lib/number.vala"
						value = i;
#line 1256 "../lib/number.vala"
						break;
#line 5743 "number.c"
					}
				}
			}
		}
#line 1259 "../lib/number.vala"
		if (value < 0) {
#line 1260 "../lib/number.vala"
			break;
#line 5752 "number.c"
		}
#line 1262 "../lib/number.vala"
		end = index;
#line 1263 "../lib/number.vala"
		number_base += value * base_multiplier;
#line 1264 "../lib/number.vala"
		base_multiplier *= 10;
#line 5760 "number.c"
	}
#line 1267 "../lib/number.vala"
	_tmp8_ = parse_literal_prefix (str, &base_prefix);
#line 1267 "../lib/number.vala"
	literal_base = _tmp8_;
#line 1269 "../lib/number.vala"
	if (number_base != 0) {
#line 1269 "../lib/number.vala"
		_tmp10_ = literal_base != 0;
#line 5770 "number.c"
	} else {
#line 1269 "../lib/number.vala"
		_tmp10_ = FALSE;
#line 5774 "number.c"
	}
#line 1269 "../lib/number.vala"
	if (_tmp10_) {
#line 1269 "../lib/number.vala"
		_tmp9_ = literal_base != number_base;
#line 5780 "number.c"
	} else {
#line 1269 "../lib/number.vala"
		_tmp9_ = FALSE;
#line 5784 "number.c"
	}
#line 1269 "../lib/number.vala"
	if (_tmp9_) {
#line 1270 "../lib/number.vala"
		result = NULL;
#line 1270 "../lib/number.vala"
		return result;
#line 5792 "number.c"
	}
#line 1272 "../lib/number.vala"
	if (number_base == 0) {
#line 5796 "number.c"
		gint _tmp11_ = 0;
#line 1273 "../lib/number.vala"
		if (literal_base != 0) {
#line 1273 "../lib/number.vala"
			_tmp11_ = literal_base;
#line 5802 "number.c"
		} else {
#line 1273 "../lib/number.vala"
			_tmp11_ = default_base;
#line 5806 "number.c"
		}
#line 1273 "../lib/number.vala"
		number_base = _tmp11_;
#line 5810 "number.c"
	}
#line 1276 "../lib/number.vala"
	negate = FALSE;
#line 1277 "../lib/number.vala"
	index = base_prefix;
#line 1278 "../lib/number.vala"
	string_get_next_char (str, &index, &_tmp12_);
#line 1278 "../lib/number.vala"
	c = _tmp12_;
#line 1279 "../lib/number.vala"
	if (c == ((gunichar) '+')) {
#line 1280 "../lib/number.vala"
		negate = FALSE;
#line 5824 "number.c"
	} else {
		gboolean _tmp13_ = FALSE;
#line 1281 "../lib/number.vala"
		if (c == ((gunichar) '-')) {
#line 1281 "../lib/number.vala"
			_tmp13_ = TRUE;
#line 5831 "number.c"
		} else {
#line 1281 "../lib/number.vala"
			_tmp13_ = c == 8722U;
#line 5835 "number.c"
		}
#line 1281 "../lib/number.vala"
		if (_tmp13_) {
#line 1282 "../lib/number.vala"
			negate = TRUE;
#line 5841 "number.c"
		} else {
			gunichar _tmp14_ = 0U;
#line 1284 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp14_);
#line 1284 "../lib/number.vala"
			c = _tmp14_;
#line 5848 "number.c"
		}
	}
#line 1287 "../lib/number.vala"
	_tmp15_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1287 "../lib/number.vala"
	z = _tmp15_;
#line 1289 "../lib/number.vala"
	while (TRUE) {
#line 5857 "number.c"
		gunichar _tmp16_ = 0U;
		gboolean _tmp17_;
		gint i = 0;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
#line 1289 "../lib/number.vala"
		_tmp17_ = string_get_next_char (str, &index, &_tmp16_);
#line 1289 "../lib/number.vala"
		c = _tmp16_;
#line 1289 "../lib/number.vala"
		if (!_tmp17_) {
#line 1289 "../lib/number.vala"
			break;
#line 5875 "number.c"
		}
#line 1291 "../lib/number.vala"
		i = char_val (c, number_base);
#line 1292 "../lib/number.vala"
		if (i > number_base) {
#line 1293 "../lib/number.vala"
			result = NULL;
#line 1293 "../lib/number.vala"
			_g_object_unref0 (z);
#line 1293 "../lib/number.vala"
			return result;
#line 5887 "number.c"
		}
#line 1294 "../lib/number.vala"
		if (i < 0) {
#line 5891 "number.c"
			gunichar _tmp18_ = 0U;
#line 1296 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp18_);
#line 1296 "../lib/number.vala"
			c = _tmp18_;
#line 1297 "../lib/number.vala"
			break;
#line 5899 "number.c"
		}
#line 1300 "../lib/number.vala"
		_tmp19_ = z;
#line 1300 "../lib/number.vala"
		_tmp20_ = number_multiply_integer (_tmp19_, (gint64) number_base);
#line 1300 "../lib/number.vala"
		_tmp21_ = _tmp20_;
#line 1300 "../lib/number.vala"
		_tmp22_ = number_new_integer ((gint64) i, (gint64) 0);
#line 1300 "../lib/number.vala"
		_tmp23_ = _tmp22_;
#line 1300 "../lib/number.vala"
		_tmp24_ = number_add (_tmp21_, _tmp23_);
#line 1300 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1300 "../lib/number.vala"
		z = _tmp24_;
#line 1300 "../lib/number.vala"
		_g_object_unref0 (_tmp23_);
#line 1300 "../lib/number.vala"
		_g_object_unref0 (_tmp21_);
#line 5921 "number.c"
	}
#line 1307 "../lib/number.vala"
	has_fraction = FALSE;
#line 1308 "../lib/number.vala"
	_tmp26_ = string_get_next_char (str, &index, &_tmp25_);
#line 1308 "../lib/number.vala"
	c = _tmp25_;
#line 1308 "../lib/number.vala"
	if (_tmp26_) {
#line 5931 "number.c"
		{
			gint i = 0;
#line 1310 "../lib/number.vala"
			i = 0;
#line 5936 "number.c"
			{
				gboolean _tmp27_ = FALSE;
#line 1310 "../lib/number.vala"
				_tmp27_ = TRUE;
#line 1310 "../lib/number.vala"
				while (TRUE) {
#line 5943 "number.c"
					gunichar _tmp29_;
#line 1310 "../lib/number.vala"
					if (!_tmp27_) {
#line 5947 "number.c"
						gint _tmp28_;
#line 1310 "../lib/number.vala"
						_tmp28_ = i;
#line 1310 "../lib/number.vala"
						i = _tmp28_ + 1;
#line 5953 "number.c"
					}
#line 1310 "../lib/number.vala"
					_tmp27_ = FALSE;
#line 1310 "../lib/number.vala"
					if (!(i < G_N_ELEMENTS (fractions))) {
#line 1310 "../lib/number.vala"
						break;
#line 5961 "number.c"
					}
#line 1312 "../lib/number.vala"
					_tmp29_ = fractions[i];
#line 1312 "../lib/number.vala"
					if (c == _tmp29_) {
#line 5967 "number.c"
						Number* fraction = NULL;
						gint _tmp30_;
						gint _tmp31_;
						Number* _tmp32_;
						Number* _tmp33_;
						Number* _tmp34_;
						Number* _tmp35_;
						gunichar _tmp36_ = 0U;
						gboolean _tmp37_;
#line 1314 "../lib/number.vala"
						_tmp30_ = numerators[i];
#line 1314 "../lib/number.vala"
						_tmp31_ = denominators[i];
#line 1314 "../lib/number.vala"
						_tmp32_ = number_new_fraction ((gint64) _tmp30_, (gint64) _tmp31_);
#line 1314 "../lib/number.vala"
						fraction = _tmp32_;
#line 1315 "../lib/number.vala"
						_tmp33_ = z;
#line 1315 "../lib/number.vala"
						_tmp34_ = fraction;
#line 1315 "../lib/number.vala"
						_tmp35_ = number_add (_tmp33_, _tmp34_);
#line 1315 "../lib/number.vala"
						_g_object_unref0 (z);
#line 1315 "../lib/number.vala"
						z = _tmp35_;
#line 1318 "../lib/number.vala"
						_tmp37_ = string_get_next_char (str, &index, &_tmp36_);
#line 1318 "../lib/number.vala"
						c = _tmp36_;
#line 1318 "../lib/number.vala"
						if (!_tmp37_) {
#line 1319 "../lib/number.vala"
							result = z;
#line 1319 "../lib/number.vala"
							_g_object_unref0 (fraction);
#line 1319 "../lib/number.vala"
							return result;
#line 6007 "number.c"
						} else {
#line 1321 "../lib/number.vala"
							result = NULL;
#line 1321 "../lib/number.vala"
							_g_object_unref0 (fraction);
#line 1321 "../lib/number.vala"
							_g_object_unref0 (z);
#line 1321 "../lib/number.vala"
							return result;
#line 6017 "number.c"
						}
#line 1312 "../lib/number.vala"
						_g_object_unref0 (fraction);
#line 6021 "number.c"
					}
				}
			}
		}
#line 1326 "../lib/number.vala"
		if (c == ((gunichar) '.')) {
#line 1327 "../lib/number.vala"
			has_fraction = TRUE;
#line 6030 "number.c"
		} else {
			gunichar _tmp38_ = 0U;
#line 1329 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp38_);
#line 1329 "../lib/number.vala"
			c = _tmp38_;
#line 6037 "number.c"
		}
	}
#line 1333 "../lib/number.vala"
	if (has_fraction) {
#line 6042 "number.c"
		Number* numerator = NULL;
		Number* _tmp39_;
		Number* denominator = NULL;
		Number* _tmp40_;
		Number* _tmp52_;
		Number* _tmp53_;
		Number* _tmp54_;
		Number* _tmp55_;
		Number* _tmp56_;
		Number* _tmp57_;
#line 1335 "../lib/number.vala"
		_tmp39_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1335 "../lib/number.vala"
		numerator = _tmp39_;
#line 1336 "../lib/number.vala"
		_tmp40_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1336 "../lib/number.vala"
		denominator = _tmp40_;
#line 1338 "../lib/number.vala"
		while (TRUE) {
#line 6063 "number.c"
			gunichar _tmp41_ = 0U;
			gboolean _tmp42_;
			gint i = 0;
			Number* _tmp44_;
			Number* _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
			Number* _tmp49_;
			Number* _tmp50_;
			Number* _tmp51_;
#line 1338 "../lib/number.vala"
			_tmp42_ = string_get_next_char (str, &index, &_tmp41_);
#line 1338 "../lib/number.vala"
			c = _tmp41_;
#line 1338 "../lib/number.vala"
			if (!_tmp42_) {
#line 1338 "../lib/number.vala"
				break;
#line 6083 "number.c"
			}
#line 1340 "../lib/number.vala"
			i = char_val (c, number_base);
#line 1341 "../lib/number.vala"
			if (i < 0) {
#line 6089 "number.c"
				gunichar _tmp43_ = 0U;
#line 1343 "../lib/number.vala"
				string_get_prev_char (str, &index, &_tmp43_);
#line 1343 "../lib/number.vala"
				c = _tmp43_;
#line 1344 "../lib/number.vala"
				break;
#line 6097 "number.c"
			}
#line 1347 "../lib/number.vala"
			_tmp44_ = denominator;
#line 1347 "../lib/number.vala"
			_tmp45_ = number_multiply_integer (_tmp44_, (gint64) number_base);
#line 1347 "../lib/number.vala"
			_g_object_unref0 (denominator);
#line 1347 "../lib/number.vala"
			denominator = _tmp45_;
#line 1348 "../lib/number.vala"
			_tmp46_ = numerator;
#line 1348 "../lib/number.vala"
			_tmp47_ = number_multiply_integer (_tmp46_, (gint64) number_base);
#line 1348 "../lib/number.vala"
			_g_object_unref0 (numerator);
#line 1348 "../lib/number.vala"
			numerator = _tmp47_;
#line 1349 "../lib/number.vala"
			_tmp48_ = numerator;
#line 1349 "../lib/number.vala"
			_tmp49_ = number_new_integer ((gint64) i, (gint64) 0);
#line 1349 "../lib/number.vala"
			_tmp50_ = _tmp49_;
#line 1349 "../lib/number.vala"
			_tmp51_ = number_add (_tmp48_, _tmp50_);
#line 1349 "../lib/number.vala"
			_g_object_unref0 (numerator);
#line 1349 "../lib/number.vala"
			numerator = _tmp51_;
#line 1349 "../lib/number.vala"
			_g_object_unref0 (_tmp50_);
#line 6129 "number.c"
		}
#line 1352 "../lib/number.vala"
		_tmp52_ = numerator;
#line 1352 "../lib/number.vala"
		_tmp53_ = denominator;
#line 1352 "../lib/number.vala"
		_tmp54_ = number_divide (_tmp52_, _tmp53_);
#line 1352 "../lib/number.vala"
		_g_object_unref0 (numerator);
#line 1352 "../lib/number.vala"
		numerator = _tmp54_;
#line 1353 "../lib/number.vala"
		_tmp55_ = z;
#line 1353 "../lib/number.vala"
		_tmp56_ = numerator;
#line 1353 "../lib/number.vala"
		_tmp57_ = number_add (_tmp55_, _tmp56_);
#line 1353 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1353 "../lib/number.vala"
		z = _tmp57_;
#line 1333 "../lib/number.vala"
		_g_object_unref0 (denominator);
#line 1333 "../lib/number.vala"
		_g_object_unref0 (numerator);
#line 6155 "number.c"
	}
#line 1356 "../lib/number.vala"
	if (index != end) {
#line 1357 "../lib/number.vala"
		result = NULL;
#line 1357 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1357 "../lib/number.vala"
		return result;
#line 6165 "number.c"
	}
#line 1359 "../lib/number.vala"
	if (negate) {
#line 6169 "number.c"
		Number* _tmp58_;
		Number* _tmp59_;
#line 1360 "../lib/number.vala"
		_tmp58_ = z;
#line 1360 "../lib/number.vala"
		_tmp59_ = number_invert_sign (_tmp58_);
#line 1360 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1360 "../lib/number.vala"
		z = _tmp59_;
#line 6180 "number.c"
	}
#line 1362 "../lib/number.vala"
	result = z;
#line 1362 "../lib/number.vala"
	return result;
#line 6186 "number.c"
}

gint
char_val (gunichar c,
          gint number_base)
{
	gint value = 0;
	gint result;
#line 1367 "../lib/number.vala"
	if (!g_unichar_isxdigit (c)) {
#line 1368 "../lib/number.vala"
		result = -1;
#line 1368 "../lib/number.vala"
		return result;
#line 6201 "number.c"
	}
#line 1370 "../lib/number.vala"
	value = g_unichar_xdigit_value (c);
#line 1372 "../lib/number.vala"
	if (value >= number_base) {
#line 1373 "../lib/number.vala"
		result = -1;
#line 1373 "../lib/number.vala"
		return result;
#line 6211 "number.c"
	}
#line 1375 "../lib/number.vala"
	result = value;
#line 1375 "../lib/number.vala"
	return result;
#line 6217 "number.c"
}

Number*
set_from_sexagesimal (const gchar* str)
{
	gint degree_index = 0;
	Number* degrees = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	gint minute_start = 0;
	gunichar c = 0U;
	gunichar _tmp5_ = 0U;
	gint minute_index = 0;
	Number* minutes = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	gint second_start = 0;
	gunichar _tmp16_ = 0U;
	gint second_index = 0;
	Number* seconds = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_;
	Number* _tmp19_;
	Number* _tmp20_;
	Number* _tmp21_;
	Number* _tmp22_;
	Number* _tmp23_;
	Number* _tmp24_;
	Number* _tmp25_;
	Number* _tmp26_;
	gunichar _tmp27_ = 0U;
	Number* result;
#line 1378 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1380 "../lib/number.vala"
	degree_index = string_index_of_char (str, 176U, 0);
#line 1381 "../lib/number.vala"
	if (degree_index < 0) {
#line 1382 "../lib/number.vala"
		result = NULL;
#line 1382 "../lib/number.vala"
		return result;
#line 6271 "number.c"
	}
#line 1383 "../lib/number.vala"
	_tmp0_ = string_substring (str, (glong) 0, (glong) degree_index);
#line 1383 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1383 "../lib/number.vala"
	_tmp2_ = mp_set_from_string (_tmp1_, 10);
#line 1383 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1383 "../lib/number.vala"
	_g_free0 (_tmp1_);
#line 1383 "../lib/number.vala"
	degrees = _tmp3_;
#line 1384 "../lib/number.vala"
	_tmp4_ = degrees;
#line 1384 "../lib/number.vala"
	if (_tmp4_ == NULL) {
#line 1385 "../lib/number.vala"
		result = NULL;
#line 1385 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1385 "../lib/number.vala"
		return result;
#line 6295 "number.c"
	}
#line 1386 "../lib/number.vala"
	minute_start = degree_index;
#line 1388 "../lib/number.vala"
	string_get_next_char (str, &minute_start, &_tmp5_);
#line 1388 "../lib/number.vala"
	c = _tmp5_;
#line 1390 "../lib/number.vala"
	if (string_get (str, (glong) minute_start) == '\0') {
#line 1391 "../lib/number.vala"
		result = degrees;
#line 1391 "../lib/number.vala"
		return result;
#line 6309 "number.c"
	}
#line 1392 "../lib/number.vala"
	minute_index = string_index_of_char (str, (gunichar) '\'', minute_start);
#line 1393 "../lib/number.vala"
	if (minute_index < 0) {
#line 1394 "../lib/number.vala"
		result = NULL;
#line 1394 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1394 "../lib/number.vala"
		return result;
#line 6321 "number.c"
	}
#line 1395 "../lib/number.vala"
	_tmp6_ = string_substring (str, (glong) minute_start, (glong) (minute_index - minute_start));
#line 1395 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1395 "../lib/number.vala"
	_tmp8_ = mp_set_from_string (_tmp7_, 10);
#line 1395 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 1395 "../lib/number.vala"
	_g_free0 (_tmp7_);
#line 1395 "../lib/number.vala"
	minutes = _tmp9_;
#line 1396 "../lib/number.vala"
	_tmp10_ = minutes;
#line 1396 "../lib/number.vala"
	if (_tmp10_ == NULL) {
#line 1397 "../lib/number.vala"
		result = NULL;
#line 1397 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1397 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1397 "../lib/number.vala"
		return result;
#line 6347 "number.c"
	}
#line 1398 "../lib/number.vala"
	_tmp11_ = degrees;
#line 1398 "../lib/number.vala"
	_tmp12_ = minutes;
#line 1398 "../lib/number.vala"
	_tmp13_ = number_divide_integer (_tmp12_, (gint64) 60);
#line 1398 "../lib/number.vala"
	_tmp14_ = _tmp13_;
#line 1398 "../lib/number.vala"
	_tmp15_ = number_add (_tmp11_, _tmp14_);
#line 1398 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 1398 "../lib/number.vala"
	degrees = _tmp15_;
#line 1398 "../lib/number.vala"
	_g_object_unref0 (_tmp14_);
#line 1399 "../lib/number.vala"
	second_start = minute_index;
#line 1400 "../lib/number.vala"
	string_get_next_char (str, &second_start, &_tmp16_);
#line 1400 "../lib/number.vala"
	c = _tmp16_;
#line 1402 "../lib/number.vala"
	if (string_get (str, (glong) second_start) == '\0') {
#line 1403 "../lib/number.vala"
		result = degrees;
#line 1403 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1403 "../lib/number.vala"
		return result;
#line 6379 "number.c"
	}
#line 1404 "../lib/number.vala"
	second_index = string_index_of_char (str, (gunichar) '"', second_start);
#line 1405 "../lib/number.vala"
	if (second_index < 0) {
#line 1406 "../lib/number.vala"
		result = NULL;
#line 1406 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1406 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1406 "../lib/number.vala"
		return result;
#line 6393 "number.c"
	}
#line 1407 "../lib/number.vala"
	_tmp17_ = string_substring (str, (glong) second_start, (glong) (second_index - second_start));
#line 1407 "../lib/number.vala"
	_tmp18_ = _tmp17_;
#line 1407 "../lib/number.vala"
	_tmp19_ = mp_set_from_string (_tmp18_, 10);
#line 1407 "../lib/number.vala"
	_tmp20_ = _tmp19_;
#line 1407 "../lib/number.vala"
	_g_free0 (_tmp18_);
#line 1407 "../lib/number.vala"
	seconds = _tmp20_;
#line 1408 "../lib/number.vala"
	_tmp21_ = seconds;
#line 1408 "../lib/number.vala"
	if (_tmp21_ == NULL) {
#line 1409 "../lib/number.vala"
		result = NULL;
#line 1409 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1409 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1409 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1409 "../lib/number.vala"
		return result;
#line 6421 "number.c"
	}
#line 1410 "../lib/number.vala"
	_tmp22_ = degrees;
#line 1410 "../lib/number.vala"
	_tmp23_ = seconds;
#line 1410 "../lib/number.vala"
	_tmp24_ = number_divide_integer (_tmp23_, (gint64) 3600);
#line 1410 "../lib/number.vala"
	_tmp25_ = _tmp24_;
#line 1410 "../lib/number.vala"
	_tmp26_ = number_add (_tmp22_, _tmp25_);
#line 1410 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 1410 "../lib/number.vala"
	degrees = _tmp26_;
#line 1410 "../lib/number.vala"
	_g_object_unref0 (_tmp25_);
#line 1411 "../lib/number.vala"
	string_get_next_char (str, &second_index, &_tmp27_);
#line 1411 "../lib/number.vala"
	c = _tmp27_;
#line 1414 "../lib/number.vala"
	if (string_get (str, (glong) second_index) == '\0') {
#line 1415 "../lib/number.vala"
		result = degrees;
#line 1415 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1415 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1415 "../lib/number.vala"
		return result;
#line 6453 "number.c"
	} else {
#line 1417 "../lib/number.vala"
		result = NULL;
#line 1417 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1417 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1417 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1417 "../lib/number.vala"
		return result;
#line 6465 "number.c"
	}
}

gboolean
mp_is_overflow (Number* x,
                gint wordlen)
{
	Number* t2 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	gboolean result;
#line 1421 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, FALSE);
#line 1423 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1423 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1423 "../lib/number.vala"
	_tmp2_ = number_xpowy_integer (_tmp1_, (gint64) wordlen);
#line 1423 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1423 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 1423 "../lib/number.vala"
	t2 = _tmp3_;
#line 1424 "../lib/number.vala"
	result = number_compare (t2, x) > 0;
#line 1424 "../lib/number.vala"
	_g_object_unref0 (t2);
#line 1424 "../lib/number.vala"
	return result;
#line 6499 "number.c"
}

